Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:20:18 2012
FILE NAME: lscond.f90
PROGRAM NAME: lscond
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    48  error( 919): Module information file of module "gridset" does not exist. (PT=7)
   159  error( 919): Module information file of module "saturate" does not exist. (PT=9)
   166  error( 212): Variable "imax" in specification expression is invalid. (PT=43)
   166  error( 439): Name "imax" must be typed explicitly. (PT=43)
   166  error( 212): Variable "jmax" in specification expression is invalid. (PT=53)
   166  error( 439): Name "jmax" must be typed explicitly. (PT=53)
   166  error( 212): Variable "kmax" in specification expression is invalid. (PT=61)
   166  error( 439): Name "kmax" must be typed explicitly. (PT=61)
   168  error( 212): Variable "imax" in specification expression is invalid. (PT=43)
   168  error( 212): Variable "jmax" in specification expression is invalid. (PT=53)
   168  error( 212): Variable "kmax" in specification expression is invalid. (PT=61)
   170  error( 212): Variable "imax" in specification expression is invalid. (PT=46)
   170  error( 212): Variable "jmax" in specification expression is invalid. (PT=56)
   170  error( 212): Variable "kmax" in specification expression is invalid. (PT=64)
   173  error( 212): Variable "imax" in specification expression is invalid. (PT=46)
   173  error( 212): Variable "jmax" in specification expression is invalid. (PT=56)
   173  error( 212): Variable "kmax" in specification expression is invalid. (PT=64)
   176  error( 212): Variable "imax" in specification expression is invalid. (PT=41)
   176  error( 212): Variable "jmax" in specification expression is invalid. (PT=51)
   176  error( 212): Variable "kmax" in specification expression is invalid. (PT=59)
   179  error( 212): Variable "imax" in specification expression is invalid. (PT=41)
   179  error( 212): Variable "jmax" in specification expression is invalid. (PT=51)
   179  error( 212): Variable "kmax" in specification expression is invalid. (PT=59)
   182  error( 212): Variable "imax" in specification expression is invalid. (PT=47)
   182  error( 212): Variable "jmax" in specification expression is invalid. (PT=56)
   182  error( 212): Variable "kmax" in specification expression is invalid. (PT=63)
   188  error( 212): Variable "imax" in specification expression is invalid. (PT=30)
   188  error( 212): Variable "jmax" in specification expression is invalid. (PT=40)
   191  error( 212): Variable "imax" in specification expression is invalid. (PT=34)
   191  error( 212): Variable "jmax" in specification expression is invalid. (PT=44)
   191  error( 212): Variable "kmax" in specification expression is invalid. (PT=52)
   194  error( 212): Variable "imax" in specification expression is invalid. (PT=34)
   194  error( 212): Variable "jmax" in specification expression is invalid. (PT=44)
   194  error( 212): Variable "kmax" in specification expression is invalid. (PT=52)
   198  error( 212): Variable "imax" in specification expression is invalid. (PT=29)
   198  error( 212): Variable "jmax" in specification expression is invalid. (PT=39)
   198  error( 212): Variable "kmax" in specification expression is invalid. (PT=47)
   201  error( 212): Variable "imax" in specification expression is invalid. (PT=29)
   201  error( 212): Variable "jmax" in specification expression is invalid. (PT=39)
   201  error( 212): Variable "kmax" in specification expression is invalid. (PT=47)
   205  error( 212): Variable "imax" in specification expression is invalid. (PT=36)
   205  error( 212): Variable "jmax" in specification expression is invalid. (PT=46)
   205  error( 212): Variable "kmax" in specification expression is invalid. (PT=54)
   208  error( 212): Variable "imax" in specification expression is invalid. (PT=36)
   208  error( 212): Variable "jmax" in specification expression is invalid. (PT=46)
   208  error( 212): Variable "kmax" in specification expression is invalid. (PT=54)
   223  error( 212): Variable "imax" in specification expression is invalid. (PT=30)
   223  error( 212): Variable "jmax" in specification expression is invalid. (PT=40)
   223  error( 212): Variable "kmax" in specification expression is invalid. (PT=48)
   228  error( 212): Variable "imax" in specification expression is invalid. (PT=35)
   228  error( 212): Variable "jmax" in specification expression is invalid. (PT=45)
   228  error( 212): Variable "kmax" in specification expression is invalid. (PT=53)
   264  error( 439): Name "xyz_calcqvapsat" must be typed explicitly. (PT=19)
   286  error( 439): Name "xyz_calcdqvapsatdtemp" must be typed explicitly. (PT=27)
   415  warn (  82): Name "tempbefadj" is not used.
   415  warn (  82): Name "qvapbefadj" is not used.
   415  warn (  82): Name "xyz_rainlsc" is not used.
   415  warn (  81): Name "imax" is referenced but not defined.
   415  warn (  81): Name "jmax" is referenced but not defined.
   415  warn (  81): Name "kmax" is referenced but not defined.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:20:18 2012
FILE NAME: lscond.f90
PROGRAM NAME: lscond
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != 絬϶ŷ (ήŷ) (Manabe et al., 1965)
     2  !
     3  != Large scale condensation (non-convective condensation) (Manabe et al., 1965)
     4  !
     5  ! Authors::   Yasuhiro MORIKAWA, Yukiko YAMADA, Satoshi NODA, Yoshiyuki O. Takahashi
     6  ! Version::   $Id: lscond.f90,v 1.13 2011-12-02 04:07:03 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module lscond
    13    !
    14    != 絬϶ŷ (ήŷ)
    15    !
    16    != Large scale condensation (non-convective condensation)
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! 絬϶ŷˤäƲ٤漾Ĵᤷޤ.
    21    !
    22    ! Adjust temperature and specific humidity by
    23    ! a large scale condensation process.
    24    !
    25    !== References
    26    !
    27    !  Manabe, S., J. Smagorinsky, R. F. Strickler,
    28    !    Simulated climatology of a general circulation model with a hydrologic cycle,
    29    !    Mon. Wea. Rev., 93, 769-798, 1965.
    30    !
    31    !== Procedures List
    32    !
    33    ! LScaleCond    :: ٤漾Ĵ
    34    ! ------------  :: ------------
    35    ! LScaleCond    :: Adjust temperature and specific humidity
    36    !
    37    !== NAMELIST
    38    !
    39    ! NAMELIST#lscond_nml
    40    !
    41  
    42    ! ⥸塼 ; USE statements
    43    !
    44  
    45    ! ʻ
    46    ! Grid points settings
    47    !
    48    use gridset, only: imax, & ! ٳʻ.
    49                               ! Number of grid points in longitude
    50      &                jmax, & ! ٳʻ.
    51                               ! Number of grid points in latitude
    52      &                kmax    ! ľؿ.
    53                               ! Number of vertical level
    54  
    55    ! ̷ѥ᥿
    56    ! Kind type parameter
    57    !
    58    use dc_types, only: DP, &      ! ټ¿. Double precision.
    59      &                 STRING     ! ʸ.       Strings.
    60  
    61    ! å
    62    ! Message output
    63    !
    64    use dc_message, only: MessageNotify
    65  
    66    ! ʸ ; Declaration statements
    67    !
    68    implicit none
    69    private
    70  
    71    ! ³
    72    ! Public procedure
    73    !
    74    public:: LScaleCond
    75    public:: LScaleCondInit
    76  
    77    ! ѿ
    78    ! Public variables
    79    !
    80    logical, save :: lscond_inited = .false.
    81                                ! ե饰.
    82                                ! Initialization flag
    83  
    84    ! ѿ
    85    ! Private variables
    86    !
    87    real(DP), save:: CrtlRH
    88                                ! ׳м.
    89                                ! Critical relative humidity
    90    integer, save:: ItrtMax
    91                                ! ƥ졼.
    92                                ! Number of iteration
    93    logical, save:: FlagUse
    94                                ! ѥե饰
    95                                ! flag for use of this scheme
    96  
    97    character(*), parameter:: module_name = 'lscond'
    98                                ! ⥸塼̾.
    99                                ! Module name
   100    character(*), parameter:: version = &
   101      & '$Name: dcpam5-20120921 $' // &
   102      & '$Id: lscond.f90,v 1.13 2011-12-02 04:07:03 yot Exp $'
   103                                ! ⥸塼ΥС
   104                                ! Module version
   105  
   106  contains
   107  
   108    !--------------------------------------------------------------------------------------
   109  
   110    subroutine LScaleCond(        &
   111      & xyz_Temp, xyz_QVap,       &  ! (inout)
   112      & xyz_DTempDt, xyz_DQVapDt, &  ! (inout)
   113      & xyz_Press, xyr_Press,     &  ! (in)
   114      & xyz_DQH2OLiqDt            &  ! (out)
   115      & )
   116      !
   117      ! 絬϶ŷ륹ˤ, ٤漾Ĵᤷޤ.
   118      !
   119      ! Adjust temperature and specific humidity by
   120      ! large scale condensation scheme.
   121      !
   122  
   123      ! ⥸塼 ; USE statements
   124      !
   125  
   126      ! ʪ
   127      ! Physical constants settings
   128      !
   129      use constants, only: &
   130        & Grav, &
   131                                ! $ g $ [m s-2].
   132                                ! ϲ®.
   133                                ! Gravitational acceleration
   134        & CpDry, &
   135                                ! $ C_p $ [J kg-1 K-1].
   136                                ! 絤갵Ǯ.
   137                                ! Specific heat of air at constant pressure
   138        & LatentHeat
   139                                ! $ L $ [J kg-1] .
   140                                ! ŷǮ.
   141                                ! Latent heat of condensation
   142  
   143      ! 
   144      ! Time control
   145      !
   146      use timeset, only: &
   147        & DelTime, &            ! $ \Delta t $
   148        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   149        & TimesetClockStart, TimesetClockStop
   150  
   151      ! ҥȥǡ
   152      ! History data output
   153      !
   154      use gtool_historyauto, only: HistoryAutoPut
   155  
   156      ! ˰漾λ
   157      ! Evaluate saturation specific humidity
   158      !
   159      use saturate, only: xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
   160  
   161  
   162      ! ʸ ; Declaration statements
   163      !
   164      implicit none
   165  
   166      real(DP), intent(inout):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
   167                                ! $ T $ .     . Temperature
   168      real(DP), intent(inout):: xyz_QVap (0:imax-1, 1:jmax, 1:kmax)
   169                                ! $ q $ .     漾. Specific humidity
   170      real(DP), intent(inout):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   171                                ! ѲΨ.
   172                                ! Temperature tendency
   173      real(DP), intent(inout):: xyz_DQVapDt (0:imax-1, 1:jmax, 1:kmax)
   174                                ! 漾ѲΨ.
   175                                ! Specific humidity tendency
   176      real(DP), intent(in):: xyz_Press (0:imax-1, 1:jmax, 1:kmax)
   177                                ! $ p $ .  (٥).
   178                                ! Air pressure (full level)
   179      real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   180                                ! $ \hat{p} $ .  (Ⱦ٥).
   181                                ! Air pressure (half level)
   182      real(DP), intent(out) :: xyz_DQH2OLiqDt(0:imax-1,1:jmax,1:kmax)
   183  
   184  
   185      ! ѿ
   186      ! Work variables
   187      !
   188      real(DP):: xy_RainLsc (0:imax-1, 1:jmax)
   189                                ! ߿.
   190                                ! Precipitation
   191      real(DP):: xyz_DTempDtLsc (0:imax-1, 1:jmax, 1:kmax)
   192                                ! ѲΨ.
   193                                ! Temperature tendency
   194      real(DP):: xyz_DQVapDtLsc (0:imax-1, 1:jmax, 1:kmax)
   195                                ! 漾ѲΨ.
   196                                ! Specific humidity tendency
   197  
   198      real(DP):: xyz_QVapB (0:imax-1, 1:jmax, 1:kmax)
   199                                ! Ĵ漾.
   200                                ! Specific humidity before adjust.
   201      real(DP):: xyz_TempB (0:imax-1, 1:jmax, 1:kmax)
   202                                ! Ĵβ.
   203                                ! Temperature before adjust.
   204                                !
   205      real(DP):: xyz_QVapSat      (0:imax-1, 1:jmax, 1:kmax)
   206                                ! ˰漾.
   207                                ! Saturation specific humidity.
   208      real(DP):: xyz_DQVapSatDTemp(0:imax-1, 1:jmax, 1:kmax)
   209                                ! $ \DD{q_{\rm{sat}}}{T} $
   210      real(DP):: DelTemp
   211                                ! Ĵˤ벹Ѳ.
   212                                ! Temperature variation by adjustment
   213  
   214      integer:: i               ! ˲ DO 롼Ѻѿ
   215                                ! Work variables for DO loop in longitude
   216      integer:: j               ! ˲ DO 롼Ѻѿ
   217                                ! Work variables for DO loop in latitude
   218      integer:: k               ! ľ˲ DO 롼Ѻѿ
   219                                ! Work variables for DO loop in vertical direction
   220      integer:: itr             ! ƥ졼˲ DO 롼Ѻѿ
   221                                ! Work variables for DO loop in iteration direction
   222  
   223      real(DP):: xyz_RainLSC(0:imax-1, 1:jmax, 1:kmax)
   224  
   225      real(DP):: TempBefAdj
   226      real(DP):: QVapBefAdj
   227  
   228      logical:: xyz_FlagSaturated(0:imax-1, 1:jmax, 1:kmax)
   229  
   230  
   231      ! ¹ʸ ; Executable statement
   232      !
   233  
   234      ! ǧ
   235      ! Initialization check
   236      !
   237      if ( .not. lscond_inited ) then
   238        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   239      end if
   240  
   241      if ( .not. FlagUse ) return
   242  
   243  
   244      ! ׻ַ¬
   245      ! Start measurement of computation time
   246      !
   247      call TimesetClockStart( module_name )
   248  
   249  
   250      ! Ĵ "QVap", "Temp" ¸
   251      ! Store "QVap", "Temp" before adjustment
   252      !
   253      xyz_QVapB  = xyz_QVap
   254      xyz_TempB  = xyz_Temp
   255  
   256  
   257      ! Ĵ
   258      ! Adjustment
   259      !
   260  
   261      ! ˰漾׻
   262      ! Calculate saturation specific humidity
   263      !
   264      xyz_QVapSat = xyz_CalcQVapSat( xyz_Temp, xyz_Press )
   265  
   266      do k = 1, kmax
   267        do j = 1, jmax
   268          do i = 0, imax-1
   269  
   270            if ( ( xyz_QVap(i,j,k) / xyz_QVapSat(i,j,k) ) >= CrtlRH ) then
   271              xyz_FlagSaturated(i,j,k) = .true.
   272            else
   273              xyz_FlagSaturated(i,j,k) = .false.
   274            end if
   275  
   276          end do
   277        end do
   278      end do
   279  
   280      do itr = 1, ItrtMax
   281  
   282        ! ˰漾׻
   283        ! Calculate saturation specific humidity
   284        !
   285        xyz_QVapSat       = xyz_CalcQVapSat      ( xyz_Temp, xyz_Press   )
   286        xyz_DQVapSatDTemp = xyz_CalcDQVapSatDTemp( xyz_Temp, xyz_QVapSat )
   287  
   288        do k = 1, kmax
   289          do j = 1, jmax
   290            do i = 0, imax-1
   291  
   292              ! ˰¤Ƥ, ٤漾Ѳ׻
   293              ! Calculate tendency of temperature and humidity
   294              ! if moist is saturation.
   295              !
   296              if ( xyz_FlagSaturated(i,j,k) ) then
   297  
   298                ! ٤Ѳʬ˥塼ȥˡǵ
   299                ! Calculate variation of temperature
   300                !
   301                DelTemp = &
   302                  & LatentHeat * ( xyz_QVap(i,j,k) - xyz_QVapSat(i,j,k) ) &
   303                  &    / ( CpDry + LatentHeat * xyz_DQVapSatDTemp(i,j,k) )
   304  
   305  
   306                !=========
   307                ! check routine
   308                !---------
   309  !!$              TempBefAdj = xyz_Temp(i,j,k)
   310  !!$              QVapBefAdj = xyz_QVap(i,j,k)
   311                !=========
   312  
   313                ! ٤漾Ĵ
   314                ! Adjust temperature and specific humidity
   315                !
   316                xyz_Temp(i,j,k) = xyz_Temp(i,j,k) + DelTemp
   317                xyz_QVap(i,j,k) = xyz_QVapSat(i,j,k) + xyz_DQVapSatDTemp(i,j,k) * DelTemp
   318  
   319                !=========
   320                ! check routine
   321                !---------
   322  !!$              write( 6, * ) '====='
   323  !!$              write( 6, * ) 'Energy difference before and after adjustment and each energy'
   324  !!$              write( 6, * ) &
   325  !!$                &     CpDry * TempBefAdj      + LatentHeat * QVapBefAdj            &
   326  !!$                & - ( CpDry * xyz_Temp(i,j,k) + LatentHeat * xyz_QVap(i,j,k) ),    &
   327  !!$                &     CpDry * TempBefAdj      + LatentHeat * QVapBefAdj,           &
   328  !!$                &   ( CpDry * xyz_Temp(i,j,k) + LatentHeat * xyz_QVap(i,j,k) )
   329                !=========
   330  
   331  
   332              end if
   333  
   334            end do
   335          end do
   336        end do
   337  
   338      end do
   339  
   340      ! 漾ѲΨ, ѲΨ, ߿̤λ
   341      ! Calculate specific humidity tendency, temperature tendency,
   342      ! precipitation
   343      !
   344      xyz_DQVapDtLsc = ( xyz_QVap - xyz_QVapB ) / ( 2.0_DP * DelTime )
   345      xyz_DTempDtLsc = ( xyz_Temp - xyz_TempB ) / ( 2.0_DP * DelTime )
   346  
   347      xyz_DTempDt = xyz_DTempDt + xyz_DTempDtLsc
   348      xyz_DQVapDt = xyz_DQVapDt + xyz_DQVapDtLsc
   349  
   350  
   351      ! OLD CODE TO BE DELETED
   352      !
   353  !!$    xy_RainLsc     = 0.
   354  !!$    do k = kmax, 1, -1
   355  !!$      xy_RainLsc = xy_RainLsc &
   356  !!$        & + ( xyz_Temp(:,:,k) - xyz_TempB(:,:,k) ) &
   357  !!$        &     * CpDry / ( 2.0_DP * DelTime ) &
   358  !!$        &     * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav &
   359  !!$        &     / LatentHeat
   360  !!$    end do
   361  !!$
   362  !!$    xy_RainLsc     = 0.0d0
   363  !!$    do k = kmax, 1, -1
   364  !!$      xy_RainLsc = xy_RainLsc                                     &
   365  !!$        & + ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav      &
   366  !!$        &   * ( xyz_QVapB(:,:,k) - xyz_QVap(:,:,k) )
   367  !!$    end do
   368  !!$    xy_RainLsc = xy_RainLsc / ( 2.0_DP * DelTime )
   369  
   370  !!$    i = 0
   371  !!$    j = jmax/2+1
   372  !!$    write( 6, * ) xy_RainLsc(i,j)
   373  
   374  !!$    xyz_DQH2OLiqDt = - xyz_DQVapDtLsc
   375  !!$    xy_RainLsc     = 0.0d0
   376  !!$    do k = kmax, 1, -1
   377  !!$      xy_RainLsc = xy_RainLsc                                     &
   378  !!$        & + xyz_DQH2OLiqDt(:,:,k) * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   379  !!$    end do
   380  
   381  !!$    i = 0
   382  !!$    j = jmax/2+1
   383  !!$    write( 6, * ) xy_RainLsc(i,j)
   384  !!$    write( 6, * ) '---'
   385  
   386  
   387  !!$    xy_Rain     = xy_Rain     + xy_RainLsc
   388  
   389  
   390      xyz_DQH2OLiqDt = - xyz_DQVapDtLsc
   391  
   392  
   393      ! calculation for output
   394      xy_RainLsc     = 0.0d0
   395      do k = kmax, 1, -1
   396        xy_RainLsc = xy_RainLsc                                     &
   397          & + xyz_DQH2OLiqDt(:,:,k) * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   398      end do
   399  
   400  
   401      ! ҥȥǡ
   402      ! History data output
   403      !
   404      call HistoryAutoPut( TimeN, 'RainLsc',    xy_RainLsc * LatentHeat )
   405      call HistoryAutoPut( TimeN, 'DTempDtLsc', xyz_DTempDtLsc )
   406      call HistoryAutoPut( TimeN, 'DQVapDtLsc', xyz_DQVapDtLsc )
   407  
   408  
   409  
   410      ! ׻ַ¬
   411      ! Pause measurement of computation time
   412      !
   413      call TimesetClockStop( module_name )
   414  
   415    end subroutine LScaleCond
   416  
   417    !--------------------------------------------------------------------------------------
   418  
   419    subroutine LScaleCondInit
   420      !
   421      ! lscond ⥸塼νԤޤ.
   422      ! NAMELIST#lscond_nml ɤ߹ߤϤμ³ǹԤޤ.
   423      !
   424      ! "lscond" module is initialized.
   425      ! "NAMELIST#lscond_nml" is loaded in this procedure.
   426      !
   427  
   428      ! ⥸塼 ; USE statements
   429      !
   430  
   431      ! NAMELIST եϤ˴ؤ桼ƥƥ
   432      ! Utilities for NAMELIST file input
   433      !
   434      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   435  
   436      ! ե
   437      ! File I/O support
   438      !
   439      use dc_iounit, only: FileOpen
   440  
   441      ! ̷ѥ᥿
   442      ! Kind type parameter
   443      !
   444      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   445  
   446      ! ʸ
   447      ! Character handling
   448      !
   449      use dc_string, only: StoA
   450  
   451      ! ҥȥǡ
   452      ! History data output
   453      !
   454      use gtool_historyauto, only: HistoryAutoAddVariable
   455  
   456      ! ʸ ; Declaration statements
   457      !
   458      implicit none
   459  
   460      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   461                                ! Unit number for NAMELIST file open
   462      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   463                                ! IOSTAT of NAMELIST read
   464  
   465      ! NAMELIST ѿ
   466      ! NAMELIST group name
   467      !
   468      namelist /lscond_nml/ &
   469        & CrtlRH, ItrtMax, FlagUse
   470            !
   471            ! ǥեͤˤĤƤϽ³ "lscond#LSCondInit"
   472            ! Υɤ򻲾ȤΤ.
   473            !
   474            ! Refer to source codes in the initialization procedure
   475            ! "lscond#LSCondInit" for the default values.
   476            !
   477  
   478      ! ¹ʸ ; Executable statement
   479      !
   480  
   481      if ( lscond_inited ) return
   482  
   483  
   484      ! ǥեͤ
   485      ! Default values settings
   486      !
   487      CrtlRH  = 1.0_DP
   488      ItrtMax = 3
   489      FlagUse = .true.
   490  
   491      ! NAMELIST ɤ߹
   492      ! NAMELIST is input
   493      !
   494      if ( trim(namelist_filename) /= '' ) then
   495        call FileOpen( unit_nml, &          ! (out)
   496          & namelist_filename, mode = 'r' ) ! (in)
   497  
   498        rewind( unit_nml )
   499        read( unit_nml, &         ! (in)
   500          & nml = lscond_nml, &   ! (out)
   501          & iostat = iostat_nml ) ! (out)
   502        close( unit_nml )
   503  
   504        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   505        if ( iostat_nml == 0 ) write( STDOUT, nml = lscond_nml )
   506      end if
   507  
   508      ! ҥȥǡϤΤΤؤѿϿ
   509      ! Register of variables for history data output
   510      !
   511      call HistoryAutoAddVariable( 'RainLsc', &
   512        & (/ 'lon ', 'lat ', 'time' /), &
   513        & 'precipitation by large scale condensation', 'W m-2' )
   514      call HistoryAutoAddVariable( 'DTempDtLsc', &
   515        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   516        & 'large-scale condensation heating', 'K s-1' )
   517      call HistoryAutoAddVariable( 'DQVapDtLsc', &
   518        & (/ 'lon ', 'lat ', 'sig ', 'time' /), &
   519        & 'large-scale condensation moistening', 'kg kg-1 s-1' )
   520  
   521      !  ; Print
   522      !
   523      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   524      call MessageNotify( 'M', module_name, '  FlagUse = %b', l = (/ FlagUse /) )
   525      call MessageNotify( 'M', module_name, '  CrtlRH  = %f', d = (/ CrtlRH /) )
   526      call MessageNotify( 'M', module_name, '  ItrtMax = %d', i = (/ ItrtMax /) )
   527      call MessageNotify( 'M', module_name, '' )
   528      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   529  
   530      lscond_inited = .true.
   531  
   532    end subroutine LScaleCondInit
   533  
   534    !--------------------------------------------------------------------------------------
   535  
   536  end module lscond
