Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:30 2012
FILE NAME: rad_Earth_SW_V2_1.f90
PROGRAM NAME: rad_earth_sw_v2_1
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   281  opt  (  11): Fused array assignments. :line 281 - 282
   281  opt  (1593): Loop nest collapsed into one loop.
   281  vec  (   4): Vectorized array expression.
   294  opt  (1592): Outer loop unrolled inside inner loop.
   294  vec  (   4): Vectorized array expression.
   294  vec  (   4): Vectorized array expression.
   295  opt  (1017): Subroutine call prevents optimization.
   299  opt  (  11): Fused array assignments. :line 299 - 304
   299  vec  (   4): Vectorized array expression.
   299  vec  (   4): Vectorized array expression.
   304  opt  (1592): Outer loop unrolled inside inner loop.
   309  opt  (  11): Fused array assignments. :line 309 - 310
   309  vec  (   4): Vectorized array expression.
   309  vec  (   4): Vectorized array expression.
   310  opt  (1592): Outer loop unrolled inside inner loop.
   326  opt  (1592): Outer loop unrolled inside inner loop.
   326  vec  (   4): Vectorized array expression.
   326  vec  (   4): Vectorized array expression.
   328  opt  (1592): Outer loop unrolled inside inner loop.
   328  vec  (   4): Vectorized array expression.
   328  vec  (   4): Vectorized array expression.
   334  opt  (  11): Fused array assignments. :line 334 - 339
   334  vec  (   4): Vectorized array expression.
   334  vec  (   4): Vectorized array expression.
   339  opt  (1592): Outer loop unrolled inside inner loop.
   345  opt  (1592): Outer loop unrolled inside inner loop.
   345  vec  (   4): Vectorized array expression.
   345  vec  (   4): Vectorized array expression.
   346  vec  (   3): Unvectorized loop.
   346  vec  (  13): Overhead of loop division is too large.
   347  opt  (1037): Feedback of array elements.
   347  opt  (1592): Outer loop unrolled inside inner loop.
   347  vec  (   4): Vectorized array expression.
   347  vec  (   4): Vectorized array expression.
   350  vec  (   4): Vectorized array expression.
   358  vec  (   1): Vectorized loop.
   358  vec  (   1): Vectorized loop.
   362  opt  (1592): Outer loop unrolled inside inner loop.
   365  vec  (   4): Vectorized array expression.
   381  opt  (  11): Fused array assignments. :line 381 - 382
   381  vec  (   4): Vectorized array expression.
   381  vec  (   4): Vectorized array expression.
   382  opt  (1592): Outer loop unrolled inside inner loop.
   409  opt  (1592): Outer loop unrolled inside inner loop.
   409  vec  (   4): Vectorized array expression.
   409  vec  (   4): Vectorized array expression.
   414  opt  (  11): Fused array assignments. :line 414 - 419
   414  vec  (   4): Vectorized array expression.
   414  vec  (   4): Vectorized array expression.
   419  opt  (1592): Outer loop unrolled inside inner loop.
   424  opt  (  11): Fused array assignments. :line 424 - 425
   424  vec  (   4): Vectorized array expression.
   424  vec  (   4): Vectorized array expression.
   425  opt  (1592): Outer loop unrolled inside inner loop.
   430  opt  (1017): Subroutine call prevents optimization.
   435  opt  (  11): Fused array assignments. :line 435 - 440
   435  vec  (   4): Vectorized array expression.
   435  vec  (   4): Vectorized array expression.
   440  opt  (1592): Outer loop unrolled inside inner loop.
   445  opt  (1592): Outer loop unrolled inside inner loop.
   445  vec  (   4): Vectorized array expression.
   445  vec  (   4): Vectorized array expression.
   446  vec  (   3): Unvectorized loop.
   446  vec  (  13): Overhead of loop division is too large.
   447  opt  (1037): Feedback of array elements.
   447  opt  (1592): Outer loop unrolled inside inner loop.
   447  vec  (   4): Vectorized array expression.
   447  vec  (   4): Vectorized array expression.
   450  opt  (1592): Outer loop unrolled inside inner loop.
   450  vec  (   4): Vectorized array expression.
   450  vec  (   4): Vectorized array expression.
   457  vec  (   1): Vectorized loop.
   457  vec  (   1): Vectorized loop.
   461  opt  (1592): Outer loop unrolled inside inner loop.
   464  vec  (   4): Vectorized array expression.
   480  opt  (  11): Fused array assignments. :line 480 - 484
   480  vec  (   4): Vectorized array expression.
   531  warn (  83): Dummy argument "xyz_cloudcover" is not used.
   531  warn (  82): Name "xyr_radflux" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:30 2012
FILE NAME: rad_Earth_SW_V2_1.f90
PROGRAM NAME: rad_earth_sw_v2_1
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ϵ絤ûͥǥ Ver. 2.1
     2  !
     3  != short wave radiation model for the Earth's atmosphere Ver. 2.1
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: rad_Earth_SW_V2_1.f90,v 1.5 2012-09-08 15:24:05 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  module rad_Earth_SW_V2_1
    12  
    13    !
    14    != ϵ絤ûͥǥ Ver. 2.1
    15    !
    16    != short wave radiation model for the Earth's atmosphere Ver. 2.1
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ϵ絤ûͥǥ.
    21    !
    22    ! This is a short wave radiation model for the Earth's atmospehre.
    23    !
    24    ! The wavenumber range of shortwave radiation treated by this routine is
    25    ! from 1000 to 57143 cm-1 (0.175 to 10 micron).
    26    !
    27    ! From 1000 to 57143 cm-1, the following effects are considered.
    28    ! * 1000 to 14286 cm-1 (0.70-10 micron):
    29    !   * absorption by H2O,
    30    !     * absorption by H2O is considered by using k-distribution method
    31    !       following Chou and Lee (1996),
    32    !   * absorption and scattering by cloud droplets.
    33    !     * optical properties of cloud is obtained from Chou et al. (1998)
    34    ! * 14286 to 57143 cm-1 (0.175 to 0.70 micron):
    35    !   * Rayleigh scattering,
    36    !     * scattering coefficient is obtained from Chou and Lee (1996),
    37    !   * scattering by cloud droplets.
    38    !     * optical properties of cloud is obtained from Chou et al. (1998)
    39    !
    40    !
    41    !== References
    42    !
    43    !  Chou, M.-D., and K.-T. Lee,
    44    !    Parameterizations for the absorption of solar radiation by water vapor and ozone,
    45    !    J. Atmos. Sci., 53, 1203-1208, 1996.
    46    !
    47    !  Chou, M.-D., M. J. Suarez, C.-H. Ho, M. M.-H. Yan, and K.-T. Lee,
    48    !    Parameterizations for cloud overlapping and shortwave single-scattering
    49    !    properties for use in general circulation and cloud ensemble models,
    50    !    J. Climate, 11, 202-214, 1998.
    51    !
    52    !== Procedures List
    53    !
    54    ! RadEarthSWV21Flux   :: ͥեåη׻
    55    ! ------------        :: ------------
    56    ! RadEarthSWV21Flux   :: Calculate radiation flux
    57    !
    58    !== NAMELIST
    59    !
    60    ! NAMELIST#rad_Earth_SW_V2_1_nml
    61    !
    62  
    63    ! USE statements
    64    !
    65  
    66    !
    67    ! Kind type parameter
    68    !
    69    use dc_types, only: DP, &      ! Double precision.
    70      &                 STRING, &  ! Strings.
    71      &                 TOKEN      ! Keywords.
    72  
    73    ! å
    74    ! Message output
    75    !
    76    use dc_message, only: MessageNotify
    77  
    78  
    79    ! ʻ
    80    ! Grid points settings
    81    !
    82    use gridset, only: imax, & ! ٳʻ.
    83                               ! Number of grid points in longitude
    84      &                jmax, & ! ٳʻ.
    85                               ! Number of grid points in latitude
    86      &                kmax    ! ľؿ.
    87                               ! Number of vertical level
    88  
    89    ! 
    90    ! Time control
    91    !
    92    use timeset, only: &
    93      & TimesetClockStart, TimesetClockStop
    94  
    95    implicit none
    96  
    97    private
    98  
    99    logical , save      :: FlagRayleighScattering
   100    real(DP), save      :: SolarConst
   101  
   102  
   103    real(DP), save      :: CloudWatREff
   104    real(DP), save      :: CloudIceREff
   105  
   106  
   107    ! ѿ
   108    ! Public variables
   109    !
   110    logical, save :: rad_Earth_SW_V2_1_inited = .false.
   111                                ! ե饰.
   112                                ! Initialization flag
   113  
   114    public :: RadEarthSWV21Flux
   115    public :: RadEarthSWV21Init
   116  
   117    character(*), parameter:: module_name = 'rad_Earth_SW_V2_1'
   118                                ! ⥸塼̾.
   119                                ! Module name
   120    character(*), parameter:: version = &
   121      & '$Name: dcpam5-20120921 $' // &
   122      & '$Id: rad_Earth_SW_V2_1.f90,v 1.5 2012-09-08 15:24:05 yot Exp $'
   123                                ! ⥸塼ΥС
   124                                ! Module version
   125  
   126    !--------------------------------------------------------------------------------------
   127  
   128  contains
   129  
   130    !--------------------------------------------------------------------------------------
   131  
   132    subroutine RadEarthSWV21Flux(                                &
   133      & xy_SurfAlbedo,                                           &
   134      & xyz_DelAtmMass,                                          &
   135      & xyz_DelH2OVapMass, xyz_DelH2OLiqMass, xyz_DelH2OSolMass, &
   136      & xyz_DelO3Mass,                                           &
   137      & xyz_Press, xyz_Temp,                                     &
   138      & xyz_CloudCover,                                          &
   139      & xyr_RadSUwFlux, xyr_RadSDwFlux                           &
   140      & )
   141  
   142      ! USE statements
   143      !
   144  
   145      ! û ()
   146      ! Short wave (insolation) incoming
   147      !
   148      use rad_short_income, only : RadShortIncome
   149  
   150      !
   151      ! Solve radiative transfer equation in two stream approximation
   152      !
   153      use rad_rte_two_stream_app, only: RadRTETwoStreamAppSW
   154  
   155      ! Chou and Lee (1996) ˤûͥǥ
   156      ! Short wave radiation model described by Chou and Lee (1996)
   157      !
   158      use rad_CL1996, only :       &
   159        & RadCL1996NumBands      , &
   160        & RadCL1996UVVISParams   , &
   161        & RadCL1996IRH2ONumKDFBin, &
   162        & RadCL1996IRH2OKDFParams, &
   163        & RadCL1996ScaleH2OVapMass
   164  
   165  
   166      ! Chou et al (1998) ˤûѱǥ
   167      ! Cloud model for short wave radiation model described by Chou et al (1998)
   168      !
   169      use rad_C1998, only : RadC1998CalcCloudOptProp
   170  
   171  
   172      real(DP), intent(in ) :: xy_SurfAlbedo    (0:imax-1, 1:jmax )
   173      real(DP), intent(in ) :: xyz_DelAtmMass   (0:imax-1, 1:jmax, 1:kmax)
   174      real(DP), intent(in ) :: xyz_DelH2OVapMass(0:imax-1, 1:jmax, 1:kmax)
   175      real(DP), intent(in ) :: xyz_DelH2OLiqMass(0:imax-1, 1:jmax, 1:kmax)
   176      real(DP), intent(in ) :: xyz_DelH2OSolMass(0:imax-1, 1:jmax, 1:kmax)
   177      real(DP), intent(in ) :: xyz_DelO3Mass    (0:imax-1, 1:jmax, 1:kmax)
   178      real(DP), intent(in ) :: xyz_Press        (0:imax-1, 1:jmax, 1:kmax)
   179      real(DP), intent(in ) :: xyz_Temp         (0:imax-1, 1:jmax, 1:kmax)
   180      real(DP), intent(in ) :: xyz_CloudCover   (0:imax-1, 1:jmax, 1:kmax)
   181      real(DP), intent(out) :: xyr_RadSUwFlux   (0:imax-1, 1:jmax, 0:kmax)
   182      real(DP), intent(out) :: xyr_RadSDwFlux   (0:imax-1, 1:jmax, 0:kmax)
   183  
   184  
   185      real(DP) :: xy_InAngle    (0:imax-1, 1:jmax)
   186                                ! sec (ͳ).
   187                                ! sec (angle of incidence)
   188      real(DP) :: DistFromStarScld
   189                                 ! Distance between the central star and the planet
   190      real(DP) :: DiurnalMeanFactor
   191  
   192  
   193      integer  :: nbands1
   194      integer  :: nbands2
   195  
   196      real(DP) :: UVVISFracSolarFlux
   197      real(DP) :: UVVISO3AbsCoef
   198      real(DP) :: UVVISRayScatCoef
   199  
   200      real(DP) :: SolarFluxTOA
   201  
   202  
   203  
   204      real(DP) :: xyz_SSA       (0:imax-1, 1:jmax, 1:kmax)
   205      real(DP) :: xyz_AF        (0:imax-1, 1:jmax, 1:kmax)
   206  
   207  
   208      real(DP), parameter :: RayScatSinScatAlb = 1.0d0 - 1.0d-10
   209      real(DP), parameter :: RayScatAsymFact   = 0.0d0
   210  
   211      real(DP)            :: xyz_DelH2OVapMassScaled( 0:imax-1, 1:jmax, 1:kmax )
   212  
   213      real(DP)            :: xyz_DelCloudWatOptDep( 0:imax-1, 1:jmax, 1:kmax )
   214      real(DP)            :: xyz_DelCloudIceOptDep( 0:imax-1, 1:jmax, 1:kmax )
   215  
   216      real(DP)            :: xyz_RayScatDelOptDep( 0:imax-1, 1:jmax, 1:kmax )
   217  
   218      real(DP)            :: xyz_O3AbsDelOptDep  ( 0:imax-1, 1:jmax, 1:kmax )
   219  
   220      real(DP)            :: xyz_DelTotOptDep( 0:imax-1, 1:jmax, 1:kmax )
   221      real(DP)            :: xyr_TotOptDep   ( 0:imax-1, 1:jmax, 0:kmax )
   222      real(DP)            :: xyr_RadFlux     ( 0:imax-1, 1:jmax, 0:kmax )
   223      real(DP)            :: xyr_RadUwFlux   ( 0:imax-1, 1:jmax, 0:kmax )
   224      real(DP)            :: xyr_RadDwFlux   ( 0:imax-1, 1:jmax, 0:kmax )
   225  
   226      integer  :: nkdf
   227  
   228      integer  :: ikdfbin
   229      real(DP) :: KDFAbsCoef
   230      real(DP) :: KDFWeight
   231      real(DP) :: xyz_H2ODelOptDep( 0:imax-1, 1:jmax, 1:kmax )
   232  
   233  
   234      real(DP) :: xyz_CloudREff   (0:imax-1, 1:jmax, 1:kmax)
   235      real(DP) :: xyz_CloudExtCoef(0:imax-1, 1:jmax, 1:kmax)
   236      real(DP) :: xyz_CloudCoAlb  (0:imax-1, 1:jmax, 1:kmax)
   237      real(DP) :: xyz_CloudWatSSA (0:imax-1, 1:jmax, 1:kmax)
   238      real(DP) :: xyz_CloudWatAF  (0:imax-1, 1:jmax, 1:kmax)
   239      real(DP) :: xyz_CloudIceSSA (0:imax-1, 1:jmax, 1:kmax)
   240      real(DP) :: xyz_CloudIceAF  (0:imax-1, 1:jmax, 1:kmax)
   241  
   242  
   243  
   244      integer  :: i
   245      integer  :: j
   246      integer  :: k
   247      integer  :: l
   248  
   249  
   250      ! ǧ
   251      ! Initialization check
   252      !
   253      if ( .not. rad_Earth_SW_V2_1_inited ) then
   254        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   255      end if
   256  
   257  
   258      ! ׻ַ¬
   259      ! Start measurement of computation time
   260      !
   261      call TimesetClockStart( module_name )
   262  
   263  
   264      ! ûͤη׻
   265      ! Calculate short wave (insolation) incoming radiation
   266      !
   267      call RadShortIncome(                       &
   268        & xy_InAngle        = xy_InAngle,        & ! (out) optional
   269        & DistFromStarScld  = DistFromStarScld,  & ! (out) optional
   270        & DiurnalMeanFactor = DiurnalMeanFactor  &
   271        & )
   272  
   273  
   274      call RadCL1996NumBands(   &
   275        & nbands1, nbands2      & ! (out)
   276        & )
   277  
   278  
   279      ! Initialization
   280      !
   281      xyr_RadSUwFlux = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t870 = 1, jmax*(kmax + 1)*imax                                 
     .           xyr_radsuwflux(t870-1,1,0) = 0.0000000000000000e+000           
     .           xyr_radsdwflux(t870-1,1,0) = 0.0000000000000000e+000           
     .        end do                                                            
   282      xyr_RadSDwFlux = 0.0_DP
   283  
   284  
   285      ! * 14286 to 57143 cm-1 (0.175 to 0.70 micron):
   286      !   * Rayleigh scattering,
   287      !   * scattering by cloud droplets.
   288      !   * O3 absorption
   289      !
   290      do l = 1, nbands1
   291  
   292        ! Water cloud optical properties
   293        !
   294        xyz_CloudREff = CloudWatREff
     .        if (xyz_cloudreff.DSC.U2 .gt. 0) then                             
     .           J1 = and(xyz_cloudreff.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t884 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t886 = 1, xyz_cloudreff.DSC.U1 + 1                       
     .                 xyz_cloudreff(t886-1,t884,t882+1) = cloudwatreff         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t884 = J1 + 1, xyz_cloudreff.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t886 = 1, xyz_cloudreff.DSC.U1 + 1                       
     .                 xyz_cloudreff(t886-1,t884,t882+1) = cloudwatreff         
     .                 xyz_cloudreff(t886-1,t884+1,t882+1) = cloudwatreff       
     .                 xyz_cloudreff(t886-1,t884+2,t882+1) = cloudwatreff       
     .                 xyz_cloudreff(t886-1,t884+3,t882+1) = cloudwatreff       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   295        call RadC1998CalcCloudOptProp(                        &
   296          & 'Liquid', l, xyz_CloudREff,                       & ! (in )
   297          & xyz_CloudExtCoef, xyz_CloudCoAlb, xyz_CloudWatAF  & ! (out)
   298          & )
   299        xyz_DelCloudWatOptDep = xyz_CloudExtCoef * xyz_DelH2OLiqMass
     .        if (xyz_cloudextcoef.DSC.U2 .gt. 0) then                          
     .           J2 = and(xyz_cloudextcoef.DSC.U2,1)                            
     .  !CDIR    NODEP                                                          
     .           do t893 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t895 = 1, xyz_cloudextcoef.DSC.U1 + 1                    
     .                 xyz_delcloudwatoptdep(t895-1,t893,t891+1) =              
     .       1            xyz_cloudextcoef(t895-1,t893,t891+1)*xyz_delh2oliqmass
     .       2            (t895-1,t893,t891+1)                                  
     .                 xyz_cloudwatssa(t895-1,t893,t891+1) =                    
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t895-1,t893,   
     .       2            t891+1)                                               
     .                 xyz_cloudreff(t895-1,t893,t891+1) = cloudicereff         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t893 = J2 + 1, xyz_cloudextcoef.DSC.U2, 2                   
     .  !CDIR       NODEP                                                       
     .              do t895 = 1, xyz_cloudextcoef.DSC.U1 + 1                    
     .                 xyz_delcloudwatoptdep(t895-1,t893,t891+1) =              
     .       1            xyz_cloudextcoef(t895-1,t893,t891+1)*xyz_delh2oliqmass
     .       2            (t895-1,t893,t891+1)                                  
     .                 xyz_delcloudwatoptdep(t895-1,t893+1,t891+1) =            
     .       1            xyz_cloudextcoef(t895-1,t893+1,t891+1)*               
     .       2            xyz_delh2oliqmass(t895-1,t893+1,t891+1)               
     .                 xyz_cloudwatssa(t895-1,t893,t891+1) =                    
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t895-1,t893,   
     .       2            t891+1)                                               
     .                 xyz_cloudwatssa(t895-1,t893+1,t891+1) =                  
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t895-1,t893+1, 
     .       2            t891+1)                                               
     .                 xyz_cloudreff(t895-1,t893,t891+1) = cloudicereff         
     .                 xyz_cloudreff(t895-1,t893+1,t891+1) = cloudicereff       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   300        xyz_CloudWatSSA       = 1.0_DP - xyz_CloudCoAlb
   301  
   302        ! Ice cloud optical properties
   303        !
   304        xyz_CloudREff = CloudIceREff
   305        call RadC1998CalcCloudOptProp(                        &
   306          & 'Ice', l, xyz_CloudREff,                          & ! (in )
   307          & xyz_CloudExtCoef, xyz_CloudCoAlb, xyz_CloudIceAF  & ! (out)
   308          & )
   309        xyz_DelCloudIceOptDep = xyz_CloudExtCoef * xyz_DelH2OSolMass
     .        if (xyz_cloudextcoef.DSC.U2 .gt. 0) then                          
     .           J3 = and(xyz_cloudextcoef.DSC.U2,1)                            
     .  !CDIR    NODEP                                                          
     .           do t917 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t919 = 1, xyz_cloudextcoef.DSC.U1 + 1                    
     .                 xyz_delcloudiceoptdep(t919-1,t917,t915+1) =              
     .       1            xyz_cloudextcoef(t919-1,t917,t915+1)*xyz_delh2osolmass
     .       2            (t919-1,t917,t915+1)                                  
     .                 xyz_cloudicessa(t919-1,t917,t915+1) =                    
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t919-1,t917,   
     .       2            t915+1)                                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t917 = J3 + 1, xyz_cloudextcoef.DSC.U2, 2                   
     .  !CDIR       NODEP                                                       
     .              do t919 = 1, xyz_cloudextcoef.DSC.U1 + 1                    
     .                 xyz_delcloudiceoptdep(t919-1,t917,t915+1) =              
     .       1            xyz_cloudextcoef(t919-1,t917,t915+1)*xyz_delh2osolmass
     .       2            (t919-1,t917,t915+1)                                  
     .                 xyz_delcloudiceoptdep(t919-1,t917+1,t915+1) =            
     .       1            xyz_cloudextcoef(t919-1,t917+1,t915+1)*               
     .       2            xyz_delh2osolmass(t919-1,t917+1,t915+1)               
     .                 xyz_cloudicessa(t919-1,t917,t915+1) =                    
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t919-1,t917,   
     .       2            t915+1)                                               
     .                 xyz_cloudicessa(t919-1,t917+1,t915+1) =                  
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t919-1,t917+1, 
     .       2            t915+1)                                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   310        xyz_CloudIceSSA       = 1.0_DP - xyz_CloudCoAlb
   311  
   312  
   313        ! UV and Visible optical properties and solar flux
   314        !
   315        call RadCL1996UVVISParams(                                &
   316          & l,                                                    & ! (in )
   317          & UVVISFracSolarFlux, UVVISO3AbsCoef, UVVISRayScatCoef  & ! (out)
   318          & )
   319  
   320        SolarFluxTOA = UVVISFracSolarFlux * SolarConst / DistFromStarScld**2 * DiurnalMeanFactor
   321  
   322  
   323        ! Rayleigh scattering
   324        !
   325        if ( FlagRayleighScattering ) then
   326          xyz_RayScatDelOptDep = UVVISRayScatCoef * xyz_DelAtmMass
     .        if (1 + jmax - min0(1,jmax) .gt. 0) then                          
     .           J4 = and(1 + jmax - min0(1,jmax),3)                            
     .  !CDIR    NODEP                                                          
     .           do t1276 = 1, J4                                               
     .  !CDIR       NODEP                                                       
     .              do t1278 = 1, imax + 1 - min0(1,imax)                       
     .                 xyz_rayscatdeloptdep(t1278-1,t1276,t1274+1) =            
     .       1            uvvisrayscatcoef*xyz_delatmmass(t1278-1,t1276,t1274+1)
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1276 = J4 + 1, 1 + jmax - min0(1,jmax), 4                  
     .  !CDIR       NODEP                                                       
     .              do t1278 = 1, imax + 1 - min0(1,imax)                       
     .                 xyz_rayscatdeloptdep(t1278-1,t1276,t1274+1) =            
     .       1            uvvisrayscatcoef*xyz_delatmmass(t1278-1,t1276,t1274+1)
     .                 xyz_rayscatdeloptdep(t1278-1,t1276+1,t1274+1) =          
     .       1            uvvisrayscatcoef*xyz_delatmmass(t1278-1,t1276+1,t1274+
     .       2            1)                                                    
     .                 xyz_rayscatdeloptdep(t1278-1,t1276+2,t1274+1) =          
     .       1            uvvisrayscatcoef*xyz_delatmmass(t1278-1,t1276+2,t1274+
     .       2            1)                                                    
     .                 xyz_rayscatdeloptdep(t1278-1,t1276+3,t1274+1) =          
     .       1            uvvisrayscatcoef*xyz_delatmmass(t1278-1,t1276+3,t1274+
     .       2            1)                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   327        else
   328          xyz_RayScatDelOptDep = 0.0d0
     .        if (xyz_rayscatdeloptdep.DSC.U2 .gt. 0) then                      
     .           J5 = and(xyz_rayscatdeloptdep.DSC.U2,3)                        
     .  !CDIR    NODEP                                                          
     .           do t938 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t940 = 1, xyz_rayscatdeloptdep.DSC.U1 + 1                
     .                 xyz_rayscatdeloptdep(t940-1,t938,t936+1) =               
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t938 = J5 + 1, xyz_rayscatdeloptdep.DSC.U2, 4               
     .  !CDIR       NODEP                                                       
     .              do t940 = 1, xyz_rayscatdeloptdep.DSC.U1 + 1                
     .                 xyz_rayscatdeloptdep(t940-1,t938,t936+1) =               
     .       1            0.0000000000000000e+000                               
     .                 xyz_rayscatdeloptdep(t940-1,t938+1,t936+1) =             
     .       1            0.0000000000000000e+000                               
     .                 xyz_rayscatdeloptdep(t940-1,t938+2,t936+1) =             
     .       1            0.0000000000000000e+000                               
     .                 xyz_rayscatdeloptdep(t940-1,t938+3,t936+1) =             
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   329        end if
   330  
   331  
   332        ! O3 absorption
   333        !
   334        xyz_O3AbsDelOptDep = UVVISO3AbsCoef * xyz_DelO3Mass
     .        if (jmax .gt. 0) then                                             
     .           J6 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t947 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t949 = 1, imax                                           
     .                 xyz_o3absdeloptdep(t949-1,t947,t945+1) = uvviso3abscoef* 
     .       1            xyz_delo3mass(t949-1,t947,t945+1)                     
     .                 xyz_deltotoptdep(t949-1,t947,t945+1) =                   
     .       1            xyz_delcloudwatoptdep(t949-1,t947,t945+1) +           
     .       2            xyz_delcloudiceoptdep(t949-1,t947,t945+1) +           
     .       3            xyz_rayscatdeloptdep(t949-1,t947,t945+1) +            
     .       4            xyz_o3absdeloptdep(t949-1,t947,t945+1)                
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t947 = J6 + 1, jmax, 2                                      
     .  !CDIR       NODEP                                                       
     .              do t949 = 1, imax                                           
     .                 xyz_o3absdeloptdep(t949-1,t947,t945+1) = uvviso3abscoef* 
     .       1            xyz_delo3mass(t949-1,t947,t945+1)                     
     .                 xyz_o3absdeloptdep(t949-1,t947+1,t945+1) = uvviso3abscoef
     .       1            *xyz_delo3mass(t949-1,t947+1,t945+1)                  
     .                 xyz_deltotoptdep(t949-1,t947,t945+1) =                   
     .       1            xyz_delcloudwatoptdep(t949-1,t947,t945+1) +           
     .       2            xyz_delcloudiceoptdep(t949-1,t947,t945+1) +           
     .       3            xyz_rayscatdeloptdep(t949-1,t947,t945+1) +            
     .       4            xyz_o3absdeloptdep(t949-1,t947,t945+1)                
     .                 xyz_deltotoptdep(t949-1,t947+1,t945+1) =                 
     .       1            xyz_delcloudwatoptdep(t949-1,t947+1,t945+1) +         
     .       2            xyz_delcloudiceoptdep(t949-1,t947+1,t945+1) +         
     .       3            xyz_rayscatdeloptdep(t949-1,t947+1,t945+1) +          
     .       4            xyz_o3absdeloptdep(t949-1,t947+1,t945+1)              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   335  
   336  
   337        ! Total optical parameter
   338        !
   339        xyz_DelTotOptDep =            &
   340          &   xyz_DelCloudWatOptDep   &
   341          & + xyz_DelCloudIceOptDep   &
   342          & + xyz_RayScatDelOptDep    &
   343          & + xyz_O3AbsDelOptDep
   344        !
   345        xyr_TotOptDep(:,:,kmax) = 0.0d0
     .        if (xyr_totoptdep.DSC.U2 .gt. 0) then                             
     .           J7 = and(xyr_totoptdep.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t972 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t974 = 1, xyr_totoptdep.DSC.U1 + 1                       
     .                 xyr_totoptdep(t974-1,t972,kmax) = 0.0000000000000000e+000
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t972 = J7 + 1, xyr_totoptdep.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t974 = 1, xyr_totoptdep.DSC.U1 + 1                       
     .                 xyr_totoptdep(t974-1,t972,kmax) = 0.0000000000000000e+000
     .                 xyr_totoptdep(t974-1,t972+1,kmax) =                      
     .       1            0.0000000000000000e+000                               
     .                 xyr_totoptdep(t974-1,t972+2,kmax) =                      
     .       1            0.0000000000000000e+000                               
     .                 xyr_totoptdep(t974-1,t972+3,kmax) =                      
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   346        do k = kmax-1, 0, -1
   347          xyr_TotOptDep(:,:,k) = xyr_TotOptDep(:,:,k+1) + xyz_DelTotOptDep(:,:,k+1)
     .        if (xyr_totoptdep.DSC.U2 .gt. 0) then                             
     .           J8 = and(xyr_totoptdep.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t978 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t980 = 1, xyr_totoptdep.DSC.U1 + 1                       
     .                 xyr_totoptdep(t980-1,t978,k) = xyr_totoptdep(t980-1,t978,
     .       1            k+1) + xyz_deltotoptdep(t980-1,t978,k+1)              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t978 = J8 + 1, xyr_totoptdep.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t980 = 1, xyr_totoptdep.DSC.U1 + 1                       
     .                 xyr_totoptdep(t980-1,t978,k) = xyr_totoptdep(t980-1,t978,
     .       1            k+1) + xyz_deltotoptdep(t980-1,t978,k+1)              
     .                 xyr_totoptdep(t980-1,t978+1,k) = xyr_totoptdep(t980-1,   
     .       1            t978+1,k+1) + xyz_deltotoptdep(t980-1,t978+1,k+1)     
     .                 xyr_totoptdep(t980-1,t978+2,k) = xyr_totoptdep(t980-1,   
     .       1            t978+2,k+1) + xyz_deltotoptdep(t980-1,t978+2,k+1)     
     .                 xyr_totoptdep(t980-1,t978+3,k) = xyr_totoptdep(t980-1,   
     .       1            t978+3,k+1) + xyz_deltotoptdep(t980-1,t978+3,k+1)     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   348        end do
   349        !
   350        xyz_SSA =                                           &
     .  !CDIR NODEP                                                             
     .        do t992 = 1, xyz_cloudwatssa.DSC.U1 + 1                           
     .           xyz_ssa(t992-1,t990+1,t988+1) = (xyz_cloudwatssa(t992-1,t990+1,
     .       1      t988+1)*xyz_delcloudwatoptdep(t992-1,t990+1,t988+1)+        
     .       2      xyz_cloudicessa(t992-1,t990+1,t988+1)*xyz_delcloudiceoptdep(
     .       3      t992-1,t990+1,t988+1)+9.99999999899999e-001*                
     .       4      xyz_rayscatdeloptdep(t992-1,t990+1,t988+1)+                 
     .       5      0.0000000000000000e+000*xyz_o3absdeloptdep(t992-1,t990+1,   
     .       6      t988+1))/(xyz_deltotoptdep(t992-1,t990+1,t988+1)+           
     .       7      1.00000000000000e-100)                                      
     .        end do                                                            
   351          &   ( xyz_CloudWatSSA   * xyz_DelCloudWatOptDep   &
   352          &   + xyz_CloudIceSSA   * xyz_DelCloudIceOptDep   &
   353          &   + RayScatSinScatAlb * xyz_RayScatDelOptDep    &
   354          &   + 0.0d0             * xyz_O3AbsDelOptDep   )  &
   355          & / ( xyz_DelTotOptDep + 1.0d-100 )
   356        do k = 1, kmax
   357          do j = 1, jmax
   358            do i = 0, imax-1
   359              if ( xyz_SSA(i,j,k) >= 1.0d0 ) then
   360                xyz_SSA(i,j,k) = 1.0d0 - 1.0d-10
   361              end if
   362            end do
   363          end do
     .        if (jmax .gt. 0) then                                             
     .           J9 = and(jmax,1)                                               
     .           do j = 1, J9                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_ssa(i-1,j,k) .ge. 1.00000000000000e+000) then    
     .                    xyz_ssa(i-1,j,k) = 9.99999999899999e-001              
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J9 + 1, jmax, 2                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_ssa(i-1,j,k) .ge. 1.00000000000000e+000) then    
     .                    xyz_ssa(i-1,j,k) = 9.99999999899999e-001              
     .                 endif                                                    
     .                 if (xyz_ssa(i-1,j+1,k) .ge. 1.00000000000000e+000) then  
     .                    xyz_ssa(i-1,j+1,k) = 9.99999999899999e-001            
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   364        end do
   365        xyz_AF  =                                                               &
     .  !CDIR NODEP                                                             
     .        do t1022 = 1, xyz_cloudwataf.DSC.U1 + 1                           
     .           xyz_af(t1022-1,t1020+1,t1018+1) = (xyz_cloudwataf(t1022-1,t1020
     .       1      +1,t1018+1)*xyz_cloudwatssa(t1022-1,t1020+1,t1018+1)*       
     .       2      xyz_delcloudwatoptdep(t1022-1,t1020+1,t1018+1)+             
     .       3      xyz_cloudiceaf(t1022-1,t1020+1,t1018+1)*xyz_cloudicessa(    
     .       4      t1022-1,t1020+1,t1018+1)*xyz_delcloudiceoptdep(t1022-1,t1020
     .       5      +1,t1018+1)+0.0000000000000000e+000*xyz_rayscatdeloptdep(   
     .       6      t1022-1,t1020+1,t1018+1)+0.0000000000000000e+000*           
     .       7      xyz_o3absdeloptdep(t1022-1,t1020+1,t1018+1))/(xyz_ssa(t1022-
     .       8      1,t1020+1,t1018+1)*xyz_deltotoptdep(t1022-1,t1020+1,t1018+1)
     .       9      +1.00000000000000e-100)                                     
     .        end do                                                            
   366          &   ( xyz_CloudWatAF    * xyz_CloudWatSSA   * xyz_DelCloudWatOptDep   &
   367          &   + xyz_CloudIceAF    * xyz_CloudIceSSA   * xyz_DelCloudIceOptDep   &
   368          &   + RayScatAsymFact   * RayScatSinScatAlb * xyz_RayScatDelOptDep    &
   369          &   + 0.0d0             * 0.0d0             * xyz_O3AbsDelOptDep   )  &
   370          & / ( xyz_SSA * xyz_DelTotOptDep + 1.0d-100 )
   371  
   372  
   373        call RadRTETwoStreamAppSW(        &
   374          & xyz_SSA, xyz_AF,              & ! (in)
   375          & xyr_TotOptDep,                & ! (in)
   376          & xy_SurfAlbedo,                & ! (in)
   377          & SolarFluxTOA, xy_InAngle,     & ! (in)
   378          & xyr_RadUwFlux, xyr_RadDwFlux  & ! (out)
   379          & )
   380  
   381        xyr_RadSUwFlux = xyr_RadSUwFlux + xyr_RadUwFlux
     .        if (jmax .gt. 0) then                                             
     .           J10 = and(jmax,1)                                              
     .  !CDIR    NODEP                                                          
     .           do t1059 = 1, J10                                              
     .  !CDIR       NODEP                                                       
     .              do t1061 = 1, imax                                          
     .                 xyr_radsuwflux(t1061-1,t1059,t1057) = xyr_radsuwflux(    
     .       1            t1061-1,t1059,t1057) + xyr_raduwflux(t1061-1,t1059,   
     .       2            t1057)                                                
     .                 xyr_radsdwflux(t1061-1,t1059,t1057) = xyr_radsdwflux(    
     .       1            t1061-1,t1059,t1057) + xyr_raddwflux(t1061-1,t1059,   
     .       2            t1057)                                                
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1059 = J10 + 1, jmax, 2                                    
     .  !CDIR       NODEP                                                       
     .              do t1061 = 1, imax                                          
     .                 xyr_radsuwflux(t1061-1,t1059,t1057) = xyr_radsuwflux(    
     .       1            t1061-1,t1059,t1057) + xyr_raduwflux(t1061-1,t1059,   
     .       2            t1057)                                                
     .                 xyr_radsuwflux(t1061-1,t1059+1,t1057) = xyr_radsuwflux(  
     .       1            t1061-1,t1059+1,t1057) + xyr_raduwflux(t1061-1,t1059+1
     .       2            ,t1057)                                               
     .                 xyr_radsdwflux(t1061-1,t1059,t1057) = xyr_radsdwflux(    
     .       1            t1061-1,t1059,t1057) + xyr_raddwflux(t1061-1,t1059,   
     .       2            t1057)                                                
     .                 xyr_radsdwflux(t1061-1,t1059+1,t1057) = xyr_radsdwflux(  
     .       1            t1061-1,t1059+1,t1057) + xyr_raddwflux(t1061-1,t1059+1
     .       2            ,t1057)                                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   382        xyr_RadSDwFlux = xyr_RadSDwFlux + xyr_RadDwFlux
   383  
   384      end do
   385  
   386  
   387      ! * 1000 to 14286 cm-1 (0.70-10 micron):
   388      !   * absorption by H2O,
   389      !   * scattering by cloud droplets.
   390      !
   391  
   392      call RadCL1996ScaleH2OVapMass(              &
   393        & xyz_Temp, xyz_DelH2OVapMass, xyz_Press, & ! (in )
   394        & xyz_DelH2OVapMassScaled                 & ! (out)
   395        & )
   396  
   397  
   398      call RadCL1996IRH2ONumKDFBin( &
   399        & nkdf & ! (out)
   400        & )
   401  
   402  
   403      SolarFluxTOA = SolarConst / DistFromStarScld**2 * DiurnalMeanFactor
   404  
   405      do l = nbands1+1, nbands1+nbands2
   406  
   407        ! Water cloud optical properties
   408        !
   409        xyz_CloudREff = CloudWatREff
     .        if (xyz_cloudreff.DSC.U2 .gt. 0) then                             
     .           J11 = and(xyz_cloudreff.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t1083 = 1, J11                                              
     .  !CDIR       NODEP                                                       
     .              do t1085 = 1, xyz_cloudreff.DSC.U1 + 1                      
     .                 xyz_cloudreff(t1085-1,t1083,t1081+1) = cloudwatreff      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1083 = J11 + 1, xyz_cloudreff.DSC.U2, 4                    
     .  !CDIR       NODEP                                                       
     .              do t1085 = 1, xyz_cloudreff.DSC.U1 + 1                      
     .                 xyz_cloudreff(t1085-1,t1083,t1081+1) = cloudwatreff      
     .                 xyz_cloudreff(t1085-1,t1083+1,t1081+1) = cloudwatreff    
     .                 xyz_cloudreff(t1085-1,t1083+2,t1081+1) = cloudwatreff    
     .                 xyz_cloudreff(t1085-1,t1083+3,t1081+1) = cloudwatreff    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   410        call RadC1998CalcCloudOptProp(                        &
   411          & 'Liquid', l, xyz_CloudREff,                       & ! (in )
   412          & xyz_CloudExtCoef, xyz_CloudCoAlb, xyz_CloudWatAF  & ! (out)
   413          & )
   414        xyz_DelCloudWatOptDep = xyz_CloudExtCoef * xyz_DelH2OLiqMass
     .        if (xyz_cloudextcoef.DSC.U2 .gt. 0) then                          
     .           J12 = and(xyz_cloudextcoef.DSC.U2,1)                           
     .  !CDIR    NODEP                                                          
     .           do t1092 = 1, J12                                              
     .  !CDIR       NODEP                                                       
     .              do t1094 = 1, xyz_cloudextcoef.DSC.U1 + 1                   
     .                 xyz_delcloudwatoptdep(t1094-1,t1092,t1090+1) =           
     .       1            xyz_cloudextcoef(t1094-1,t1092,t1090+1)*              
     .       2            xyz_delh2oliqmass(t1094-1,t1092,t1090+1)              
     .                 xyz_cloudwatssa(t1094-1,t1092,t1090+1) =                 
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t1094-1,t1092, 
     .       2            t1090+1)                                              
     .                 xyz_cloudreff(t1094-1,t1092,t1090+1) = cloudicereff      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1092 = J12 + 1, xyz_cloudextcoef.DSC.U2, 2                 
     .  !CDIR       NODEP                                                       
     .              do t1094 = 1, xyz_cloudextcoef.DSC.U1 + 1                   
     .                 xyz_delcloudwatoptdep(t1094-1,t1092,t1090+1) =           
     .       1            xyz_cloudextcoef(t1094-1,t1092,t1090+1)*              
     .       2            xyz_delh2oliqmass(t1094-1,t1092,t1090+1)              
     .                 xyz_delcloudwatoptdep(t1094-1,t1092+1,t1090+1) =         
     .       1            xyz_cloudextcoef(t1094-1,t1092+1,t1090+1)*            
     .       2            xyz_delh2oliqmass(t1094-1,t1092+1,t1090+1)            
     .                 xyz_cloudwatssa(t1094-1,t1092,t1090+1) =                 
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t1094-1,t1092, 
     .       2            t1090+1)                                              
     .                 xyz_cloudwatssa(t1094-1,t1092+1,t1090+1) =               
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t1094-1,t1092+1
     .       2            ,t1090+1)                                             
     .                 xyz_cloudreff(t1094-1,t1092,t1090+1) = cloudicereff      
     .                 xyz_cloudreff(t1094-1,t1092+1,t1090+1) = cloudicereff    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   415        xyz_CloudWatSSA       = 1.0_DP - xyz_CloudCoAlb
   416  
   417        ! Ice cloud optical properties
   418        !
   419        xyz_CloudREff = CloudIceREff
   420        call RadC1998CalcCloudOptProp(                        &
   421          & 'Ice', l, xyz_CloudREff,                          & ! (in )
   422          & xyz_CloudExtCoef, xyz_CloudCoAlb, xyz_CloudIceAF  & ! (out)
   423          & )
   424        xyz_DelCloudIceOptDep = xyz_CloudExtCoef * xyz_DelH2OSolMass
     .        if (xyz_cloudextcoef.DSC.U2 .gt. 0) then                          
     .           J13 = and(xyz_cloudextcoef.DSC.U2,1)                           
     .  !CDIR    NODEP                                                          
     .           do t1116 = 1, J13                                              
     .  !CDIR       NODEP                                                       
     .              do t1118 = 1, xyz_cloudextcoef.DSC.U1 + 1                   
     .                 xyz_delcloudiceoptdep(t1118-1,t1116,t1114+1) =           
     .       1            xyz_cloudextcoef(t1118-1,t1116,t1114+1)*              
     .       2            xyz_delh2osolmass(t1118-1,t1116,t1114+1)              
     .                 xyz_cloudicessa(t1118-1,t1116,t1114+1) =                 
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t1118-1,t1116, 
     .       2            t1114+1)                                              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1116 = J13 + 1, xyz_cloudextcoef.DSC.U2, 2                 
     .  !CDIR       NODEP                                                       
     .              do t1118 = 1, xyz_cloudextcoef.DSC.U1 + 1                   
     .                 xyz_delcloudiceoptdep(t1118-1,t1116,t1114+1) =           
     .       1            xyz_cloudextcoef(t1118-1,t1116,t1114+1)*              
     .       2            xyz_delh2osolmass(t1118-1,t1116,t1114+1)              
     .                 xyz_delcloudiceoptdep(t1118-1,t1116+1,t1114+1) =         
     .       1            xyz_cloudextcoef(t1118-1,t1116+1,t1114+1)*            
     .       2            xyz_delh2osolmass(t1118-1,t1116+1,t1114+1)            
     .                 xyz_cloudicessa(t1118-1,t1116,t1114+1) =                 
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t1118-1,t1116, 
     .       2            t1114+1)                                              
     .                 xyz_cloudicessa(t1118-1,t1116+1,t1114+1) =               
     .       1            1.00000000000000e+000 - xyz_cloudcoalb(t1118-1,t1116+1
     .       2            ,t1114+1)                                             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   425        xyz_CloudIceSSA       = 1.0_DP - xyz_CloudCoAlb
   426  
   427  
   428        do ikdfbin = 1, nkdf
   429  
   430          call RadCL1996IRH2OKDFParams(              &
   431            & l, ikdfbin,                            & ! (in )
   432            & KDFAbsCoef, KDFWeight                  & ! (out)
   433            & )
   434  
   435          xyz_H2ODelOptDep = KDFAbsCoef * xyz_DelH2OVapMassScaled
     .        if (xyz_delh2ovapmassscaled.DSC.U2 .gt. 0) then                   
     .           J14 = and(xyz_delh2ovapmassscaled.DSC.U2,1)                    
     .  !CDIR    NODEP                                                          
     .           do t1137 = 1, J14                                              
     .  !CDIR       NODEP                                                       
     .              do t1139 = 1, xyz_delh2ovapmassscaled.DSC.U1 + 1            
     .                 xyz_h2odeloptdep(t1139-1,t1137,t1135+1) = kdfabscoef*    
     .       1            xyz_delh2ovapmassscaled(t1139-1,t1137,t1135+1)        
     .                 xyz_deltotoptdep(t1139-1,t1137,t1135+1) =                
     .       1            xyz_delcloudwatoptdep(t1139-1,t1137,t1135+1) +        
     .       2            xyz_delcloudiceoptdep(t1139-1,t1137,t1135+1) +        
     .       3            xyz_h2odeloptdep(t1139-1,t1137,t1135+1)               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1137 = J14 + 1, xyz_delh2ovapmassscaled.DSC.U2, 2          
     .  !CDIR       NODEP                                                       
     .              do t1139 = 1, xyz_delh2ovapmassscaled.DSC.U1 + 1            
     .                 xyz_h2odeloptdep(t1139-1,t1137,t1135+1) = kdfabscoef*    
     .       1            xyz_delh2ovapmassscaled(t1139-1,t1137,t1135+1)        
     .                 xyz_h2odeloptdep(t1139-1,t1137+1,t1135+1) = kdfabscoef*  
     .       1            xyz_delh2ovapmassscaled(t1139-1,t1137+1,t1135+1)      
     .                 xyz_deltotoptdep(t1139-1,t1137,t1135+1) =                
     .       1            xyz_delcloudwatoptdep(t1139-1,t1137,t1135+1) +        
     .       2            xyz_delcloudiceoptdep(t1139-1,t1137,t1135+1) +        
     .       3            xyz_h2odeloptdep(t1139-1,t1137,t1135+1)               
     .                 xyz_deltotoptdep(t1139-1,t1137+1,t1135+1) =              
     .       1            xyz_delcloudwatoptdep(t1139-1,t1137+1,t1135+1) +      
     .       2            xyz_delcloudiceoptdep(t1139-1,t1137+1,t1135+1) +      
     .       3            xyz_h2odeloptdep(t1139-1,t1137+1,t1135+1)             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   436  
   437  
   438          ! Total optical parameter
   439          !
   440          xyz_DelTotOptDep =          &
   441            &   xyz_DelCloudWatOptDep &
   442            & + xyz_DelCloudIceOptDep &
   443            & + xyz_H2ODelOptDep
   444  
   445          xyr_TotOptDep(:,:,kmax) = 0.0d0
     .        if (xyr_totoptdep.DSC.U2 .gt. 0) then                             
     .           J15 = and(xyr_totoptdep.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t1159 = 1, J15                                              
     .  !CDIR       NODEP                                                       
     .              do t1161 = 1, xyr_totoptdep.DSC.U1 + 1                      
     .                 xyr_totoptdep(t1161-1,t1159,kmax) =                      
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1159 = J15 + 1, xyr_totoptdep.DSC.U2, 4                    
     .  !CDIR       NODEP                                                       
     .              do t1161 = 1, xyr_totoptdep.DSC.U1 + 1                      
     .                 xyr_totoptdep(t1161-1,t1159,kmax) =                      
     .       1            0.0000000000000000e+000                               
     .                 xyr_totoptdep(t1161-1,t1159+1,kmax) =                    
     .       1            0.0000000000000000e+000                               
     .                 xyr_totoptdep(t1161-1,t1159+2,kmax) =                    
     .       1            0.0000000000000000e+000                               
     .                 xyr_totoptdep(t1161-1,t1159+3,kmax) =                    
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   446          do k = kmax-1, 0, -1
   447            xyr_TotOptDep(:,:,k) = xyr_TotOptDep(:,:,k+1) + xyz_DelTotOptDep(:,:,k+1)
     .        if (xyr_totoptdep.DSC.U2 .gt. 0) then                             
     .           J16 = and(xyr_totoptdep.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t1165 = 1, J16                                              
     .  !CDIR       NODEP                                                       
     .              do t1167 = 1, xyr_totoptdep.DSC.U1 + 1                      
     .                 xyr_totoptdep(t1167-1,t1165,k) = xyr_totoptdep(t1167-1,  
     .       1            t1165,k+1) + xyz_deltotoptdep(t1167-1,t1165,k+1)      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1165 = J16 + 1, xyr_totoptdep.DSC.U2, 4                    
     .  !CDIR       NODEP                                                       
     .              do t1167 = 1, xyr_totoptdep.DSC.U1 + 1                      
     .                 xyr_totoptdep(t1167-1,t1165,k) = xyr_totoptdep(t1167-1,  
     .       1            t1165,k+1) + xyz_deltotoptdep(t1167-1,t1165,k+1)      
     .                 xyr_totoptdep(t1167-1,t1165+1,k) = xyr_totoptdep(t1167-1,
     .       1            t1165+1,k+1) + xyz_deltotoptdep(t1167-1,t1165+1,k+1)  
     .                 xyr_totoptdep(t1167-1,t1165+2,k) = xyr_totoptdep(t1167-1,
     .       1            t1165+2,k+1) + xyz_deltotoptdep(t1167-1,t1165+2,k+1)  
     .                 xyr_totoptdep(t1167-1,t1165+3,k) = xyr_totoptdep(t1167-1,
     .       1            t1165+3,k+1) + xyz_deltotoptdep(t1167-1,t1165+3,k+1)  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   448          end do
   449  
   450          xyz_SSA =                                            &
     .        if (xyz_cloudwatssa.DSC.U2 .gt. 0) then                           
     .           J17 = and(xyz_cloudwatssa.DSC.U2,3)                            
     .  !CDIR    NODEP                                                          
     .           do t1177 = 1, J17                                              
     .  !CDIR       NODEP                                                       
     .              do t1179 = 1, xyz_cloudwatssa.DSC.U1 + 1                    
     .                 xyz_ssa(t1179-1,t1177,t1175+1) = (xyz_cloudwatssa(t1179-1
     .       1            ,t1177,t1175+1)*xyz_delcloudwatoptdep(t1179-1,t1177,  
     .       2            t1175+1)+xyz_cloudicessa(t1179-1,t1177,t1175+1)*      
     .       3            xyz_delcloudiceoptdep(t1179-1,t1177,t1175+1)+         
     .       4            0.0000000000000000e+000*xyz_h2odeloptdep(t1179-1,t1177
     .       5            ,t1175+1))/(xyz_deltotoptdep(t1179-1,t1177,t1175+1)+  
     .       6            1.00000000000000e-100)                                
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1177 = J17 + 1, xyz_cloudwatssa.DSC.U2, 4                  
     .  !CDIR       NODEP                                                       
     .              do t1179 = 1, xyz_cloudwatssa.DSC.U1 + 1                    
     .                 xyz_ssa(t1179-1,t1177,t1175+1) = (xyz_cloudwatssa(t1179-1
     .       1            ,t1177,t1175+1)*xyz_delcloudwatoptdep(t1179-1,t1177,  
     .       2            t1175+1)+xyz_cloudicessa(t1179-1,t1177,t1175+1)*      
     .       3            xyz_delcloudiceoptdep(t1179-1,t1177,t1175+1)+         
     .       4            0.0000000000000000e+000*xyz_h2odeloptdep(t1179-1,t1177
     .       5            ,t1175+1))/(xyz_deltotoptdep(t1179-1,t1177,t1175+1)+  
     .       6            1.00000000000000e-100)                                
     .                 xyz_ssa(t1179-1,t1177+1,t1175+1) = (xyz_cloudwatssa(t1179
     .       1            -1,t1177+1,t1175+1)*xyz_delcloudwatoptdep(t1179-1,    
     .       2            t1177+1,t1175+1)+xyz_cloudicessa(t1179-1,t1177+1,t1175
     .       3            +1)*xyz_delcloudiceoptdep(t1179-1,t1177+1,t1175+1)+   
     .       4            0.0000000000000000e+000*xyz_h2odeloptdep(t1179-1,t1177
     .       5            +1,t1175+1))/(xyz_deltotoptdep(t1179-1,t1177+1,t1175+1
     .       6            )+1.00000000000000e-100)                              
     .                 xyz_ssa(t1179-1,t1177+2,t1175+1) = (xyz_cloudwatssa(t1179
     .       1            -1,t1177+2,t1175+1)*xyz_delcloudwatoptdep(t1179-1,    
     .       2            t1177+2,t1175+1)+xyz_cloudicessa(t1179-1,t1177+2,t1175
     .       3            +1)*xyz_delcloudiceoptdep(t1179-1,t1177+2,t1175+1)+   
     .       4            0.0000000000000000e+000*xyz_h2odeloptdep(t1179-1,t1177
     .       5            +2,t1175+1))/(xyz_deltotoptdep(t1179-1,t1177+2,t1175+1
     .       6            )+1.00000000000000e-100)                              
     .                 xyz_ssa(t1179-1,t1177+3,t1175+1) = (xyz_cloudwatssa(t1179
     .       1            -1,t1177+3,t1175+1)*xyz_delcloudwatoptdep(t1179-1,    
     .       2            t1177+3,t1175+1)+xyz_cloudicessa(t1179-1,t1177+3,t1175
     .       3            +1)*xyz_delcloudiceoptdep(t1179-1,t1177+3,t1175+1)+   
     .       4            0.0000000000000000e+000*xyz_h2odeloptdep(t1179-1,t1177
     .       5            +3,t1175+1))/(xyz_deltotoptdep(t1179-1,t1177+3,t1175+1
     .       6            )+1.00000000000000e-100)                              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   451            &   ( xyz_CloudWatSSA   * xyz_DelCloudWatOptDep    &
   452            &   + xyz_CloudIceSSA   * xyz_DelCloudIceOptDep    &
   453            &   + 0.0d0             * xyz_H2ODelOptDep      )  &
   454            & / ( xyz_DelTotOptDep + 1.0d-100 )
   455          do k = 1, kmax
   456            do j = 1, jmax
   457              do i = 0, imax-1
   458                if ( xyz_SSA(i,j,k) >= 1.0d0 ) then
   459                  xyz_SSA(i,j,k) = 1.0d0 - 1.0d-10
   460                end if
   461              end do
   462            end do
     .        if (jmax .gt. 0) then                                             
     .           J18 = and(jmax,1)                                              
     .           do j = 1, J18                                                  
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_ssa(i-1,j,k) .ge. 1.00000000000000e+000) then    
     .                    xyz_ssa(i-1,j,k) = 9.99999999899999e-001              
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J18 + 1, jmax, 2                                        
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_ssa(i-1,j,k) .ge. 1.00000000000000e+000) then    
     .                    xyz_ssa(i-1,j,k) = 9.99999999899999e-001              
     .                 endif                                                    
     .                 if (xyz_ssa(i-1,j+1,k) .ge. 1.00000000000000e+000) then  
     .                    xyz_ssa(i-1,j+1,k) = 9.99999999899999e-001            
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   463          end do
   464          xyz_AF  =                                                               &
     .  !CDIR NODEP                                                             
     .        do t1206 = 1, xyz_cloudwataf.DSC.U1 + 1                           
     .           xyz_af(t1206-1,t1204+1,t1202+1) = (xyz_cloudwataf(t1206-1,t1204
     .       1      +1,t1202+1)*xyz_cloudwatssa(t1206-1,t1204+1,t1202+1)*       
     .       2      xyz_delcloudwatoptdep(t1206-1,t1204+1,t1202+1)+             
     .       3      xyz_cloudiceaf(t1206-1,t1204+1,t1202+1)*xyz_cloudicessa(    
     .       4      t1206-1,t1204+1,t1202+1)*xyz_delcloudiceoptdep(t1206-1,t1204
     .       5      +1,t1202+1)+0.0000000000000000e+000*xyz_h2odeloptdep(t1206-1
     .       6      ,t1204+1,t1202+1))/(xyz_ssa(t1206-1,t1204+1,t1202+1)*       
     .       7      xyz_deltotoptdep(t1206-1,t1204+1,t1202+1)+                  
     .       8      1.00000000000000e-100)                                      
     .        end do                                                            
   465            &   ( xyz_CloudWatAF    * xyz_CloudWatSSA   * xyz_DelCloudWatOptDep   &
   466            &   + xyz_CloudIceAF    * xyz_CloudIceSSA   * xyz_DelCloudIceOptDep   &
   467            &   + 0.0d0             * 0.0d0             * xyz_H2ODelOptDep     )  &
   468            & / ( xyz_ssa * xyz_DelTotOptDep + 1.0d-100 )
   469  
   470  
   471          call RadRTETwoStreamAppSW(        &
   472            & xyz_SSA, xyz_AF,              & ! (in)
   473            & xyr_TotOptDep,                & ! (in)
   474            & xy_SurfAlbedo,                & ! (in)
   475            & SolarFluxTOA, xy_InAngle,     & ! (in)
   476            & xyr_RadUwFlux, xyr_RadDwFlux  & ! (out)
   477            & )
   478  
   479  
   480          xyr_RadUwFlux = xyr_RadUwFlux * KDFWeight
     .  !CDIR NODEP                                                             
     .        do t1242 = 1, xyr_raduwflux.DSC.U1 + 1                            
     .           xyr_raduwflux(t1242-1,t1240+1,t1238) = xyr_raduwflux(t1242-1,  
     .       1      t1240+1,t1238)*kdfweight                                    
     .           xyr_raddwflux(t1242-1,t1240+1,t1238) = xyr_raddwflux(t1242-1,  
     .       1      t1240+1,t1238)*kdfweight                                    
     .           xyr_radsuwflux(t1242-1,t1240+1,t1238) = xyr_radsuwflux(t1242-1,
     .       1      t1240+1,t1238) + xyr_raduwflux(t1242-1,t1240+1,t1238)       
     .           xyr_radsdwflux(t1242-1,t1240+1,t1238) = xyr_radsdwflux(t1242-1,
     .       1      t1240+1,t1238) + xyr_raddwflux(t1242-1,t1240+1,t1238)       
     .        end do                                                            
   481          xyr_RadDwFlux = xyr_RadDwFlux * KDFWeight
   482  
   483          xyr_RadSUwFlux = xyr_RadSUwFlux + xyr_RadUwFlux
   484          xyr_RadSDwFlux = xyr_RadSDwFlux + xyr_RadDwFlux
   485  
   486        end do
   487  
   488      end do
   489  
   490  
   491  
   492  !!$    i = 0
   493  !!$    j = jmax / 2 + 1
   494  !!$    do k = 1, kmax
   495  !!$      write( 73, * ) xyz_Temp(i,j,k), xyz_QH2OVap(i,j,k), &
   496  !!$        & xyz_Press(i,j,k)
   497  !!$    end do
   498  !!$    call flush( 73 )
   499  !!$
   500  !!$    i = 0
   501  !!$    j = jmax / 2 + 1
   502  !!$    do k = 1, kmax
   503  !!$      write( 83, * ) &
   504  !!$        & + (     xyr_RadSFlux(i,j,k-1) - xyr_RadSFlux(i,j,k) )  &
   505  !!$        &     / ( xyr_Press(i,j,k-1)    - xyr_Press(i,j,k) )     &
   506  !!$        &     / 1004.6 * Grav, &
   507  !!$        & xyz_Press(i,j,k)
   508  !!$    end do
   509  !!$    call flush( 83 )
   510  !!$
   511  !!$!    write( 6, * ) '########## ', acos( 1.0d0 / xy_InAngle(i,j) ) * 180.0d0 / 3.141592d0
   512  !!$
   513  !!$
   514  !!$    i = 0
   515  !!$    j = jmax / 2 + 1
   516  !!$    write( 93, * ) '# ', xy_SurfAlbedo(i,j)
   517  !!$    write( 93, * ) '# ', 1.0_DP / xy_InAngle(i,j)
   518  !!$    do k = 0, kmax
   519  !!$      write( 93, * ) xyr_RadSFlux(i,j,k), xyr_Press(i,j,k)
   520  !!$    end do
   521  !!$    call flush( 93 )
   522  !!$    stop
   523  
   524  
   525      ! ׻ַ¬
   526      ! Pause measurement of computation time
   527      !
   528      call TimesetClockStop( module_name )
   529  
   530  
   531    end subroutine RadEarthSWV21Flux
   532  
   533    !--------------------------------------------------------------------------------------
   534  
   535    subroutine RadEarthSWV21Init
   536  
   537      ! ե
   538      ! File I/O support
   539      !
   540      use dc_iounit, only: FileOpen
   541  
   542      ! NAMELIST եϤ˴ؤ桼ƥƥ
   543      ! Utilities for NAMELIST file input
   544      !
   545      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   546  
   547      ! û ()
   548      ! Short wave (insolation) incoming
   549      !
   550      use rad_short_income, only : RadShortIncomeInit
   551  
   552      !
   553      ! Solve radiative transfer equation in two stream approximation
   554      !
   555      use rad_rte_two_stream_app, only: RadRTETwoStreamAppInit
   556  
   557      ! Chou and Lee (1996) ˤûͥǥ
   558      ! Short wave radiation model described by Chou and Lee (1996)
   559      !
   560      use rad_CL1996, only : RadCL1996Init
   561  
   562      ! Chou et al (1998) ˤûѱǥ
   563      ! Cloud model for short wave radiation model described by Chou et al (1998)
   564      !
   565      use rad_C1998, only : RadC1998Init
   566  
   567  
   568      ! ʸ ; Declaration statements
   569      !
   570  
   571      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   572                                ! Unit number for NAMELIST file open
   573      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   574                                ! IOSTAT of NAMELIST read
   575  
   576      ! NAMELIST ѿ
   577      ! NAMELIST group name
   578      !
   579      namelist /rad_Earth_SW_V2_1_nml/ &
   580        & FlagRayleighScattering, &
   581        & SolarConst, &
   582        & CloudWatREff, CloudIceREff
   583            !
   584            ! ǥեͤˤĤƤϽ³ "rad_Earth_SW_V2_1#RadEarthSWV21Init"
   585            ! Υɤ򻲾ȤΤ.
   586            !
   587            ! Refer to source codes in the initialization procedure
   588            ! "rad_Earth_SW_V2_1#RadEarthSWEV21Init" for the default values.
   589            !
   590  
   591      if ( rad_Earth_SW_V2_1_inited ) return
   592  
   593  
   594      ! ǥեͤ
   595      ! Default values settings
   596      !
   597      FlagRayleighScattering = .true.
   598  
   599  !!$    SolarConst             = 1380.0_DP
   600      SolarConst             = 1366.0_DP
   601  
   602      CloudWatREff           = 10.0d-6
   603      CloudIceREff           = 50.0d-6
   604  
   605      ! NAMELIST ɤ߹
   606      ! NAMELIST is input
   607      !
   608      if ( trim(namelist_filename) /= '' ) then
   609        call FileOpen( unit_nml, &          ! (out)
   610          & namelist_filename, mode = 'r' ) ! (in)
   611  
   612        rewind( unit_nml )
   613        read( unit_nml,                          & ! (in)
   614          & nml = rad_Earth_SW_V2_1_nml,         & ! (out)
   615          & iostat = iostat_nml )                  ! (out)
   616        close( unit_nml )
   617  
   618        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   619      end if
   620  
   621  
   622  
   623      ! Initialization of modules used in this module
   624      !
   625  
   626      ! û ()
   627      ! Short wave (insolation) incoming
   628      !
   629      call RadShortIncomeInit
   630  
   631      !
   632      ! Solve radiative transfer equation in two stream approximation
   633      !
   634      call RadRTETwoStreamAppInit
   635  
   636      ! Chou and Lee (1996) ˤûͥǥ
   637      ! Short wave radiation model described by Chou and Lee (1996)
   638      !
   639      call RadCL1996Init
   640  
   641      ! Chou et al (1998) ˤûѱǥ
   642      ! Cloud model for short wave radiation model described by Chou et al (1998)
   643      !
   644      call RadC1998Init
   645  
   646  
   647      !  ; Print
   648      !
   649      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   650      call MessageNotify( 'M', module_name, 'FlagRayleighScattering = %b', l = (/ FlagRayleighScattering /) )
   651      call MessageNotify( 'M', module_name, 'SolarConst             = %f', d = (/ SolarConst /) )
   652      call MessageNotify( 'M', module_name, 'CloudWatREff           = %f', &
   653        & d = (/ CloudWatREff /) )
   654      call MessageNotify( 'M', module_name, 'CloudIceREff           = %f', &
   655        & d = (/ CloudIceREff /) )
   656      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   657  
   658  
   659      rad_Earth_SW_V2_1_inited = .true.
   660  
   661    end subroutine RadEarthSWV21Init
   662  
   663    !--------------------------------------------------------------------------------------
   664  
   665  end module rad_Earth_SW_V2_1
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:30 2012
FILE NAME: rad_Earth_SW_V2_1.f90
PROGRAM NAME: rad_earth_sw_v2_1
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ϵ絤ûͥǥ Ver. 2.1
     2:            !
     3:            != short wave radiation model for the Earth's atmosphere Ver. 2.1
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: rad_Earth_SW_V2_1.f90,v 1.5 2012-09-08 15:24:05 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            module rad_Earth_SW_V2_1
    12:            
    13:              !
    14:              != ϵ絤ûͥǥ Ver. 2.1
    15:              !
    16:              != short wave radiation model for the Earth's atmosphere Ver. 2.1
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ϵ絤ûͥǥ.
    21:              !
    22:              ! This is a short wave radiation model for the Earth's atmospehre.
    23:              !
    24:              ! The wavenumber range of shortwave radiation treated by this routine is 
    25:              ! from 1000 to 57143 cm-1 (0.175 to 10 micron). 
    26:              !
    27:              ! From 1000 to 57143 cm-1, the following effects are considered. 
    28:              ! * 1000 to 14286 cm-1 (0.70-10 micron): 
    29:              !   * absorption by H2O, 
    30:              !     * absorption by H2O is considered by using k-distribution method 
    31:              !       following Chou and Lee (1996), 
    32:              !   * absorption and scattering by cloud droplets.
    33:              !     * optical properties of cloud is obtained from Chou et al. (1998)
    34:              ! * 14286 to 57143 cm-1 (0.175 to 0.70 micron): 
    35:              !   * Rayleigh scattering, 
    36:              !     * scattering coefficient is obtained from Chou and Lee (1996), 
    37:              !   * scattering by cloud droplets. 
    38:              !     * optical properties of cloud is obtained from Chou et al. (1998)
    39:              !
    40:              !
    41:              !== References
    42:              !
    43:              !  Chou, M.-D., and K.-T. Lee, 
    44:              !    Parameterizations for the absorption of solar radiation by water vapor and ozone,
    45:              !    J. Atmos. Sci., 53, 1203-1208, 1996.
    46:              !
    47:              !  Chou, M.-D., M. J. Suarez, C.-H. Ho, M. M.-H. Yan, and K.-T. Lee, 
    48:              !    Parameterizations for cloud overlapping and shortwave single-scattering 
    49:              !    properties for use in general circulation and cloud ensemble models, 
    50:              !    J. Climate, 11, 202-214, 1998.
    51:              !
    52:              !== Procedures List
    53:              !
    54:              ! RadEarthSWV21Flux   :: ͥեåη׻
    55:              ! ------------        :: ------------
    56:              ! RadEarthSWV21Flux   :: Calculate radiation flux
    57:              !
    58:              !== NAMELIST
    59:              !
    60:              ! NAMELIST#rad_Earth_SW_V2_1_nml
    61:              !
    62:            
    63:              ! USE statements
    64:              !
    65:            
    66:              !
    67:              ! Kind type parameter
    68:              !
    69:              use dc_types, only: DP, &      ! Double precision.
    70:                &                 STRING, &  ! Strings.
    71:                &                 TOKEN      ! Keywords.
    72:            
    73:              ! å
    74:              ! Message output
    75:              !
    76:              use dc_message, only: MessageNotify
    77:            
    78:            
    79:              ! ʻ
    80:              ! Grid points settings
    81:              !
    82:              use gridset, only: imax, & ! ٳʻ.
    83:                                         ! Number of grid points in longitude
    84:                &                jmax, & ! ٳʻ.
    85:                                         ! Number of grid points in latitude
    86:                &                kmax    ! ľؿ.
    87:                                         ! Number of vertical level
    88:            
    89:              ! 
    90:              ! Time control
    91:              !
    92:              use timeset, only: &
    93:                & TimesetClockStart, TimesetClockStop
    94:            
    95:              implicit none
    96:            
    97:              private
    98:            
    99:              logical , save      :: FlagRayleighScattering
   100:              real(DP), save      :: SolarConst
   101:            
   102:            
   103:              real(DP), save      :: CloudWatREff
   104:              real(DP), save      :: CloudIceREff
   105:            
   106:            
   107:              ! ѿ
   108:              ! Public variables
   109:              !
   110:              logical, save :: rad_Earth_SW_V2_1_inited = .false.
   111:                                          ! ե饰.
   112:                                          ! Initialization flag
   113:            
   114:              public :: RadEarthSWV21Flux
   115:              public :: RadEarthSWV21Init
   116:            
   117:              character(*), parameter:: module_name = 'rad_Earth_SW_V2_1'
   118:                                          ! ⥸塼̾.
   119:                                          ! Module name
   120:              character(*), parameter:: version = &
   121:                & '$Name: dcpam5-20120921 $' // &
   122:                & '$Id: rad_Earth_SW_V2_1.f90,v 1.5 2012-09-08 15:24:05 yot Exp $'
   123:                                          ! ⥸塼ΥС
   124:                                          ! Module version
   125:            
   126:              !--------------------------------------------------------------------------------------
   127:            
   128:            contains
   129:            
   130:              !--------------------------------------------------------------------------------------
   131:            
   132:              subroutine RadEarthSWV21Flux(                                &
   133:                & xy_SurfAlbedo,                                           &
   134:                & xyz_DelAtmMass,                                          &
   135:                & xyz_DelH2OVapMass, xyz_DelH2OLiqMass, xyz_DelH2OSolMass, &
   136:                & xyz_DelO3Mass,                                           &
   137:                & xyz_Press, xyz_Temp,                                     &
   138:                & xyz_CloudCover,                                          &
   139:                & xyr_RadSUwFlux, xyr_RadSDwFlux                           &
   140:                & )
   141:            
   142:                ! USE statements
   143:                !
   144:            
   145:                ! û ()
   146:                ! Short wave (insolation) incoming
   147:                !
   148:                use rad_short_income, only : RadShortIncome
   149:            
   150:                !
   151:                ! Solve radiative transfer equation in two stream approximation
   152:                !
   153:                use rad_rte_two_stream_app, only: RadRTETwoStreamAppSW
   154:            
   155:                ! Chou and Lee (1996) ˤûͥǥ
   156:                ! Short wave radiation model described by Chou and Lee (1996)
   157:                !
   158:                use rad_CL1996, only :       &
   159:                  & RadCL1996NumBands      , &
   160:                  & RadCL1996UVVISParams   , &
   161:                  & RadCL1996IRH2ONumKDFBin, &
   162:                  & RadCL1996IRH2OKDFParams, &
   163:                  & RadCL1996ScaleH2OVapMass
   164:            
   165:            
   166:                ! Chou et al (1998) ˤûѱǥ
   167:                ! Cloud model for short wave radiation model described by Chou et al (1998)
   168:                !
   169:                use rad_C1998, only : RadC1998CalcCloudOptProp
   170:            
   171:            
   172:                real(DP), intent(in ) :: xy_SurfAlbedo    (0:imax-1, 1:jmax )
   173:                real(DP), intent(in ) :: xyz_DelAtmMass   (0:imax-1, 1:jmax, 1:kmax)
   174:                real(DP), intent(in ) :: xyz_DelH2OVapMass(0:imax-1, 1:jmax, 1:kmax)
   175:                real(DP), intent(in ) :: xyz_DelH2OLiqMass(0:imax-1, 1:jmax, 1:kmax)
   176:                real(DP), intent(in ) :: xyz_DelH2OSolMass(0:imax-1, 1:jmax, 1:kmax)
   177:                real(DP), intent(in ) :: xyz_DelO3Mass    (0:imax-1, 1:jmax, 1:kmax)
   178:                real(DP), intent(in ) :: xyz_Press        (0:imax-1, 1:jmax, 1:kmax)
   179:                real(DP), intent(in ) :: xyz_Temp         (0:imax-1, 1:jmax, 1:kmax)
   180:                real(DP), intent(in ) :: xyz_CloudCover   (0:imax-1, 1:jmax, 1:kmax)
   181:                real(DP), intent(out) :: xyr_RadSUwFlux   (0:imax-1, 1:jmax, 0:kmax)
   182:                real(DP), intent(out) :: xyr_RadSDwFlux   (0:imax-1, 1:jmax, 0:kmax)
   183:            
   184:            
   185:                real(DP) :: xy_InAngle    (0:imax-1, 1:jmax)
   186:                                          ! sec (ͳ).
   187:                                          ! sec (angle of incidence)
   188:                real(DP) :: DistFromStarScld
   189:                                           ! Distance between the central star and the planet
   190:                real(DP) :: DiurnalMeanFactor
   191:            
   192:            
   193:                integer  :: nbands1
   194:                integer  :: nbands2
   195:            
   196:                real(DP) :: UVVISFracSolarFlux
   197:                real(DP) :: UVVISO3AbsCoef
   198:                real(DP) :: UVVISRayScatCoef
   199:            
   200:                real(DP) :: SolarFluxTOA
   201:            
   202:            
   203:            
   204:                real(DP) :: xyz_SSA       (0:imax-1, 1:jmax, 1:kmax)
   205:                real(DP) :: xyz_AF        (0:imax-1, 1:jmax, 1:kmax)
   206:            
   207:            
   208:                real(DP), parameter :: RayScatSinScatAlb = 1.0d0 - 1.0d-10
   209:                real(DP), parameter :: RayScatAsymFact   = 0.0d0
   210:            
   211:                real(DP)            :: xyz_DelH2OVapMassScaled( 0:imax-1, 1:jmax, 1:kmax )
   212:            
   213:                real(DP)            :: xyz_DelCloudWatOptDep( 0:imax-1, 1:jmax, 1:kmax )
   214:                real(DP)            :: xyz_DelCloudIceOptDep( 0:imax-1, 1:jmax, 1:kmax )
   215:            
   216:                real(DP)            :: xyz_RayScatDelOptDep( 0:imax-1, 1:jmax, 1:kmax )
   217:            
   218:                real(DP)            :: xyz_O3AbsDelOptDep  ( 0:imax-1, 1:jmax, 1:kmax )
   219:            
   220:                real(DP)            :: xyz_DelTotOptDep( 0:imax-1, 1:jmax, 1:kmax )
   221:                real(DP)            :: xyr_TotOptDep   ( 0:imax-1, 1:jmax, 0:kmax )
   222:                real(DP)            :: xyr_RadFlux     ( 0:imax-1, 1:jmax, 0:kmax )
   223:                real(DP)            :: xyr_RadUwFlux   ( 0:imax-1, 1:jmax, 0:kmax )
   224:                real(DP)            :: xyr_RadDwFlux   ( 0:imax-1, 1:jmax, 0:kmax )
   225:            
   226:                integer  :: nkdf
   227:            
   228:                integer  :: ikdfbin
   229:                real(DP) :: KDFAbsCoef
   230:                real(DP) :: KDFWeight
   231:                real(DP) :: xyz_H2ODelOptDep( 0:imax-1, 1:jmax, 1:kmax )
   232:            
   233:            
   234:                real(DP) :: xyz_CloudREff   (0:imax-1, 1:jmax, 1:kmax)
   235:                real(DP) :: xyz_CloudExtCoef(0:imax-1, 1:jmax, 1:kmax)
   236:                real(DP) :: xyz_CloudCoAlb  (0:imax-1, 1:jmax, 1:kmax)
   237:                real(DP) :: xyz_CloudWatSSA (0:imax-1, 1:jmax, 1:kmax)
   238:                real(DP) :: xyz_CloudWatAF  (0:imax-1, 1:jmax, 1:kmax)
   239:                real(DP) :: xyz_CloudIceSSA (0:imax-1, 1:jmax, 1:kmax)
   240:                real(DP) :: xyz_CloudIceAF  (0:imax-1, 1:jmax, 1:kmax)
   241:            
   242:            
   243:            
   244:                integer  :: i
   245:                integer  :: j
   246:                integer  :: k
   247:                integer  :: l
   248:            
   249:            
   250:                ! ǧ
   251:                ! Initialization check
   252:                !
   253:                if ( .not. rad_Earth_SW_V2_1_inited ) then
   254:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   255:                end if
   256:            
   257:            
   258:                ! ׻ַ¬
   259:                ! Start measurement of computation time
   260:                !
   261:                call TimesetClockStart( module_name )
   262:            
   263:            
   264:                ! ûͤη׻
   265:                ! Calculate short wave (insolation) incoming radiation
   266:                !
   267:                call RadShortIncome(                       &
   268:                  & xy_InAngle        = xy_InAngle,        & ! (out) optional
   269:                  & DistFromStarScld  = DistFromStarScld,  & ! (out) optional
   270:                  & DiurnalMeanFactor = DiurnalMeanFactor  &
   271:                  & )
   272:            
   273:            
   274:                call RadCL1996NumBands(   &
   275:                  & nbands1, nbands2      & ! (out)
   276:                  & )
   277:            
   278:            
   279:                ! Initialization
   280:                !
   281: **W---->       xyr_RadSUwFlux = 0.0_DP
   282: **W----        xyr_RadSDwFlux = 0.0_DP
   283:            
   284:            
   285:                ! * 14286 to 57143 cm-1 (0.175 to 0.70 micron): 
   286:                !   * Rayleigh scattering, 
   287:                !   * scattering by cloud droplets. 
   288:                !   * O3 absorption
   289:                !
   290: +------>       do l = 1, nbands1
   291: |          
   292: |                ! Water cloud optical properties
   293: |                !
   294: |++V===          xyz_CloudREff = CloudWatREff
   295: |                call RadC1998CalcCloudOptProp(                        &
   296: |                  & 'Liquid', l, xyz_CloudREff,                       & ! (in )
   297: |                  & xyz_CloudExtCoef, xyz_CloudCoAlb, xyz_CloudWatAF  & ! (out)
   298: |                  & )
   299: |**V--->         xyz_DelCloudWatOptDep = xyz_CloudExtCoef * xyz_DelH2OLiqMass
   300: ||||             xyz_CloudWatSSA       = 1.0_DP - xyz_CloudCoAlb
   301: ||||       
   302: ||||             ! Ice cloud optical properties
   303: ||||             !
   304: |**V---          xyz_CloudREff = CloudIceREff
   305: |                call RadC1998CalcCloudOptProp(                        &
   306: |                  & 'Ice', l, xyz_CloudREff,                          & ! (in )
   307: |                  & xyz_CloudExtCoef, xyz_CloudCoAlb, xyz_CloudIceAF  & ! (out)
   308: |                  & )
   309: |**V--->         xyz_DelCloudIceOptDep = xyz_CloudExtCoef * xyz_DelH2OSolMass
   310: |**V---          xyz_CloudIceSSA       = 1.0_DP - xyz_CloudCoAlb
   311: |          
   312: |          
   313: |                ! UV and Visible optical properties and solar flux
   314: |                !
   315: |                call RadCL1996UVVISParams(                                &
   316: |                  & l,                                                    & ! (in )
   317: |                  & UVVISFracSolarFlux, UVVISO3AbsCoef, UVVISRayScatCoef  & ! (out)
   318: |                  & )
   319: |          
   320: |                SolarFluxTOA = UVVISFracSolarFlux * SolarConst / DistFromStarScld**2 * DiurnalMeanFactor
   321: |          
   322: |          
   323: |                ! Rayleigh scattering
   324: |                !
   325: |                if ( FlagRayleighScattering ) then
   326: |++V===            xyz_RayScatDelOptDep = UVVISRayScatCoef * xyz_DelAtmMass
   327: |                else
   328: |++V===            xyz_RayScatDelOptDep = 0.0d0
   329: |                end if
   330: |          
   331: |          
   332: |                ! O3 absorption
   333: |                !
   334: |**V--->         xyz_O3AbsDelOptDep = UVVISO3AbsCoef * xyz_DelO3Mass
   335: ||||       
   336: ||||       
   337: ||||             ! Total optical parameter
   338: ||||             !
   339: |**V---          xyz_DelTotOptDep =            &
   340: |                  &   xyz_DelCloudWatOptDep   &
   341: |                  & + xyz_DelCloudIceOptDep   &
   342: |                  & + xyz_RayScatDelOptDep    &
   343: |                  & + xyz_O3AbsDelOptDep
   344: |                !
   345: |+V====          xyr_TotOptDep(:,:,kmax) = 0.0d0
   346: |+----->         do k = kmax-1, 0, -1
   347: ||+V===            xyr_TotOptDep(:,:,k) = xyr_TotOptDep(:,:,k+1) + xyz_DelTotOptDep(:,:,k+1)
   348: |+-----          end do
   349: |                !
   350: |++V===          xyz_SSA =                                           &
   351: |                  &   ( xyz_CloudWatSSA   * xyz_DelCloudWatOptDep   &
   352: |                  &   + xyz_CloudIceSSA   * xyz_DelCloudIceOptDep   &
   353: |                  &   + RayScatSinScatAlb * xyz_RayScatDelOptDep    &
   354: |                  &   + 0.0d0             * xyz_O3AbsDelOptDep   )  &
   355: |                  & / ( xyz_DelTotOptDep + 1.0d-100 )
   356: |+----->         do k = 1, kmax
   357: ||+---->           do j = 1, jmax
   358: |||V--->             do i = 0, imax-1
   359: ||||                   if ( xyz_SSA(i,j,k) >= 1.0d0 ) then
   360: ||||                     xyz_SSA(i,j,k) = 1.0d0 - 1.0d-10
   361: ||||                   end if
   362: |||V---              end do
   363: ||+----            end do
   364: |+-----          end do
   365: |++V===          xyz_AF  =                                                               &
   366: |                  &   ( xyz_CloudWatAF    * xyz_CloudWatSSA   * xyz_DelCloudWatOptDep   &
   367: |                  &   + xyz_CloudIceAF    * xyz_CloudIceSSA   * xyz_DelCloudIceOptDep   &
   368: |                  &   + RayScatAsymFact   * RayScatSinScatAlb * xyz_RayScatDelOptDep    &
   369: |                  &   + 0.0d0             * 0.0d0             * xyz_O3AbsDelOptDep   )  &
   370: |                  & / ( xyz_SSA * xyz_DelTotOptDep + 1.0d-100 )
   371: |          
   372: |          
   373: |                call RadRTETwoStreamAppSW(        &
   374: |                  & xyz_SSA, xyz_AF,              & ! (in)
   375: |                  & xyr_TotOptDep,                & ! (in)
   376: |                  & xy_SurfAlbedo,                & ! (in)
   377: |                  & SolarFluxTOA, xy_InAngle,     & ! (in)
   378: |                  & xyr_RadUwFlux, xyr_RadDwFlux  & ! (out)
   379: |                  & )
   380: |          
   381: |**V--->         xyr_RadSUwFlux = xyr_RadSUwFlux + xyr_RadUwFlux
   382: |**V---          xyr_RadSDwFlux = xyr_RadSDwFlux + xyr_RadDwFlux
   383: |          
   384: +------        end do
   385:            
   386:            
   387:                ! * 1000 to 14286 cm-1 (0.70-10 micron): 
   388:                !   * absorption by H2O, 
   389:                !   * scattering by cloud droplets.
   390:                !
   391:            
   392:                call RadCL1996ScaleH2OVapMass(              &
   393:                  & xyz_Temp, xyz_DelH2OVapMass, xyz_Press, & ! (in )
   394:                  & xyz_DelH2OVapMassScaled                 & ! (out)
   395:                  & )
   396:            
   397:            
   398:                call RadCL1996IRH2ONumKDFBin( &
   399:                  & nkdf & ! (out)
   400:                  & )
   401:            
   402:            
   403:                SolarFluxTOA = SolarConst / DistFromStarScld**2 * DiurnalMeanFactor
   404:            
   405: +------>       do l = nbands1+1, nbands1+nbands2
   406: |          
   407: |                ! Water cloud optical properties
   408: |                !
   409: |++V===          xyz_CloudREff = CloudWatREff
   410: |                call RadC1998CalcCloudOptProp(                        &
   411: |                  & 'Liquid', l, xyz_CloudREff,                       & ! (in )
   412: |                  & xyz_CloudExtCoef, xyz_CloudCoAlb, xyz_CloudWatAF  & ! (out)
   413: |                  & )
   414: |**V--->         xyz_DelCloudWatOptDep = xyz_CloudExtCoef * xyz_DelH2OLiqMass
   415: ||||             xyz_CloudWatSSA       = 1.0_DP - xyz_CloudCoAlb
   416: ||||       
   417: ||||             ! Ice cloud optical properties
   418: ||||             !
   419: |**V---          xyz_CloudREff = CloudIceREff
   420: |                call RadC1998CalcCloudOptProp(                        &
   421: |                  & 'Ice', l, xyz_CloudREff,                          & ! (in )
   422: |                  & xyz_CloudExtCoef, xyz_CloudCoAlb, xyz_CloudIceAF  & ! (out)
   423: |                  & )
   424: |**V--->         xyz_DelCloudIceOptDep = xyz_CloudExtCoef * xyz_DelH2OSolMass
   425: |**V---          xyz_CloudIceSSA       = 1.0_DP - xyz_CloudCoAlb
   426: |          
   427: |          
   428: |+----->         do ikdfbin = 1, nkdf
   429: ||         
   430: ||                 call RadCL1996IRH2OKDFParams(              &
   431: ||                   & l, ikdfbin,                            & ! (in )
   432: ||                   & KDFAbsCoef, KDFWeight                  & ! (out)
   433: ||                   & )
   434: ||         
   435: ||**V-->           xyz_H2ODelOptDep = KDFAbsCoef * xyz_DelH2OVapMassScaled
   436: |||||      
   437: |||||      
   438: |||||              ! Total optical parameter
   439: |||||              !
   440: ||**V--            xyz_DelTotOptDep =          &
   441: ||                   &   xyz_DelCloudWatOptDep &
   442: ||                   & + xyz_DelCloudIceOptDep &
   443: ||                   & + xyz_H2ODelOptDep
   444: ||         
   445: ||+V===            xyr_TotOptDep(:,:,kmax) = 0.0d0
   446: ||+---->           do k = kmax-1, 0, -1
   447: |||+V==              xyr_TotOptDep(:,:,k) = xyr_TotOptDep(:,:,k+1) + xyz_DelTotOptDep(:,:,k+1)
   448: ||+----            end do
   449: ||         
   450: ||++V==            xyz_SSA =                                            &
   451: ||                   &   ( xyz_CloudWatSSA   * xyz_DelCloudWatOptDep    &
   452: ||                   &   + xyz_CloudIceSSA   * xyz_DelCloudIceOptDep    &
   453: ||                   &   + 0.0d0             * xyz_H2ODelOptDep      )  &
   454: ||                   & / ( xyz_DelTotOptDep + 1.0d-100 )
   455: ||+---->           do k = 1, kmax
   456: |||+--->             do j = 1, jmax
   457: ||||V-->               do i = 0, imax-1
   458: |||||                    if ( xyz_SSA(i,j,k) >= 1.0d0 ) then
   459: |||||                      xyz_SSA(i,j,k) = 1.0d0 - 1.0d-10
   460: |||||                    end if
   461: ||||V--                end do
   462: |||+---              end do
   463: ||+----            end do
   464: ||++V==            xyz_AF  =                                                               &
   465: ||                   &   ( xyz_CloudWatAF    * xyz_CloudWatSSA   * xyz_DelCloudWatOptDep   &
   466: ||                   &   + xyz_CloudIceAF    * xyz_CloudIceSSA   * xyz_DelCloudIceOptDep   &
   467: ||                   &   + 0.0d0             * 0.0d0             * xyz_H2ODelOptDep     )  &
   468: ||                   & / ( xyz_ssa * xyz_DelTotOptDep + 1.0d-100 )
   469: ||         
   470: ||         
   471: ||                 call RadRTETwoStreamAppSW(        &
   472: ||                   & xyz_SSA, xyz_AF,              & ! (in)
   473: ||                   & xyr_TotOptDep,                & ! (in)
   474: ||                   & xy_SurfAlbedo,                & ! (in)
   475: ||                   & SolarFluxTOA, xy_InAngle,     & ! (in)
   476: ||                   & xyr_RadUwFlux, xyr_RadDwFlux  & ! (out)
   477: ||                   & )
   478: ||         
   479: ||         
   480: ||**V-->           xyr_RadUwFlux = xyr_RadUwFlux * KDFWeight
   481: |||||              xyr_RadDwFlux = xyr_RadDwFlux * KDFWeight
   482: |||||      
   483: |||||              xyr_RadSUwFlux = xyr_RadSUwFlux + xyr_RadUwFlux
   484: ||**V--            xyr_RadSDwFlux = xyr_RadSDwFlux + xyr_RadDwFlux
   485: ||         
   486: |+-----          end do
   487: |          
   488: +------        end do
   489:            
   490:            
   491:            
   492:            !!$    i = 0
   493:            !!$    j = jmax / 2 + 1
   494:            !!$    do k = 1, kmax
   495:            !!$      write( 73, * ) xyz_Temp(i,j,k), xyz_QH2OVap(i,j,k), &
   496:            !!$        & xyz_Press(i,j,k)
   497:            !!$    end do
   498:            !!$    call flush( 73 )
   499:            !!$
   500:            !!$    i = 0
   501:            !!$    j = jmax / 2 + 1
   502:            !!$    do k = 1, kmax
   503:            !!$      write( 83, * ) &
   504:            !!$        & + (     xyr_RadSFlux(i,j,k-1) - xyr_RadSFlux(i,j,k) )  &
   505:            !!$        &     / ( xyr_Press(i,j,k-1)    - xyr_Press(i,j,k) )     &
   506:            !!$        &     / 1004.6 * Grav, &
   507:            !!$        & xyz_Press(i,j,k)
   508:            !!$    end do
   509:            !!$    call flush( 83 )
   510:            !!$
   511:            !!$!    write( 6, * ) '########## ', acos( 1.0d0 / xy_InAngle(i,j) ) * 180.0d0 / 3.141592d0
   512:            !!$
   513:            !!$
   514:            !!$    i = 0
   515:            !!$    j = jmax / 2 + 1
   516:            !!$    write( 93, * ) '# ', xy_SurfAlbedo(i,j)
   517:            !!$    write( 93, * ) '# ', 1.0_DP / xy_InAngle(i,j)
   518:            !!$    do k = 0, kmax
   519:            !!$      write( 93, * ) xyr_RadSFlux(i,j,k), xyr_Press(i,j,k)
   520:            !!$    end do
   521:            !!$    call flush( 93 )
   522:            !!$    stop
   523:            
   524:            
   525:                ! ׻ַ¬
   526:                ! Pause measurement of computation time
   527:                !
   528:                call TimesetClockStop( module_name )
   529:            
   530:            
   531:              end subroutine RadEarthSWV21Flux
   532:            
   533:              !--------------------------------------------------------------------------------------
   534:            
   535:              subroutine RadEarthSWV21Init
   536:            
   537:                ! ե
   538:                ! File I/O support
   539:                !
   540:                use dc_iounit, only: FileOpen
   541:            
   542:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   543:                ! Utilities for NAMELIST file input
   544:                !
   545:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   546:            
   547:                ! û ()
   548:                ! Short wave (insolation) incoming
   549:                !
   550:                use rad_short_income, only : RadShortIncomeInit
   551:            
   552:                !
   553:                ! Solve radiative transfer equation in two stream approximation
   554:                !
   555:                use rad_rte_two_stream_app, only: RadRTETwoStreamAppInit
   556:            
   557:                ! Chou and Lee (1996) ˤûͥǥ
   558:                ! Short wave radiation model described by Chou and Lee (1996)
   559:                !
   560:                use rad_CL1996, only : RadCL1996Init
   561:            
   562:                ! Chou et al (1998) ˤûѱǥ
   563:                ! Cloud model for short wave radiation model described by Chou et al (1998)
   564:                !
   565:                use rad_C1998, only : RadC1998Init
   566:            
   567:            
   568:                ! ʸ ; Declaration statements
   569:                !
   570:            
   571:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   572:                                          ! Unit number for NAMELIST file open
   573:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   574:                                          ! IOSTAT of NAMELIST read
   575:            
   576:                ! NAMELIST ѿ
   577:                ! NAMELIST group name
   578:                !
   579:                namelist /rad_Earth_SW_V2_1_nml/ &
   580:                  & FlagRayleighScattering, &
   581:                  & SolarConst, &
   582:                  & CloudWatREff, CloudIceREff
   583:                      !
   584:                      ! ǥեͤˤĤƤϽ³ "rad_Earth_SW_V2_1#RadEarthSWV21Init"
   585:                      ! Υɤ򻲾ȤΤ.
   586:                      !
   587:                      ! Refer to source codes in the initialization procedure
   588:                      ! "rad_Earth_SW_V2_1#RadEarthSWEV21Init" for the default values.
   589:                      !
   590:            
   591:                if ( rad_Earth_SW_V2_1_inited ) return
   592:            
   593:            
   594:                ! ǥեͤ
   595:                ! Default values settings
   596:                !
   597:                FlagRayleighScattering = .true.
   598:            
   599:            !!$    SolarConst             = 1380.0_DP
   600:                SolarConst             = 1366.0_DP
   601:            
   602:                CloudWatREff           = 10.0d-6
   603:                CloudIceREff           = 50.0d-6
   604:            
   605:                ! NAMELIST ɤ߹
   606:                ! NAMELIST is input
   607:                !
   608:                if ( trim(namelist_filename) /= '' ) then
   609:                  call FileOpen( unit_nml, &          ! (out)
   610:                    & namelist_filename, mode = 'r' ) ! (in)
   611:            
   612:                  rewind( unit_nml )
   613:                  read( unit_nml,                          & ! (in)
   614:                    & nml = rad_Earth_SW_V2_1_nml,         & ! (out)
   615:                    & iostat = iostat_nml )                  ! (out)
   616:                  close( unit_nml )
   617:            
   618:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   619:                end if
   620:            
   621:            
   622:            
   623:                ! Initialization of modules used in this module
   624:                !
   625:            
   626:                ! û ()
   627:                ! Short wave (insolation) incoming
   628:                !
   629:                call RadShortIncomeInit
   630:            
   631:                !
   632:                ! Solve radiative transfer equation in two stream approximation
   633:                !
   634:                call RadRTETwoStreamAppInit
   635:            
   636:                ! Chou and Lee (1996) ˤûͥǥ
   637:                ! Short wave radiation model described by Chou and Lee (1996)
   638:                !
   639:                call RadCL1996Init
   640:            
   641:                ! Chou et al (1998) ˤûѱǥ
   642:                ! Cloud model for short wave radiation model described by Chou et al (1998)
   643:                !
   644:                call RadC1998Init
   645:            
   646:            
   647:                !  ; Print
   648:                !
   649:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   650:                call MessageNotify( 'M', module_name, 'FlagRayleighScattering = %b', l = (/ FlagRayleighScattering /) )
   651:                call MessageNotify( 'M', module_name, 'SolarConst             = %f', d = (/ SolarConst /) )
   652:                call MessageNotify( 'M', module_name, 'CloudWatREff           = %f', &
   653:                  & d = (/ CloudWatREff /) )
   654:                call MessageNotify( 'M', module_name, 'CloudIceREff           = %f', &
   655:                  & d = (/ CloudIceREff /) )
   656:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   657:            
   658:            
   659:                rad_Earth_SW_V2_1_inited = .true.
   660:            
   661:              end subroutine RadEarthSWV21Init
   662:            
   663:              !--------------------------------------------------------------------------------------
   664:            
   665:            end module rad_Earth_SW_V2_1
