Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:04 2012
FILE NAME: rad_simple_LW.f90
PROGRAM NAME: rad_simple_lw
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   258  opt  (  11): Fused array assignments. :line 258 - 259
   258  opt  (1593): Loop nest collapsed into one loop.
   258  vec  (   4): Vectorized array expression.
   260  opt  (  11): Fused array assignments. :line 260 - 261
   260  opt  (1772): Loop nest fused with following nest(s).
   260  opt  (1593): Loop nest collapsed into one loop.
   260  vec  (   4): Vectorized array expression.
   271  opt  (1592): Outer loop unrolled inside inner loop.
   271  vec  (   4): Vectorized array expression.
   271  vec  (   4): Vectorized array expression.
   272  opt  (1592): Outer loop unrolled inside inner loop.
   272  vec  (   4): Vectorized array expression.
   272  vec  (   4): Vectorized array expression.
   273  opt  (  11): Fused array assignments. :line 273 - 274
   273  vec  (   4): Vectorized array expression.
   273  vec  (   4): Vectorized array expression.
   274  opt  (1592): Outer loop unrolled inside inner loop.
   280  opt  (1017): Subroutine call prevents optimization.
   303  opt  (1592): Outer loop unrolled inside inner loop.
   303  vec  (   4): Vectorized array expression.
   303  vec  (   4): Vectorized array expression.
   304  opt  (1592): Outer loop unrolled inside inner loop.
   304  vec  (   4): Vectorized array expression.
   304  vec  (   4): Vectorized array expression.
   305  opt  (  11): Fused array assignments. :line 305 - 306
   305  vec  (   4): Vectorized array expression.
   305  vec  (   4): Vectorized array expression.
   306  opt  (1592): Outer loop unrolled inside inner loop.
   314  opt  (  11): Fused array assignments. :line 314 - 325
   314  vec  (   4): Vectorized array expression.
   314  vec  (   4): Vectorized array expression.
   325  opt  (1592): Outer loop unrolled inside inner loop.
   328  opt  (1592): Outer loop unrolled inside inner loop.
   328  vec  (   4): Vectorized array expression.
   328  vec  (   4): Vectorized array expression.
   330  vec  (   3): Unvectorized loop.
   330  vec  (  13): Overhead of loop division is too large.
   331  opt  (1037): Feedback of array elements.
   331  opt  (1036): Potential feedback - use directive if OK.
   331  opt  (1592): Outer loop unrolled inside inner loop.
   331  vec  (   4): Vectorized array expression.
   331  vec  (   4): Vectorized array expression.
   333  vec  (   3): Unvectorized loop.
   333  vec  (  13): Overhead of loop division is too large.
   334  opt  (1592): Outer loop unrolled inside inner loop.
   334  vec  (   4): Vectorized array expression.
   334  vec  (   4): Vectorized array expression.
   347  opt  (  11): Fused array assignments. :line 347 - 348
   347  vec  (   4): Vectorized array expression.
   347  vec  (   4): Vectorized array expression.
   348  opt  (1592): Outer loop unrolled inside inner loop.
   349  opt  (  11): Fused array assignments. :line 349 - 350
   349  opt  (1772): Loop nest fused with following nest(s).
   349  vec  (   4): Vectorized array expression.
   507  vec  (   4): Vectorized array expression.
   508  opt  (  11): Fused array assignments. :line 508 - 513
   508  vec  (   4): Vectorized array expression.
   515  opt  (  11): Fused array assignments. :line 515 - 521
   548  vec  (   4): Vectorized array expression.
   550  opt  (  11): Fused array assignments. :line 550 - 557
   550  vec  (   4): Vectorized array expression.
   594  vec  (   3): Unvectorized loop.
   595  opt  (1017): Subroutine call prevents optimization.
   595  vec  (  10): Vectorization obstructive procedure reference.:messagenotifyc
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:04 2012
FILE NAME: rad_simple_LW.f90
PROGRAM NAME: rad_simple_lw
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ͥեå (ñĹȥХɥǥ)
     2  !
     3  != Radiation flux (simple longwave band model)
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: rad_simple_LW.f90,v 1.2 2012-02-01 05:19:54 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module rad_simple_LW
    13    !
    14    != ͥեå (ñĹȥХɥǥ)
    15    !
    16    != Radiation flux (simple longwave band model)
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! , 漾, , ͥեå׻ͥǥǤ.
    21    !
    22    ! This is a radiation model that calculates radiation flux from
    23    ! temperature, specific humidity, and air pressure.
    24    !
    25    !== References
    26    !
    27    !
    28    !
    29    !== Procedures List
    30    !
    31    ! RadSimpleLWFlux     :: ͥեåη׻
    32  !!$  ! RadSimpleLWFinalize :: λ (⥸塼ѿγդ)
    33    ! ------------------- :: ------------
    34    ! RadSimpleLWFlux     :: Calculate radiation flux
    35  !!$  ! RadSimpleLWFinalize :: Termination (deallocate variables in this module)
    36    !
    37    !== NAMELIST
    38    !
    39    ! NAMELIST#rad_Simple_LW_nml
    40    !
    41  
    42    ! ⥸塼 ; USE statements
    43    !
    44  
    45    ! ʻ
    46    ! Grid points settings
    47    !
    48    use gridset, only: imax, & ! ٳʻ.
    49                               ! Number of grid points in longitude
    50      &                jmax, & ! ٳʻ.
    51                               ! Number of grid points in latitude
    52      &                kmax    ! ľؿ.
    53                               ! Number of vertical level
    54  
    55    ! ̷ѥ᥿
    56    ! Kind type parameter
    57    !
    58    use dc_types, only: DP, &      ! ټ¿. Double precision.
    59      &                 STRING, &  ! ʸ.       Strings.
    60      &                 TOKEN      ! .   Keywords.
    61  
    62    ! NAMELIST եϤ˴ؤ桼ƥƥ
    63    ! Utilities for NAMELIST file input
    64    !
    65    use namelist_util, only: MaxNmlArySize
    66                                ! NAMELIST ɤ߹κ祵.
    67                                ! Maximum size of arrays loaded from NAMELIST
    68  
    69    ! å
    70    ! Message output
    71    !
    72    use dc_message, only: MessageNotify
    73  
    74    ! ꥹȥǡ
    75    ! Restart data output
    76    !
    77    use gtool_history, only: GT_HISTORY
    78  
    79    ! ʸ ; Declaration statements
    80    !
    81    implicit none
    82    private
    83  
    84    ! ³
    85    ! Public procedure
    86    !
    87    public:: RadSimpleLWFlux
    88    public:: RadSimpleLWInit
    89  
    90    ! ѿ
    91    ! Public variables
    92    !
    93    logical, save :: rad_simple_LW_inited = .false.
    94                                ! ե饰.
    95                                ! Initialization flag
    96  
    97  
    98    ! ѿ
    99    ! Private variables
   100    !
   101    logical, save:: Old_Flux_saved = .false.
   102                                ! ٷ׻եå¸Ȥ򼨤ե饰.
   103                                ! Flag for saving of flux calculated once
   104  
   105    integer , save:: nbmax
   106                                ! ĹȥХɿ.
   107                                ! Number of long wave band
   108    real(DP), save:: a_WNBnds(0:MaxNmlArySize)
   109                                !
   110                                ! Wavenumber bounds for bands
   111    real(DP), save:: a_AbsCoefDryCom(1:MaxNmlArySize)
   112                                ! $ \bar{k}_R $ . εۼ
   113                                ! Absorption coefficient of dry component
   114    real(DP), save:: a_PressScaleIndDryCom(1:MaxNmlArySize)
   115                                !
   116                                ! Pressure scaling index for dry component
   117    real(DP), save:: a_RefPressDryCom(1:MaxNmlArySize)
   118                                !
   119                                ! Reference pressure for dry component.
   120    real(DP), save:: a_AbsCoefH2OVap(1:MaxNmlArySize)
   121                                ! $ k_R $ . εۼ
   122                                ! Absorption coefficient of water vapor
   123    real(DP), save:: a_PressScaleIndH2OVap(1:MaxNmlArySize)
   124                                !
   125                                ! Pressure scaling index for water vapor
   126    real(DP), save:: a_RefPressH2OVap(1:MaxNmlArySize)
   127                                !
   128                                ! Reference pressure for water vapor
   129    real(DP), save:: DiffFact
   130                                !
   131                                ! Diffusivity factor
   132  
   133    integer , save:: NumGaussNode
   134  
   135  
   136    character(*), parameter:: module_name = 'rad_simple_LW'
   137                                ! ⥸塼̾.
   138                                ! Module name
   139    character(*), parameter:: version = &
   140      & '$Name: dcpam5-20120921 $' // &
   141      & '$Id: rad_simple_LW.f90,v 1.2 2012-02-01 05:19:54 yot Exp $'
   142                                ! ⥸塼ΥС
   143                                ! Module version
   144  
   145  contains
   146  
   147    !--------------------------------------------------------------------------------------
   148  
   149    subroutine RadSimpleLWFlux(                                          &
   150      & xy_SurfEmis, xyz_Temp, xyz_Press, xy_SurfTemp,                   & ! (in)
   151      & xyz_DelAtmMass, xyz_QH2OVap,                                     & ! (in)
   152      & xyr_RadLUwFlux, xyr_RadLDwFlux,                                  & ! (out)
   153      & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                           & ! (out)
   154      & )
   155      !
   156      ! Ĺȥեåη׻
   157      !
   158      ! Calculate long wave flux
   159      !
   160  
   161      ! ⥸塼 ; USE statements
   162      !
   163  
   164      ! ʪ
   165      ! Physical and mathematical constants settings
   166      !
   167      use constants0, only: &
   168        & PI,               &   ! $ \pi $ .
   169                                ! ߼Ψ.  Circular constant
   170        & StB                   ! $ \sigma_{SB} $ .
   171                                ! ƥեܥĥޥ.
   172                                ! Stefan-Boltzmann constant
   173  
   174      ! ץ󥯴ؿη׻
   175      ! Calculate Planck function
   176      !
   177      use planck_func, only : Integ_PF_GQ_Array3D, Integ_PF_GQ_Array2D, Integ_DPFDT_GQ_Array2D
   178  
   179      ! ̵뤷ã
   180      ! Radiative transfer equation without considering scattering
   181      !
   182      use rad_rte_nonscat, only : RadRTENonScat
   183  
   184  
   185      ! ʸ ; Declaration statements
   186      !
   187      real(DP), intent(in):: xy_SurfEmis       (0:imax-1, 1:jmax)
   188                                ! ɽ̼ͽΨ.
   189                                ! Surface emissivity
   190      real(DP), intent(in):: xyz_Temp          (0:imax-1, 1:jmax, 1:kmax)
   191                                ! $ T $ .     . Temperature
   192      real(DP), intent(in):: xyz_Press         (0:imax-1, 1:jmax, 1:kmax)
   193                                ! $ T $ .     . Temperature
   194  
   195      real(DP), intent(in):: xy_SurfTemp       (0:imax-1, 1:jmax)
   196                                ! ɽ̲.
   197                                ! Surface temperature
   198      real(DP), intent(in):: xyz_DelAtmMass    (0:imax-1, 1:jmax, 1:kmax)
   199                                !
   200                                ! Atmospheric mass of layers
   201      real(DP), intent(in):: xyz_QH2OVap       (0:imax-1, 1:jmax, 1:kmax)
   202                                !
   203                                ! Specific humidity
   204      real(DP), intent(out):: xyr_RadLUwFlux     (0:imax-1, 1:jmax, 0:kmax)
   205                                ! Ĺȥեå.
   206                                ! Upward longwave flux
   207      real(DP), intent(out):: xyr_RadLDwFlux     (0:imax-1, 1:jmax, 0:kmax)
   208                                ! Ĺȥեå.
   209                                ! Downward longwave flux
   210      real(DP), intent(out):: xyra_DelRadLUwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   211                                ! ĹɽѲ.
   212                                !
   213      real(DP), intent(out):: xyra_DelRadLDwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   214                                ! ĹɽѲ.
   215                                !
   216  
   217      ! ѿ
   218      ! Work variables
   219      !
   220      real(DP) :: xyz_DelOptDepDryCom(0:imax-1, 1:jmax, 1:kmax)
   221      real(DP) :: xyz_DelOptDepH2OVap(0:imax-1, 1:jmax, 1:kmax)
   222      real(DP) :: xyz_TransEachLayer (0:imax-1, 1:jmax, 1:kmax)
   223      real(DP) :: xyrr_Trans         (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   224                                ! Ʃ᷸.
   225                                ! Transmission coefficient
   226      real(DP) :: xyz_IntPF   (0:imax-1, 1:jmax, 1:kmax)
   227      real(DP) :: xy_SurfIntPF(0:imax-1, 1:jmax)
   228      real(DP) :: xy_IntDPFDT0(0:imax-1, 1:jmax)
   229      real(DP) :: xy_IntDPFDT1(0:imax-1, 1:jmax)
   230  
   231      real(DP) :: xyr_RadUwFlux     (0:imax-1, 1:jmax, 0:kmax)
   232                                ! Ĺȥեå.
   233                                ! Upward longwave flux
   234      real(DP) :: xyr_RadDwFlux     (0:imax-1, 1:jmax, 0:kmax)
   235                                ! Ĺȥեå.
   236                                ! Downward longwave flux
   237      real(DP) :: xyra_DelRadUwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   238                                ! ĹɽѲ.
   239                                !
   240      real(DP) :: xyra_DelRadDwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   241                                ! ĹɽѲ.
   242                                !
   243  
   244      real(DP) :: WNs
   245      real(DP) :: WNe
   246  
   247      integer:: k, kk           ! ľ˲ DO 롼Ѻѿ
   248                                ! Work variables for DO loop in vertical direction
   249      integer:: n               ! ĹˤĤƲ DO 롼Ѻѿ
   250                                ! Work variables for DO loop in wavenumber bands
   251  
   252      ! ¹ʸ ; Executable statement
   253      !
   254  
   255  
   256      !   Initialization
   257      !
   258      xyr_RadLUwFlux     = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t568 = 1, jmax*(kmax + 1)*imax                                 
     .           xyr_radluwflux(t568-1,1,0) = 0.0000000000000000e+000           
     .           xyr_radldwflux(t568-1,1,0) = 0.0000000000000000e+000           
     .        end do                                                            
   259      xyr_RadLDwFlux     = 0.0_DP
   260      xyra_DelRadLUwFlux = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t582 = 1, jmax*(kmax + 1)*imax                                 
     .           xyra_delradluwflux(t582-1,1,0,0) = 0.0000000000000000e+000     
     .           xyra_delradldwflux(t582-1,1,0,0) = 0.0000000000000000e+000     
     .           xyra_delradluwflux(t582-1,1,0,1) = 0.0000000000000000e+000     
     .           xyra_delradldwflux(t582-1,1,0,1) = 0.0000000000000000e+000     
     .        end do                                                            
   261      xyra_DelRadLDwFlux = 0.0_DP
   262      !
   263      LOOP_BAND_RTE : do n = 1, nbmax
   264  
   265  
   266        ! $ \pi B $, $ \pi DBDT $ η׻
   267        ! Calculate $ \pi B $ and $ \pi DBDT $
   268        !
   269        if ( nbmax == 1 ) then
   270  
   271          xy_SurfIntPF = xy_SurfEmis * StB * ( xy_SurfTemp**4 )
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t748 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t750 = 1, imax                                           
     .                 xy_surfintpf(t750-1,t748) = xy_surfemis(t750-1,t748)*    
     .       1            5.66999999999999e-008*xy_surftemp(t750-1,t748)**4     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t748 = J1 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t750 = 1, imax                                           
     .                 xy_surfintpf(t750-1,t748) = xy_surfemis(t750-1,t748)*    
     .       1            5.66999999999999e-008*xy_surftemp(t750-1,t748)**4     
     .                 xy_surfintpf(t750-1,t748+1) = xy_surfemis(t750-1,t748+1)*
     .       1            5.66999999999999e-008*xy_surftemp(t750-1,t748+1)**4   
     .                 xy_surfintpf(t750-1,t748+2) = xy_surfemis(t750-1,t748+2)*
     .       1            5.66999999999999e-008*xy_surftemp(t750-1,t748+2)**4   
     .                 xy_surfintpf(t750-1,t748+3) = xy_surfemis(t750-1,t748+3)*
     .       1            5.66999999999999e-008*xy_surftemp(t750-1,t748+3)**4   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   272          xyz_IntPF    =               StB * ( xyz_Temp**4 )
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t760 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t762 = 1, imax                                           
     .                 xyz_intpf(t762-1,t760,t758+1) = 5.66999999999999e-008*   
     .       1            xyz_temp(t762-1,t760,t758+1)**4                       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t760 = J2 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t762 = 1, imax                                           
     .                 xyz_intpf(t762-1,t760,t758+1) = 5.66999999999999e-008*   
     .       1            xyz_temp(t762-1,t760,t758+1)**4                       
     .                 xyz_intpf(t762-1,t760+1,t758+1) = 5.66999999999999e-008* 
     .       1            xyz_temp(t762-1,t760+1,t758+1)**4                     
     .                 xyz_intpf(t762-1,t760+2,t758+1) = 5.66999999999999e-008* 
     .       1            xyz_temp(t762-1,t760+2,t758+1)**4                     
     .                 xyz_intpf(t762-1,t760+3,t758+1) = 5.66999999999999e-008* 
     .       1            xyz_temp(t762-1,t760+3,t758+1)**4                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   273          xy_IntDPFDT0 = xy_SurfEmis * 4.0_DP * xy_SurfIntPF / xy_SurfTemp
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t770 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t772 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_intdpfdt0(t772-1,t770) = xy_surfemis(t772-1,t770)*    
     .       1            4.00000000000000e+000*xy_surfintpf(t772-1,t770)/      
     .       2            xy_surftemp(t772-1,t770)                              
     .                 xy_intdpfdt1(t772-1,t770) = 4.00000000000000e+000*       
     .       1            xyz_intpf(t772-1,t770,1)/xyz_temp(t772-1,t770,1)      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t770 = J3 + 1, jmax, 2                                      
     .  !CDIR       NODEP                                                       
     .              do t772 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_intdpfdt0(t772-1,t770) = xy_surfemis(t772-1,t770)*    
     .       1            4.00000000000000e+000*xy_surfintpf(t772-1,t770)/      
     .       2            xy_surftemp(t772-1,t770)                              
     .                 xy_intdpfdt0(t772-1,t770+1) = xy_surfemis(t772-1,t770+1)*
     .       1            4.00000000000000e+000*xy_surfintpf(t772-1,t770+1)/    
     .       2            xy_surftemp(t772-1,t770+1)                            
     .                 xy_intdpfdt1(t772-1,t770) = 4.00000000000000e+000*       
     .       1            xyz_intpf(t772-1,t770,1)/xyz_temp(t772-1,t770,1)      
     .                 xy_intdpfdt1(t772-1,t770+1) = 4.00000000000000e+000*     
     .       1            xyz_intpf(t772-1,t770+1,1)/xyz_temp(t772-1,t770+1,1)  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10047                                                       
   274          xy_IntDPFDT1 =               4.0_DP * xyz_IntPF(:,:,1) / xyz_Temp(:,:,1)
   275  
   276        else
   277  
   278          WNs = a_WNBnds(n-1)
   279          WNe = a_WNBnds(n  )
   280          call Integ_PF_GQ_Array3D(        &
   281            & WNs, WNe, NumGaussNode,      &
   282            & 0, imax-1, 1, jmax, 1, kmax, &
   283            & xyz_Temp,                    &
   284            & xyz_IntPF                    &
   285            & )
   286          call Integ_PF_GQ_Array2D(   &
   287            & WNs, WNe, NumGaussNode, &
   288            & 0, imax-1, 1, jmax,     &
   289            & xy_SurfTemp,            &
   290            & xy_SurfIntPF            &
   291            & )
   292          call Integ_DPFDT_GQ_Array2D(             &
   293            & WNs, WNe, NumGaussNode,              & ! (in )
   294            & 0, imax-1, 1, jmax, xyz_Temp(:,:,1), & ! (in )
   295            & xy_IntDPFDT1                         & ! (out)
   296            & )
   297          call Integ_DPFDT_GQ_Array2D(         &
   298            & WNs, WNe, NumGaussNode,          & ! (in )
   299            & 0, imax-1, 1, jmax, xy_SurfTemp, & ! (in )
   300            & xy_IntDPFDT0                     & ! (out)
   301            & )
   302  
   303          xy_SurfIntPF = xy_SurfEmis * PI * xy_SurfIntPF
     .        if (t97 .gt. 0) then                                              
     .           J4 = and(t97,3)                                                
     .  !CDIR    NODEP                                                          
     .           do t596 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t598 = 1, t96 + 1                                        
     .                 xy_surfintpf(t598-1,t596) = xy_surfemis(t598-1,t596)*    
     .       1            3.14159265358979e+000*xy_surfintpf(t598-1,t596)       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t596 = J4 + 1, t97, 4                                       
     .  !CDIR       NODEP                                                       
     .              do t598 = 1, t96 + 1                                        
     .                 xy_surfintpf(t598-1,t596) = xy_surfemis(t598-1,t596)*    
     .       1            3.14159265358979e+000*xy_surfintpf(t598-1,t596)       
     .                 xy_surfintpf(t598-1,t596+1) = xy_surfemis(t598-1,t596+1)*
     .       1            3.14159265358979e+000*xy_surfintpf(t598-1,t596+1)     
     .                 xy_surfintpf(t598-1,t596+2) = xy_surfemis(t598-1,t596+2)*
     .       1            3.14159265358979e+000*xy_surfintpf(t598-1,t596+2)     
     .                 xy_surfintpf(t598-1,t596+3) = xy_surfemis(t598-1,t596+3)*
     .       1            3.14159265358979e+000*xy_surfintpf(t598-1,t596+3)     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   304          xyz_IntPF    =               PI * xyz_IntPF
     .        if (xyz_intpf.DSC.U2 .gt. 0) then                                 
     .           J5 = and(xyz_intpf.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t608 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t610 = 1, xyz_intpf.DSC.U1 + 1                           
     .                 xyz_intpf(t610-1,t608,t606+1) = 3.14159265358979e+000*   
     .       1            xyz_intpf(t610-1,t608,t606+1)                         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t608 = J5 + 1, xyz_intpf.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t610 = 1, xyz_intpf.DSC.U1 + 1                           
     .                 xyz_intpf(t610-1,t608,t606+1) = 3.14159265358979e+000*   
     .       1            xyz_intpf(t610-1,t608,t606+1)                         
     .                 xyz_intpf(t610-1,t608+1,t606+1) = 3.14159265358979e+000* 
     .       1            xyz_intpf(t610-1,t608+1,t606+1)                       
     .                 xyz_intpf(t610-1,t608+2,t606+1) = 3.14159265358979e+000* 
     .       1            xyz_intpf(t610-1,t608+2,t606+1)                       
     .                 xyz_intpf(t610-1,t608+3,t606+1) = 3.14159265358979e+000* 
     .       1            xyz_intpf(t610-1,t608+3,t606+1)                       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   305          xy_IntDPFDT0 = xy_SurfEmis * PI * xy_IntDPFDT0
     .        if (t97 .gt. 0) then                                              
     .           J6 = and(t97,1)                                                
     .  !CDIR    NODEP                                                          
     .           do t618 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t620 = 1, t96 + 1                                        
     .                 xy_intdpfdt0(t620-1,t618) = xy_surfemis(t620-1,t618)*    
     .       1            3.14159265358979e+000*xy_intdpfdt0(t620-1,t618)       
     .                 xy_intdpfdt1(t620-1,t618) = 3.14159265358979e+000*       
     .       1            xy_intdpfdt1(t620-1,t618)                             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t618 = J6 + 1, t97, 2                                       
     .  !CDIR       NODEP                                                       
     .              do t620 = 1, t96 + 1                                        
     .                 xy_intdpfdt0(t620-1,t618) = xy_surfemis(t620-1,t618)*    
     .       1            3.14159265358979e+000*xy_intdpfdt0(t620-1,t618)       
     .                 xy_intdpfdt0(t620-1,t618+1) = xy_surfemis(t620-1,t618+1)*
     .       1            3.14159265358979e+000*xy_intdpfdt0(t620-1,t618+1)     
     .                 xy_intdpfdt1(t620-1,t618) = 3.14159265358979e+000*       
     .       1            xy_intdpfdt1(t620-1,t618)                             
     .                 xy_intdpfdt1(t620-1,t618+1) = 3.14159265358979e+000*     
     .       1            xy_intdpfdt1(t620-1,t618+1)                           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   306          xy_IntDPFDT1 =               PI * xy_IntDPFDT1
   307  
   308        end if
   309  
   310  
   311        ! Ūη׻
   312        ! Calculate optical depth
   313        !
   314        xyz_DelOptDepDryCom = a_AbsCoefDryCom(n)                             &
     .        if (t109 .gt. 0) then                                             
     .           J7 = and(t109,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t634 = 1, J7                                                
     .              D7 = 1.D0/a_refpressdrycom(n)                               
     .              D8 = 1.D0/a_refpressh2ovap(n)                               
     .  !CDIR       NODEP                                                       
     .              do t636 = 1, t108 + 1                                       
     .                 xyz_deloptdepdrycom1 = a_abscoefdrycom(n)*(xyz_press(t636
     .       1            -1,t634,t632+1)*D7)**a_pressscaleinddrycom(n)*        
     .       2            xyz_delatmmass(t636-1,t634,t632+1)                    
     .                 xyz_deloptdeph2ovap1 = a_abscoefh2ovap(n)*(xyz_press(t636
     .       1            -1,t634,t632+1)*D8)**a_pressscaleindh2ovap(n)*        
     .       2            xyz_delatmmass(t636-1,t634,t632+1)*xyz_qh2ovap(t636-1,
     .       3            t634,t632+1)                                          
     .                 xyz_transeachlayer(t636-1,t634,t632+1) = dexp((-difffact*
     .       1            (xyz_deloptdepdrycom1 + xyz_deloptdeph2ovap1)))       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t634 = J7 + 1, t109, 2                                      
     .              D3 = a_pressscaleinddrycom(n)                               
     .              D2 = a_refpressdrycom(n)                                    
     .              D1 = a_abscoefdrycom(n)                                     
     .  !CDIR       NODEP                                                       
     .              do t636 = 1, t108 + 1                                       
     .                 xyz_deloptdepdrycom(t636-1,t634,t632+1) = D1*(xyz_press( 
     .       1            t636-1,t634,t632+1)/D2)**D3*xyz_delatmmass(t636-1,t634
     .       2            ,t632+1)                                              
     .                 xyz_deloptdepdrycom(t636-1,t634+1,t632+1) = D1*(xyz_press
     .       1            (t636-1,t634+1,t632+1)/D2)**D3*xyz_delatmmass(t636-1, 
     .       2            t634+1,t632+1)                                        
     .                 D6 = a_pressscaleindh2ovap(n)                            
     .                 D5 = a_refpressh2ovap(n)                                 
     .                 D4 = a_abscoefh2ovap(n)                                  
     .                 xyz_deloptdeph2ovap(t636-1,t634,t632+1) = D4*(xyz_press( 
     .       1            t636-1,t634,t632+1)/D5)**D6*xyz_delatmmass(t636-1,t634
     .       2            ,t632+1)*xyz_qh2ovap(t636-1,t634,t632+1)              
     .                 xyz_deloptdeph2ovap(t636-1,t634+1,t632+1) = D4*(xyz_press
     .       1            (t636-1,t634+1,t632+1)/D5)**D6*xyz_delatmmass(t636-1, 
     .       2            t634+1,t632+1)*xyz_qh2ovap(t636-1,t634+1,t632+1)      
     .                 xyz_transeachlayer(t636-1,t634,t632+1) = dexp((-difffact*
     .       1            (xyz_deloptdepdrycom(t636-1,t634,t632+1)+             
     .       2            xyz_deloptdeph2ovap(t636-1,t634,t632+1))))            
     .                 xyz_transeachlayer(t636-1,t634+1,t632+1) = dexp((-       
     .       1            difffact*(xyz_deloptdepdrycom(t636-1,t634+1,t632+1)+  
     .       2            xyz_deloptdeph2ovap(t636-1,t634+1,t632+1))))          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   315          & * ( xyz_Press / a_RefPressDryCom(n) )**a_PressScaleIndDryCom(n)  &
   316          & * xyz_DelAtmMass
   317        xyz_DelOptDepH2OVap = a_AbsCoefH2OVap(n)                             &
   318          & * ( xyz_Press / a_RefPressH2OVap(n) )**a_PressScaleIndH2OVap(n)  &
   319          & * xyz_DelAtmMass * xyz_QH2OVap
   320  
   321  
   322        ! Ʃؿη׻
   323        ! Calculate transmission functions
   324        !
   325        xyz_TransEachLayer = exp( - DiffFact * ( xyz_DelOptDepDryCom + xyz_DelOptDepH2OVap ) )
   326        do k = 0, kmax
   327          do kk = k, k
   328            xyrr_Trans(:,:,k,kk) = 1.0d0
   329          end do
     .        if (xyrr_trans.DSC.U2 .gt. 0) then                                
     .           J8 = and(xyrr_trans.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t668 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t670 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t670-1,t668,k,k) = 1.00000000000000e+000      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t668 = J8 + 1, xyrr_trans.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t670 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t670-1,t668,k,k) = 1.00000000000000e+000      
     .                 xyrr_trans(t670-1,t668+1,k,k) = 1.00000000000000e+000    
     .                 xyrr_trans(t670-1,t668+2,k,k) = 1.00000000000000e+000    
     .                 xyrr_trans(t670-1,t668+3,k,k) = 1.00000000000000e+000    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   330          do kk = k+1, kmax
   331            xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,k,kk-1) * xyz_TransEachLayer(:,:,kk)
     .        if (xyrr_trans.DSC.U2 .gt. 0) then                                
     .           J9 = and(xyrr_trans.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t674 = 1, J9                                                
     .  !CDIR       NODEP                                                       
     .              do t676 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t676-1,t674,k,kk) = xyrr_trans(t676-1,t674,k, 
     .       1            kk-1)*xyz_transeachlayer(t676-1,t674,kk)              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t674 = J9 + 1, xyrr_trans.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t676 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t676-1,t674,k,kk) = xyrr_trans(t676-1,t674,k, 
     .       1            kk-1)*xyz_transeachlayer(t676-1,t674,kk)              
     .                 xyrr_trans(t676-1,t674+1,k,kk) = xyrr_trans(t676-1,t674+1
     .       1            ,k,kk-1)*xyz_transeachlayer(t676-1,t674+1,kk)         
     .                 xyrr_trans(t676-1,t674+2,k,kk) = xyrr_trans(t676-1,t674+2
     .       1            ,k,kk-1)*xyz_transeachlayer(t676-1,t674+2,kk)         
     .                 xyrr_trans(t676-1,t674+3,k,kk) = xyrr_trans(t676-1,t674+3
     .       1            ,k,kk-1)*xyz_transeachlayer(t676-1,t674+3,kk)         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   332          end do
   333          do kk = 0, k-1
   334            xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,kk,k)
     .        if (xyrr_trans.DSC.U2 .gt. 0) then                                
     .           J10 = and(xyrr_trans.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t684 = 1, J10                                               
     .  !CDIR       NODEP                                                       
     .              do t686 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t686-1,t684,k,kk) = xyrr_trans(t686-1,t684,kk,
     .       1            k)                                                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t684 = J10 + 1, xyrr_trans.DSC.U2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t686 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t686-1,t684,k,kk) = xyrr_trans(t686-1,t684,kk,
     .       1            k)                                                    
     .                 xyrr_trans(t686-1,t684+1,k,kk) = xyrr_trans(t686-1,t684+1
     .       1            ,kk,k)                                                
     .                 xyrr_trans(t686-1,t684+2,k,kk) = xyrr_trans(t686-1,t684+2
     .       1            ,kk,k)                                                
     .                 xyrr_trans(t686-1,t684+3,k,kk) = xyrr_trans(t686-1,t684+3
     .       1            ,kk,k)                                                
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   335          end do
   336        end do
   337  
   338  
   339        call RadRTENonScat(                                      &
   340          & xyz_IntPF, xy_SurfIntPF, xy_IntDPFDT1, xy_IntDPFDT0, & ! (in)
   341          & xyrr_Trans,                                          & ! (in)
   342          & xyr_RadUwFlux, xyr_RadDwFlux,                        & ! (out)
   343          & xyra_DelRadUwFlux, xyra_DelRadDwFlux                 & ! (out)
   344          & )
   345  
   346  
   347        xyr_RadLUwFlux     = xyr_RadLUwFlux     + xyr_RadUwFlux
     .        if (t135 .gt. 0) then                                             
     .           J11 = and(t135,1)                                              
     .  !CDIR    NODEP                                                          
     .           do t694 = 1, J11                                               
     .  !CDIR       NODEP                                                       
     .              do t696 = 1, t134 + 1                                       
     .                 xyr_radluwflux(t696-1,t694,t692) = xyr_radluwflux(t696-1,
     .       1            t694,t692) + xyr_raduwflux(t696-1,t694,t692)          
     .                 xyr_radldwflux(t696-1,t694,t692) = xyr_radldwflux(t696-1,
     .       1            t694,t692) + xyr_raddwflux(t696-1,t694,t692)          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t694 = J11 + 1, t135, 2                                     
     .  !CDIR       NODEP                                                       
     .              do t696 = 1, t134 + 1                                       
     .                 xyr_radluwflux(t696-1,t694,t692) = xyr_radluwflux(t696-1,
     .       1            t694,t692) + xyr_raduwflux(t696-1,t694,t692)          
     .                 xyr_radluwflux(t696-1,t694+1,t692) = xyr_radluwflux(t696-
     .       1            1,t694+1,t692) + xyr_raduwflux(t696-1,t694+1,t692)    
     .                 xyr_radldwflux(t696-1,t694,t692) = xyr_radldwflux(t696-1,
     .       1            t694,t692) + xyr_raddwflux(t696-1,t694,t692)          
     .                 xyr_radldwflux(t696-1,t694+1,t692) = xyr_radldwflux(t696-
     .       1            1,t694+1,t692) + xyr_raddwflux(t696-1,t694+1,t692)    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   348        xyr_RadLDwFlux     = xyr_RadLDwFlux     + xyr_RadDwFlux
   349        xyra_DelRadLUwFlux = xyra_DelRadLUwFlux + xyra_DelRadUwFlux
     .  !CDIR NODEP                                                             
     .        do t718 = 1, t150 + 1                                             
     .  !CDIR    NODEP                                                          
     .           do t720 = 1, t149                                              
     .  !CDIR       NODEP                                                       
     .              do t722 = 1, t148 + 1                                       
     .                 xyra_delradluwflux(t722-1,t720,t718-1,0) =               
     .       1            xyra_delradluwflux(t722-1,t720,t718-1,0) +            
     .       2            xyra_delraduwflux(t722-1,t720,t718-1,0)               
     .                 xyra_delradldwflux(t722-1,t720,t718-1,0) =               
     .       1            xyra_delradldwflux(t722-1,t720,t718-1,0) +            
     .       2            xyra_delraddwflux(t722-1,t720,t718-1,0)               
     .                 xyra_delradluwflux(t722-1,t720,t718-1,1) =               
     .       1            xyra_delradluwflux(t722-1,t720,t718-1,1) +            
     .       2            xyra_delraduwflux(t722-1,t720,t718-1,1)               
     .                 xyra_delradldwflux(t722-1,t720,t718-1,1) =               
     .       1            xyra_delradldwflux(t722-1,t720,t718-1,1) +            
     .       2            xyra_delraddwflux(t722-1,t720,t718-1,1)               
     .              end do                                                      
     .           end do                                                         
     .        end do                                                            
   350        xyra_DelRadLDwFlux = xyra_DelRadLDwFlux + xyra_DelRadDwFlux
   351  
   352      end do LOOP_BAND_RTE
   353  
   354  
   355    end subroutine RadSimpleLWFlux
   356  
   357    !--------------------------------------------------------------------------------------
   358  
   359    subroutine RadSimpleLWInit
   360      !
   361      ! rad_simple_LW ⥸塼νԤޤ.
   362      ! NAMELIST#rad_simple_LW_nml ɤ߹ߤϤμ³ǹԤޤ.
   363      !
   364      ! "rad_simple_LW" module is initialized.
   365      ! "NAMELIST#rad_simple_LW_nml" is loaded in this procedure.
   366      !
   367  
   368      ! ⥸塼 ; USE statements
   369      !
   370  
   371      ! ϥեδܾ
   372      ! Basic information for output files
   373      !
   374      use fileset, only: &
   375        & FileTitle, &
   376                                ! ϥǡեɽ.
   377                                ! Title of output data files
   378        & FileSource, &
   379                                ! ǡեμ.
   380                                ! Source of data file
   381        & FileInstitution
   382                                ! ǡեǽŪѹȿ/Ŀ.
   383                                ! Institution or person that changes data files for the last time
   384  
   385      ! ʪ
   386      ! Physical and mathematical constants settings
   387      !
   388      use constants0, only: &
   389        & PI                    ! $ \pi $ .
   390                                ! ߼Ψ.  Circular constant
   391  
   392      ! ɸǡ
   393      ! Axes data settings
   394      !
   395      use axesset, only: &
   396        & x_Lon, &
   397                                ! $ \lambda $ [rad.] . . Longitude
   398        & x_Lon_Weight, &
   399                                ! $ \Delta \lambda $ [rad.] .
   400                                ! ٺɸŤ.
   401                                ! Weight of longitude
   402        & y_Lat, &
   403                                ! $ \varphi $ [rad.] . . Latitude
   404        & y_Lat_Weight, &
   405                                ! $ \Delta \varphi $ [rad.] .
   406                                ! ٺɸŤ.
   407                                ! Weight of latitude
   408        & z_Sigma, &
   409                                ! $ \sigma $ ٥ ().
   410                                ! Full $ \sigma $ level
   411        & r_Sigma, &
   412                                ! $ \sigma $ ٥ (Ⱦ).
   413                                ! Half $ \sigma $ level
   414        & z_DelSigma
   415                                ! $ \Delta \sigma $ ().
   416                                ! $ \Delta \sigma $ (Full)
   417  
   418      ! 
   419      ! Time control
   420      !
   421      use timeset, only: &
   422        & RestartTime           ! ꥹȳϻ.
   423                                ! Retart time of calculation
   424  
   425  
   426      ! NAMELIST եϤ˴ؤ桼ƥƥ
   427      ! Utilities for NAMELIST file input
   428      !
   429      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   430  
   431      ! μ갷
   432      ! Calendar and Date handler
   433      !
   434      use dc_calendar, only: DCCalConvertByUnit
   435  
   436      ! ե
   437      ! File I/O support
   438      !
   439      use dc_iounit, only: FileOpen
   440  
   441      ! ̷ѥ᥿
   442      ! Kind type parameter
   443      !
   444      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   445  
   446      ! ʸ
   447      ! Character handling
   448      !
   449      use dc_string, only: toChar
   450  
   451      ! ̵뤷ã
   452      ! Radiative transfer equation without considering scattering
   453      !
   454      use rad_rte_nonscat, only : RadRTENonScatInit
   455  
   456      ! ʸ ; Declaration statements
   457      !
   458      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   459                                ! Unit number for NAMELIST file open
   460      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   461                                ! IOSTAT of NAMELIST read
   462  
   463      real(DP) :: WNBnds             (0:MaxNmlArySize)
   464      real(DP) :: AbsCoefDryCom      (1:MaxNmlArySize)
   465      real(DP) :: PressScaleIndDryCom(1:MaxNmlArySize)
   466      real(DP) :: RefPressDryCom     (1:MaxNmlArySize)
   467      real(DP) :: AbsCoefH2OVap      (1:MaxNmlArySize)
   468      real(DP) :: PressScaleIndH2OVap(1:MaxNmlArySize)
   469      real(DP) :: RefPressH2OVap     (1:MaxNmlArySize)
   470  
   471      integer  :: n
   472  
   473      ! NAMELIST ѿ
   474      ! NAMELIST group name
   475      !
   476      namelist /rad_simple_LW_nml/ &
   477        & nbmax, &
   478        & WNBnds,                                             &
   479        & AbsCoefDryCom, PressScaleIndDryCom, RefPressDryCom, &
   480        & AbsCoefH2OVap, PressScaleIndH2OVap, RefPressH2OVap, &
   481        & DiffFact,                                           &
   482        & NumGaussNode
   483            !
   484            ! ǥեͤˤĤƤϽ³ "rad_DennouAGCM#RadInit"
   485            ! Υɤ򻲾ȤΤ.
   486            !
   487            ! Refer to source codes in the initialization procedure
   488            ! "rad_DennouAGCM#RadInit" for the default values.
   489            !
   490  
   491      ! ¹ʸ ; Executable statement
   492      !
   493  
   494      if ( rad_simple_LW_inited ) return
   495  
   496  
   497      ! ǥեͤ
   498      ! Default values settings
   499      !
   500  
   501      ! ĹȥեåѾ
   502      ! Information for long wave flux
   503      !
   504  
   505      nbmax                  = 1
   506  
   507      WNBnds                 = -999.9_DP
   508      AbsCoefDryCom          = -999.9_DP
   509      PressScaleIndDryCom    = -999.9_DP
   510      RefPressDryCom         = -999.9_DP
   511      AbsCoefH2OVap          = -999.9_DP
   512      PressScaleIndH2OVap    = -999.9_DP
   513      RefPressH2OVap         = -999.9_DP
   514  
   515      AbsCoefDryCom      (1:nbmax) = (/ 5.0d-5 /)
     .           abscoefdrycom(1) = %IG4(1)                                     
     .        pressscaleinddrycom(1) = %IG5(1)                                  
     .        refpressdrycom(1) = %IG6(1)                                       
     .        abscoefh2ovap(1) = %IG7(1)                                        
     .        pressscaleindh2ovap(1) = %IG8(1)                                  
     .        refpressh2ovap(1) = %IG9(1)                                       
   516      PressScaleIndDryCom(1:nbmax) = (/ 0.0d0  /)
   517      RefPressDryCom     (1:nbmax) = (/ 1.0d5  /)
   518  
   519      AbsCoefH2OVap      (1:nbmax) = (/ 1.0d-2 /)
   520      PressScaleIndH2OVap(1:nbmax) = (/ 0.0d0  /)
   521      RefPressH2OVap     (1:nbmax) = (/ 1.0d5  /)
   522  
   523      DiffFact        = 1.66_DP
   524  
   525      NumGaussNode    = 5
   526  
   527  
   528      ! NAMELIST ɤ߹
   529      ! NAMELIST is input
   530      !
   531      if ( trim(namelist_filename) /= '' ) then
   532        call FileOpen( unit_nml, &          ! (out)
   533          & namelist_filename, mode = 'r' ) ! (in)
   534  
   535        rewind( unit_nml )
   536        read( unit_nml,                    & ! (in)
   537          & nml = rad_simple_LW_nml,       & ! (out)
   538          & iostat = iostat_nml )            ! (out)
   539        close( unit_nml )
   540  
   541        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   542      end if
   543  
   544      if ( nbmax > MaxNmlArySize ) then
   545        call MessageNotify( 'E', module_name, 'nbmax = %d > %d', i = (/ nbmax, MaxNmlArySize /) )
   546      end if
   547  
   548      a_WNBnds              = WNBnds * 100.0_DP    ! Convert from cm-1 to m-1
   549  !!$    a_AbsCoefDryCom = 5.0d-5
   550      a_AbsCoefDryCom       = AbsCoefDryCom
   551      a_PressScaleIndDryCom = PressScaleIndDryCom
   552      a_RefPressDryCom      = RefPressDryCom
   553  
   554  !!$    a_AbsCoefH2OVap = 1.0d-2
   555      a_AbsCoefH2OVap = AbsCoefH2OVap
   556      a_PressScaleIndH2OVap = PressScaleIndH2OVap
   557      a_RefPressH2OVap      = RefPressH2OVap
   558  
   559  
   560      ! Initialization of modules used in this module
   561      !
   562  
   563      ! ̵뤷ã
   564      ! Radiative transfer equation without considering scattering
   565      !
   566      call RadRTENonScatInit
   567  
   568  
   569      !  ; Print
   570      !
   571      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   572  
   573  !!$    call MessageNotify( 'M', module_name, 'DelTime:' )
   574  !!$    call MessageNotify( 'M', module_name, '  DelTime  = %f [%c]', &
   575  !!$      & d = (/ DelTimeValue /), c1 = trim( DelTimeUnit ) )
   576  
   577      call MessageNotify( 'M', module_name, 'nbmax         = %d', i = (/ nbmax /) )
   578  
   579  !!$    call MessageNotify( 'M', module_name, 'WNBnds              = (/ %*r /)', &
   580  !!$      & r = real( a_WNBnds(0:nbmax) ), n = (/ nbmax+1 /) )
   581  !!$    call MessageNotify( 'M', module_name, 'AbsCoefDryCom       = (/ %*r /)', &
   582  !!$      & r = real( a_AbsCoefDryCom(1:nbmax) ), n = (/ nbmax /) )
   583  !!$    call MessageNotify( 'M', module_name, 'PressScaleIndDryCom = (/ %*r /)', &
   584  !!$      & r = real( a_PressScaleIndDryCom(1:nbmax) ), n = (/ nbmax /) )
   585  !!$    call MessageNotify( 'M', module_name, 'RefPressDryCom      = (/ %*r /)', &
   586  !!$      & r = real( a_RefPressDryCom(1:nbmax) ), n = (/ nbmax /) )
   587  !!$    call MessageNotify( 'M', module_name, 'AbsCoefH2OVap       = (/ %*r /)', &
   588  !!$      & r = real( a_AbsCoefH2OVap(1:nbmax) ), n = (/ nbmax /) )
   589  !!$    call MessageNotify( 'M', module_name, 'PressScaleIndH2OVap = (/ %*r /)', &
   590  !!$      & r = real( a_PressScaleIndH2OVap(1:nbmax) ), n = (/ nbmax /) )
   591  !!$    call MessageNotify( 'M', module_name, 'RefPressH2OVap      = (/ %*r /)', &
   592  !!$      & r = real( a_RefPressH2OVap(1:nbmax) ), n = (/ nbmax /) )
   593  
   594      do n = 1, nbmax
   595        call MessageNotify( 'M', module_name, '  %d : %f %f %f %f %f %f %f %f',       &
   596          & i = (/ n /),                                                              &
   597          & d = (/ a_WNBnds(n-1)*1.0e-2, a_WNBnds(n)*1.0e-2,                          &
   598          &        a_AbsCoefDryCom(n), a_PressScaleIndDryCom(n), a_RefPressDryCom(n), &
   599          &        a_AbsCoefH2OVap(n), a_PressScaleIndH2OVap(n), a_RefPressH2OVap(n) /) )
   600      end do
   601  
   602      call MessageNotify( 'M', module_name, 'DiffFact      = %f', d = (/ DiffFact /) )
   603  !
   604      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   605  
   606      rad_simple_LW_inited = .true.
   607  
   608    end subroutine RadSimpleLWInit
   609  
   610    !--------------------------------------------------------------------------------------
   611  
   612  end module rad_simple_LW
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:04 2012
FILE NAME: rad_simple_LW.f90
PROGRAM NAME: rad_simple_lw
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ͥեå (ñĹȥХɥǥ)
     2:            !
     3:            != Radiation flux (simple longwave band model)
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: rad_simple_LW.f90,v 1.2 2012-02-01 05:19:54 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module rad_simple_LW
    13:              !
    14:              != ͥեå (ñĹȥХɥǥ)
    15:              !
    16:              != Radiation flux (simple longwave band model)
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! , 漾, , ͥեå׻ͥǥǤ. 
    21:              !
    22:              ! This is a radiation model that calculates radiation flux from
    23:              ! temperature, specific humidity, and air pressure.
    24:              !
    25:              !== References
    26:              !
    27:              !
    28:              !
    29:              !== Procedures List
    30:              !
    31:              ! RadSimpleLWFlux     :: ͥեåη׻
    32:            !!$  ! RadSimpleLWFinalize :: λ (⥸塼ѿγդ)
    33:              ! ------------------- :: ------------
    34:              ! RadSimpleLWFlux     :: Calculate radiation flux
    35:            !!$  ! RadSimpleLWFinalize :: Termination (deallocate variables in this module)
    36:              !
    37:              !== NAMELIST
    38:              !
    39:              ! NAMELIST#rad_Simple_LW_nml
    40:              !
    41:            
    42:              ! ⥸塼 ; USE statements
    43:              !
    44:            
    45:              ! ʻ
    46:              ! Grid points settings
    47:              !
    48:              use gridset, only: imax, & ! ٳʻ. 
    49:                                         ! Number of grid points in longitude
    50:                &                jmax, & ! ٳʻ. 
    51:                                         ! Number of grid points in latitude
    52:                &                kmax    ! ľؿ. 
    53:                                         ! Number of vertical level
    54:            
    55:              ! ̷ѥ᥿
    56:              ! Kind type parameter
    57:              !
    58:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    59:                &                 STRING, &  ! ʸ.       Strings. 
    60:                &                 TOKEN      ! .   Keywords. 
    61:            
    62:              ! NAMELIST եϤ˴ؤ桼ƥƥ
    63:              ! Utilities for NAMELIST file input
    64:              !
    65:              use namelist_util, only: MaxNmlArySize
    66:                                          ! NAMELIST ɤ߹κ祵. 
    67:                                          ! Maximum size of arrays loaded from NAMELIST
    68:            
    69:              ! å
    70:              ! Message output
    71:              !
    72:              use dc_message, only: MessageNotify
    73:            
    74:              ! ꥹȥǡ
    75:              ! Restart data output
    76:              !
    77:              use gtool_history, only: GT_HISTORY
    78:            
    79:              ! ʸ ; Declaration statements
    80:              !
    81:              implicit none
    82:              private
    83:            
    84:              ! ³
    85:              ! Public procedure
    86:              !
    87:              public:: RadSimpleLWFlux
    88:              public:: RadSimpleLWInit
    89:            
    90:              ! ѿ
    91:              ! Public variables
    92:              !
    93:              logical, save :: rad_simple_LW_inited = .false.
    94:                                          ! ե饰. 
    95:                                          ! Initialization flag
    96:            
    97:            
    98:              ! ѿ
    99:              ! Private variables
   100:              !
   101:              logical, save:: Old_Flux_saved = .false.
   102:                                          ! ٷ׻եå¸Ȥ򼨤ե饰. 
   103:                                          ! Flag for saving of flux calculated once
   104:            
   105:              integer , save:: nbmax
   106:                                          ! ĹȥХɿ. 
   107:                                          ! Number of long wave band
   108:              real(DP), save:: a_WNBnds(0:MaxNmlArySize)
   109:                                          ! 
   110:                                          ! Wavenumber bounds for bands
   111:              real(DP), save:: a_AbsCoefDryCom(1:MaxNmlArySize)
   112:                                          ! $ \bar{k}_R $ . εۼ
   113:                                          ! Absorption coefficient of dry component
   114:              real(DP), save:: a_PressScaleIndDryCom(1:MaxNmlArySize)
   115:                                          ! 
   116:                                          ! Pressure scaling index for dry component
   117:              real(DP), save:: a_RefPressDryCom(1:MaxNmlArySize)
   118:                                          ! 
   119:                                          ! Reference pressure for dry component.
   120:              real(DP), save:: a_AbsCoefH2OVap(1:MaxNmlArySize)
   121:                                          ! $ k_R $ . εۼ
   122:                                          ! Absorption coefficient of water vapor
   123:              real(DP), save:: a_PressScaleIndH2OVap(1:MaxNmlArySize)
   124:                                          ! 
   125:                                          ! Pressure scaling index for water vapor
   126:              real(DP), save:: a_RefPressH2OVap(1:MaxNmlArySize)
   127:                                          ! 
   128:                                          ! Reference pressure for water vapor
   129:              real(DP), save:: DiffFact
   130:                                          ! 
   131:                                          ! Diffusivity factor
   132:            
   133:              integer , save:: NumGaussNode
   134:            
   135:            
   136:              character(*), parameter:: module_name = 'rad_simple_LW'
   137:                                          ! ⥸塼̾. 
   138:                                          ! Module name
   139:              character(*), parameter:: version = &
   140:                & '$Name: dcpam5-20120921 $' // &
   141:                & '$Id: rad_simple_LW.f90,v 1.2 2012-02-01 05:19:54 yot Exp $'
   142:                                          ! ⥸塼ΥС
   143:                                          ! Module version
   144:            
   145:            contains
   146:            
   147:              !--------------------------------------------------------------------------------------
   148:            
   149:              subroutine RadSimpleLWFlux(                                          &
   150:                & xy_SurfEmis, xyz_Temp, xyz_Press, xy_SurfTemp,                   & ! (in)
   151:                & xyz_DelAtmMass, xyz_QH2OVap,                                     & ! (in)
   152:                & xyr_RadLUwFlux, xyr_RadLDwFlux,                                  & ! (out)
   153:                & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                           & ! (out)
   154:                & )
   155:                !
   156:                ! Ĺȥեåη׻
   157:                !
   158:                ! Calculate long wave flux
   159:                !
   160:            
   161:                ! ⥸塼 ; USE statements
   162:                !
   163:            
   164:                ! ʪ
   165:                ! Physical and mathematical constants settings
   166:                !
   167:                use constants0, only: &
   168:                  & PI,               &   ! $ \pi $ .
   169:                                          ! ߼Ψ.  Circular constant
   170:                  & StB                   ! $ \sigma_{SB} $ . 
   171:                                          ! ƥեܥĥޥ. 
   172:                                          ! Stefan-Boltzmann constant
   173:            
   174:                ! ץ󥯴ؿη׻
   175:                ! Calculate Planck function
   176:                !
   177:                use planck_func, only : Integ_PF_GQ_Array3D, Integ_PF_GQ_Array2D, Integ_DPFDT_GQ_Array2D
   178:            
   179:                ! ̵뤷ã
   180:                ! Radiative transfer equation without considering scattering
   181:                !
   182:                use rad_rte_nonscat, only : RadRTENonScat
   183:            
   184:            
   185:                ! ʸ ; Declaration statements
   186:                !
   187:                real(DP), intent(in):: xy_SurfEmis       (0:imax-1, 1:jmax)
   188:                                          ! ɽ̼ͽΨ.
   189:                                          ! Surface emissivity
   190:                real(DP), intent(in):: xyz_Temp          (0:imax-1, 1:jmax, 1:kmax)
   191:                                          ! $ T $ .     . Temperature
   192:                real(DP), intent(in):: xyz_Press         (0:imax-1, 1:jmax, 1:kmax)
   193:                                          ! $ T $ .     . Temperature
   194:            
   195:                real(DP), intent(in):: xy_SurfTemp       (0:imax-1, 1:jmax)
   196:                                          ! ɽ̲. 
   197:                                          ! Surface temperature
   198:                real(DP), intent(in):: xyz_DelAtmMass    (0:imax-1, 1:jmax, 1:kmax)
   199:                                          ! 
   200:                                          ! Atmospheric mass of layers
   201:                real(DP), intent(in):: xyz_QH2OVap       (0:imax-1, 1:jmax, 1:kmax)
   202:                                          !
   203:                                          ! Specific humidity
   204:                real(DP), intent(out):: xyr_RadLUwFlux     (0:imax-1, 1:jmax, 0:kmax)
   205:                                          ! Ĺȥեå. 
   206:                                          ! Upward longwave flux
   207:                real(DP), intent(out):: xyr_RadLDwFlux     (0:imax-1, 1:jmax, 0:kmax)
   208:                                          ! Ĺȥեå. 
   209:                                          ! Downward longwave flux
   210:                real(DP), intent(out):: xyra_DelRadLUwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   211:                                          ! ĹɽѲ. 
   212:                                          ! 
   213:                real(DP), intent(out):: xyra_DelRadLDwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   214:                                          ! ĹɽѲ. 
   215:                                          ! 
   216:            
   217:                ! ѿ
   218:                ! Work variables
   219:                !
   220:                real(DP) :: xyz_DelOptDepDryCom(0:imax-1, 1:jmax, 1:kmax)
   221:                real(DP) :: xyz_DelOptDepH2OVap(0:imax-1, 1:jmax, 1:kmax)
   222:                real(DP) :: xyz_TransEachLayer (0:imax-1, 1:jmax, 1:kmax)
   223:                real(DP) :: xyrr_Trans         (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   224:                                          ! Ʃ᷸. 
   225:                                          ! Transmission coefficient
   226:                real(DP) :: xyz_IntPF   (0:imax-1, 1:jmax, 1:kmax)
   227:                real(DP) :: xy_SurfIntPF(0:imax-1, 1:jmax)
   228:                real(DP) :: xy_IntDPFDT0(0:imax-1, 1:jmax)
   229:                real(DP) :: xy_IntDPFDT1(0:imax-1, 1:jmax)
   230:            
   231:                real(DP) :: xyr_RadUwFlux     (0:imax-1, 1:jmax, 0:kmax)
   232:                                          ! Ĺȥեå. 
   233:                                          ! Upward longwave flux
   234:                real(DP) :: xyr_RadDwFlux     (0:imax-1, 1:jmax, 0:kmax)
   235:                                          ! Ĺȥեå. 
   236:                                          ! Downward longwave flux
   237:                real(DP) :: xyra_DelRadUwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   238:                                          ! ĹɽѲ. 
   239:                                          ! 
   240:                real(DP) :: xyra_DelRadDwFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   241:                                          ! ĹɽѲ. 
   242:                                          ! 
   243:            
   244:                real(DP) :: WNs
   245:                real(DP) :: WNe
   246:            
   247:                integer:: k, kk           ! ľ˲ DO 롼Ѻѿ
   248:                                          ! Work variables for DO loop in vertical direction
   249:                integer:: n               ! ĹˤĤƲ DO 롼Ѻѿ
   250:                                          ! Work variables for DO loop in wavenumber bands
   251:            
   252:                ! ¹ʸ ; Executable statement
   253:                !
   254:            
   255:            
   256:                !   Initialization
   257:                !
   258: **W---->       xyr_RadLUwFlux     = 0.0_DP
   259: **W----        xyr_RadLDwFlux     = 0.0_DP
   260: ***W--->       xyra_DelRadLUwFlux = 0.0_DP
   261: ***W---        xyra_DelRadLDwFlux = 0.0_DP
   262:                !
   263: +------>       LOOP_BAND_RTE : do n = 1, nbmax
   264: |          
   265: |          
   266: |                ! $ \pi B $, $ \pi DBDT $ η׻
   267: |                ! Calculate $ \pi B $ and $ \pi DBDT $
   268: |                !
   269: |                if ( nbmax == 1 ) then
   270: |          
   271: |+V====            xy_SurfIntPF = xy_SurfEmis * StB * ( xy_SurfTemp**4 )
   272: |++V===            xyz_IntPF    =               StB * ( xyz_Temp**4 )
   273: |*V---->           xy_IntDPFDT0 = xy_SurfEmis * 4.0_DP * xy_SurfIntPF / xy_SurfTemp
   274: |*V----            xy_IntDPFDT1 =               4.0_DP * xyz_IntPF(:,:,1) / xyz_Temp(:,:,1)
   275: |          
   276: |                else
   277: |          
   278: |                  WNs = a_WNBnds(n-1)
   279: |                  WNe = a_WNBnds(n  )
   280: |                  call Integ_PF_GQ_Array3D(        &
   281: |                    & WNs, WNe, NumGaussNode,      &
   282: |                    & 0, imax-1, 1, jmax, 1, kmax, &
   283: |                    & xyz_Temp,                    &
   284: |                    & xyz_IntPF                    &
   285: |                    & )
   286: |                  call Integ_PF_GQ_Array2D(   &
   287: |                    & WNs, WNe, NumGaussNode, &
   288: |                    & 0, imax-1, 1, jmax,     &
   289: |                    & xy_SurfTemp,            &
   290: |                    & xy_SurfIntPF            &
   291: |                    & )
   292: |                  call Integ_DPFDT_GQ_Array2D(             &
   293: |                    & WNs, WNe, NumGaussNode,              & ! (in )
   294: |                    & 0, imax-1, 1, jmax, xyz_Temp(:,:,1), & ! (in )
   295: |                    & xy_IntDPFDT1                         & ! (out)
   296: |                    & )
   297: |                  call Integ_DPFDT_GQ_Array2D(         &
   298: |                    & WNs, WNe, NumGaussNode,          & ! (in )
   299: |                    & 0, imax-1, 1, jmax, xy_SurfTemp, & ! (in )
   300: |                    & xy_IntDPFDT0                     & ! (out)
   301: |                    & )
   302: |          
   303: |+V====            xy_SurfIntPF = xy_SurfEmis * PI * xy_SurfIntPF
   304: |++V===            xyz_IntPF    =               PI * xyz_IntPF
   305: |*V---->           xy_IntDPFDT0 = xy_SurfEmis * PI * xy_IntDPFDT0
   306: |*V----            xy_IntDPFDT1 =               PI * xy_IntDPFDT1
   307: |          
   308: |                end if
   309: |          
   310: |          
   311: |                ! Ūη׻
   312: |                ! Calculate optical depth
   313: |                !
   314: |**V--->         xyz_DelOptDepDryCom = a_AbsCoefDryCom(n)                             &
   315: ||||               & * ( xyz_Press / a_RefPressDryCom(n) )**a_PressScaleIndDryCom(n)  &
   316: ||||               & * xyz_DelAtmMass
   317: ||||             xyz_DelOptDepH2OVap = a_AbsCoefH2OVap(n)                             &
   318: ||||               & * ( xyz_Press / a_RefPressH2OVap(n) )**a_PressScaleIndH2OVap(n)  &
   319: ||||               & * xyz_DelAtmMass * xyz_QH2OVap
   320: ||||       
   321: ||||       
   322: ||||             ! Ʃؿη׻
   323: ||||             ! Calculate transmission functions
   324: ||||             !
   325: |**V---          xyz_TransEachLayer = exp( - DiffFact * ( xyz_DelOptDepDryCom + xyz_DelOptDepH2OVap ) )
   326: |+----->         do k = 0, kmax
   327: ||+---->           do kk = k, k
   328: |||+V==              xyrr_Trans(:,:,k,kk) = 1.0d0
   329: ||+----            end do
   330: ||+---->           do kk = k+1, kmax
   331: |||+V==              xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,k,kk-1) * xyz_TransEachLayer(:,:,kk)
   332: ||+----            end do
   333: ||+---->           do kk = 0, k-1
   334: |||+V==              xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,kk,k)
   335: ||+----            end do
   336: |+-----          end do
   337: |          
   338: |          
   339: |                call RadRTENonScat(                                      &
   340: |                  & xyz_IntPF, xy_SurfIntPF, xy_IntDPFDT1, xy_IntDPFDT0, & ! (in)
   341: |                  & xyrr_Trans,                                          & ! (in)
   342: |                  & xyr_RadUwFlux, xyr_RadDwFlux,                        & ! (out)
   343: |                  & xyra_DelRadUwFlux, xyra_DelRadDwFlux                 & ! (out)
   344: |                  & )
   345: |          
   346: |          
   347: |**V--->         xyr_RadLUwFlux     = xyr_RadLUwFlux     + xyr_RadUwFlux
   348: |**V---          xyr_RadLDwFlux     = xyr_RadLDwFlux     + xyr_RadDwFlux
   349: |***V-->         xyra_DelRadLUwFlux = xyra_DelRadLUwFlux + xyra_DelRadUwFlux
   350: |***V--          xyra_DelRadLDwFlux = xyra_DelRadLDwFlux + xyra_DelRadDwFlux
   351: |          
   352: +------        end do LOOP_BAND_RTE
   353:            
   354:            
   355:              end subroutine RadSimpleLWFlux
   356:            
   357:              !--------------------------------------------------------------------------------------
   358:            
   359:              subroutine RadSimpleLWInit
   360:                !
   361:                ! rad_simple_LW ⥸塼νԤޤ. 
   362:                ! NAMELIST#rad_simple_LW_nml ɤ߹ߤϤμ³ǹԤޤ. 
   363:                !
   364:                ! "rad_simple_LW" module is initialized. 
   365:                ! "NAMELIST#rad_simple_LW_nml" is loaded in this procedure. 
   366:                !
   367:            
   368:                ! ⥸塼 ; USE statements
   369:                !
   370:            
   371:                ! ϥեδܾ
   372:                ! Basic information for output files
   373:                ! 
   374:                use fileset, only: &
   375:                  & FileTitle, &
   376:                                          ! ϥǡեɽ.
   377:                                          ! Title of output data files
   378:                  & FileSource, &
   379:                                          ! ǡեμ. 
   380:                                          ! Source of data file
   381:                  & FileInstitution
   382:                                          ! ǡեǽŪѹȿ/Ŀ. 
   383:                                          ! Institution or person that changes data files for the last time
   384:            
   385:                ! ʪ
   386:                ! Physical and mathematical constants settings
   387:                !
   388:                use constants0, only: &
   389:                  & PI                    ! $ \pi $ .
   390:                                          ! ߼Ψ.  Circular constant
   391:            
   392:                ! ɸǡ
   393:                ! Axes data settings
   394:                !
   395:                use axesset, only: &
   396:                  & x_Lon, &
   397:                                          ! $ \lambda $ [rad.] . . Longitude
   398:                  & x_Lon_Weight, &
   399:                                          ! $ \Delta \lambda $ [rad.] . 
   400:                                          ! ٺɸŤ. 
   401:                                          ! Weight of longitude
   402:                  & y_Lat, &
   403:                                          ! $ \varphi $ [rad.] . . Latitude
   404:                  & y_Lat_Weight, &
   405:                                          ! $ \Delta \varphi $ [rad.] . 
   406:                                          ! ٺɸŤ. 
   407:                                          ! Weight of latitude
   408:                  & z_Sigma, &
   409:                                          ! $ \sigma $ ٥ (). 
   410:                                          ! Full $ \sigma $ level
   411:                  & r_Sigma, &
   412:                                          ! $ \sigma $ ٥ (Ⱦ). 
   413:                                          ! Half $ \sigma $ level
   414:                  & z_DelSigma
   415:                                          ! $ \Delta \sigma $ (). 
   416:                                          ! $ \Delta \sigma $ (Full)
   417:            
   418:                ! 
   419:                ! Time control
   420:                !
   421:                use timeset, only: &
   422:                  & RestartTime           ! ꥹȳϻ. 
   423:                                          ! Retart time of calculation
   424:            
   425:            
   426:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   427:                ! Utilities for NAMELIST file input
   428:                !
   429:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   430:            
   431:                ! μ갷
   432:                ! Calendar and Date handler
   433:                !
   434:                use dc_calendar, only: DCCalConvertByUnit
   435:            
   436:                ! ե
   437:                ! File I/O support
   438:                !
   439:                use dc_iounit, only: FileOpen
   440:            
   441:                ! ̷ѥ᥿
   442:                ! Kind type parameter
   443:                !
   444:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   445:            
   446:                ! ʸ
   447:                ! Character handling
   448:                !
   449:                use dc_string, only: toChar
   450:            
   451:                ! ̵뤷ã
   452:                ! Radiative transfer equation without considering scattering
   453:                !
   454:                use rad_rte_nonscat, only : RadRTENonScatInit
   455:            
   456:                ! ʸ ; Declaration statements
   457:                !
   458:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   459:                                          ! Unit number for NAMELIST file open
   460:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   461:                                          ! IOSTAT of NAMELIST read
   462:            
   463:                real(DP) :: WNBnds             (0:MaxNmlArySize)
   464:                real(DP) :: AbsCoefDryCom      (1:MaxNmlArySize)
   465:                real(DP) :: PressScaleIndDryCom(1:MaxNmlArySize)
   466:                real(DP) :: RefPressDryCom     (1:MaxNmlArySize)
   467:                real(DP) :: AbsCoefH2OVap      (1:MaxNmlArySize)
   468:                real(DP) :: PressScaleIndH2OVap(1:MaxNmlArySize)
   469:                real(DP) :: RefPressH2OVap     (1:MaxNmlArySize)
   470:            
   471:                integer  :: n
   472:            
   473:                ! NAMELIST ѿ
   474:                ! NAMELIST group name
   475:                !
   476:                namelist /rad_simple_LW_nml/ &
   477:                  & nbmax, &
   478:                  & WNBnds,                                             &
   479:                  & AbsCoefDryCom, PressScaleIndDryCom, RefPressDryCom, &
   480:                  & AbsCoefH2OVap, PressScaleIndH2OVap, RefPressH2OVap, &
   481:                  & DiffFact,                                           &
   482:                  & NumGaussNode
   483:                      !
   484:                      ! ǥեͤˤĤƤϽ³ "rad_DennouAGCM#RadInit" 
   485:                      ! Υɤ򻲾ȤΤ. 
   486:                      !
   487:                      ! Refer to source codes in the initialization procedure
   488:                      ! "rad_DennouAGCM#RadInit" for the default values. 
   489:                      !
   490:            
   491:                ! ¹ʸ ; Executable statement
   492:                !
   493:            
   494:                if ( rad_simple_LW_inited ) return
   495:            
   496:            
   497:                ! ǥեͤ
   498:                ! Default values settings
   499:                !
   500:            
   501:                ! ĹȥեåѾ
   502:                ! Information for long wave flux
   503:                !
   504:            
   505:                nbmax                  = 1
   506:            
   507: V======        WNBnds                 = -999.9_DP
   508: V------>       AbsCoefDryCom          = -999.9_DP
   509: |              PressScaleIndDryCom    = -999.9_DP
   510: |              RefPressDryCom         = -999.9_DP
   511: |              AbsCoefH2OVap          = -999.9_DP
   512: |              PressScaleIndH2OVap    = -999.9_DP
   513: V------        RefPressH2OVap         = -999.9_DP
   514:            
   515: +------>       AbsCoefDryCom      (1:nbmax) = (/ 5.0d-5 /)
   516: |              PressScaleIndDryCom(1:nbmax) = (/ 0.0d0  /)
   517: |              RefPressDryCom     (1:nbmax) = (/ 1.0d5  /)
   518: |          
   519: |              AbsCoefH2OVap      (1:nbmax) = (/ 1.0d-2 /)
   520: |              PressScaleIndH2OVap(1:nbmax) = (/ 0.0d0  /)
   521: +------        RefPressH2OVap     (1:nbmax) = (/ 1.0d5  /)
   522:            
   523:                DiffFact        = 1.66_DP
   524:            
   525:                NumGaussNode    = 5
   526:            
   527:            
   528:                ! NAMELIST ɤ߹
   529:                ! NAMELIST is input
   530:                !
   531:                if ( trim(namelist_filename) /= '' ) then
   532:                  call FileOpen( unit_nml, &          ! (out)
   533:                    & namelist_filename, mode = 'r' ) ! (in)
   534:            
   535:                  rewind( unit_nml )
   536:                  read( unit_nml,                    & ! (in)
   537:                    & nml = rad_simple_LW_nml,       & ! (out)
   538:                    & iostat = iostat_nml )            ! (out)
   539:                  close( unit_nml )
   540:            
   541:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   542:                end if
   543:            
   544:                if ( nbmax > MaxNmlArySize ) then
   545:                  call MessageNotify( 'E', module_name, 'nbmax = %d > %d', i = (/ nbmax, MaxNmlArySize /) )
   546:                end if
   547:            
   548: V======        a_WNBnds              = WNBnds * 100.0_DP    ! Convert from cm-1 to m-1
   549:            !!$    a_AbsCoefDryCom = 5.0d-5
   550: V------>       a_AbsCoefDryCom       = AbsCoefDryCom
   551: |              a_PressScaleIndDryCom = PressScaleIndDryCom
   552: |              a_RefPressDryCom      = RefPressDryCom
   553: |          
   554: |          !!$    a_AbsCoefH2OVap = 1.0d-2
   555: |              a_AbsCoefH2OVap = AbsCoefH2OVap
   556: |              a_PressScaleIndH2OVap = PressScaleIndH2OVap
   557: V------        a_RefPressH2OVap      = RefPressH2OVap
   558:            
   559:            
   560:                ! Initialization of modules used in this module
   561:                !
   562:            
   563:                ! ̵뤷ã
   564:                ! Radiative transfer equation without considering scattering
   565:                !
   566:                call RadRTENonScatInit
   567:            
   568:            
   569:                !  ; Print
   570:                !
   571:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   572:            
   573:            !!$    call MessageNotify( 'M', module_name, 'DelTime:' )
   574:            !!$    call MessageNotify( 'M', module_name, '  DelTime  = %f [%c]', &
   575:            !!$      & d = (/ DelTimeValue /), c1 = trim( DelTimeUnit ) )
   576:            
   577:                call MessageNotify( 'M', module_name, 'nbmax         = %d', i = (/ nbmax /) )
   578:            
   579:            !!$    call MessageNotify( 'M', module_name, 'WNBnds              = (/ %*r /)', &
   580:            !!$      & r = real( a_WNBnds(0:nbmax) ), n = (/ nbmax+1 /) )
   581:            !!$    call MessageNotify( 'M', module_name, 'AbsCoefDryCom       = (/ %*r /)', &
   582:            !!$      & r = real( a_AbsCoefDryCom(1:nbmax) ), n = (/ nbmax /) )
   583:            !!$    call MessageNotify( 'M', module_name, 'PressScaleIndDryCom = (/ %*r /)', &
   584:            !!$      & r = real( a_PressScaleIndDryCom(1:nbmax) ), n = (/ nbmax /) )
   585:            !!$    call MessageNotify( 'M', module_name, 'RefPressDryCom      = (/ %*r /)', &
   586:            !!$      & r = real( a_RefPressDryCom(1:nbmax) ), n = (/ nbmax /) )
   587:            !!$    call MessageNotify( 'M', module_name, 'AbsCoefH2OVap       = (/ %*r /)', &
   588:            !!$      & r = real( a_AbsCoefH2OVap(1:nbmax) ), n = (/ nbmax /) )
   589:            !!$    call MessageNotify( 'M', module_name, 'PressScaleIndH2OVap = (/ %*r /)', &
   590:            !!$      & r = real( a_PressScaleIndH2OVap(1:nbmax) ), n = (/ nbmax /) )
   591:            !!$    call MessageNotify( 'M', module_name, 'RefPressH2OVap      = (/ %*r /)', &
   592:            !!$      & r = real( a_RefPressH2OVap(1:nbmax) ), n = (/ nbmax /) )
   593:            
   594: +------>       do n = 1, nbmax
   595: |                call MessageNotify( 'M', module_name, '  %d : %f %f %f %f %f %f %f %f',       &
   596: |                  & i = (/ n /),                                                              &
   597: |                  & d = (/ a_WNBnds(n-1)*1.0e-2, a_WNBnds(n)*1.0e-2,                          &
   598: |                  &        a_AbsCoefDryCom(n), a_PressScaleIndDryCom(n), a_RefPressDryCom(n), &
   599: |                  &        a_AbsCoefH2OVap(n), a_PressScaleIndH2OVap(n), a_RefPressH2OVap(n) /) )
   600: +------        end do
   601:            
   602:                call MessageNotify( 'M', module_name, 'DiffFact      = %f', d = (/ DiffFact /) )
   603:            !
   604:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   605:            
   606:                rad_simple_LW_inited = .true.
   607:            
   608:              end subroutine RadSimpleLWInit
   609:            
   610:              !--------------------------------------------------------------------------------------
   611:            
   612:            end module rad_simple_LW
