Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:57 2012
FILE NAME: set_Mars_dust.f90
PROGRAM NAME: set_mars_dust
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   180  vec  (   3): Unvectorized loop.
   180  vec  (  13): Overhead of loop division is too large.
   181  opt  (1592): Outer loop unrolled inside inner loop.
   181  vec  (   4): Vectorized array expression.
   181  vec  (   4): Vectorized array expression.
   188  opt  (1593): Loop nest collapsed into one loop.
   188  vec  (   4): Vectorized array expression.
   189  vec  (   3): Unvectorized loop.
   189  vec  (  13): Overhead of loop division is too large.
   190  opt  (1037): Feedback of array elements.
   190  opt  (1592): Outer loop unrolled inside inner loop.
   190  vec  (   4): Vectorized array expression.
   190  vec  (   4): Vectorized array expression.
   297  opt  (  11): Fused array assignments. :line 297 - 300
   297  vec  (   4): Vectorized array expression.
   297  vec  (   4): Vectorized array expression.
   300  opt  (1592): Outer loop unrolled inside inner loop.
   308  opt  (1592): Outer loop unrolled inside inner loop.
   308  vec  (   4): Vectorized array expression.
   308  vec  (   4): Vectorized array expression.
   313  vec  (   3): Unvectorized loop.
   313  vec  (  13): Overhead of loop division is too large.
   313  vec  (   3): Unvectorized loop.
   313  vec  (  13): Overhead of loop division is too large.
   314  opt  (1592): Outer loop unrolled inside inner loop.
   314  vec  (   4): Vectorized array expression.
   314  vec  (   4): Vectorized array expression.
   326  opt  (1592): Outer loop unrolled inside inner loop.
   326  vec  (   4): Vectorized array expression.
   326  vec  (   4): Vectorized array expression.
   331  vec  (   3): Unvectorized loop.
   331  vec  (  13): Overhead of loop division is too large.
   331  vec  (   3): Unvectorized loop.
   331  vec  (  13): Overhead of loop division is too large.
   332  opt  (1592): Outer loop unrolled inside inner loop.
   332  vec  (   4): Vectorized array expression.
   332  vec  (   4): Vectorized array expression.
   365  vec  (   3): Unvectorized loop.
   365  vec  (  13): Overhead of loop division is too large.
   366  opt  (1592): Outer loop unrolled inside inner loop.
   366  vec  (   4): Vectorized array expression.
   366  vec  (   4): Vectorized array expression.
   371  opt  (1592): Outer loop unrolled inside inner loop.
   371  vec  (   4): Vectorized array expression.
   371  vec  (   4): Vectorized array expression.
   375  opt  (1593): Loop nest collapsed into one loop.
   375  vec  (   4): Vectorized array expression.
   376  vec  (   3): Unvectorized loop.
   376  vec  (  13): Overhead of loop division is too large.
   377  opt  (1037): Feedback of array elements.
   377  opt  (1592): Outer loop unrolled inside inner loop.
   377  vec  (   4): Vectorized array expression.
   377  vec  (   4): Vectorized array expression.
   381  opt  (1592): Outer loop unrolled inside inner loop.
   381  vec  (   4): Vectorized array expression.
   381  vec  (   4): Vectorized array expression.
   382  vec  (   3): Unvectorized loop.
   382  vec  (  13): Overhead of loop division is too large.
   383  opt  (1592): Outer loop unrolled inside inner loop.
   383  vec  (   4): Vectorized array expression.
   383  vec  (   4): Vectorized array expression.
   514  vec  (   3): Unvectorized loop.
   514  vec  (  13): Overhead of loop division is too large.
   521  vec  (   4): Vectorized array expression.
   529  vec  (   4): Vectorized array expression.
   534  opt  (  11): Fused array assignments. :line 534 - 539
   534  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:57 2012
FILE NAME: set_Mars_dust.f90
PROGRAM NAME: set_mars_dust
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  !=
     2  !
     3  != Dust distribution is set
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: set_Mars_dust.f90,v 1.10 2012-09-17 11:00:19 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  module set_Mars_dust
    12    !
    13    !=
    14    !
    15    != Dust distribution is set
    16    !
    17    ! <b>Note that Japanese and English are described in parallel.</b>
    18    !
    19    !
    20    !
    21    !
    22    !
    23    !
    24    !== References
    25    !
    26    !  Lewis, S. R., Collins, M., Forget, F.,
    27    !    Mars climate database v3.0 detailed design document,
    28    !    Technical Note. Contract 11369/95/NL/JG. Work Package 7, ESA, 2001.
    29    !
    30    !== Procedures List
    31    !
    32  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    33  !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    34  !!$  ! RadiationFluxOutput     :: ͥեåν
    35  !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    36  !!$  ! ------------            :: ------------
    37  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    38  !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    39  !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    40  !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    41    !
    42    !== NAMELIST
    43    !
    44  !!$  ! NAMELIST#radiation_DennouAGCM_nml
    45    !
    46  
    47    ! USE statements
    48    !
    49  
    50    !
    51    ! Kind type parameter
    52    !
    53    use dc_types, only: DP, &      ! Double precision.
    54      &                 STRING, &  ! Strings.
    55      &                 TOKEN      ! Keywords.
    56  
    57    ! ʻ
    58    ! Grid points settings
    59    !
    60    use gridset, only: imax, & ! ٳʻ.
    61                               ! Number of grid points in longitude
    62      &                jmax, & ! ٳʻ.
    63                               ! Number of grid points in latitude
    64      &                kmax    ! ľؿ.
    65                               ! Number of vertical level
    66  
    67    implicit none
    68  
    69    private
    70  
    71  
    72    ! ѿ
    73    ! Public variables
    74    !
    75    logical, save, public:: set_Mars_dust_inited = .false.
    76                                ! ե饰.
    77                                ! Initialization flag
    78  
    79    ! Private variables
    80    !
    81    real(DP), save :: DustExtEff
    82    real(DP), save :: REff
    83    real(DP), save :: RhoDust
    84  
    85  
    86    character(STRING), save :: DustScenario
    87    real(DP)         , save :: DOD067       ! Dust optical depth at 0.67 micron.
    88    real(DP)         , save :: DustVerDistCoef
    89  
    90    real(DP)         , save :: DustOptDepRefPress
    91    real(DP)         , save :: DustVerDistRefPress
    92  
    93    integer          , save      :: IDDustScenario
    94    integer          , parameter :: IDDustScenarioConst          = 1
    95    integer          , parameter :: IDDustScenarioVikingNoDS     = 2
    96    integer          , parameter :: IDDustScenarioViking         = 3
    97    integer          , parameter :: IDDustScenarioMGS            = 4
    98    integer          , parameter :: IDDustScenarioMGSDODFromFile = 5
    99  
   100    character(STRING), save      :: DODFileName
   101    character(STRING), save      :: DODVarName
   102  
   103    public :: SetMarsDustCalcDOD067
   104    public :: SetMarsDustSetDOD067
   105    public :: SetMarsDustInit
   106  
   107    character(*), parameter:: module_name = 'set_Mars_dust'
   108                                ! ⥸塼̾.
   109                                ! Module name
   110    character(*), parameter:: version = &
   111      & '$Name: dcpam5-20120921 $' // &
   112      & '$Id: set_Mars_dust.f90,v 1.10 2012-09-17 11:00:19 yot Exp $'
   113                                ! ⥸塼ΥС
   114                                ! Module version
   115  
   116    !--------------------------------------------------------------------------------------
   117  
   118  contains
   119  
   120    !--------------------------------------------------------------------------------------
   121  
   122    subroutine SetMarsDustCalcDOD067( &
   123      & xyr_Press, xyz_QDust,         & ! (in)
   124      & xyr_DOD067                    & ! (out)
   125      & )
   126      !
   127      !
   128      !
   129      ! Calculate dust optical depth at 0.67 micron
   130      !
   131  
   132      ! ⥸塼 ; USE statements
   133      !
   134  
   135      ! å
   136      ! Message output
   137      !
   138      use dc_message, only: MessageNotify
   139  
   140      ! ҥȥǡ
   141      ! History data output
   142      !
   143      use gtool_historyauto, only: HistoryAutoPut
   144  
   145      ! ʪ
   146      ! Physical constants settings
   147      !
   148      use constants, only: Grav
   149  
   150  
   151      ! ʸ ; Declaration statements
   152      !
   153  
   154      real(DP), intent(in ):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   155                                ! Pressure
   156      real(DP), intent(in ):: xyz_QDust (0:imax-1, 1:jmax, 1:kmax)
   157                                ! Dust mixing ratio
   158      real(DP), intent(out):: xyr_DOD067(0:imax-1, 1:jmax, 0:kmax)
   159                                ! Optical depth
   160  
   161      ! ѿ
   162      ! Work variables
   163      !
   164      real(DP)            :: xyz_DelDOD(0:imax-1, 1:jmax, 1:kmax)
   165  
   166      integer :: k             ! ľ˲ DO 롼Ѻѿ
   167                               ! Work variables for DO loop in vertical direction
   168  
   169      ! ¹ʸ ; Executable statement
   170      !
   171  
   172      ! 
   173      ! Initialization
   174      !
   175      if ( .not. set_Mars_dust_inited ) then
   176        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   177      end if
   178  
   179  
   180      do k = 1, kmax
   181        xyz_DelDOD(:,:,k) =                                            &
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t108 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t110 = 1, imax                                           
     .                 xyz_deldod(t110-1,t108,k) = 7.50000000000000e-001*       
     .       1            dustexteff/(reff*rhodust*grav)*xyz_qdust(t110-1,t108,k
     .       2            )*(xyr_press(t110-1,t108,k-1)-xyr_press(t110-1,t108,k)
     .       3            )                                                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t108 = J1 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t110 = 1, imax                                           
     .                 xyz_deldod(t110-1,t108,k) = ((7.50000000000000e-001*     
     .       1            dustexteff)/((reff*rhodust)*grav))*xyz_qdust(t110-1,  
     .       2            t108,k)*(xyr_press(t110-1,t108,k-1)-xyr_press(t110-1, 
     .       3            t108,k))                                              
     .                 xyz_deldod(t110-1,t108+1,k) = ((7.50000000000000e-001*   
     .       1            dustexteff)/((reff*rhodust)*grav))*xyz_qdust(t110-1,  
     .       2            t108+1,k)*(xyr_press(t110-1,t108+1,k-1)-xyr_press(t110
     .       3            -1,t108+1,k))                                         
     .                 xyz_deldod(t110-1,t108+2,k) = ((7.50000000000000e-001*   
     .       1            dustexteff)/((reff*rhodust)*grav))*xyz_qdust(t110-1,  
     .       2            t108+2,k)*(xyr_press(t110-1,t108+2,k-1)-xyr_press(t110
     .       3            -1,t108+2,k))                                         
     .                 xyz_deldod(t110-1,t108+3,k) = ((7.50000000000000e-001*   
     .       1            dustexteff)/((reff*rhodust)*grav))*xyz_qdust(t110-1,  
     .       2            t108+3,k)*(xyr_press(t110-1,t108+3,k-1)-xyr_press(t110
     .       3            -1,t108+3,k))                                         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   182          &   3.0_DP / 4.0_DP * DustExtEff / ( REff * RhoDust * Grav ) &
   183          & * xyz_QDust(:,:,k)                                         &
   184          & * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) )
   185      end do
   186  
   187      k = kmax
   188      xyr_DOD067(:,:,k) = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t120 = 1, jmax*imax                                            
     .           xyr_dod067(t120-1,1,k) = 0.0000000000000000e+000               
     .        end do                                                            
   189      do k = kmax-1, 0, -1
   190        xyr_DOD067(:,:,k) = xyr_DOD067(:,:,k+1) + xyz_DelDOD(:,:,k)
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t126 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t128 = 1, imax                                           
     .                 xyr_dod067(t128-1,t126,k) = xyr_dod067(t128-1,t126,k+1)  
     .       1             + xyz_deldod(t128-1,t126,k)                          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t126 = J2 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t128 = 1, imax                                           
     .                 xyr_dod067(t128-1,t126,k) = xyr_dod067(t128-1,t126,k+1)  
     .       1             + xyz_deldod(t128-1,t126,k)                          
     .                 xyr_dod067(t128-1,t126+1,k) = xyr_dod067(t128-1,t126+1,k+
     .       1            1) + xyz_deldod(t128-1,t126+1,k)                      
     .                 xyr_dod067(t128-1,t126+2,k) = xyr_dod067(t128-1,t126+2,k+
     .       1            1) + xyz_deldod(t128-1,t126+2,k)                      
     .                 xyr_dod067(t128-1,t126+3,k) = xyr_dod067(t128-1,t126+3,k+
     .       1            1) + xyz_deldod(t128-1,t126+3,k)                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   191      end do
   192  
   193  
   194      ! ҥȥǡ
   195      ! History data output
   196      !
   197  
   198  
   199    end subroutine SetMarsDustCalcDOD067
   200  
   201    !--------------------------------------------------------------------------------------
   202  
   203    subroutine SetMarsDustSetDOD067( &
   204      & Ls, xyr_Press, xyz_Press,    & ! (out) optional & ! (in)
   205      & xyr_DOD067                   & ! (out)
   206      & )
   207      !
   208      !
   209      !
   210      ! Set dust optical depth at 0.67 micron
   211      !
   212  
   213      ! ⥸塼 ; USE statements
   214      !
   215  
   216      ! å
   217      ! Message output
   218      !
   219      use dc_message, only: MessageNotify
   220  
   221      ! ҥȥǡ
   222      ! History data output
   223      !
   224      use gtool_historyauto, only: HistoryAutoPut
   225  
   226      ! 
   227      ! Time control
   228      !
   229      use timeset, only: &
   230        & TimeN
   231  
   232      ! ʪ
   233      ! Physical and mathematical constants settings
   234      !
   235      use constants0, only: &
   236        & PI                    ! $ \pi $.
   237                                ! ߼Ψ. Circular constant
   238  
   239      ! ʪ
   240      ! Physical constants settings
   241      !
   242      use constants, only: Grav
   243  
   244      ! ɸǡ
   245      ! Axes data settings
   246      !
   247      use axesset, only: &
   248        & y_Lat    ! $ \varphi $ [rad.] . . Latitude
   249  
   250      ! ǡɤ߹
   251      ! Reading time series
   252      !
   253      use read_time_series, only: SetValuesFromTimeSeriesWrapper
   254  
   255  
   256      ! ʸ ; Declaration statements
   257      !
   258  
   259      real(DP), intent(in ):: Ls
   260                                ! Ls
   261      real(DP), intent(in ):: xyr_Press    (0:imax-1, 1:jmax, 0:kmax)
   262                                ! Pressure
   263      real(DP), intent(in ):: xyz_Press    (0:imax-1, 1:jmax, 1:kmax)
   264                                ! Pressure
   265      real(DP), intent(out):: xyr_DOD067   (0:imax-1, 1:jmax, 0:kmax)
   266                                ! Optical depth
   267  
   268      ! ѿ
   269      ! Work variables
   270      !
   271      real(DP)            :: DOD
   272      real(DP)            :: xy_DOD067       (0:imax-1, 1:jmax)
   273                                ! Dust optical depth at 0.67 micron
   274      real(DP)            :: xyz_MixRtDust   (0:imax-1, 1:jmax, 1:kmax)
   275      real(DP)            :: xy_DODFac       (0:imax-1, 1:jmax)
   276      real(DP)            :: xy_MaxHeightDust(0:imax-1, 1:jmax)
   277  
   278      real(DP)            :: MixRtDust0
   279  
   280      integer :: j
   281      integer :: k             ! ľ˲ DO 롼Ѻѿ
   282                               ! Work variables for DO loop in vertical direction
   283  
   284      ! ¹ʸ ; Executable statement
   285      !
   286  
   287      ! 
   288      ! Initialization
   289      !
   290      if ( .not. set_Mars_dust_inited ) then
   291        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   292      end if
   293  
   294  
   295      select case ( IDDustScenario )
   296      case ( IDDustScenarioConst )
   297        xy_DOD067 = DOD067
     .        if (xy_dod067.DSC.U2 .gt. 0) then                                 
     .           J1 = and(xy_dod067.DSC.U2,1)                                   
     .  !CDIR    NODEP                                                          
     .           do t367 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t369=1,xy_dod067.DSC.U1+2-min0(1,xy_dod067.DSC.U1+1)     
     .                 xy_dod067(t369-1,t367) = dod067                          
     .                 xy_maxheightdust(t369-1,t367) = 7.00000000000000e+004    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t367 = J1 + 1, xy_dod067.DSC.U2, 2                          
     .  !CDIR       NODEP                                                       
     .              do t369=1,xy_dod067.DSC.U1+2-min0(1,xy_dod067.DSC.U1+1)     
     .                 xy_dod067(t369-1,t367) = dod067                          
     .                 xy_dod067(t369-1,t367+1) = dod067                        
     .                 xy_maxheightdust(t369-1,t367) = 7.00000000000000e+004    
     .                 xy_maxheightdust(t369-1,t367+1) = 7.00000000000000e+004  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10008                                                       
   298  
   299        ! Height of dust top
   300        xy_MaxHeightDust = 70.0d3
   301  
   302      case ( IDDustScenarioVikingNoDS )
   303  
   304        call SetMarsDustDODVikingNoDS( &
   305          & Ls, & ! (in)
   306          & DOD & ! (out)
   307          & )
   308        xy_DOD067 = DOD
     .        if (xy_dod067.DSC.U2 .gt. 0) then                                 
     .           J2 = and(xy_dod067.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t358 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t360 = 1, xy_dod067.DSC.U1 + 1                           
     .                 xy_dod067(t360-1,t358) = dod                             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t358 = J2 + 1, xy_dod067.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t360 = 1, xy_dod067.DSC.U1 + 1                           
     .                 xy_dod067(t360-1,t358) = dod                             
     .                 xy_dod067(t360-1,t358+1) = dod                           
     .                 xy_dod067(t360-1,t358+2) = dod                           
     .                 xy_dod067(t360-1,t358+3) = dod                           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   309  
   310        ! Height of dust top
   311  !!$      xy_MaxHeightDust = 70.0d3
   312        !
   313        do j = 1, jmax
   314          xy_MaxHeightDust(:,j) =                                 &
   315            &   60.0d3                                            &
   316            & + 18.0d3 * sin( ( Ls - 158.0_DP ) * PI / 180.0_DP ) &
   317            & - 22.0d3 * sin( y_Lat(j) )**2
   318        end do
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,3)                                               
     .           do j = 1, J3                                                   
     .              D1 = (ls - 1.58000000000000e+002)/1.80000000000000e+002     
     .  !CDIR       NODEP                                                       
     .              do t364 = 1, xy_maxheightdust.DSC.U1 + 1                    
     .                 xy_maxheightdust(t364-1,j) = 6.00000000000000e+004 +     
     .       1            1.80000000000000e+004*dsin(3.14159265358979e+000*D1)  
     .       2             - 2.20000000000000e+004*dsin(y_lat(j))**2            
     .              end do                                                      
     .           end do                                                         
     .           do j = J3 + 1, jmax, 4                                         
     .              D2 = 1.D0/1.80000000000000e+002                             
     .              D3 = 1.D0/1.80000000000000e+002                             
     .              D4 = 1.D0/1.80000000000000e+002                             
     .              D5 = 1.D0/1.80000000000000e+002                             
     .  !CDIR       NODEP                                                       
     .              do t364 = 1, xy_maxheightdust.DSC.U1 + 1                    
     .                 xy_maxheightdust(t364-1,j) = (6.00000000000000e+004 + (  
     .       1            1.80000000000000e+004*(dsin((((ls -                   
     .       2            1.58000000000000e+002)*3.14159265358979e+000)*D2))))) 
     .       3             - 2.20000000000000e+004*dsin(y_lat(j))**2            
     .                 xy_maxheightdust(t364-1,j+1) = (6.00000000000000e+004 + (
     .       1            1.80000000000000e+004*(dsin((((ls -                   
     .       2            1.58000000000000e+002)*3.14159265358979e+000)*D3))))) 
     .       3             - 2.20000000000000e+004*dsin(y_lat(j+1))**2          
     .                 xy_maxheightdust(t364-1,j+2) = (6.00000000000000e+004 + (
     .       1            1.80000000000000e+004*(dsin((((ls -                   
     .       2            1.58000000000000e+002)*3.14159265358979e+000)*D4))))) 
     .       3             - 2.20000000000000e+004*dsin(y_lat(j+2))**2          
     .                 xy_maxheightdust(t364-1,j+3) = (6.00000000000000e+004 + (
     .       1            1.80000000000000e+004*(dsin((((ls -                   
     .       2            1.58000000000000e+002)*3.14159265358979e+000)*D5))))) 
     .       3             - 2.20000000000000e+004*dsin(y_lat(j+3))**2          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10008                                                       
   319  
   320      case ( IDDustScenarioViking )
   321  
   322        call SetMarsDustDODViking( &
   323          & Ls, & ! (in)
   324          & DOD & ! (out)
   325          & )
   326        xy_DOD067 = DOD
     .        if (xy_dod067.DSC.U2 .gt. 0) then                                 
     .           J4 = and(xy_dod067.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t349 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t351 = 1, xy_dod067.DSC.U1 + 1                           
     .                 xy_dod067(t351-1,t349) = dod                             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t349 = J4 + 1, xy_dod067.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t351 = 1, xy_dod067.DSC.U1 + 1                           
     .                 xy_dod067(t351-1,t349) = dod                             
     .                 xy_dod067(t351-1,t349+1) = dod                           
     .                 xy_dod067(t351-1,t349+2) = dod                           
     .                 xy_dod067(t351-1,t349+3) = dod                           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   327  
   328        ! Height of dust top
   329  !!$      xy_MaxHeightDust = 70.0d3
   330        !
   331        do j = 1, jmax
   332          xy_MaxHeightDust(:,j) =                                 &
   333            &   60.0d3                                            &
   334            & + 18.0d3 * sin( ( Ls - 158.0_DP ) * PI / 180.0_DP ) &
   335            & - 22.0d3 * sin( y_Lat(j) )**2
   336        end do
     .        if (jmax .gt. 0) then                                             
     .           J5 = and(jmax,3)                                               
     .           do j = 1, J5                                                   
     .              D6 = (ls - 1.58000000000000e+002)/1.80000000000000e+002     
     .  !CDIR       NODEP                                                       
     .              do t355 = 1, xy_maxheightdust.DSC.U1 + 1                    
     .                 xy_maxheightdust(t355-1,j) = 6.00000000000000e+004 +     
     .       1            1.80000000000000e+004*dsin(3.14159265358979e+000*D6)  
     .       2             - 2.20000000000000e+004*dsin(y_lat(j))**2            
     .              end do                                                      
     .           end do                                                         
     .           do j = J5 + 1, jmax, 4                                         
     .              D7 = 1.D0/1.80000000000000e+002                             
     .              D8 = 1.D0/1.80000000000000e+002                             
     .              D9 = 1.D0/1.80000000000000e+002                             
     .              D10 = 1.D0/1.80000000000000e+002                            
     .  !CDIR       NODEP                                                       
     .              do t355 = 1, xy_maxheightdust.DSC.U1 + 1                    
     .                 xy_maxheightdust(t355-1,j) = (6.00000000000000e+004 + (  
     .       1            1.80000000000000e+004*(dsin((((ls -                   
     .       2            1.58000000000000e+002)*3.14159265358979e+000)*D7))))) 
     .       3             - 2.20000000000000e+004*dsin(y_lat(j))**2            
     .                 xy_maxheightdust(t355-1,j+1) = (6.00000000000000e+004 + (
     .       1            1.80000000000000e+004*(dsin((((ls -                   
     .       2            1.58000000000000e+002)*3.14159265358979e+000)*D8))))) 
     .       3             - 2.20000000000000e+004*dsin(y_lat(j+1))**2          
     .                 xy_maxheightdust(t355-1,j+2) = (6.00000000000000e+004 + (
     .       1            1.80000000000000e+004*(dsin((((ls -                   
     .       2            1.58000000000000e+002)*3.14159265358979e+000)*D9))))) 
     .       3             - 2.20000000000000e+004*dsin(y_lat(j+2))**2          
     .                 xy_maxheightdust(t355-1,j+3) = (6.00000000000000e+004 + (
     .       1            1.80000000000000e+004*(dsin((((ls -                   
     .       2            1.58000000000000e+002)*3.14159265358979e+000)*D10)))))
     .       3             - 2.20000000000000e+004*dsin(y_lat(j+3))**2          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10008                                                       
   337  
   338      case ( IDDustScenarioMGS )
   339  
   340        call SetMarsDustDODMGS(          &
   341          & Ls,                          &
   342          & xy_DOD067, xy_MaxHeightDust  &
   343          & )
   344  
   345      case ( IDDustScenarioMGSDODFromFile )
   346  
   347        call SetMarsDustDODMGS(          &
   348          & Ls,                          &
   349          & xy_DOD067, xy_MaxHeightDust  &
   350          & )
   351  
   352        call SetValuesFromTimeSeriesWrapper( &
   353          & DODFileName, DODVarName, &
   354          & xy_DOD067,               &               ! (inout)
   355          & 'DOD'                    &
   356          & )
   357  
   358      case default
   359        call MessageNotify( 'E', module_name, 'DustScenario of %c is not supported.', c1 = trim( DustScenario ) )
   360      end select
   361  
   362  
   363      MixRtDust0      =   1.0_DP
   364  
   365      do k = 1, kmax
   366        xyz_MixRtDust(:,:,k) = MixRtDust0 &
     .        if (jmax .gt. 0) then                                             
     .           J6 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t285 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t287 = 1, imax                                           
     .                 xyz_mixrtdust(t287-1,t285,k) = mixrtdust0*dexp(          
     .       1            dustverdistcoef*(1.00000000000000e+000 - (            
     .       2            dustverdistrefpress/xyz_press(t287-1,t285,k))**(      
     .       3            7.00000000000000e+004/xy_maxheightdust(t287-1,t285))))
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t285 = J6 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t287 = 1, imax                                           
     .                 xyz_mixrtdust(t287-1,t285,k) = mixrtdust0*dexp(          
     .       1            dustverdistcoef*(1.00000000000000e+000 - (            
     .       2            dustverdistrefpress/xyz_press(t287-1,t285,k))**(      
     .       3            7.00000000000000e+004/xy_maxheightdust(t287-1,t285))))
     .                 xyz_mixrtdust(t287-1,t285+1,k) = mixrtdust0*dexp(        
     .       1            dustverdistcoef*(1.00000000000000e+000 - (            
     .       2            dustverdistrefpress/xyz_press(t287-1,t285+1,k))**(    
     .       3            7.00000000000000e+004/xy_maxheightdust(t287-1,t285+1))
     .       4            ))                                                    
     .                 xyz_mixrtdust(t287-1,t285+2,k) = mixrtdust0*dexp(        
     .       1            dustverdistcoef*(1.00000000000000e+000 - (            
     .       2            dustverdistrefpress/xyz_press(t287-1,t285+2,k))**(    
     .       3            7.00000000000000e+004/xy_maxheightdust(t287-1,t285+2))
     .       4            ))                                                    
     .                 xyz_mixrtdust(t287-1,t285+3,k) = mixrtdust0*dexp(        
     .       1            dustverdistcoef*(1.00000000000000e+000 - (            
     .       2            dustverdistrefpress/xyz_press(t287-1,t285+3,k))**(    
     .       3            7.00000000000000e+004/xy_maxheightdust(t287-1,t285+3))
     .       4            ))                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   367          & * exp( DustVerDistCoef        &
   368          &        * ( 1.0_DP - ( DustVerDistRefPress / xyz_Press(:,:,k) )**(70.0d3/xy_MaxHeightDust) ) &
   369          &      )
   370      end do
   371      xyz_MixRtDust = min( xyz_MixRtDust, MixRtDust0 )
     .        if (xyz_mixrtdust.DSC.U2 .gt. 0) then                             
     .           J7 = and(xyz_mixrtdust.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t297 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t299 = 1, xyz_mixrtdust.DSC.U1 + 1                       
     .                 xyz_mixrtdust(t299-1,t297,t295+1) = min(xyz_mixrtdust(   
     .       1            t299-1,t297,t295+1),mixrtdust0)                       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t297 = J7 + 1, xyz_mixrtdust.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t299 = 1, xyz_mixrtdust.DSC.U1 + 1                       
     .                 xyz_mixrtdust(t299-1,t297,t295+1) = min(xyz_mixrtdust(   
     .       1            t299-1,t297,t295+1),mixrtdust0)                       
     .                 xyz_mixrtdust(t299-1,t297+1,t295+1) = min(xyz_mixrtdust( 
     .       1            t299-1,t297+1,t295+1),mixrtdust0)                     
     .                 xyz_mixrtdust(t299-1,t297+2,t295+1) = min(xyz_mixrtdust( 
     .       1            t299-1,t297+2,t295+1),mixrtdust0)                     
     .                 xyz_mixrtdust(t299-1,t297+3,t295+1) = min(xyz_mixrtdust( 
     .       1            t299-1,t297+3,t295+1),mixrtdust0)                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   372  
   373  
   374      k = kmax
   375      xyr_DOD067(:,:,k) = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t307 = 1, jmax*imax                                            
     .           xyr_dod067(t307-1,1,k) = 0.0000000000000000e+000               
     .        end do                                                            
   376      do k = kmax-1, 0, -1
   377        xyr_DOD067(:,:,k) = xyr_DOD067(:,:,k+1) &
     .        if (jmax .gt. 0) then                                             
     .           J8 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t313 = 1, J8                                                
     .              D11 = 1.D0/grav                                             
     .  !CDIR       NODEP                                                       
     .              do t315 = 1, imax                                           
     .                 xyr_dod067(t315-1,t313,k) = xyr_dod067(t315-1,t313,k+1)  
     .       1             + xyz_mixrtdust(t315-1,t313,k+1)*(xyr_press(t315-1,  
     .       2            t313,k)-xyr_press(t315-1,t313,k+1))*D11               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t313 = J8 + 1, jmax, 4                                      
     .              D12 = 1.D0/grav                                             
     .              D13 = 1.D0/grav                                             
     .              D14 = 1.D0/grav                                             
     .              D15 = 1.D0/grav                                             
     .  !CDIR       NODEP                                                       
     .              do t315 = 1, imax                                           
     .                 xyr_dod067(t315-1,t313,k) = xyr_dod067(t315-1,t313,k+1)  
     .       1             + xyz_mixrtdust(t315-1,t313,k+1)*(xyr_press(t315-1,  
     .       2            t313,k)-xyr_press(t315-1,t313,k+1))*D12               
     .                 xyr_dod067(t315-1,t313+1,k) = xyr_dod067(t315-1,t313+1,k+
     .       1            1) + xyz_mixrtdust(t315-1,t313+1,k+1)*(xyr_press(t315-
     .       2            1,t313+1,k)-xyr_press(t315-1,t313+1,k+1))*D13         
     .                 xyr_dod067(t315-1,t313+2,k) = xyr_dod067(t315-1,t313+2,k+
     .       1            1) + xyz_mixrtdust(t315-1,t313+2,k+1)*(xyr_press(t315-
     .       2            1,t313+2,k)-xyr_press(t315-1,t313+2,k+1))*D14         
     .                 xyr_dod067(t315-1,t313+3,k) = xyr_dod067(t315-1,t313+3,k+
     .       1            1) + xyz_mixrtdust(t315-1,t313+3,k+1)*(xyr_press(t315-
     .       2            1,t313+3,k)-xyr_press(t315-1,t313+3,k+1))*D15         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   378          & + xyz_MixRtDust(:,:,k+1) * ( xyr_Press(:,:,k) - xyr_Press(:,:,k+1) ) / Grav
   379      end do
   380  
   381      xy_DODFac = xy_DOD067 * xyr_Press(:,:,0) / DustOptDepRefPress / xyr_DOD067(:,:,0)
     .        if (xy_dod067.DSC.U2 .gt. 0) then                                 
     .           J9 = and(xy_dod067.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t327 = 1, J9                                                
     .              D16 = 1.D0/dustoptdeprefpress                               
     .  !CDIR       NODEP                                                       
     .              do t329 = 1, xy_dod067.DSC.U1 + 1                           
     .                 xy_dodfac(t329-1,t327) = xy_dod067(t329-1,t327)*xyr_press
     .       1            (t329-1,t327,0)*D16/xyr_dod067(t329-1,t327,0)         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t327 = J9 + 1, xy_dod067.DSC.U2, 4                          
     .              D17 = 1.D0/dustoptdeprefpress                               
     .              D18 = 1.D0/dustoptdeprefpress                               
     .              D19 = 1.D0/dustoptdeprefpress                               
     .              D20 = 1.D0/dustoptdeprefpress                               
     .  !CDIR       NODEP                                                       
     .              do t329 = 1, xy_dod067.DSC.U1 + 1                           
     .                 xy_dodfac(t329-1,t327) = xy_dod067(t329-1,t327)*xyr_press
     .       1            (t329-1,t327,0)*D17/xyr_dod067(t329-1,t327,0)         
     .                 xy_dodfac(t329-1,t327+1) = xy_dod067(t329-1,t327+1)*     
     .       1            xyr_press(t329-1,t327+1,0)*D18/xyr_dod067(t329-1,t327+
     .       2            1,0)                                                  
     .                 xy_dodfac(t329-1,t327+2) = xy_dod067(t329-1,t327+2)*     
     .       1            xyr_press(t329-1,t327+2,0)*D19/xyr_dod067(t329-1,t327+
     .       2            2,0)                                                  
     .                 xy_dodfac(t329-1,t327+3) = xy_dod067(t329-1,t327+3)*     
     .       1            xyr_press(t329-1,t327+3,0)*D20/xyr_dod067(t329-1,t327+
     .       2            3,0)                                                  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   382      do k = 0, kmax
   383        xyr_DOD067(:,:,k) = xyr_DOD067(:,:,k) * xy_DODFac
     .        if (jmax .gt. 0) then                                             
     .           J10 = and(jmax,3)                                              
     .  !CDIR    NODEP                                                          
     .           do t339 = 1, J10                                               
     .  !CDIR       NODEP                                                       
     .              do t341 = 1, imax                                           
     .                 xyr_dod067(t341-1,t339,k) = xyr_dod067(t341-1,t339,k)*   
     .       1            xy_dodfac(t341-1,t339)                                
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t339 = J10 + 1, jmax, 4                                     
     .  !CDIR       NODEP                                                       
     .              do t341 = 1, imax                                           
     .                 xyr_dod067(t341-1,t339,k) = xyr_dod067(t341-1,t339,k)*   
     .       1            xy_dodfac(t341-1,t339)                                
     .                 xyr_dod067(t341-1,t339+1,k) = xyr_dod067(t341-1,t339+1,k)
     .       1            *xy_dodfac(t341-1,t339+1)                             
     .                 xyr_dod067(t341-1,t339+2,k) = xyr_dod067(t341-1,t339+2,k)
     .       1            *xy_dodfac(t341-1,t339+2)                             
     .                 xyr_dod067(t341-1,t339+3,k) = xyr_dod067(t341-1,t339+3,k)
     .       1            *xy_dodfac(t341-1,t339+3)                             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   384      end do
   385  
   386  
   387      ! ҥȥǡ
   388      ! History data output
   389      !
   390      call HistoryAutoPut( TimeN, 'DustPresc'    , xyz_MixRtDust    )
   391      call HistoryAutoPut( TimeN, 'DustMaxHeight', xy_MaxHeightDust )
   392  
   393  
   394    end subroutine SetMarsDustSetDOD067
   395  
   396    !--------------------------------------------------------------------------------------
   397  
   398    subroutine SetMarsDustDODViking( &
   399      & Ls, & ! (in)
   400      & DOD & ! (out)
   401      & )
   402  
   403      real(DP), intent(in ) :: Ls
   404      real(DP), intent(out) :: DOD
   405  
   406  
   407      !
   408      ! Local variables
   409      !
   410      real(DP) :: DODDS1
   411      real(DP) :: DODDS2
   412      real(DP) :: DSLs
   413      real(DP) :: MaxDOD
   414      real(DP) :: DSDTC
   415  
   416  
   417      call SetMarsDustDODVikingNoDS( &
   418        & Ls, & ! (in)
   419        & DOD & ! (out)
   420        & )
   421  
   422      ! Add two dust storms
   423      !
   424      DSLs   = 210.0_DP
   425      MaxDOD = 2.7_DP
   426      DSDTC  = 50.0_DP
   427      call SetMarsDustDSExp( &
   428        & Ls, DSLs, MaxDOD, DSDTC, & ! (in)
   429        & DODDS1                   & ! (out)
   430        & )
   431  
   432      DSLs   = 280.0_DP
   433      MaxDOD = 4.0_DP
   434      DSDTC  = 50.0_DP
   435      call SetMarsDustDSExp( &
   436        & Ls, DSLs, MaxDOD, DSDTC, & ! (in)
   437        & DODDS2                   & ! (out)
   438        & )
   439  
   440      DOD = max( DOD, DODDS1, DODDS2 )
   441  
   442  
   443    end subroutine SetMarsDustDODViking
   444  
   445    !--------------------------------------------------------------------------------------
   446  
   447    subroutine SetMarsDustDODVikingNoDS( &
   448      & Ls, & ! (in)
   449      & DOD & ! (out)
   450      & )
   451  
   452      ! ʪ
   453      ! Physical constants settings
   454      !
   455      use constants0, only: PI
   456  
   457      real(DP), intent(in ) :: Ls
   458      real(DP), intent(out) :: DOD
   459  
   460  
   461      ! This expression is obtained from Lewis et al. [1999].
   462      !
   463      DOD = 0.7_DP + 0.3_DP * cos( ( Ls + 80.0_DP ) * PI / 180.0_DP )
   464  
   465  
   466    end subroutine SetMarsDustDODVikingNoDS
   467  
   468    !----------------------------------------------------------------------------
   469  
   470    subroutine SetMarsDustDODMGS( &
   471      & Ls,                       &
   472      & xy_DOD, xy_MaxHeight      &
   473      & )
   474  
   475      ! ʪ
   476      ! Physical constants settings
   477      !
   478      use constants0, only: PI
   479  
   480      ! ɸǡ
   481      ! Axes data settings
   482      !
   483      use axesset, only: &
   484        & y_Lat    ! $ \varphi $ [rad.] . . Latitude
   485  
   486      real(DP), intent(in ) :: Ls
   487      real(DP), intent(out) :: xy_DOD      (0:imax-1, 1:jmax)
   488      real(DP), intent(out) :: xy_MaxHeight(0:imax-1, 1:jmax)
   489  
   490  
   491      ! Local variables
   492  
   493      real(DP) :: DODEq
   494      real(DP) :: DODSouth
   495      real(DP) :: DODNorth
   496      real(DP) :: LsFactor
   497  
   498      integer  :: j
   499  
   500  
   501      DODEq    =                &
   502        &   0.2_DP              &
   503        & + ( 0.5_DP - 0.2_DP ) &
   504        &   * cos( ( Ls - 250.0_DP ) / 2.0_DP * PI / 180.0_DP )**14
   505      DODSouth =                &
   506        &   0.1_DP              &
   507        & + ( 0.5_DP - 0.1_DP ) &
   508        &   * cos( ( Ls - 250.0_DP ) / 2.0_DP * PI / 180.0_DP )**14
   509      DODNorth = 0.1_DP
   510  
   511  
   512      LsFactor = sin( ( Ls - 160.0_DP ) * PI / 180.0_DP )
   513  
   514      do j = 1, jmax
   515  
   516        if( y_Lat(j) > 0.0_DP ) then
   517          ! wrong
   518  !!$        xy_DOD(:,j) = DODNorth              &
   519  !!$          & + 0.5_DP * ( DODEq - DODNorth ) &
   520  !!$          &   * ( 1.0_DP + tanh( ( 45.0_DP * PI / 180.0_DP - y_Lat(j) ) / 10.0_DP ) )
   521          xy_DOD(:,j) = DODNorth              &
     .  !CDIR NODEP                                                             
     .        do t121 = 1, imax                                                 
     .           xy_dod(t121-1,j) = dodnorth + 5.00000000000000e-001*(dodeq -   
     .       1      dodnorth)*(1.00000000000000e+000 + dtanh((                  
     .       2      7.85398163397448e-001 - y_lat(j))*1.00000000000000e+001))   
     .        end do                                                            
     .        go to 10005                                                       
   522            & + 0.5_DP * ( DODEq - DODNorth ) &
   523            &   * ( 1.0_DP + tanh( ( 45.0_DP * PI / 180.0_DP - y_Lat(j) ) * 10.0_DP ) )
   524        else
   525          ! wrong
   526  !!$        xy_DOD(:,j) = DODSouth              &
   527  !!$          & + 0.5_DP * ( DODEq - DODSouth ) &
   528  !!$          &   * ( 1.0_DP + tanh( ( 45.0_DP * PI / 180.0_DP + y_Lat(j) ) / 10.0_DP ) )
   529          xy_DOD(:,j) = DODSouth              &
     .  !CDIR NODEP                                                             
     .        do t113 = 1, imax                                                 
     .           xy_dod(t113-1,j) = dodsouth + 5.00000000000000e-001*(dodeq -   
     .       1      dodsouth)*(1.00000000000000e+000 + dtanh((                  
     .       2      7.85398163397448e-001 + y_lat(j))*1.00000000000000e+001))   
     .        end do                                                            
   530            & + 0.5_DP * ( DODEq - DODSouth ) &
   531            &   * ( 1.0_DP + tanh( ( 45.0_DP * PI / 180.0_DP + y_Lat(j) ) * 10.0_DP ) )
   532        end if
   533  
   534        xy_MaxHeight(:,j) =                                         &
     .  !CDIR NODEP                                                             
     .        do t116 = 1, imax                                                 
     .           xy_maxheight1 = 6.00000000000000e+001 + (1.80000000000000e+001*
     .       1      lsfactor) - (3.20000000000000e+001 + (1.80000000000000e+001*
     .       2      lsfactor))*(dsin(y_lat(j)))**4 - 8.00000000000000e+000*     
     .       3      lsfactor*(dsin(y_lat(j)))**5                                
     .           xy_maxheight(t116-1,j) = xy_maxheight1*1.00000000000000e+003   
     .        end do                                                            
   535          &   60.0_DP                                               &
   536          & + 18.0_DP * LsFactor                                    &
   537          & - ( 32.0_DP + 18.0_DP * LsFactor ) * sin( y_Lat(j) )**4 &
   538          & - 8.0_DP * LsFactor * sin( y_Lat(j) )**5
   539        xy_MaxHeight(:,j) = xy_MaxHeight(:,j) * 1.0d3
   540  
   541      end do
   542  
   543  
   544    end subroutine SetMarsDustDODMGS
   545  
   546    !----------------------------------------------------------------------------
   547  !!$
   548  !!$  subroutine SetMarsDustDODMGS( &
   549  !!$    & Ls, &
   550  !!$    & Lat, &
   551  !!$    & DOD  &
   552  !!$    & )
   553  !!$
   554  !!$    real(DP), intent(in ) :: Ls
   555  !!$    real(DP), intent(in ) :: Lat
   556  !!$    real(DP), intent(out) :: DOD
   557  !!$
   558  !!$
   559  !!$    ! Local variables
   560  !!$    ! lat2     : Temporary variable for latitude
   561  !!$    ! interc   : Intercept
   562  !!$    ! amp      :
   563  !!$    ! phase    : Phase (degree)
   564  !!$
   565  !!$    real(DP) :: lat2
   566  !!$    real(DP) :: interc
   567  !!$    real(DP) :: amp, phase
   568  !!$
   569  !!$
   570  !!$    if( lat .lt. -40.0d0 ) then
   571  !!$      lat2 = -40.0d0
   572  !!$    else if( lat .gt. 40.0d0 ) then
   573  !!$      lat2 = 40.0d0
   574  !!$    else
   575  !!$      lat2 = lat
   576  !!$    endif
   577  !!$
   578  !!$    if( lat2 .gt. 0.0d0 ) then
   579  !!$      interc = 0.16d0 - 1.8d-3 * lat2
   580  !!$    else
   581  !!$      interc = 0.16d0 + 1.3d-3 * lat2
   582  !!$    endif
   583  !!$    amp   = 0.0623d0 - 0.015d0 * atan( ( lat2 + 2.0d0 ) / 5.0d0 )
   584  !!$    phase = 258.0d0 + 1.8d-1 * lat2
   585  !!$    dod   = interc + amp * cos( ( ls - phase ) * d2r )
   586  !!$
   587  !!$
   588  !!$    ! Dust optical depth at 9 micron is converted to that at 0.67 micron.
   589  !!$
   590  !!$    dod = dod * 2.0d0
   591  !!$
   592  !!$
   593  !!$  end subroutine SetMarsDustDODMGS
   594  !!$
   595  !!$    !**************************************************************************
   596  !!$
   597  !!$    subroutine dodMGS_1yr( ls, lat, dod )
   598  !!$
   599  !!$      use mars_const, only : d2r
   600  !!$
   601  !!$      real(dp), intent(in ) :: ls
   602  !!$      real(dp), intent(in ) :: lat
   603  !!$      real(dp), intent(out) :: dod
   604  !!$
   605  !!$
   606  !!$      ! Local variables
   607  !!$
   608  !!$      real(dp) :: dodds
   609  !!$      real(dp) :: dsls, maxdod, dsdtc
   610  !!$
   611  !!$
   612  !!$      call dodMGS( ls, lat, dod )
   613  !!$
   614  !!$
   615  !!$      !*****Add dust storms
   616  !!$      !-----First year
   617  !!$      dsls   = 227.0d0
   618  !!$      maxdod = 0.475d0
   619  !!$      dsdtc  = 35.0d0
   620  !!$      call duststormexp( ls, dodds, dsls, maxdod, dsdtc )
   621  !!$      dodds  = dodds * exp( -( lat - ( -20.0d0 ) )**2 / ( 60.0d0 )**2 )
   622  !!$      dodds  = dodds * 2.0d0
   623  !!$      dod    = max( dod, dodds )
   624  !!$
   625  !!$      dsls   = 235.0d0
   626  !!$      maxdod = 0.5d0
   627  !!$      dsdtc  = 50.0d0
   628  !!$      call duststormexp( ls, dodds, dsls, maxdod, dsdtc )
   629  !!$      dodds  = dodds * exp( -( lat - ( -60.0d0 ) )**2 / ( 60.0d0 )**2 )
   630  !!$      dodds  = dodds * 2.0d0
   631  !!$      dod    = max( dod, dodds )
   632  !!$
   633  !!$      dsls   = 259.0d0
   634  !!$      maxdod = 0.4d0
   635  !!$      dsdtc  = 70.0d0
   636  !!$      call duststormexp( ls, dodds, dsls, maxdod, dsdtc )
   637  !!$      dodds  = dodds * exp( -( lat - ( -80.0d0 ) )**2 / ( 30.0d0 )**2 )
   638  !!$      dodds  = dodds * 2.0d0
   639  !!$      dod    = max( dod, dodds )
   640  !!$
   641  !!$      !-----Second year
   642  !!$!      dsls   = 360.0d0 + 190.0d0
   643  !!$!      maxdod = 1.7d0
   644  !!$!      dsdtc  = 40.0d0
   645  !!$!      call duststormexp( ls, dodds, dsls, maxdod, dsdtc )
   646  !!$!      dodds  = dodds * exp( -( lat - ( -20.0d0 ) )**2 / ( 60.0d0 )**2 )
   647  !!$!      if( abs( lat ) .gt. 60.0d0 ) dodds = 0.0d0
   648  !!$!      dod    = max( dod, dodds )
   649  !!$
   650  !!$
   651  !!$    end subroutine dodMGS_1yr
   652  !!$
   653  !!$    !**************************************************************************
   654  !!$
   655  !!$    subroutine duststormlin( ls, dod, ls0, x1, y1, x2, y2 )
   656  !!$
   657  !!$      real(dp), intent(in ) :: ls
   658  !!$      real(dp), intent(out) :: dod
   659  !!$      real(dp), intent(in ) :: ls0
   660  !!$      real(dp), intent(in ) :: x1, y1, x2, y2
   661  !!$
   662  !!$
   663  !!$      ! Local variables
   664  !!$      !
   665  !!$      real(dp) :: a, b
   666  !!$      real(dp) :: tmpls
   667  !!$
   668  !!$
   669  !!$      a = ( y2 - y1 ) / ( x2 - x1 )
   670  !!$      b = y1 - ( y2 - y1 ) / ( x2 - x1 ) * x1
   671  !!$
   672  !!$      if( ls .lt. ls0 ) then
   673  !!$         tmpls = ls + 360.0d0
   674  !!$      else
   675  !!$         tmpls = ls
   676  !!$      endif
   677  !!$
   678  !!$      dod = a * tmpls + b
   679  !!$
   680  !!$      dod = max( dod, 0.0d0 )
   681  !!$
   682  !!$
   683  !!$    end subroutine duststormlin
   684  
   685    !**************************************************************************
   686    ! dustsstormexp
   687    !**************************************************************************
   688    ! ls      : Areocentric solar longitude (degree)
   689    ! dod     : Derived dust optical depth at 0.67 micron
   690    ! dsls    : Areocentric solar longitude at the initiation of dust storm
   691    !         : (degree)
   692    ! maxdod  : Maximum value of dust optical depth at 0.67 micron
   693    ! dsdtc   : Decay time constant of dust storm in unit of areocentric
   694    !         : solar longitude (degree)
   695    !**************************************************************************
   696  
   697    subroutine SetMarsDustDSExp( &
   698      & Ls, DSLs, MaxDOD, DSDTC, & ! (in)
   699      & DOD                      & ! (out)
   700      & )
   701  
   702      real(DP), intent(in ) :: Ls
   703      real(DP), intent(in ) :: DSLs
   704      real(DP), intent(in ) :: MaxDOD
   705      real(DP), intent(in ) :: DSDTC
   706      real(DP), intent(out) :: DOD
   707  
   708  
   709      ! Local variables
   710      !
   711      real(DP) :: TMPLs
   712  
   713      if( Ls < DSLs ) then
   714        TMPLs = Ls + 360.0_DP
   715      else
   716        TMPLs = Ls
   717      endif
   718  
   719      DOD = MaxDod * exp( -( TMPLs - DSLs ) / DSDTC )
   720  
   721  
   722    end subroutine SetMarsDustDSExp
   723  
   724      !**************************************************************************
   725  !!$
   726  !!$    subroutine mars_setdust_vdist( gph, gp, grho, dod610, qdust, ijs, ije )
   727  !!$
   728  !!$      use maparam   , only : im => imax, jm => jmax, km => kmax
   729  !!$      use maconst   , only : grav
   730  !!$      use mars_const, only : pi
   731  !!$
   732  !!$      real(dp)    , intent(in ) :: gph( im, jm, km+1 ), gp( im, jm, km ), &
   733  !!$           grho( im, jm, km )
   734  !!$      real(dp)    , intent(in ) :: dod610( im, jm )
   735  !!$      real(dp)    , intent(out) :: qdust ( im, jm, km )
   736  !!$      integer(i4b), intent(in ) :: ijs, ije
   737  !!$
   738  !!$
   739  !!$      !
   740  !!$      ! local variables
   741  !!$      !
   742  !!$      ! dod067   : Dust optical depth at 0.67 micron meter
   743  !!$      !          : This is a local variable.
   744  !!$      ! qdust0   : Constant for Use of Dust Mixing Ratio profile
   745  !!$      !          : profile is obtained from Conrath [1975]
   746  !!$      ! qdust1   : Constant for Use of Dust Mixing Ratio profile
   747  !!$
   748  !!$      real(dp) :: dod067( im, jm, km+1 )
   749  !!$      real(dp) :: qdust0, qdust1
   750  !!$
   751  !!$      ! refp       : reference pressure (refp is set to 610 Pa)
   752  !!$      ! p0         : reference pressure (p0 is set to 610 Pa)
   753  !!$      !
   754  !!$      real(dp)     :: refp = 610.0d0, p0 = 610.0d0
   755  !!$
   756  !!$      real(dp)     :: dodtmp
   757  !!$
   758  !!$      integer(i4b) :: ij, k
   759  !!$
   760  !!$
   761  !!$      qdust0=1.0d0
   762  !!$!      qdust1=0.007d0
   763  !!$!      qdust1=0.03d0
   764  !!$      qdust1 = dust_nu_coef
   765  !!$
   766  !!$      do k = 1, km
   767  !!$         do ij = ijs, ije
   768  !!$            qdust( ij, 1, k ) = qdust0 &
   769  !!$                 * exp( qdust1 * ( 1.0d0 - ( p0 / gp( ij, 1, k ) ) ) )
   770  !!$         end do
   771  !!$      end do
   772  !!$
   773  !!$      call calcdod067( gph, grho, qdust, dod067, ijs, ije )
   774  !!$
   775  !!$      do ij = ijs, ije
   776  !!$         dodtmp = dod067( ij, 1, km+1 ) * refp / gph( ij, 1, km+1 )
   777  !!$         qdust0 = 1.0d0
   778  !!$         qdust0 = qdust0 * dod610( ij, 1 ) / dodtmp
   779  !!$         do k = 1, km
   780  !!$            qdust( ij, 1, k ) = qdust( ij, 1, k ) * qdust0
   781  !!$         end do
   782  !!$         do k = 1, km+1
   783  !!$            dod067( ij, 1, k ) = dod067( ij, 1, k ) * qdust0
   784  !!$         end do
   785  !!$      end do
   786  !!$
   787  !!$
   788  !!$    end subroutine mars_setdust_vdist
   789  !!$
   790    !--------------------------------------------------------------------------------------
   791  
   792    subroutine SetMarsDustInit
   793  
   794      ! ե
   795      ! File I/O support
   796      !
   797      use dc_iounit, only: FileOpen
   798  
   799      ! NAMELIST եϤ˴ؤ桼ƥƥ
   800      ! Utilities for NAMELIST file input
   801      !
   802      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   803  
   804      ! å
   805      ! Message output
   806      !
   807      use dc_message, only: MessageNotify
   808  
   809      ! ҥȥǡ
   810      ! History data output
   811      !
   812      use gtool_historyauto, only: HistoryAutoAddVariable
   813  
   814  
   815      ! ʸ ; Declaration statements
   816      !
   817  
   818      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   819                                ! Unit number for NAMELIST file open
   820      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   821                                ! IOSTAT of NAMELIST read
   822  
   823      ! NAMELIST ѿ
   824      ! NAMELIST group name
   825      !
   826      namelist /set_Mars_dust_nml/ &
   827        & DustExtEff,         &
   828        & REff,               &
   829        & RhoDust,            &
   830        & DustScenario,       &
   831        & DODFileName,        &
   832        & DODVarName,         &
   833        & DOD067,             &
   834        & DustVerDistCoef,    &
   835        & DustOptDepRefPress, &
   836        & DustVerDistRefPress
   837            !
   838            ! ǥեͤˤĤƤϽ³ "rad_Mars_V1#RadMarsV1Init"
   839            ! Υɤ򻲾ȤΤ.
   840            !
   841            ! Refer to source codes in the initialization procedure
   842            ! "rad_Mars_V1#RadMarsV1Init" for the default values.
   843            !
   844  
   845  
   846      ! ǥեͤ
   847      ! Default values settings
   848      !
   849  
   850      DustExtEff = 3.04_DP   ! Ockert-Bell et al. (1997)
   851      REff       = 1.85d-6   ! Ockert-Bell et al. (1997)
   852      RhoDust    = 2500.0_DP ! Pettengill and Ford (2000)
   853  
   854  
   855      DustScenario    = 'Const'
   856  
   857      DODFileName     = ''
   858      DODVarName      = ''
   859  
   860      DOD067          = 0.2_DP
   861  !!$    DustVerDistCoef = 0.01_DP
   862      DustVerDistCoef = 0.007_DP
   863  
   864  !!$    DustOptDepRefPress  = 610.0_DP
   865  !!$    DustVerDistRefPress = 610.0_DP
   866      DustOptDepRefPress  = 700.0_DP
   867      DustVerDistRefPress = 700.0_DP
   868  
   869      ! NAMELIST ɤ߹
   870      ! NAMELIST is input
   871      !
   872      if ( trim(namelist_filename) /= '' ) then
   873        call FileOpen( unit_nml, &          ! (out)
   874          & namelist_filename, mode = 'r' ) ! (in)
   875  
   876        rewind( unit_nml )
   877        read( unit_nml,                     & ! (in)
   878          & nml = set_Mars_dust_nml,        & ! (out)
   879          & iostat = iostat_nml )             ! (out)
   880        close( unit_nml )
   881  
   882        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   883      end if
   884  
   885  
   886      if ( DustScenario == 'Const' ) then
   887        IDDustScenario = IDDustScenarioConst
   888      else if ( DustScenario == 'VikingNoDS' ) then
   889        IDDustScenario = IDDustScenarioVikingNoDS
   890      else if ( DustScenario == 'Viking' ) then
   891        IDDustScenario = IDDustScenarioViking
   892      else if ( DustScenario == 'MGS' ) then
   893        IDDustScenario = IDDustScenarioMGS
   894      else if ( DustScenario == 'MGSDODFromFile' ) then
   895        IDDustScenario = IDDustScenarioMGSDODFromFile
   896      else
   897        call MessageNotify( 'E', module_name, 'DustScenario of %c is not supported.', c1 = trim( DustScenario ) )
   898      end if
   899  
   900  
   901  
   902      ! Initialization of modules used in this module
   903      !
   904  
   905  
   906      ! ҥȥǡϤΤΤؤѿϿ
   907      ! Register of variables for history data output
   908      !
   909      call HistoryAutoAddVariable( 'DustPresc' , &
   910        & (/ 'lon ', 'lat ', 'sig ', 'time'/),   &
   911        & 'DustPresc', '1' )
   912  
   913      call HistoryAutoAddVariable( 'DustMaxHeight' , &
   914        & (/ 'lon ', 'lat ', 'time'/),               &
   915        & 'DustMaxHeight', 'm' )
   916  
   917  
   918  
   919      !  ; Print
   920      !
   921      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   922      call MessageNotify( 'M', module_name, 'DustExtEff          = %f', d  = (/ DustExtEff /) )
   923      call MessageNotify( 'M', module_name, 'REff                = %f', d  = (/ REff /) )
   924      call MessageNotify( 'M', module_name, 'RhoDust             = %f', d  = (/ RhoDust /) )
   925      call MessageNotify( 'M', module_name, 'DustScenario        = %c', c1 = trim( DustScenario ) )
   926      call MessageNotify( 'M', module_name, 'DODFileName         = %c', c1 = trim( DODFileName ) )
   927      call MessageNotify( 'M', module_name, 'DODVarName          = %c', c1 = trim( DODVarName ) )
   928      call MessageNotify( 'M', module_name, 'DOD067              = %f', d  = (/ DOD067      /) )
   929      call MessageNotify( 'M', module_name, 'DustVerDistCoef     = %f', d  = (/ DustVerDistCoef /) )
   930      call MessageNotify( 'M', module_name, 'DustOptDepRefPress  = %f', d  = (/ DustOptDepRefPress /) )
   931      call MessageNotify( 'M', module_name, 'DustVerDistRefPress = %f', d  = (/ DustVerDistRefPress /) )
   932      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   933  
   934      set_Mars_dust_inited = .true.
   935  
   936    end subroutine SetMarsDustInit
   937  
   938    !--------------------------------------------------------------------------------------
   939  
   940  end module set_Mars_dust
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:57 2012
FILE NAME: set_Mars_dust.f90
PROGRAM NAME: set_mars_dust
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != 
     2:            !
     3:            != Dust distribution is set
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: set_Mars_dust.f90,v 1.10 2012-09-17 11:00:19 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            module set_Mars_dust
    12:              !
    13:              != 
    14:              !
    15:              != Dust distribution is set
    16:              !
    17:              ! <b>Note that Japanese and English are described in parallel.</b>
    18:              !
    19:              ! 
    20:              !
    21:              ! 
    22:              !
    23:              !
    24:              !== References
    25:              !
    26:              !  Lewis, S. R., Collins, M., Forget, F., 
    27:              !    Mars climate database v3.0 detailed design document, 
    28:              !    Technical Note. Contract 11369/95/NL/JG. Work Package 7, ESA, 2001.
    29:              !
    30:              !== Procedures List
    31:              !
    32:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    33:            !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    34:            !!$  ! RadiationFluxOutput     :: ͥեåν
    35:            !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    36:            !!$  ! ------------            :: ------------
    37:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    38:            !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    39:            !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    40:            !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    41:              !
    42:              !== NAMELIST
    43:              !
    44:            !!$  ! NAMELIST#radiation_DennouAGCM_nml
    45:              !
    46:            
    47:              ! USE statements
    48:              !
    49:            
    50:              !
    51:              ! Kind type parameter
    52:              !
    53:              use dc_types, only: DP, &      ! Double precision.
    54:                &                 STRING, &  ! Strings.
    55:                &                 TOKEN      ! Keywords.
    56:            
    57:              ! ʻ
    58:              ! Grid points settings
    59:              !
    60:              use gridset, only: imax, & ! ٳʻ.
    61:                                         ! Number of grid points in longitude
    62:                &                jmax, & ! ٳʻ.
    63:                                         ! Number of grid points in latitude
    64:                &                kmax    ! ľؿ.
    65:                                         ! Number of vertical level
    66:            
    67:              implicit none
    68:            
    69:              private
    70:            
    71:            
    72:              ! ѿ
    73:              ! Public variables
    74:              !
    75:              logical, save, public:: set_Mars_dust_inited = .false.
    76:                                          ! ե饰.
    77:                                          ! Initialization flag
    78:            
    79:              ! Private variables
    80:              !
    81:              real(DP), save :: DustExtEff
    82:              real(DP), save :: REff
    83:              real(DP), save :: RhoDust
    84:            
    85:            
    86:              character(STRING), save :: DustScenario
    87:              real(DP)         , save :: DOD067       ! Dust optical depth at 0.67 micron.
    88:              real(DP)         , save :: DustVerDistCoef
    89:            
    90:              real(DP)         , save :: DustOptDepRefPress
    91:              real(DP)         , save :: DustVerDistRefPress
    92:            
    93:              integer          , save      :: IDDustScenario
    94:              integer          , parameter :: IDDustScenarioConst          = 1
    95:              integer          , parameter :: IDDustScenarioVikingNoDS     = 2
    96:              integer          , parameter :: IDDustScenarioViking         = 3
    97:              integer          , parameter :: IDDustScenarioMGS            = 4
    98:              integer          , parameter :: IDDustScenarioMGSDODFromFile = 5
    99:            
   100:              character(STRING), save      :: DODFileName
   101:              character(STRING), save      :: DODVarName
   102:            
   103:              public :: SetMarsDustCalcDOD067
   104:              public :: SetMarsDustSetDOD067
   105:              public :: SetMarsDustInit
   106:            
   107:              character(*), parameter:: module_name = 'set_Mars_dust'
   108:                                          ! ⥸塼̾.
   109:                                          ! Module name
   110:              character(*), parameter:: version = &
   111:                & '$Name: dcpam5-20120921 $' // &
   112:                & '$Id: set_Mars_dust.f90,v 1.10 2012-09-17 11:00:19 yot Exp $'
   113:                                          ! ⥸塼ΥС
   114:                                          ! Module version
   115:            
   116:              !--------------------------------------------------------------------------------------
   117:            
   118:            contains
   119:            
   120:              !--------------------------------------------------------------------------------------
   121:            
   122:              subroutine SetMarsDustCalcDOD067( &
   123:                & xyr_Press, xyz_QDust,         & ! (in)
   124:                & xyr_DOD067                    & ! (out)
   125:                & )
   126:                !
   127:                ! 
   128:                !
   129:                ! Calculate dust optical depth at 0.67 micron
   130:                !
   131:            
   132:                ! ⥸塼 ; USE statements
   133:                !
   134:            
   135:                ! å
   136:                ! Message output
   137:                !
   138:                use dc_message, only: MessageNotify
   139:            
   140:                ! ҥȥǡ
   141:                ! History data output
   142:                !
   143:                use gtool_historyauto, only: HistoryAutoPut
   144:            
   145:                ! ʪ
   146:                ! Physical constants settings
   147:                !
   148:                use constants, only: Grav
   149:            
   150:            
   151:                ! ʸ ; Declaration statements
   152:                !
   153:            
   154:                real(DP), intent(in ):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   155:                                          ! Pressure
   156:                real(DP), intent(in ):: xyz_QDust (0:imax-1, 1:jmax, 1:kmax)
   157:                                          ! Dust mixing ratio
   158:                real(DP), intent(out):: xyr_DOD067(0:imax-1, 1:jmax, 0:kmax)
   159:                                          ! Optical depth
   160:            
   161:                ! ѿ
   162:                ! Work variables
   163:                !
   164:                real(DP)            :: xyz_DelDOD(0:imax-1, 1:jmax, 1:kmax)
   165:            
   166:                integer :: k             ! ľ˲ DO 롼Ѻѿ
   167:                                         ! Work variables for DO loop in vertical direction
   168:            
   169:                ! ¹ʸ ; Executable statement
   170:                !
   171:            
   172:                ! 
   173:                ! Initialization
   174:                !
   175:                if ( .not. set_Mars_dust_inited ) then
   176:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   177:                end if
   178:            
   179:            
   180: +------>       do k = 1, kmax
   181: |+V====          xyz_DelDOD(:,:,k) =                                            &
   182: |                  &   3.0_DP / 4.0_DP * DustExtEff / ( REff * RhoDust * Grav ) &
   183: |                  & * xyz_QDust(:,:,k)                                         &
   184: |                  & * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) )
   185: +------        end do
   186:            
   187:                k = kmax
   188: W*=====        xyr_DOD067(:,:,k) = 0.0_DP
   189: +------>       do k = kmax-1, 0, -1
   190: |+V====          xyr_DOD067(:,:,k) = xyr_DOD067(:,:,k+1) + xyz_DelDOD(:,:,k)
   191: +------        end do
   192:            
   193:            
   194:                ! ҥȥǡ
   195:                ! History data output
   196:                !
   197:            
   198:            
   199:              end subroutine SetMarsDustCalcDOD067
   200:            
   201:              !--------------------------------------------------------------------------------------
   202:            
   203:              subroutine SetMarsDustSetDOD067( &
   204:                & Ls, xyr_Press, xyz_Press,    & ! (out) optional & ! (in)
   205:                & xyr_DOD067                   & ! (out)
   206:                & )
   207:                !
   208:                ! 
   209:                !
   210:                ! Set dust optical depth at 0.67 micron
   211:                !
   212:            
   213:                ! ⥸塼 ; USE statements
   214:                !
   215:            
   216:                ! å
   217:                ! Message output
   218:                !
   219:                use dc_message, only: MessageNotify
   220:            
   221:                ! ҥȥǡ
   222:                ! History data output
   223:                !
   224:                use gtool_historyauto, only: HistoryAutoPut
   225:            
   226:                ! 
   227:                ! Time control
   228:                !
   229:                use timeset, only: &
   230:                  & TimeN
   231:            
   232:                ! ʪ
   233:                ! Physical and mathematical constants settings
   234:                !
   235:                use constants0, only: &
   236:                  & PI                    ! $ \pi $.
   237:                                          ! ߼Ψ. Circular constant
   238:            
   239:                ! ʪ
   240:                ! Physical constants settings
   241:                !
   242:                use constants, only: Grav
   243:            
   244:                ! ɸǡ
   245:                ! Axes data settings
   246:                !
   247:                use axesset, only: &
   248:                  & y_Lat    ! $ \varphi $ [rad.] . . Latitude
   249:            
   250:                ! ǡɤ߹
   251:                ! Reading time series
   252:                !
   253:                use read_time_series, only: SetValuesFromTimeSeriesWrapper
   254:            
   255:            
   256:                ! ʸ ; Declaration statements
   257:                !
   258:            
   259:                real(DP), intent(in ):: Ls
   260:                                          ! Ls
   261:                real(DP), intent(in ):: xyr_Press    (0:imax-1, 1:jmax, 0:kmax)
   262:                                          ! Pressure
   263:                real(DP), intent(in ):: xyz_Press    (0:imax-1, 1:jmax, 1:kmax)
   264:                                          ! Pressure
   265:                real(DP), intent(out):: xyr_DOD067   (0:imax-1, 1:jmax, 0:kmax)
   266:                                          ! Optical depth
   267:            
   268:                ! ѿ
   269:                ! Work variables
   270:                !
   271:                real(DP)            :: DOD
   272:                real(DP)            :: xy_DOD067       (0:imax-1, 1:jmax)
   273:                                          ! Dust optical depth at 0.67 micron
   274:                real(DP)            :: xyz_MixRtDust   (0:imax-1, 1:jmax, 1:kmax)
   275:                real(DP)            :: xy_DODFac       (0:imax-1, 1:jmax)
   276:                real(DP)            :: xy_MaxHeightDust(0:imax-1, 1:jmax)
   277:            
   278:                real(DP)            :: MixRtDust0
   279:            
   280:                integer :: j
   281:                integer :: k             ! ľ˲ DO 롼Ѻѿ
   282:                                         ! Work variables for DO loop in vertical direction
   283:            
   284:                ! ¹ʸ ; Executable statement
   285:                !
   286:            
   287:                ! 
   288:                ! Initialization
   289:                !
   290:                if ( .not. set_Mars_dust_inited ) then
   291:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   292:                end if
   293:            
   294:            
   295:                select case ( IDDustScenario )
   296:                case ( IDDustScenarioConst )
   297: *V----->         xy_DOD067 = DOD067
   298: ||         
   299: ||               ! Height of dust top
   300: *V-----          xy_MaxHeightDust = 70.0d3
   301:            
   302:                case ( IDDustScenarioVikingNoDS )
   303:            
   304:                  call SetMarsDustDODVikingNoDS( &
   305:                    & Ls, & ! (in)
   306:                    & DOD & ! (out)
   307:                    & )
   308: +V=====          xy_DOD067 = DOD
   309:            
   310:                  ! Height of dust top
   311:            !!$      xy_MaxHeightDust = 70.0d3
   312:                  !
   313: +------>         do j = 1, jmax
   314: |V=====            xy_MaxHeightDust(:,j) =                                 &
   315: |                    &   60.0d3                                            &
   316: |                    & + 18.0d3 * sin( ( Ls - 158.0_DP ) * PI / 180.0_DP ) &
   317: |                    & - 22.0d3 * sin( y_Lat(j) )**2
   318: +------          end do
   319:            
   320:                case ( IDDustScenarioViking )
   321:            
   322:                  call SetMarsDustDODViking( &
   323:                    & Ls, & ! (in)
   324:                    & DOD & ! (out)
   325:                    & )
   326: +V=====          xy_DOD067 = DOD
   327:            
   328:                  ! Height of dust top
   329:            !!$      xy_MaxHeightDust = 70.0d3
   330:                  !
   331: +------>         do j = 1, jmax
   332: |V=====            xy_MaxHeightDust(:,j) =                                 &
   333: |                    &   60.0d3                                            &
   334: |                    & + 18.0d3 * sin( ( Ls - 158.0_DP ) * PI / 180.0_DP ) &
   335: |                    & - 22.0d3 * sin( y_Lat(j) )**2
   336: +------          end do
   337:            
   338:                case ( IDDustScenarioMGS )
   339:            
   340:                  call SetMarsDustDODMGS(          &
   341:                    & Ls,                          &
   342:                    & xy_DOD067, xy_MaxHeightDust  &
   343:                    & )
   344:            
   345:                case ( IDDustScenarioMGSDODFromFile )
   346:            
   347:                  call SetMarsDustDODMGS(          &
   348:                    & Ls,                          &
   349:                    & xy_DOD067, xy_MaxHeightDust  &
   350:                    & )
   351:            
   352:                  call SetValuesFromTimeSeriesWrapper( &
   353:                    & DODFileName, DODVarName, &
   354:                    & xy_DOD067,               &               ! (inout)
   355:                    & 'DOD'                    &
   356:                    & )
   357:            
   358:                case default
   359:                  call MessageNotify( 'E', module_name, 'DustScenario of %c is not supported.', c1 = trim( DustScenario ) )
   360:                end select
   361:            
   362:            
   363:                MixRtDust0      =   1.0_DP
   364:            
   365: +------>       do k = 1, kmax
   366: |+V====          xyz_MixRtDust(:,:,k) = MixRtDust0 &
   367: |                  & * exp( DustVerDistCoef        &
   368: |                  &        * ( 1.0_DP - ( DustVerDistRefPress / xyz_Press(:,:,k) )**(70.0d3/xy_MaxHeightDust) ) &
   369: |                  &      )
   370: +------        end do
   371: ++V====        xyz_MixRtDust = min( xyz_MixRtDust, MixRtDust0 )
   372:            
   373:            
   374:                k = kmax
   375: W*=====        xyr_DOD067(:,:,k) = 0.0_DP
   376: +------>       do k = kmax-1, 0, -1
   377: |+V====          xyr_DOD067(:,:,k) = xyr_DOD067(:,:,k+1) &
   378: |                  & + xyz_MixRtDust(:,:,k+1) * ( xyr_Press(:,:,k) - xyr_Press(:,:,k+1) ) / Grav
   379: +------        end do
   380:            
   381: +V=====        xy_DODFac = xy_DOD067 * xyr_Press(:,:,0) / DustOptDepRefPress / xyr_DOD067(:,:,0)
   382: +------>       do k = 0, kmax
   383: |+V====          xyr_DOD067(:,:,k) = xyr_DOD067(:,:,k) * xy_DODFac
   384: +------        end do
   385:            
   386:            
   387:                ! ҥȥǡ
   388:                ! History data output
   389:                !
   390:                call HistoryAutoPut( TimeN, 'DustPresc'    , xyz_MixRtDust    )
   391:                call HistoryAutoPut( TimeN, 'DustMaxHeight', xy_MaxHeightDust )
   392:            
   393:            
   394:              end subroutine SetMarsDustSetDOD067
   395:            
   396:              !--------------------------------------------------------------------------------------
   397:            
   398:              subroutine SetMarsDustDODViking( &
   399:                & Ls, & ! (in)
   400:                & DOD & ! (out)
   401:                & )
   402:            
   403:                real(DP), intent(in ) :: Ls
   404:                real(DP), intent(out) :: DOD
   405:            
   406:            
   407:                !
   408:                ! Local variables
   409:                !
   410:                real(DP) :: DODDS1
   411:                real(DP) :: DODDS2
   412:                real(DP) :: DSLs
   413:                real(DP) :: MaxDOD
   414:                real(DP) :: DSDTC
   415:            
   416:            
   417:                call SetMarsDustDODVikingNoDS( &
   418:                  & Ls, & ! (in)
   419:                  & DOD & ! (out)
   420:                  & )
   421:            
   422:                ! Add two dust storms
   423:                !
   424:                DSLs   = 210.0_DP
   425:                MaxDOD = 2.7_DP
   426:                DSDTC  = 50.0_DP
   427:                call SetMarsDustDSExp( &
   428:                  & Ls, DSLs, MaxDOD, DSDTC, & ! (in)
   429:                  & DODDS1                   & ! (out)
   430:                  & )
   431:            
   432:                DSLs   = 280.0_DP
   433:                MaxDOD = 4.0_DP
   434:                DSDTC  = 50.0_DP
   435:                call SetMarsDustDSExp( &
   436:                  & Ls, DSLs, MaxDOD, DSDTC, & ! (in)
   437:                  & DODDS2                   & ! (out)
   438:                  & )
   439:            
   440:                DOD = max( DOD, DODDS1, DODDS2 )
   441:            
   442:            
   443:              end subroutine SetMarsDustDODViking
   444:            
   445:              !--------------------------------------------------------------------------------------
   446:            
   447:              subroutine SetMarsDustDODVikingNoDS( &
   448:                & Ls, & ! (in)
   449:                & DOD & ! (out)
   450:                & )
   451:            
   452:                ! ʪ
   453:                ! Physical constants settings
   454:                !
   455:                use constants0, only: PI
   456:            
   457:                real(DP), intent(in ) :: Ls
   458:                real(DP), intent(out) :: DOD
   459:            
   460:            
   461:                ! This expression is obtained from Lewis et al. [1999].
   462:                !
   463:                DOD = 0.7_DP + 0.3_DP * cos( ( Ls + 80.0_DP ) * PI / 180.0_DP )
   464:            
   465:            
   466:              end subroutine SetMarsDustDODVikingNoDS
   467:            
   468:              !----------------------------------------------------------------------------
   469:            
   470:              subroutine SetMarsDustDODMGS( &
   471:                & Ls,                       &
   472:                & xy_DOD, xy_MaxHeight      &
   473:                & )
   474:            
   475:                ! ʪ
   476:                ! Physical constants settings
   477:                !
   478:                use constants0, only: PI
   479:            
   480:                ! ɸǡ
   481:                ! Axes data settings
   482:                !
   483:                use axesset, only: &
   484:                  & y_Lat    ! $ \varphi $ [rad.] . . Latitude
   485:            
   486:                real(DP), intent(in ) :: Ls
   487:                real(DP), intent(out) :: xy_DOD      (0:imax-1, 1:jmax)
   488:                real(DP), intent(out) :: xy_MaxHeight(0:imax-1, 1:jmax)
   489:            
   490:            
   491:                ! Local variables
   492:            
   493:                real(DP) :: DODEq
   494:                real(DP) :: DODSouth
   495:                real(DP) :: DODNorth
   496:                real(DP) :: LsFactor
   497:            
   498:                integer  :: j
   499:            
   500:            
   501:                DODEq    =                &
   502:                  &   0.2_DP              &
   503:                  & + ( 0.5_DP - 0.2_DP ) &
   504:                  &   * cos( ( Ls - 250.0_DP ) / 2.0_DP * PI / 180.0_DP )**14
   505:                DODSouth =                &
   506:                  &   0.1_DP              &
   507:                  & + ( 0.5_DP - 0.1_DP ) &
   508:                  &   * cos( ( Ls - 250.0_DP ) / 2.0_DP * PI / 180.0_DP )**14
   509:                DODNorth = 0.1_DP
   510:            
   511:            
   512:                LsFactor = sin( ( Ls - 160.0_DP ) * PI / 180.0_DP )
   513:            
   514: +------>       do j = 1, jmax
   515: |          
   516: |                if( y_Lat(j) > 0.0_DP ) then
   517: |                  ! wrong
   518: |          !!$        xy_DOD(:,j) = DODNorth              &
   519: |          !!$          & + 0.5_DP * ( DODEq - DODNorth ) &
   520: |          !!$          &   * ( 1.0_DP + tanh( ( 45.0_DP * PI / 180.0_DP - y_Lat(j) ) / 10.0_DP ) )
   521: |V=====            xy_DOD(:,j) = DODNorth              &
   522: |                    & + 0.5_DP * ( DODEq - DODNorth ) &
   523: |                    &   * ( 1.0_DP + tanh( ( 45.0_DP * PI / 180.0_DP - y_Lat(j) ) * 10.0_DP ) )
   524: |                else
   525: |                  ! wrong
   526: |          !!$        xy_DOD(:,j) = DODSouth              &
   527: |          !!$          & + 0.5_DP * ( DODEq - DODSouth ) &
   528: |          !!$          &   * ( 1.0_DP + tanh( ( 45.0_DP * PI / 180.0_DP + y_Lat(j) ) / 10.0_DP ) )
   529: |V=====            xy_DOD(:,j) = DODSouth              &
   530: |                    & + 0.5_DP * ( DODEq - DODSouth ) &
   531: |                    &   * ( 1.0_DP + tanh( ( 45.0_DP * PI / 180.0_DP + y_Lat(j) ) * 10.0_DP ) )
   532: |                end if
   533: |          
   534: |V----->         xy_MaxHeight(:,j) =                                         &
   535: ||                 &   60.0_DP                                               &
   536: ||                 & + 18.0_DP * LsFactor                                    &
   537: ||                 & - ( 32.0_DP + 18.0_DP * LsFactor ) * sin( y_Lat(j) )**4 &
   538: ||                 & - 8.0_DP * LsFactor * sin( y_Lat(j) )**5
   539: |V-----          xy_MaxHeight(:,j) = xy_MaxHeight(:,j) * 1.0d3
   540: |          
   541: +------        end do
   542:            
   543:            
   544:              end subroutine SetMarsDustDODMGS
   545:            
   546:              !----------------------------------------------------------------------------
   547:            !!$
   548:            !!$  subroutine SetMarsDustDODMGS( &
   549:            !!$    & Ls, &
   550:            !!$    & Lat, &
   551:            !!$    & DOD  &
   552:            !!$    & )
   553:            !!$
   554:            !!$    real(DP), intent(in ) :: Ls
   555:            !!$    real(DP), intent(in ) :: Lat
   556:            !!$    real(DP), intent(out) :: DOD
   557:            !!$
   558:            !!$
   559:            !!$    ! Local variables
   560:            !!$    ! lat2     : Temporary variable for latitude
   561:            !!$    ! interc   : Intercept
   562:            !!$    ! amp      :
   563:            !!$    ! phase    : Phase (degree)
   564:            !!$
   565:            !!$    real(DP) :: lat2
   566:            !!$    real(DP) :: interc
   567:            !!$    real(DP) :: amp, phase
   568:            !!$
   569:            !!$
   570:            !!$    if( lat .lt. -40.0d0 ) then
   571:            !!$      lat2 = -40.0d0
   572:            !!$    else if( lat .gt. 40.0d0 ) then
   573:            !!$      lat2 = 40.0d0
   574:            !!$    else
   575:            !!$      lat2 = lat
   576:            !!$    endif
   577:            !!$
   578:            !!$    if( lat2 .gt. 0.0d0 ) then
   579:            !!$      interc = 0.16d0 - 1.8d-3 * lat2
   580:            !!$    else
   581:            !!$      interc = 0.16d0 + 1.3d-3 * lat2
   582:            !!$    endif
   583:            !!$    amp   = 0.0623d0 - 0.015d0 * atan( ( lat2 + 2.0d0 ) / 5.0d0 )
   584:            !!$    phase = 258.0d0 + 1.8d-1 * lat2
   585:            !!$    dod   = interc + amp * cos( ( ls - phase ) * d2r )
   586:            !!$
   587:            !!$
   588:            !!$    ! Dust optical depth at 9 micron is converted to that at 0.67 micron.
   589:            !!$
   590:            !!$    dod = dod * 2.0d0
   591:            !!$
   592:            !!$
   593:            !!$  end subroutine SetMarsDustDODMGS
   594:            !!$
   595:            !!$    !**************************************************************************
   596:            !!$
   597:            !!$    subroutine dodMGS_1yr( ls, lat, dod )
   598:            !!$
   599:            !!$      use mars_const, only : d2r
   600:            !!$
   601:            !!$      real(dp), intent(in ) :: ls
   602:            !!$      real(dp), intent(in ) :: lat
   603:            !!$      real(dp), intent(out) :: dod
   604:            !!$
   605:            !!$
   606:            !!$      ! Local variables
   607:            !!$
   608:            !!$      real(dp) :: dodds
   609:            !!$      real(dp) :: dsls, maxdod, dsdtc
   610:            !!$
   611:            !!$
   612:            !!$      call dodMGS( ls, lat, dod )
   613:            !!$
   614:            !!$
   615:            !!$      !*****Add dust storms
   616:            !!$      !-----First year
   617:            !!$      dsls   = 227.0d0
   618:            !!$      maxdod = 0.475d0
   619:            !!$      dsdtc  = 35.0d0
   620:            !!$      call duststormexp( ls, dodds, dsls, maxdod, dsdtc )
   621:            !!$      dodds  = dodds * exp( -( lat - ( -20.0d0 ) )**2 / ( 60.0d0 )**2 )
   622:            !!$      dodds  = dodds * 2.0d0
   623:            !!$      dod    = max( dod, dodds )
   624:            !!$
   625:            !!$      dsls   = 235.0d0
   626:            !!$      maxdod = 0.5d0
   627:            !!$      dsdtc  = 50.0d0
   628:            !!$      call duststormexp( ls, dodds, dsls, maxdod, dsdtc )
   629:            !!$      dodds  = dodds * exp( -( lat - ( -60.0d0 ) )**2 / ( 60.0d0 )**2 )
   630:            !!$      dodds  = dodds * 2.0d0
   631:            !!$      dod    = max( dod, dodds )
   632:            !!$
   633:            !!$      dsls   = 259.0d0
   634:            !!$      maxdod = 0.4d0
   635:            !!$      dsdtc  = 70.0d0
   636:            !!$      call duststormexp( ls, dodds, dsls, maxdod, dsdtc )
   637:            !!$      dodds  = dodds * exp( -( lat - ( -80.0d0 ) )**2 / ( 30.0d0 )**2 )
   638:            !!$      dodds  = dodds * 2.0d0
   639:            !!$      dod    = max( dod, dodds )
   640:            !!$
   641:            !!$      !-----Second year
   642:            !!$!      dsls   = 360.0d0 + 190.0d0
   643:            !!$!      maxdod = 1.7d0
   644:            !!$!      dsdtc  = 40.0d0
   645:            !!$!      call duststormexp( ls, dodds, dsls, maxdod, dsdtc )
   646:            !!$!      dodds  = dodds * exp( -( lat - ( -20.0d0 ) )**2 / ( 60.0d0 )**2 )
   647:            !!$!      if( abs( lat ) .gt. 60.0d0 ) dodds = 0.0d0
   648:            !!$!      dod    = max( dod, dodds )
   649:            !!$
   650:            !!$
   651:            !!$    end subroutine dodMGS_1yr
   652:            !!$
   653:            !!$    !**************************************************************************
   654:            !!$
   655:            !!$    subroutine duststormlin( ls, dod, ls0, x1, y1, x2, y2 )
   656:            !!$
   657:            !!$      real(dp), intent(in ) :: ls
   658:            !!$      real(dp), intent(out) :: dod
   659:            !!$      real(dp), intent(in ) :: ls0
   660:            !!$      real(dp), intent(in ) :: x1, y1, x2, y2
   661:            !!$
   662:            !!$
   663:            !!$      ! Local variables
   664:            !!$      !
   665:            !!$      real(dp) :: a, b
   666:            !!$      real(dp) :: tmpls
   667:            !!$
   668:            !!$
   669:            !!$      a = ( y2 - y1 ) / ( x2 - x1 )
   670:            !!$      b = y1 - ( y2 - y1 ) / ( x2 - x1 ) * x1
   671:            !!$
   672:            !!$      if( ls .lt. ls0 ) then
   673:            !!$         tmpls = ls + 360.0d0
   674:            !!$      else
   675:            !!$         tmpls = ls
   676:            !!$      endif
   677:            !!$
   678:            !!$      dod = a * tmpls + b
   679:            !!$
   680:            !!$      dod = max( dod, 0.0d0 )
   681:            !!$
   682:            !!$
   683:            !!$    end subroutine duststormlin
   684:            
   685:              !**************************************************************************
   686:              ! dustsstormexp
   687:              !**************************************************************************
   688:              ! ls      : Areocentric solar longitude (degree)
   689:              ! dod     : Derived dust optical depth at 0.67 micron
   690:              ! dsls    : Areocentric solar longitude at the initiation of dust storm
   691:              !         : (degree)
   692:              ! maxdod  : Maximum value of dust optical depth at 0.67 micron
   693:              ! dsdtc   : Decay time constant of dust storm in unit of areocentric
   694:              !         : solar longitude (degree)
   695:              !**************************************************************************
   696:            
   697:              subroutine SetMarsDustDSExp( &
   698:                & Ls, DSLs, MaxDOD, DSDTC, & ! (in)
   699:                & DOD                      & ! (out)
   700:                & )
   701:            
   702:                real(DP), intent(in ) :: Ls
   703:                real(DP), intent(in ) :: DSLs
   704:                real(DP), intent(in ) :: MaxDOD
   705:                real(DP), intent(in ) :: DSDTC
   706:                real(DP), intent(out) :: DOD
   707:            
   708:            
   709:                ! Local variables
   710:                !
   711:                real(DP) :: TMPLs
   712:            
   713:                if( Ls < DSLs ) then
   714:                  TMPLs = Ls + 360.0_DP
   715:                else
   716:                  TMPLs = Ls
   717:                endif
   718:            
   719:                DOD = MaxDod * exp( -( TMPLs - DSLs ) / DSDTC )
   720:            
   721:            
   722:              end subroutine SetMarsDustDSExp
   723:            
   724:                !**************************************************************************
   725:            !!$
   726:            !!$    subroutine mars_setdust_vdist( gph, gp, grho, dod610, qdust, ijs, ije )
   727:            !!$
   728:            !!$      use maparam   , only : im => imax, jm => jmax, km => kmax
   729:            !!$      use maconst   , only : grav
   730:            !!$      use mars_const, only : pi
   731:            !!$
   732:            !!$      real(dp)    , intent(in ) :: gph( im, jm, km+1 ), gp( im, jm, km ), &
   733:            !!$           grho( im, jm, km )
   734:            !!$      real(dp)    , intent(in ) :: dod610( im, jm )
   735:            !!$      real(dp)    , intent(out) :: qdust ( im, jm, km )
   736:            !!$      integer(i4b), intent(in ) :: ijs, ije
   737:            !!$
   738:            !!$
   739:            !!$      !
   740:            !!$      ! local variables
   741:            !!$      !
   742:            !!$      ! dod067   : Dust optical depth at 0.67 micron meter
   743:            !!$      !          : This is a local variable.
   744:            !!$      ! qdust0   : Constant for Use of Dust Mixing Ratio profile
   745:            !!$      !          : profile is obtained from Conrath [1975]
   746:            !!$      ! qdust1   : Constant for Use of Dust Mixing Ratio profile
   747:            !!$
   748:            !!$      real(dp) :: dod067( im, jm, km+1 )
   749:            !!$      real(dp) :: qdust0, qdust1
   750:            !!$
   751:            !!$      ! refp       : reference pressure (refp is set to 610 Pa)
   752:            !!$      ! p0         : reference pressure (p0 is set to 610 Pa)
   753:            !!$      !
   754:            !!$      real(dp)     :: refp = 610.0d0, p0 = 610.0d0
   755:            !!$
   756:            !!$      real(dp)     :: dodtmp
   757:            !!$
   758:            !!$      integer(i4b) :: ij, k
   759:            !!$
   760:            !!$
   761:            !!$      qdust0=1.0d0
   762:            !!$!      qdust1=0.007d0
   763:            !!$!      qdust1=0.03d0
   764:            !!$      qdust1 = dust_nu_coef
   765:            !!$
   766:            !!$      do k = 1, km
   767:            !!$         do ij = ijs, ije
   768:            !!$            qdust( ij, 1, k ) = qdust0 &
   769:            !!$                 * exp( qdust1 * ( 1.0d0 - ( p0 / gp( ij, 1, k ) ) ) )
   770:            !!$         end do
   771:            !!$      end do
   772:            !!$
   773:            !!$      call calcdod067( gph, grho, qdust, dod067, ijs, ije )
   774:            !!$
   775:            !!$      do ij = ijs, ije
   776:            !!$         dodtmp = dod067( ij, 1, km+1 ) * refp / gph( ij, 1, km+1 )
   777:            !!$         qdust0 = 1.0d0
   778:            !!$         qdust0 = qdust0 * dod610( ij, 1 ) / dodtmp
   779:            !!$         do k = 1, km
   780:            !!$            qdust( ij, 1, k ) = qdust( ij, 1, k ) * qdust0
   781:            !!$         end do
   782:            !!$         do k = 1, km+1
   783:            !!$            dod067( ij, 1, k ) = dod067( ij, 1, k ) * qdust0
   784:            !!$         end do
   785:            !!$      end do
   786:            !!$
   787:            !!$
   788:            !!$    end subroutine mars_setdust_vdist
   789:            !!$
   790:              !--------------------------------------------------------------------------------------
   791:            
   792:              subroutine SetMarsDustInit
   793:            
   794:                ! ե
   795:                ! File I/O support
   796:                !
   797:                use dc_iounit, only: FileOpen
   798:            
   799:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   800:                ! Utilities for NAMELIST file input
   801:                !
   802:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   803:            
   804:                ! å
   805:                ! Message output
   806:                !
   807:                use dc_message, only: MessageNotify
   808:            
   809:                ! ҥȥǡ
   810:                ! History data output
   811:                !
   812:                use gtool_historyauto, only: HistoryAutoAddVariable
   813:            
   814:            
   815:                ! ʸ ; Declaration statements
   816:                !
   817:            
   818:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   819:                                          ! Unit number for NAMELIST file open
   820:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   821:                                          ! IOSTAT of NAMELIST read
   822:            
   823:                ! NAMELIST ѿ
   824:                ! NAMELIST group name
   825:                !
   826:                namelist /set_Mars_dust_nml/ &
   827:                  & DustExtEff,         &
   828:                  & REff,               &
   829:                  & RhoDust,            &
   830:                  & DustScenario,       &
   831:                  & DODFileName,        &
   832:                  & DODVarName,         &
   833:                  & DOD067,             &
   834:                  & DustVerDistCoef,    &
   835:                  & DustOptDepRefPress, &
   836:                  & DustVerDistRefPress
   837:                      !
   838:                      ! ǥեͤˤĤƤϽ³ "rad_Mars_V1#RadMarsV1Init"
   839:                      ! Υɤ򻲾ȤΤ.
   840:                      !
   841:                      ! Refer to source codes in the initialization procedure
   842:                      ! "rad_Mars_V1#RadMarsV1Init" for the default values.
   843:                      !
   844:            
   845:            
   846:                ! ǥեͤ
   847:                ! Default values settings
   848:                !
   849:            
   850:                DustExtEff = 3.04_DP   ! Ockert-Bell et al. (1997)
   851:                REff       = 1.85d-6   ! Ockert-Bell et al. (1997)
   852:                RhoDust    = 2500.0_DP ! Pettengill and Ford (2000)
   853:            
   854:            
   855:                DustScenario    = 'Const'
   856:            
   857:                DODFileName     = ''
   858:                DODVarName      = ''
   859:            
   860:                DOD067          = 0.2_DP
   861:            !!$    DustVerDistCoef = 0.01_DP
   862:                DustVerDistCoef = 0.007_DP
   863:            
   864:            !!$    DustOptDepRefPress  = 610.0_DP
   865:            !!$    DustVerDistRefPress = 610.0_DP
   866:                DustOptDepRefPress  = 700.0_DP
   867:                DustVerDistRefPress = 700.0_DP
   868:            
   869:                ! NAMELIST ɤ߹
   870:                ! NAMELIST is input
   871:                !
   872:                if ( trim(namelist_filename) /= '' ) then
   873:                  call FileOpen( unit_nml, &          ! (out)
   874:                    & namelist_filename, mode = 'r' ) ! (in)
   875:            
   876:                  rewind( unit_nml )
   877:                  read( unit_nml,                     & ! (in)
   878:                    & nml = set_Mars_dust_nml,        & ! (out)
   879:                    & iostat = iostat_nml )             ! (out)
   880:                  close( unit_nml )
   881:            
   882:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   883:                end if
   884:            
   885:            
   886:                if ( DustScenario == 'Const' ) then
   887:                  IDDustScenario = IDDustScenarioConst
   888:                else if ( DustScenario == 'VikingNoDS' ) then
   889:                  IDDustScenario = IDDustScenarioVikingNoDS
   890:                else if ( DustScenario == 'Viking' ) then
   891:                  IDDustScenario = IDDustScenarioViking
   892:                else if ( DustScenario == 'MGS' ) then
   893:                  IDDustScenario = IDDustScenarioMGS
   894:                else if ( DustScenario == 'MGSDODFromFile' ) then
   895:                  IDDustScenario = IDDustScenarioMGSDODFromFile
   896:                else
   897:                  call MessageNotify( 'E', module_name, 'DustScenario of %c is not supported.', c1 = trim( DustScenario ) )
   898:                end if
   899:            
   900:            
   901:            
   902:                ! Initialization of modules used in this module
   903:                !
   904:            
   905:            
   906:                ! ҥȥǡϤΤΤؤѿϿ
   907:                ! Register of variables for history data output
   908:                !
   909:                call HistoryAutoAddVariable( 'DustPresc' , &
   910:                  & (/ 'lon ', 'lat ', 'sig ', 'time'/),   &
   911:                  & 'DustPresc', '1' )
   912:            
   913:                call HistoryAutoAddVariable( 'DustMaxHeight' , &
   914:                  & (/ 'lon ', 'lat ', 'time'/),               &
   915:                  & 'DustMaxHeight', 'm' )
   916:            
   917:            
   918:            
   919:                !  ; Print
   920:                !
   921:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   922:                call MessageNotify( 'M', module_name, 'DustExtEff          = %f', d  = (/ DustExtEff /) )
   923:                call MessageNotify( 'M', module_name, 'REff                = %f', d  = (/ REff /) )
   924:                call MessageNotify( 'M', module_name, 'RhoDust             = %f', d  = (/ RhoDust /) )
   925:                call MessageNotify( 'M', module_name, 'DustScenario        = %c', c1 = trim( DustScenario ) )
   926:                call MessageNotify( 'M', module_name, 'DODFileName         = %c', c1 = trim( DODFileName ) )
   927:                call MessageNotify( 'M', module_name, 'DODVarName          = %c', c1 = trim( DODVarName ) )
   928:                call MessageNotify( 'M', module_name, 'DOD067              = %f', d  = (/ DOD067      /) )
   929:                call MessageNotify( 'M', module_name, 'DustVerDistCoef     = %f', d  = (/ DustVerDistCoef /) )
   930:                call MessageNotify( 'M', module_name, 'DustOptDepRefPress  = %f', d  = (/ DustOptDepRefPress /) )
   931:                call MessageNotify( 'M', module_name, 'DustVerDistRefPress = %f', d  = (/ DustVerDistRefPress /) )
   932:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   933:            
   934:                set_Mars_dust_inited = .true.
   935:            
   936:              end subroutine SetMarsDustInit
   937:            
   938:              !--------------------------------------------------------------------------------------
   939:            
   940:            end module set_Mars_dust
