Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:20:21 2012
FILE NAME: i.saturate.F90
PROGRAM NAME: saturate
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    67  error( 919): Module information file of module "gridset" does not exist. (PT=7)
   142  error( 212): Variable "imax" in specification expression is invalid. (PT=39)
   142  error( 439): Name "imax" must be typed explicitly. (PT=39)
   142  error( 212): Variable "jmax" in specification expression is invalid. (PT=49)
   142  error( 439): Name "jmax" must be typed explicitly. (PT=49)
   144  error( 212): Variable "imax" in specification expression is invalid. (PT=39)
   144  error( 212): Variable "jmax" in specification expression is invalid. (PT=49)
   147  error( 212): Variable "imax" in specification expression is invalid. (PT=29)
   147  error( 212): Variable "jmax" in specification expression is invalid. (PT=39)
   162  warn (  81): Name "imax" is referenced but not defined.
   162  warn (  81): Name "jmax" is referenced but not defined.
   182  error( 212): Variable "imax" in specification expression is invalid. (PT=40)
   182  error( 439): Name "imax" must be typed explicitly. (PT=40)
   182  error( 212): Variable "jmax" in specification expression is invalid. (PT=50)
   182  error( 439): Name "jmax" must be typed explicitly. (PT=50)
   182  error( 212): Variable "kmax" in specification expression is invalid. (PT=58)
   182  error( 439): Name "kmax" must be typed explicitly. (PT=58)
   184  error( 212): Variable "imax" in specification expression is invalid. (PT=40)
   184  error( 212): Variable "jmax" in specification expression is invalid. (PT=50)
   184  error( 212): Variable "kmax" in specification expression is invalid. (PT=58)
   187  error( 212): Variable "imax" in specification expression is invalid. (PT=30)
   187  error( 212): Variable "jmax" in specification expression is invalid. (PT=40)
   187  error( 212): Variable "kmax" in specification expression is invalid. (PT=48)
   202  warn (  81): Name "imax" is referenced but not defined.
   202  warn (  81): Name "jmax" is referenced but not defined.
   202  warn (  81): Name "kmax" is referenced but not defined.
   223  error( 212): Variable "imax" in specification expression is invalid. (PT=41)
   223  error( 439): Name "imax" must be typed explicitly. (PT=41)
   223  error( 212): Variable "jmax" in specification expression is invalid. (PT=51)
   223  error( 439): Name "jmax" must be typed explicitly. (PT=51)
   225  error( 212): Variable "imax" in specification expression is invalid. (PT=41)
   225  error( 212): Variable "jmax" in specification expression is invalid. (PT=51)
   227  error( 212): Variable "imax" in specification expression is invalid. (PT=35)
   227  error( 212): Variable "jmax" in specification expression is invalid. (PT=45)
   243  warn (  81): Name "imax" is referenced but not defined.
   243  warn (  81): Name "jmax" is referenced but not defined.
   264  error( 212): Variable "imax" in specification expression is invalid. (PT=42)
   264  error( 439): Name "imax" must be typed explicitly. (PT=42)
   264  error( 212): Variable "jmax" in specification expression is invalid. (PT=52)
   264  error( 439): Name "jmax" must be typed explicitly. (PT=52)
   264  error( 212): Variable "kmax" in specification expression is invalid. (PT=60)
   264  error( 439): Name "kmax" must be typed explicitly. (PT=60)
   266  error( 212): Variable "imax" in specification expression is invalid. (PT=42)
   266  error( 212): Variable "jmax" in specification expression is invalid. (PT=52)
   266  error( 212): Variable "kmax" in specification expression is invalid. (PT=60)
   268  error( 212): Variable "imax" in specification expression is invalid. (PT=36)
   268  error( 212): Variable "jmax" in specification expression is invalid. (PT=46)
   268  error( 212): Variable "kmax" in specification expression is invalid. (PT=54)
   283  warn (  81): Name "imax" is referenced but not defined.
   283  warn (  81): Name "jmax" is referenced but not defined.
   283  warn (  81): Name "kmax" is referenced but not defined.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:20:21 2012
FILE NAME: i.saturate.F90
PROGRAM NAME: saturate
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ˰漾λ
     2  !
     3  != Evaluate saturation specific humidity
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: saturate.F90,v 1.1 2010-09-12 02:08:11 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module saturate
    13    !
    14    != ˰漾λ
    15    !
    16    != Evaluate saturation specific humidity
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ˰漾˰漾βʬͤ򻻽Фޤ.
    21    !
    22    ! Saturation specific humidity and temperature derivative of it are calculated.
    23    !
    24    ! ˰漾η׻ˤϥǥեȤǤ
    25    ! Tetens (1930) Ѥ (saturate_t1930 ).
    26    ! ޤ, Config.mk  CPPFLAGS  -DLIB_SATURATE_NHA1992 ꤹ
    27    ! Nakajima et al. (1992) Ѥ (saturate_tnha1992 ).
    28    !
    29    ! By default, Tetens (1930) is used for calculation of
    30    ! saturation specific humidity (See "saturate_t1930").
    31    ! If "-DLIB_SATURATE_NHA1992" is specified to "CPPFLAGS" in Config.mk,
    32    ! Nakajima et al. (1992) is used (See "saturate_nha1992").
    33    !
    34    !== References
    35    !
    36    !== Procedures List
    37    !
    38    ! CalcQVapSat            :: ˰漾η׻
    39    ! CalcDQVapSatDTemp      :: ˰漾βʬη׻
    40    ! ------------  :: ------------
    41    ! CalcQVapSat            :: Calculate saturation specific humidity
    42    ! CalcDQVapSatDTemp      :: Calculate temperature derivative of saturation specific humidity
    43    !
    44    !--
    45    !== NAMELIST
    46    !
    47    ! NAMELIST#saturate_nml
    48    !++
    49  
    50    ! ⥸塼 ; USE statements
    51    !
    52  
    53    ! ̷ѥ᥿
    54    ! Kind type parameter
    55    !
    56    use dc_types, only: DP, &      ! ټ¿. Double precision.
    57      &                 STRING     ! ʸ.       Strings.
    58  
    59    ! å
    60    ! Message output
    61    !
    62    use dc_message, only: MessageNotify
    63  
    64    ! ʻ
    65    ! Grid points settings
    66    !
    67    use gridset, only: imax, & ! ٳʻ.
    68                               ! Number of grid points in longitude
    69      &                jmax, & ! ٳʻ.
    70                               ! Number of grid points in latitude
    71      &                kmax    ! ľؿ.
    72                               ! Number of vertical level
    73  
    74  
    75      ! Tetens (1930) Ѥ˰漾λ
    76      ! Evaluate saturation specific humidity with Tetens (1930)
    77      !
    78      use saturate_t1930, only:                               &
    79  
    80        & xy_CalcQVapSatCore        => xy_CalcQVapSat       , &
    81        & xy_CalcDQVapSatDTempCore  => xy_CalcDQVapSatDTemp , &
    82        & xyz_CalcQVapSatCore       => xyz_CalcQVapSat      , &
    83        & xyz_CalcDQVapSatDTempCore => xyz_CalcDQVapSatDTemp
    84  
    85  
    86  
    87    ! ʸ ; Declaration statements
    88    !
    89    implicit none
    90    private
    91  
    92    ! ³
    93    ! Public procedure
    94    !
    95    public:: xy_CalcQVapSat , xy_CalcDQVapSatDTemp
    96    public:: xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
    97  
    98    ! ѿ
    99    ! Public variables
   100    !
   101    logical, save, public:: saturate_inited = .false.
   102                                ! ե饰.
   103                                ! Initialization flag
   104  
   105    ! ѿ
   106    ! Private variables
   107    !
   108    character(*), parameter:: module_name = 'saturate'
   109                                ! ⥸塼̾.
   110                                ! Module name
   111  
   112    character(*), parameter:: saturate_scheme = &
   113  
   114      & 'Tetens (1930)'
   115  
   116  
   117    character(*), parameter:: version = &
   118      & '$Name: dcpam5-20120921 $' // &
   119      & '$Id: saturate.F90,v 1.1 2010-09-12 02:08:11 yot Exp $'
   120                                ! ⥸塼ΥС
   121                                ! Module version
   122  
   123  
   124  contains
   125  
   126    function xy_CalcQVapSat( xy_Temp, xy_Press ) result( xy_QVapSat )
   127      !
   128      !  *Temp* ȵ *Press* Ѥ,
   129      ! ˰漾 *QVapSat* ޤ.
   130      !
   131      ! Calculate saturation specific humidity *QVapSat* using
   132      ! temperature *Temp* and air pressure *Press*.
   133      !
   134  
   135      ! ⥸塼 ; USE statements
   136      !
   137  
   138      ! ʸ ; Declaration statements
   139      !
   140      implicit none
   141  
   142      real(DP), intent(in):: xy_Temp (0:imax-1, 1:jmax)
   143                                ! $ T $ . . Temperature
   144      real(DP), intent(in):: xy_Press(0:imax-1, 1:jmax)
   145                                ! $ p $ . . Air pressure
   146  
   147      real(DP):: xy_QVapSat(0:imax-1, 1:jmax)
   148                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   149  
   150      ! ѿ
   151      ! Work variables
   152      !
   153  
   154      ! ¹ʸ ; Executable statement
   155      !
   156  
   157      call SaturateInit
   158  
   159      xy_QVapSat = xy_CalcQVapSatCore( 0, imax-1, 1, jmax, xy_Temp, xy_Press )
   160  
   161  
   162    end function xy_CalcQVapSat
   163  
   164    !-------------------------------------------------------------------
   165  
   166    function xyz_CalcQVapSat( xyz_Temp, xyz_Press ) result( xyz_QVapSat )
   167      !
   168      !  *Temp* ȵ *Press* Ѥ,
   169      ! ˰漾 *QVapSat* ޤ.
   170      !
   171      ! Calculate saturation specific humidity *QVapSat* using
   172      ! temperature *Temp* and air pressure *Press*.
   173      !
   174  
   175      ! ⥸塼 ; USE statements
   176      !
   177  
   178      ! ʸ ; Declaration statements
   179      !
   180      implicit none
   181  
   182      real(DP), intent(in):: xyz_Temp (0:imax-1, 1:jmax, 1:kmax)
   183                                ! $ T $ . . Temperature
   184      real(DP), intent(in):: xyz_Press(0:imax-1, 1:jmax, 1:kmax)
   185                                ! $ p $ . . Air pressure
   186  
   187      real(DP):: xyz_QVapSat(0:imax-1, 1:jmax, 1:kmax)
   188                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   189  
   190      ! ѿ
   191      ! Work variables
   192      !
   193  
   194      ! ¹ʸ ; Executable statement
   195      !
   196  
   197      call SaturateInit
   198  
   199      xyz_QVapSat = xyz_CalcQVapSatCore( 0, imax-1, 1, jmax, 1, kmax, xyz_Temp, xyz_Press )
   200  
   201  
   202    end function xyz_CalcQVapSat
   203  
   204    !-------------------------------------------------------------------
   205  
   206    function xy_CalcDQVapSatDTemp( xy_Temp, xy_QVapSat ) result( xy_DQVapSatDTemp )
   207      !
   208      !  *Temp* ˰漾 *QVapSat* Ѥ,
   209      ! ˰漾βʬ *DQVapSatDTemp* ޤ.
   210      !
   211      ! Calculate temperature derivative of saturation specific humidity
   212      ! *DQVapSatDTemp* using
   213      ! temperature *Temp* and saturation specific humidity *QVapSat*.
   214      !
   215  
   216      ! ⥸塼 ; USE statements
   217      !
   218  
   219      ! ʸ ; Declaration statements
   220      !
   221      implicit none
   222  
   223      real(DP), intent(in):: xy_Temp   (0:imax-1, 1:jmax)
   224                                ! $ T $ . . Temperature
   225      real(DP), intent(in):: xy_QVapSat(0:imax-1, 1:jmax)
   226                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   227      real(DP):: xy_DQVapSatDTemp(0:imax-1, 1:jmax)
   228                                ! $ \DP{q^{*}}{T} $ . ˰漾βʬ.
   229                                ! Temperature derivative of saturation specific humidity.
   230  
   231      ! ѿ
   232      ! Work variables
   233      !
   234  
   235      ! ¹ʸ ; Executable statement
   236      !
   237  
   238      call SaturateInit
   239  
   240      xy_DQVapSatDTemp = xy_CalcDQVapSatDTempCore( 0, imax-1, 1, jmax, xy_Temp, xy_QVapSat )
   241  
   242  
   243    end function xy_CalcDQVapSatDTemp
   244  
   245    !-------------------------------------------------------------------
   246  
   247    function xyz_CalcDQVapSatDTemp( xyz_Temp, xyz_QVapSat ) result( xyz_DQVapSatDTemp )
   248      !
   249      !  *Temp* ˰漾 *QVapSat* Ѥ,
   250      ! ˰漾βʬ *DQVapSatDTemp* ޤ.
   251      !
   252      ! Calculate temperature derivative of saturation specific humidity
   253      ! *DQVapSatDTemp* using
   254      ! temperature *Temp* and saturation specific humidity *QVapSat*.
   255      !
   256  
   257      ! ⥸塼 ; USE statements
   258      !
   259  
   260      ! ʸ ; Declaration statements
   261      !
   262      implicit none
   263  
   264      real(DP), intent(in):: xyz_Temp   (0:imax-1, 1:jmax, 1:kmax)
   265                                ! $ T $ . . Temperature
   266      real(DP), intent(in):: xyz_QVapSat(0:imax-1, 1:jmax, 1:kmax)
   267                                ! $ q^{*} $ . ˰漾. Saturation specific humidity
   268      real(DP):: xyz_DQVapSatDTemp(0:imax-1, 1:jmax, 1:kmax)
   269                                ! $ \DP{q^{*}}{T} $ . ˰漾βʬ.
   270                                ! Temperature derivative of saturation specific humidity.
   271  
   272      ! ѿ
   273      ! Work variables
   274      !
   275  
   276      ! ¹ʸ ; Executable statement
   277      !
   278  
   279      call SaturateInit
   280  
   281      xyz_DQVapSatDTemp = xyz_CalcDQVapSatDTempCore( 0, imax-1, 1, jmax, 1, kmax, xyz_Temp, xyz_QVapSat )
   282  
   283    end function xyz_CalcDQVapSatDTemp
   284  
   285    !-------------------------------------------------------------------
   286  
   287    subroutine SaturateInit
   288      !
   289      ! saturate ⥸塼νԤޤ.
   290      !--
   291      ! NAMELIST#saturate_nml ɤ߹ߤϤμ³ǹԤޤ.
   292      !++
   293      !
   294      ! "saturate" module is initialized.
   295      !--
   296      ! "NAMELIST#saturate_nml" is loaded in this procedure.
   297      !++
   298  
   299      ! ⥸塼 ; USE statements
   300      !
   301  
   302      ! NAMELIST եϤ˴ؤ桼ƥƥ
   303      ! Utilities for NAMELIST file input
   304      !
   305      use namelist_util, only: namelist_filename, NmlutilMsg
   306  
   307      ! ե
   308      ! File I/O support
   309      !
   310      use dc_iounit, only: FileOpen
   311  
   312      ! ̷ѥ᥿
   313      ! Kind type parameter
   314      !
   315      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   316  
   317      ! ʸ
   318      ! Character handling
   319      !
   320      use dc_string, only: StoA
   321  
   322      ! ҥȥǡ
   323      ! History data output
   324      !
   325      use gtool_historyauto, only: HistoryAutoAddVariable
   326  
   327      ! ʸ ; Declaration statements
   328      !
   329      implicit none
   330  
   331  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   332  !!$                              ! Unit number for NAMELIST file open
   333  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   334  !!$                              ! IOSTAT of NAMELIST read
   335  
   336      ! NAMELIST ѿ
   337      ! NAMELIST group name
   338      !
   339  !!$    namelist /saturate_nml/
   340            !
   341            ! ǥեͤˤĤƤϽ³ "saturate#SaturateInit"
   342            ! Υɤ򻲾ȤΤ.
   343            !
   344            ! Refer to source codes in the initialization procedure
   345            ! "saturate#SaturateInit" for the default values.
   346            !
   347  
   348      ! ¹ʸ ; Executable statement
   349      !
   350  
   351      if ( saturate_inited ) return
   352  
   353      ! ǥեͤ
   354      ! Default values settings
   355      !
   356  
   357  
   358  !!$    ! NAMELIST ɤ߹
   359  !!$    ! NAMELIST is input
   360  !!$    !
   361  !!$    if ( trim(namelist_filename) /= '' ) then
   362  !!$      call FileOpen( unit_nml, &          ! (out)
   363  !!$        & namelist_filename, mode = 'r' ) ! (in)
   364  !!$
   365  !!$      rewind( unit_nml )
   366  !!$      read( unit_nml, &           ! (in)
   367  !!$        & nml = saturate_nml, &  ! (out)
   368  !!$        & iostat = iostat_nml )   ! (out)
   369  !!$      close( unit_nml )
   370  !!$
   371  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   372  !!$    end if
   373  
   374      !  ; Print
   375      !
   376      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   377      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   378      call MessageNotify( 'M', module_name, '  Scheme of saturation = %c', &
   379        & c1 = saturate_scheme )
   380      saturate_inited = .true.
   381    end subroutine SaturateInit
   382  
   383    !-------------------------------------------------------------------
   384  
   385  end module saturate
