Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:28 2012
FILE NAME: phy_implicit_atmonly.f90
PROGRAM NAME: phy_implicit_atmonly
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   277  opt  (  11): Fused array assignments. :line 277 - 282
   277  vec  (   4): Vectorized array expression.
   277  vec  (   4): Vectorized array expression.
   282  opt  (1592): Outer loop unrolled inside inner loop.
   285  vec  (   3): Unvectorized loop.
   285  vec  (  13): Overhead of loop division is too large.
   286  opt  (  11): Fused array assignments. :line 286 - 292
   286  vec  (   4): Vectorized array expression.
   286  vec  (   4): Vectorized array expression.
   292  opt  (1592): Outer loop unrolled inside inner loop.
   297  opt  (  11): Fused array assignments. :line 297 - 302
   297  vec  (   4): Vectorized array expression.
   297  vec  (   4): Vectorized array expression.
   302  opt  (1592): Outer loop unrolled inside inner loop.
   309  opt  (  11): Fused array assignments. :line 309 - 313
   309  vec  (   4): Vectorized array expression.
   309  vec  (   4): Vectorized array expression.
   313  opt  (1592): Outer loop unrolled inside inner loop.
   316  vec  (   3): Unvectorized loop.
   316  vec  (  13): Overhead of loop division is too large.
   317  opt  (  11): Fused array assignments. :line 317 - 323
   317  vec  (   4): Vectorized array expression.
   328  opt  (  11): Fused array assignments. :line 328 - 333
   328  vec  (   4): Vectorized array expression.
   328  vec  (   4): Vectorized array expression.
   333  opt  (1592): Outer loop unrolled inside inner loop.
   342  opt  (  11): Fused array assignments. :line 342 - 347
   342  vec  (   4): Vectorized array expression.
   342  vec  (   4): Vectorized array expression.
   347  opt  (1592): Outer loop unrolled inside inner loop.
   350  vec  (   3): Unvectorized loop.
   350  vec  (  13): Overhead of loop division is too large.
   351  opt  (  11): Fused array assignments. :line 351 - 357
   351  vec  (   4): Vectorized array expression.
   351  vec  (   4): Vectorized array expression.
   357  opt  (1592): Outer loop unrolled inside inner loop.
   362  opt  (  11): Fused array assignments. :line 362 - 367
   362  vec  (   4): Vectorized array expression.
   362  vec  (   4): Vectorized array expression.
   367  opt  (1592): Outer loop unrolled inside inner loop.
   375  opt  (1772): Loop nest fused with following nest(s).
   375  opt  (1592): Outer loop unrolled inside inner loop.
   375  vec  (   4): Vectorized array expression.
   375  vec  (   4): Vectorized array expression.
   381  opt  (1593): Loop nest collapsed into one loop.
   381  vec  (   1): Vectorized loop.
   382  opt  (  11): Fused array assignments. :line 382 - 383
   396  opt  (1593): Loop nest collapsed into one loop.
   396  vec  (   1): Vectorized loop.
   397  opt  (  11): Fused array assignments. :line 397 - 398
   405  opt  (1772): Loop nest fused with following nest(s).
   405  opt  (1592): Outer loop unrolled inside inner loop.
   405  vec  (   4): Vectorized array expression.
   405  vec  (   4): Vectorized array expression.
   412  vec  (   3): Unvectorized loop.
   412  vec  (  13): Overhead of loop division is too large.
   413  opt  (1592): Outer loop unrolled inside inner loop.
   413  vec  (   4): Vectorized array expression.
   413  vec  (   4): Vectorized array expression.
   423  opt  (1592): Outer loop unrolled inside inner loop.
   423  vec  (   4): Vectorized array expression.
   423  vec  (   4): Vectorized array expression.
   429  opt  (1772): Loop nest fused with following nest(s).
   429  opt  (1592): Outer loop unrolled inside inner loop.
   429  vec  (   4): Vectorized array expression.
   429  vec  (   4): Vectorized array expression.
   437  vec  (   3): Unvectorized loop.
   437  vec  (  13): Overhead of loop division is too large.
   438  opt  (1592): Outer loop unrolled inside inner loop.
   438  vec  (   4): Vectorized array expression.
   438  vec  (   4): Vectorized array expression.
   442  opt  (1017): Subroutine call prevents optimization.
   448  opt  (1592): Outer loop unrolled inside inner loop.
   448  vec  (   4): Vectorized array expression.
   448  vec  (   4): Vectorized array expression.
   457  warn (  83): Dummy argument "xy_surfqvaptranscoef" is not used.
   457  warn (  83): Dummy argument "xy_surftemptranscoef" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:28 2012
FILE NAME: phy_implicit_atmonly.f90
PROGRAM NAME: phy_implicit_atmonly
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ˡˤʬ (絤Τ / ɽ̲١ھٷ׻ʤ)
     2  !
     3  != Time integration by using implicit scheme in case without calculation of surface and soil temperature
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: phy_implicit_atmonly.f90,v 1.2 2011-07-08 03:55:19 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module phy_implicit_atmonly
    13    !
    14    != ˡˤʬ (絤Τ / ɽ̲١ھٷ׻ʤ)
    15    !
    16    != Time integration by using implicit scheme in case without calculation of surface and soil temperature
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    !== Procedures List
    21    !
    22    ! PhyImplTendency      :: ѲΨη׻
    23    ! ------------         :: ------------
    24    ! PhyImplTendency      :: Calculate tendency
    25    !
    26    !--
    27    !== NAMELIST
    28    !
    29    ! NAMELIST#phy_implicit_nml
    30    !++
    31  
    32    ! ⥸塼 ; USE statements
    33    !
    34  
    35    ! ʻ
    36    ! Grid points settings
    37    !
    38    use gridset, only:   imax, & ! ٳʻ.
    39                                 ! Number of grid points in longitude
    40      &                  jmax, & ! ٳʻ.
    41                                 ! Number of grid points in latitude
    42      &                  kmax, & ! ľؿ.
    43                                 ! Number of vertical level
    44      &                  kslmax  ! ϲαľؿ.
    45                                 ! Number of subsurface vertical level
    46  
    47    ! ˴ؤ
    48    ! Settings of array for atmospheric composition
    49    !
    50    use composition, only: ncmax, IndexH2OVap
    51  
    52    ! ̷ѥ᥿
    53    ! Kind type parameter
    54    !
    55    use dc_types, only: DP, &      ! ټ¿. Double precision.
    56      &                 STRING     ! ʸ.       Strings.
    57  
    58    ! å
    59    ! Message output
    60    !
    61    use dc_message, only: MessageNotify
    62  
    63    ! ʸ ; Declaration statements
    64    !
    65    implicit none
    66    private
    67  
    68    ! ³
    69    ! Public procedure
    70    !
    71    public :: PhyImplAtmOnlyTendency
    72    public :: PhyImplAtmOnlyInit
    73  
    74  
    75    ! ѿ
    76    ! Public variables
    77    !
    78  
    79    ! ѿ
    80    ! Private variables
    81    !
    82    logical, save :: phy_implicit_atmonly_inited = .false.
    83                                ! ե饰.
    84                                ! Initialization flag
    85  
    86    character(*), parameter:: module_name = 'phy_implicit_atmonly'
    87                                ! ⥸塼̾.
    88                                ! Module name
    89    character(*), parameter:: version = &
    90      & '$Name: dcpam5-20120921 $' // &
    91      & '$Id: phy_implicit_atmonly.f90,v 1.2 2011-07-08 03:55:19 yot Exp $'
    92                                ! ⥸塼ΥС
    93                                ! Module version
    94  
    95  
    96  contains
    97  
    98    subroutine PhyImplAtmOnlyTendency(                           &
    99      & xyr_MomFluxX, xyr_MomFluxY, xyr_HeatFlux, xyrf_QMixFlux, & ! (in)
   100      & xyr_Press, xyz_Exner, xyr_Exner,                         & ! (in)
   101      & xyr_VelTransCoef, xyr_TempTransCoef,                     & ! (in)
   102      & xyr_QMixTransCoef,                                       & ! (in)
   103      & xy_SurfVelTransCoef, xy_SurfTempTransCoef,               & ! (in)
   104      & xy_SurfQVapTransCoef,                                    & ! (in)
   105      & xyz_DUDt, xyz_DVDt, xyz_DTempDt, xyzf_DQMixDt            & ! (out)
   106      & )
   107      !
   108      ! ѲΨη׻Ԥޤ.
   109      !
   110      ! Calculate tendencies.
   111      !
   112  
   113      ! ⥸塼 ; USE statements
   114      !
   115  
   116      ! ʪ
   117      ! Physical constants settings
   118      !
   119      use constants, only: &
   120        & Grav, &               ! $ g $ [m s-2].
   121                                ! ϲ®.
   122                                ! Gravitational acceleration
   123        & CpDry, &
   124                                ! $ C_p $ [J kg-1 K-1].
   125                                ! 絤갵Ǯ.
   126                                ! Specific heat of air at constant pressure
   127        & LatentHeat, &
   128                                ! $ L $ [J kg-1] .
   129                                ! ŷǮ.
   130                                ! Latent heat of condensation
   131        & GasRDry
   132                                ! $ R $ [J kg-1 K-1].
   133                                ! 絤ε.
   134                                ! Gas constant of air
   135  
   136      ! 
   137      ! Time control
   138      !
   139      use timeset, only: &
   140        & DelTime, &            ! $ \Delta t $ [s]
   141        & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $.
   142        & TimesetClockStart, TimesetClockStop
   143  
   144      ! ˡˤʬΤΥ롼
   145      ! Routines for time integration with implicit scheme
   146      !
   147      use phy_implicit_utils, only : PhyImplLUDecomp3, PhyImplLUSolve3
   148  
   149      ! ʸ ; Declaration statements
   150      !
   151      implicit none
   152  
   153      real(DP), intent(in):: xyr_MomFluxX (0:imax-1, 1:jmax, 0:kmax)
   154                                ! ư̥եå.
   155                                ! Eastward momentum flux
   156      real(DP), intent(in):: xyr_MomFluxY (0:imax-1, 1:jmax, 0:kmax)
   157                                ! ư̥եå.
   158                                ! Northward momentum flux
   159      real(DP), intent(in):: xyr_HeatFlux (0:imax-1, 1:jmax, 0:kmax)
   160                                ! Ǯեå.
   161                                ! Heat flux
   162      real(DP), intent(in):: xyrf_QMixFlux(0:imax-1, 1:jmax, 0:kmax, 1:ncmax)
   163                                ! 漾եå.
   164                                ! Specific humidity flux
   165  
   166      real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   167                                ! $ \hat{p} $ .  (Ⱦ٥).
   168                                ! Air pressure (half level)
   169      real(DP), intent(in):: xyz_Exner (0:imax-1, 1:jmax, 1:kmax)
   170                                ! Exner ؿ (٥).
   171                                ! Exner function (full level)
   172      real(DP), intent(in):: xyr_Exner (0:imax-1, 1:jmax, 0:kmax)
   173                                ! Exner ؿ (Ⱦ٥).
   174                                ! Exner function (half level)
   175  
   176      real(DP), intent(in):: xyr_VelTransCoef (0:imax-1, 1:jmax, 0:kmax)
   177                                ! ͢ư.
   178                                ! Transfer coefficient: velocity
   179      real(DP), intent(in):: xyr_TempTransCoef (0:imax-1, 1:jmax, 0:kmax)
   180                                ! ͢.
   181                                ! Transfer coefficient: temperature
   182      real(DP), intent(in):: xyr_QMixTransCoef(0:imax-1, 1:jmax, 0:kmax)
   183                                ! ͢.
   184                                ! Transfer coefficient: mass of constituents
   185  
   186      real(DP), intent(in):: xy_SurfVelTransCoef (0:imax-1, 1:jmax)
   187                                ! ͢ư.
   188                                ! Diffusion coefficient: velocity
   189      real(DP), intent(in):: xy_SurfTempTransCoef (0:imax-1, 1:jmax)
   190                                ! ͢.
   191                                ! Transfer coefficient: temperature
   192      real(DP), intent(in):: xy_SurfQVapTransCoef (0:imax-1, 1:jmax)
   193                                ! ͢漾.
   194                                ! Transfer coefficient: specific humidity
   195  
   196      real(DP), intent(out):: xyz_DUDt (0:imax-1, 1:jmax, 1:kmax)
   197                                ! $ \DP{u}{t} $ . ®Ѳ.
   198                                ! Eastward wind tendency
   199      real(DP), intent(out):: xyz_DVDt (0:imax-1, 1:jmax, 1:kmax)
   200                                ! $ \DP{v}{t} $ . ®Ѳ.
   201                                ! Northward wind tendency
   202      real(DP), intent(out):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   203                                ! $ \DP{T}{t} $ . Ѳ.
   204                                ! Temperature tendency
   205      real(DP), intent(out):: xyzf_DQMixDt(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   206                                ! $ \DP{q}{t} $ . ̺Ѳ.
   207                                ! Mass mixing ratio tendency
   208  
   209      ! ѿ
   210      ! Work variables
   211      !
   212      real(DP):: xyza_UVMtx  (0:imax-1, 1:jmax, 1:kmax, -1:1)
   213                                ! ®ٱ.
   214                                ! Implicit matrix about velocity
   215      real(DP):: xyra_TempMtx(0:imax-1, 1:jmax, 1:kmax, -1:1)
   216                                ! ٱ.
   217                                ! Implicit matrix about temperature
   218      real(DP):: xyza_QMixMtx(0:imax-1, 1:jmax, 1:kmax, -1:1)
   219                                ! ̺汢.
   220                                ! Implicit matrix about mass mixing ratio
   221  
   222      real(DP):: xyza_UVLUMtx    (0:imax-1, 1:jmax, 1:kmax,-1:1)
   223                                ! LU .
   224                                ! LU matrix
   225      real(DP):: xyza_QMixLUMtx  (0:imax-1, 1:jmax, 1:kmax, -1:1)
   226                                ! LU .
   227                                ! LU matrix
   228      real(DP):: xyz_DelQMixLUVec(0:imax-1, 1:jmax, 1:kmax)
   229                                ! $ q $ λѲ.
   230                                ! Tendency of $ q $
   231  
   232      real(DP):: xyaa_TempLUMtx  (0:imax-1, 1:jmax, 1:kmax, -1:1)
   233                                ! LU .
   234                                ! LU matrix
   235      real(DP):: xya_DelTempLUVec(0:imax-1, 1:jmax, 1:kmax)
   236                                ! $ T, Tg $ λѲ.
   237                                ! Tendency of $ T $ and $ Tg |
   238  
   239  
   240  !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   241  !!$                              ! Work variables for DO loop in longitude
   242  !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   243  !!$                              ! Work variables for DO loop in latitude
   244      integer:: k               ! ľ˲ DO 롼Ѻѿ
   245                                ! Work variables for DO loop in vertical direction
   246  !!$    integer:: l               !  DO 롼Ѻѿ
   247  !!$                              ! Work variables for DO loop of matrices
   248      integer:: n               ! ˲ DO 롼Ѻѿ
   249                                ! Work variables for DO loop in dimension of constituents
   250  
   251      ! ¹ʸ ; Executable statement
   252      !
   253  
   254      ! ǧ
   255      ! Initialization check
   256      !
   257      if ( .not. phy_implicit_atmonly_inited ) then
   258        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   259      end if
   260  
   261  
   262      ! ׻ַ¬
   263      ! Start measurement of computation time
   264      !
   265      call TimesetClockStart( module_name )
   266  
   267  
   268  
   269      ! ˡΤι
   270      ! Create matrices for implicit scheme
   271      !
   272  
   273      ! ľȻ͢鱢η׻ (®)
   274      ! Calculate implicit matrices from transfer coefficient of vertical diffusion scheme (velocity)
   275      !
   276      k = 1
   277      xyza_UVMtx  (:,:,k,-1) = 0.0d0
     .        if (xyza_uvmtx.DSC.U2 .gt. 0) then                                
     .           J1 = and(xyza_uvmtx.DSC.U2,1)                                  
     .  !CDIR    NODEP                                                          
     .           do t835 = 1, J1                                                
     .              D1 = 1.D0/grav                                              
     .              D2 = D1/(2.00000000000000e+000*deltime)                     
     .  !CDIR       NODEP                                                       
     .              do t837 = 1, xyza_uvmtx.DSC.U1 + 1                          
     .                 xyza_uvmtx(t837-1,t835,1,-1) = 0.0000000000000000e+000   
     .                 xyza_uvmtx(t837-1,t835,1,0) = xy_surfveltranscoef(t837-1,
     .       1            t835) - (xyr_press(t837-1,t835,1)-xyr_press(t837-1,   
     .       2            t835,0))*D2 + xyr_veltranscoef(t837-1,t835,1)         
     .                 xyza_uvmtx(t837-1,t835,1,1) = -xyr_veltranscoef(t837-1,  
     .       1            t835,1)                                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t835 = J1 + 1, xyza_uvmtx.DSC.U2, 2                         
     .              D3 = 1.D0/grav                                              
     .              D4 = D3/(2.00000000000000e+000*deltime)                     
     .              D5 = 1.D0/grav                                              
     .              D6 = D5/(2.00000000000000e+000*deltime)                     
     .  !CDIR       NODEP                                                       
     .              do t837 = 1, xyza_uvmtx.DSC.U1 + 1                          
     .                 xyza_uvmtx(t837-1,t835,1,-1) = 0.0000000000000000e+000   
     .                 xyza_uvmtx(t837-1,t835+1,1,-1) = 0.0000000000000000e+000 
     .                 xyza_uvmtx(t837-1,t835,1,0) = xy_surfveltranscoef(t837-1,
     .       1            t835) - (xyr_press(t837-1,t835,1)-xyr_press(t837-1,   
     .       2            t835,0))*D4 + xyr_veltranscoef(t837-1,t835,1)         
     .                 xyza_uvmtx(t837-1,t835+1,1,0) = xy_surfveltranscoef(t837-
     .       1            1,t835+1) - (xyr_press(t837-1,t835+1,1)-xyr_press(t837
     .       2            -1,t835+1,0))*D6 + xyr_veltranscoef(t837-1,t835+1,1)  
     .                 xyza_uvmtx(t837-1,t835,1,1) = -xyr_veltranscoef(t837-1,  
     .       1            t835,1)                                               
     .                 xyza_uvmtx(t837-1,t835+1,1,1) = -xyr_veltranscoef(t837-1,
     .       1            t835+1,1)                                             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   278      xyza_UVMtx  (:,:,k, 0) =                                                  &
   279        & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   280        & + xy_SurfVelTransCoef(:,:)                                            &
   281        & + xyr_VelTransCoef(:,:,k  )
   282      xyza_UVMtx  (:,:,k, 1) = &
   283        & - xyr_VelTransCoef(:,:,k)
   284  
   285      do k = 2, kmax-1
   286        xyza_UVMtx  (:,:,k,-1) = &
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t855 = 1, J2                                                
     .              D7 = 1.D0/grav                                              
     .              D8 = D7/(2.00000000000000e+000*deltime)                     
     .  !CDIR       NODEP                                                       
     .              do t857 = 1, imax                                           
     .                 xyza_uvmtx(t857-1,t855,k,-1) = -xyr_veltranscoef(t857-1, 
     .       1            t855,k-1)                                             
     .                 xyza_uvmtx(t857-1,t855,k,0) = xyr_veltranscoef(t857-1,   
     .       1            t855,k-1) - (xyr_press(t857-1,t855,k)-xyr_press(t857-1
     .       2            ,t855,k-1))*D8 + xyr_veltranscoef(t857-1,t855,k)      
     .                 xyza_uvmtx(t857-1,t855,k,1) = -xyr_veltranscoef(t857-1,  
     .       1            t855,k)                                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t855 = J2 + 1, jmax, 2                                      
     .              D9 = 1.D0/grav                                              
     .              D10 = D9/(2.00000000000000e+000*deltime)                    
     .              D11 = 1.D0/grav                                             
     .              D12 = D11/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t857 = 1, imax                                           
     .                 xyza_uvmtx(t857-1,t855,k,-1) = -xyr_veltranscoef(t857-1, 
     .       1            t855,k-1)                                             
     .                 xyza_uvmtx(t857-1,t855+1,k,-1) = -xyr_veltranscoef(t857-1
     .       1            ,t855+1,k-1)                                          
     .                 xyza_uvmtx(t857-1,t855,k,0) = xyr_veltranscoef(t857-1,   
     .       1            t855,k-1) - (xyr_press(t857-1,t855,k)-xyr_press(t857-1
     .       2            ,t855,k-1))*D10 + xyr_veltranscoef(t857-1,t855,k)     
     .                 xyza_uvmtx(t857-1,t855+1,k,0) = xyr_veltranscoef(t857-1, 
     .       1            t855+1,k-1) - (xyr_press(t857-1,t855+1,k)-xyr_press(  
     .       2            t857-1,t855+1,k-1))*D12 + xyr_veltranscoef(t857-1,t855
     .       3            +1,k)                                                 
     .                 xyza_uvmtx(t857-1,t855,k,1) = -xyr_veltranscoef(t857-1,  
     .       1            t855,k)                                               
     .                 xyza_uvmtx(t857-1,t855+1,k,1) = -xyr_veltranscoef(t857-1,
     .       1            t855+1,k)                                             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   287          & - xyr_VelTransCoef(:,:,k-1)
   288        xyza_UVMtx  (:,:,k, 0) =                                                  &
   289          & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   290          & + xyr_VelTransCoef(:,:,k-1)                                           &
   291          & + xyr_VelTransCoef(:,:,k  )
   292        xyza_UVMtx  (:,:,k, 1) = &
   293          & - xyr_VelTransCoef(:,:,k)
   294      end do
   295  
   296      k = kmax
   297      xyza_UVMtx  (:,:,k,-1) = &
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t877 = 1, J3                                                
     .              D13 = 1.D0/grav                                             
     .              D14 = D13/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t879 = 1, imax                                           
     .                 xyza_uvmtx(t879-1,t877,k,-1) = -xyr_veltranscoef(t879-1, 
     .       1            t877,k-1)                                             
     .                 xyza_uvmtx(t879-1,t877,k,0) = xyr_veltranscoef(t879-1,   
     .       1            t877,k-1) - (xyr_press(t879-1,t877,k)-xyr_press(t879-1
     .       2            ,t877,k-1))*D14                                       
     .                 xyza_uvmtx(t879-1,t877,k,1) = 0.0000000000000000e+000    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t877 = J3 + 1, jmax, 2                                      
     .              D15 = 1.D0/grav                                             
     .              D16 = D15/(2.00000000000000e+000*deltime)                   
     .              D17 = 1.D0/grav                                             
     .              D18 = D17/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t879 = 1, imax                                           
     .                 xyza_uvmtx(t879-1,t877,k,-1) = -xyr_veltranscoef(t879-1, 
     .       1            t877,k-1)                                             
     .                 xyza_uvmtx(t879-1,t877+1,k,-1) = -xyr_veltranscoef(t879-1
     .       1            ,t877+1,k-1)                                          
     .                 xyza_uvmtx(t879-1,t877,k,0) = xyr_veltranscoef(t879-1,   
     .       1            t877,k-1) - (xyr_press(t879-1,t877,k)-xyr_press(t879-1
     .       2            ,t877,k-1))*D16                                       
     .                 xyza_uvmtx(t879-1,t877+1,k,0) = xyr_veltranscoef(t879-1, 
     .       1            t877+1,k-1) - (xyr_press(t879-1,t877+1,k)-xyr_press(  
     .       2            t879-1,t877+1,k-1))*D18                               
     .                 xyza_uvmtx(t879-1,t877,k,1) = 0.0000000000000000e+000    
     .                 xyza_uvmtx(t879-1,t877+1,k,1) = 0.0000000000000000e+000  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   298        & - xyr_VelTransCoef(:,:,k-1)
   299      xyza_UVMtx  (:,:,k, 0) =                                                  &
   300        & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   301        & + xyr_VelTransCoef(:,:,k-1)
   302      xyza_UVMtx  (:,:,k, 1) = 0.0d0
   303  
   304  
   305      ! ľȻ͢鱢η׻ ()
   306      ! Calculate implicit matrices from transfer coefficient of vertical diffusion scheme (temperature)
   307      !
   308      k = 1
   309      xyra_TempMtx(:,:,k,-1) = 0.0_DP
     .        if (xyra_tempmtx.DSC.U2 .gt. 0) then                              
     .           J4 = and(xyra_tempmtx.DSC.U2,1)                                
     .  !CDIR    NODEP                                                          
     .           do t895 = 1, J4                                                
     .              D19 = cpdry/grav                                            
     .              D20 = D19/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t897 = 1, xyra_tempmtx.DSC.U1 + 1                        
     .                 xyra_tempmtx(t897-1,t895,1,-1) = 0.0000000000000000e+000 
     .                 xyra_tempmtx(t897-1,t895,1,0) = (cpdry*xyr_exner(t897-1, 
     .       1            t895,1))/xyz_exner(t897-1,t895,1)*xyr_temptranscoef(  
     .       2            t897-1,t895,1) - (xyr_press(t897-1,t895,1)-xyr_press( 
     .       3            t897-1,t895,0))*D20                                   
     .                 xyra_tempmtx(t897-1,t895,1,1) = -(cpdry*xyr_exner(t897-1,
     .       1            t895,1))/xyz_exner(t897-1,t895,2)*xyr_temptranscoef(  
     .       2            t897-1,t895,1)                                        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t895 = J4 + 1, xyra_tempmtx.DSC.U2, 2                       
     .              D21 = cpdry/grav                                            
     .              D22 = D21/(2.00000000000000e+000*deltime)                   
     .              D23 = cpdry/grav                                            
     .              D24 = D23/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t897 = 1, xyra_tempmtx.DSC.U1 + 1                        
     .                 xyra_tempmtx(t897-1,t895,1,-1) = 0.0000000000000000e+000 
     .                 xyra_tempmtx(t897-1,t895+1,1,-1) =                       
     .       1            0.0000000000000000e+000                               
     .                 xyra_tempmtx(t897-1,t895,1,0) = (cpdry*xyr_exner(t897-1, 
     .       1            t895,1))/xyz_exner(t897-1,t895,1)*xyr_temptranscoef(  
     .       2            t897-1,t895,1) - (xyr_press(t897-1,t895,1)-xyr_press( 
     .       3            t897-1,t895,0))*D22                                   
     .                 xyra_tempmtx(t897-1,t895+1,1,0) = (cpdry*xyr_exner(t897-1
     .       1            ,t895+1,1))/xyz_exner(t897-1,t895+1,1)*               
     .       2            xyr_temptranscoef(t897-1,t895+1,1) - (xyr_press(t897-1
     .       3            ,t895+1,1)-xyr_press(t897-1,t895+1,0))*D24            
     .                 xyra_tempmtx(t897-1,t895,1,1) = -(cpdry*xyr_exner(t897-1,
     .       1            t895,1))/xyz_exner(t897-1,t895,2)*xyr_temptranscoef(  
     .       2            t897-1,t895,1)                                        
     .                 xyra_tempmtx(t897-1,t895+1,1,1) = -(cpdry*xyr_exner(t897-
     .       1            1,t895+1,1))/xyz_exner(t897-1,t895+1,2)*              
     .       2            xyr_temptranscoef(t897-1,t895+1,1)                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   310      xyra_TempMtx(:,:,k, 0) =                                                          &
   311        & - CpDry * ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   312        & + CpDry * xyr_Exner(:,:,k  ) / xyz_Exner(:,:,k  ) * xyr_TempTransCoef(:,:,k  )
   313      xyra_TempMtx(:,:,k, 1) = &
   314        & - CpDry * xyr_Exner(:,:,k  ) / xyz_Exner(:,:,k+1) * xyr_TempTransCoef(:,:,k  )
   315  
   316      do k = 2, kmax-1
   317        xyra_TempMtx(:,:,k,-1) = &
     .        D25 = cpdry/grav                                                  
     .        D26 = D25/(2.00000000000000e+000*deltime)                         
     .  !CDIR NODEP                                                             
     .        do t923 = 1, imax                                                 
     .           xyra_tempmtx(t923-1,t921+1,k,-1) = -(cpdry*xyr_exner(t923-1,   
     .       1      t921+1,k-1))/xyz_exner(t923-1,t921+1,k-1)*xyr_temptranscoef(
     .       2      t923-1,t921+1,k-1)                                          
     .           xyra_tempmtx(t923-1,t921+1,k,0) = (cpdry*xyr_exner(t923-1,t921+
     .       1      1,k-1))/xyz_exner(t923-1,t921+1,k)*xyr_temptranscoef(t923-1,
     .       2      t921+1,k-1) - (xyr_press(t923-1,t921+1,k)-xyr_press(t923-1, 
     .       3      t921+1,k-1))*D26 + (cpdry*xyr_exner(t923-1,t921+1,k))/      
     .       4      xyz_exner(t923-1,t921+1,k)*xyr_temptranscoef(t923-1,t921+1,k
     .       5      )                                                           
     .           xyra_tempmtx(t923-1,t921+1,k,1) = -(cpdry*xyr_exner(t923-1,t921
     .       1      +1,k))/xyz_exner(t923-1,t921+1,k+1)*xyr_temptranscoef(t923-1
     .       2      ,t921+1,k)                                                  
     .        end do                                                            
   318          & - CpDry * xyr_Exner(:,:,k-1) / xyz_Exner(:,:,k-1) * xyr_TempTransCoef(:,:,k-1)
   319        xyra_TempMtx(:,:,k, 0) =                                                          &
   320          & - CpDry * ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   321          & + CpDry * xyr_Exner(:,:,k-1) / xyz_Exner(:,:,k  ) * xyr_TempTransCoef(:,:,k-1)&
   322          & + CpDry * xyr_Exner(:,:,k  ) / xyz_Exner(:,:,k  ) * xyr_TempTransCoef(:,:,k  )
   323        xyra_TempMtx(:,:,k, 1) = &
   324          & - CpDry * xyr_Exner(:,:,k  ) / xyz_Exner(:,:,k+1) * xyr_TempTransCoef(:,:,k  )
   325      end do
   326  
   327      k = kmax
   328      xyra_TempMtx(:,:,k,-1) = &
     .        if (jmax .gt. 0) then                                             
     .           J5 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t959 = 1, J5                                                
     .              D27 = cpdry/grav                                            
     .              D28 = D27/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t961 = 1, imax                                           
     .                 xyra_tempmtx(t961-1,t959,k,-1) = -(cpdry*xyr_exner(t961-1
     .       1            ,t959,k-1))/xyz_exner(t961-1,t959,k-1)*               
     .       2            xyr_temptranscoef(t961-1,t959,k-1)                    
     .                 xyra_tempmtx(t961-1,t959,k,0) = (cpdry*xyr_exner(t961-1, 
     .       1            t959,k-1))/xyz_exner(t961-1,t959,k)*xyr_temptranscoef(
     .       2            t961-1,t959,k-1) - (xyr_press(t961-1,t959,k)-xyr_press
     .       3            (t961-1,t959,k-1))*D28                                
     .                 xyra_tempmtx(t961-1,t959,k,1) = 0.0000000000000000e+000  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t959 = J5 + 1, jmax, 2                                      
     .              D29 = cpdry/grav                                            
     .              D30 = D29/(2.00000000000000e+000*deltime)                   
     .              D31 = cpdry/grav                                            
     .              D32 = D31/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t961 = 1, imax                                           
     .                 xyra_tempmtx(t961-1,t959,k,-1) = -(cpdry*xyr_exner(t961-1
     .       1            ,t959,k-1))/xyz_exner(t961-1,t959,k-1)*               
     .       2            xyr_temptranscoef(t961-1,t959,k-1)                    
     .                 xyra_tempmtx(t961-1,t959+1,k,-1) = -(cpdry*xyr_exner(t961
     .       1            -1,t959+1,k-1))/xyz_exner(t961-1,t959+1,k-1)*         
     .       2            xyr_temptranscoef(t961-1,t959+1,k-1)                  
     .                 xyra_tempmtx(t961-1,t959,k,0) = (cpdry*xyr_exner(t961-1, 
     .       1            t959,k-1))/xyz_exner(t961-1,t959,k)*xyr_temptranscoef(
     .       2            t961-1,t959,k-1) - (xyr_press(t961-1,t959,k)-xyr_press
     .       3            (t961-1,t959,k-1))*D30                                
     .                 xyra_tempmtx(t961-1,t959+1,k,0) = (cpdry*xyr_exner(t961-1
     .       1            ,t959+1,k-1))/xyz_exner(t961-1,t959+1,k)*             
     .       2            xyr_temptranscoef(t961-1,t959+1,k-1) - (xyr_press(t961
     .       3            -1,t959+1,k)-xyr_press(t961-1,t959+1,k-1))*D32        
     .                 xyra_tempmtx(t961-1,t959,k,1) = 0.0000000000000000e+000  
     .                 xyra_tempmtx(t961-1,t959+1,k,1) = 0.0000000000000000e+000
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   329        & - CpDry * xyr_Exner(:,:,k-1) / xyz_Exner(:,:,k-1) * xyr_TempTransCoef(:,:,k-1)
   330      xyra_TempMtx(:,:,k, 0) =                                                          &
   331        & - CpDry * ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   332        & + CpDry * xyr_Exner(:,:,k-1) / xyz_Exner(:,:,k  ) * xyr_TempTransCoef(:,:,k-1)
   333      xyra_TempMtx(:,:,k, 1) = 0.0d0
   334  
   335  
   336  
   337      ! ľȻ͢鱢η׻ (漾)
   338      ! Calculate implicit matrices from transfer coefficient of vertical diffusion scheme (specific humidity)
   339      !
   340  
   341      k = 1
   342      xyza_QMixMtx(:,:,k,-1) =                                                  &
     .        if (xyza_qmixmtx.DSC.U2 .gt. 0) then                              
     .           J6 = and(xyza_qmixmtx.DSC.U2,1)                                
     .  !CDIR    NODEP                                                          
     .           do t985 = 1, J6                                                
     .              D33 = 1.D0/grav                                             
     .              D34 = D33/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t987 = 1, xyza_qmixmtx.DSC.U1 + 1                        
     .                 xyza_qmixmtx(t987-1,t985,1,-1) = 0.0000000000000000e+000 
     .                 xyza_qmixmtx(t987-1,t985,1,0) = xyr_qmixtranscoef(t987-1,
     .       1            t985,1) - (xyr_press(t987-1,t985,1)-xyr_press(t987-1, 
     .       2            t985,0))*D34                                          
     .                 xyza_qmixmtx(t987-1,t985,1,1) = -xyr_qmixtranscoef(t987-1
     .       1            ,t985,1)                                              
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t985 = J6 + 1, xyza_qmixmtx.DSC.U2, 2                       
     .              D35 = 1.D0/grav                                             
     .              D36 = D35/(2.00000000000000e+000*deltime)                   
     .              D37 = 1.D0/grav                                             
     .              D38 = D37/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t987 = 1, xyza_qmixmtx.DSC.U1 + 1                        
     .                 xyza_qmixmtx(t987-1,t985,1,-1) = 0.0000000000000000e+000 
     .                 xyza_qmixmtx(t987-1,t985+1,1,-1) =                       
     .       1            0.0000000000000000e+000                               
     .                 xyza_qmixmtx(t987-1,t985,1,0) = xyr_qmixtranscoef(t987-1,
     .       1            t985,1) - (xyr_press(t987-1,t985,1)-xyr_press(t987-1, 
     .       2            t985,0))*D36                                          
     .                 xyza_qmixmtx(t987-1,t985+1,1,0) = xyr_qmixtranscoef(t987-
     .       1            1,t985+1,1) - (xyr_press(t987-1,t985+1,1)-xyr_press(  
     .       2            t987-1,t985+1,0))*D38                                 
     .                 xyza_qmixmtx(t987-1,t985,1,1) = -xyr_qmixtranscoef(t987-1
     .       1            ,t985,1)                                              
     .                 xyza_qmixmtx(t987-1,t985+1,1,1) = -xyr_qmixtranscoef(t987
     .       1            -1,t985+1,1)                                          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   343        & 0.0d0
   344      xyza_QMixMtx(:,:,k, 0) =                                                  &
   345        & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   346        & + xyr_QMixTransCoef(:,:,k  )
   347      xyza_QMixMtx(:,:,k, 1) =                                                  &
   348        & - xyr_QMixTransCoef(:,:,k  )
   349  
   350      do k = 2, kmax-1
   351        xyza_QMixMtx(:,:,k,-1) =                                                  &
     .        if (jmax .gt. 0) then                                             
     .           J7 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t1003 = 1, J7                                               
     .              D39 = 1.D0/grav                                             
     .              D40 = D39/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t1005 = 1, imax                                          
     .                 xyza_qmixmtx(t1005-1,t1003,k,-1) = -xyr_qmixtranscoef(   
     .       1            t1005-1,t1003,k-1)                                    
     .                 xyza_qmixmtx(t1005-1,t1003,k,0) = xyr_qmixtranscoef(t1005
     .       1            -1,t1003,k-1) - (xyr_press(t1005-1,t1003,k)-xyr_press(
     .       2            t1005-1,t1003,k-1))*D40 + xyr_qmixtranscoef(t1005-1,  
     .       3            t1003,k)                                              
     .                 xyza_qmixmtx(t1005-1,t1003,k,1) = -xyr_qmixtranscoef(    
     .       1            t1005-1,t1003,k)                                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1003 = J7 + 1, jmax, 2                                     
     .              D41 = 1.D0/grav                                             
     .              D42 = D41/(2.00000000000000e+000*deltime)                   
     .              D43 = 1.D0/grav                                             
     .              D44 = D43/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t1005 = 1, imax                                          
     .                 xyza_qmixmtx(t1005-1,t1003,k,-1) = -xyr_qmixtranscoef(   
     .       1            t1005-1,t1003,k-1)                                    
     .                 xyza_qmixmtx(t1005-1,t1003+1,k,-1) = -xyr_qmixtranscoef( 
     .       1            t1005-1,t1003+1,k-1)                                  
     .                 xyza_qmixmtx(t1005-1,t1003,k,0) = xyr_qmixtranscoef(t1005
     .       1            -1,t1003,k-1) - (xyr_press(t1005-1,t1003,k)-xyr_press(
     .       2            t1005-1,t1003,k-1))*D42 + xyr_qmixtranscoef(t1005-1,  
     .       3            t1003,k)                                              
     .                 xyza_qmixmtx(t1005-1,t1003+1,k,0) = xyr_qmixtranscoef(   
     .       1            t1005-1,t1003+1,k-1) - (xyr_press(t1005-1,t1003+1,k)- 
     .       2            xyr_press(t1005-1,t1003+1,k-1))*D44 +                 
     .       3            xyr_qmixtranscoef(t1005-1,t1003+1,k)                  
     .                 xyza_qmixmtx(t1005-1,t1003,k,1) = -xyr_qmixtranscoef(    
     .       1            t1005-1,t1003,k)                                      
     .                 xyza_qmixmtx(t1005-1,t1003+1,k,1) = -xyr_qmixtranscoef(  
     .       1            t1005-1,t1003+1,k)                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   352          & - xyr_QMixTransCoef(:,:,k-1)
   353        xyza_QMixMtx(:,:,k, 0) =                                                  &
   354          & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   355          & + xyr_QMixTransCoef(:,:,k-1)                                          &
   356          & + xyr_QMixTransCoef(:,:,k  )
   357        xyza_QMixMtx(:,:,k, 1) =                                                  &
   358          & - xyr_QMixTransCoef(:,:,k  )
   359      end do
   360  
   361      k = kmax
   362      xyza_QMixMtx(:,:,k,-1) =                                                  &
     .        if (jmax .gt. 0) then                                             
     .           J8 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t1025 = 1, J8                                               
     .              D45 = 1.D0/grav                                             
     .              D46 = D45/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t1027 = 1, imax                                          
     .                 xyza_qmixmtx(t1027-1,t1025,k,-1) = -xyr_qmixtranscoef(   
     .       1            t1027-1,t1025,k-1)                                    
     .                 xyza_qmixmtx(t1027-1,t1025,k,0) = xyr_qmixtranscoef(t1027
     .       1            -1,t1025,k-1) - (xyr_press(t1027-1,t1025,k)-xyr_press(
     .       2            t1027-1,t1025,k-1))*D46                               
     .                 xyza_qmixmtx(t1027-1,t1025,k,1) = 0.0000000000000000e+000
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1025 = J8 + 1, jmax, 2                                     
     .              D47 = 1.D0/grav                                             
     .              D48 = D47/(2.00000000000000e+000*deltime)                   
     .              D49 = 1.D0/grav                                             
     .              D50 = D49/(2.00000000000000e+000*deltime)                   
     .  !CDIR       NODEP                                                       
     .              do t1027 = 1, imax                                          
     .                 xyza_qmixmtx(t1027-1,t1025,k,-1) = -xyr_qmixtranscoef(   
     .       1            t1027-1,t1025,k-1)                                    
     .                 xyza_qmixmtx(t1027-1,t1025+1,k,-1) = -xyr_qmixtranscoef( 
     .       1            t1027-1,t1025+1,k-1)                                  
     .                 xyza_qmixmtx(t1027-1,t1025,k,0) = xyr_qmixtranscoef(t1027
     .       1            -1,t1025,k-1) - (xyr_press(t1027-1,t1025,k)-xyr_press(
     .       2            t1027-1,t1025,k-1))*D48                               
     .                 xyza_qmixmtx(t1027-1,t1025+1,k,0) = xyr_qmixtranscoef(   
     .       1            t1027-1,t1025+1,k-1) - (xyr_press(t1027-1,t1025+1,k)- 
     .       2            xyr_press(t1027-1,t1025+1,k-1))*D50                   
     .                 xyza_qmixmtx(t1027-1,t1025,k,1) = 0.0000000000000000e+000
     .                 xyza_qmixmtx(t1027-1,t1025+1,k,1) =                      
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   363        & - xyr_QMixTransCoef(:,:,k-1)
   364      xyza_QMixMtx(:,:,k, 0) =                                                  &
   365        & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   366        & + xyr_QMixTransCoef(:,:,k-1)
   367      xyza_QMixMtx(:,:,k, 1) = 0.0d0
   368  
   369  
   370  
   371  
   372      ! ®, ®η׻
   373      ! Calculate eastward and northward wind
   374      !
   375      xyza_UVLUMtx = xyza_UVMtx
     .  !CDIR NODEP                                                             
     .        do t1045 = 1, xyza_uvlumtx.DSC.U3                                 
     .           if (xyza_uvlumtx.DSC.U2 .gt. 0) then                           
     .              J9 = and(xyza_uvlumtx.DSC.U2,1)                             
     .  !CDIR       NODEP                                                       
     .              do t1047 = 1, J9                                            
     .  !CDIR          NODEP                                                    
     .                 do t1049 = 1, xyza_uvlumtx.DSC.U1 + 1                    
     .                    xyza_uvlumtx(t1049-1,t1047,t1045,-1) = xyza_uvmtx(    
     .       1               t1049-1,t1047,t1045,-1)                            
     .                    xyza_uvlumtx(t1049-1,t1047,t1045,0) = xyza_uvmtx(t1049
     .       1               -1,t1047,t1045,0)                                  
     .                    xyza_uvlumtx(t1049-1,t1047,t1045,1) = xyza_uvmtx(t1049
     .       1               -1,t1047,t1045,1)                                  
     .                 end do                                                   
     .              end do                                                      
     .  !CDIR       NODEP                                                       
     .              do t1047 = J9 + 1, xyza_uvlumtx.DSC.U2, 2                   
     .  !CDIR          NODEP                                                    
     .                 do t1049 = 1, xyza_uvlumtx.DSC.U1 + 1                    
     .                    xyza_uvlumtx(t1049-1,t1047,t1045,-1) = xyza_uvmtx(    
     .       1               t1049-1,t1047,t1045,-1)                            
     .                    xyza_uvlumtx(t1049-1,t1047+1,t1045,-1) = xyza_uvmtx(  
     .       1               t1049-1,t1047+1,t1045,-1)                          
     .                    xyza_uvlumtx(t1049-1,t1047,t1045,0) = xyza_uvmtx(t1049
     .       1               -1,t1047,t1045,0)                                  
     .                    xyza_uvlumtx(t1049-1,t1047+1,t1045,0) = xyza_uvmtx(   
     .       1               t1049-1,t1047+1,t1045,0)                           
     .                    xyza_uvlumtx(t1049-1,t1047,t1045,1) = xyza_uvmtx(t1049
     .       1               -1,t1047,t1045,1)                                  
     .                    xyza_uvlumtx(t1049-1,t1047+1,t1045,1) = xyza_uvmtx(   
     .       1               t1049-1,t1047+1,t1045,1)                           
     .                 end do                                                   
     .              end do                                                      
     .           endif                                                          
     .        end do                                                            
   376  
   377      call PhyImplLUDecomp3( &
   378        & xyza_UVLUMtx, &     ! (inout)
   379        & imax * jmax, kmax ) ! (in)
   380  
   381      do k = 1, kmax
   382        xyz_DUDt(:,:,k) = - ( xyr_MomFluxX(:,:,k) - xyr_MomFluxX(:,:,k-1) )
   383        xyz_DVDt(:,:,k) = - ( xyr_MomFluxY(:,:,k) - xyr_MomFluxY(:,:,k-1) )
   384      end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do k = 1, kmax*t63*(t62 + 1)                                      
     .           xyz_dudt(k-1,1,1) = -(xyr_momfluxx(k-1,1,1)-xyr_momfluxx(k-1,1,
     .       1      0))                                                         
     .           xyz_dvdt(k-1,1,1) = -(xyr_momfluxy(k-1,1,1)-xyr_momfluxy(k-1,1,
     .       1      0))                                                         
     .        end do                                                            
   385  
   386      call PhyImplLUSolve3( &
   387        & xyz_DUDt, &            ! (inout)
   388        & xyza_UVLUMtx, &        ! (in)
   389        & 1, imax * jmax, kmax ) ! (in)
   390  
   391      call PhyImplLUSolve3( &
   392        & xyz_DVDt, &            ! (inout)
   393        & xyza_UVLUMtx, &        ! (in)
   394        & 1, imax * jmax, kmax ) ! (in)
   395  
   396      do k = 1, kmax
   397        xyz_DUDt(:,:,k) = xyz_DUDt(:,:,k) / ( 2. * DelTime )
   398        xyz_DVDt(:,:,k) = xyz_DVDt(:,:,k) / ( 2. * DelTime )
   399      end do
     .        D51 = 1.D0/(2.00000000000000e+000*deltime)                        
     .        D52 = 1.D0/(2.00000000000000e+000*deltime)                        
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do k = 1, kmax*t150*(t149 + 1)                                    
     .           xyz_dudt(k-1,1,1) = xyz_dudt(k-1,1,1)*D51                      
     .           xyz_dvdt(k-1,1,1) = xyz_dvdt(k-1,1,1)*D52                      
     .        end do                                                            
   400  
   401  
   402      ! ٤η׻
   403      ! Calculate temperature
   404      !
   405      xyaa_TempLUMtx = xyra_TempMtx
     .  !CDIR NODEP                                                             
     .        do t1089 = 1, xyaa_templumtx.DSC.U3                               
     .           if (xyaa_templumtx.DSC.U2 .gt. 0) then                         
     .              J10 = and(xyaa_templumtx.DSC.U2,1)                          
     .  !CDIR       NODEP                                                       
     .              do t1091 = 1, J10                                           
     .  !CDIR          NODEP                                                    
     .                 do t1093 = 1, xyaa_templumtx.DSC.U1 + 1                  
     .                    xyaa_templumtx(t1093-1,t1091,t1089,-1) = xyra_tempmtx(
     .       1               t1093-1,t1091,t1089,-1)                            
     .                    xyaa_templumtx(t1093-1,t1091,t1089,0) = xyra_tempmtx( 
     .       1               t1093-1,t1091,t1089,0)                             
     .                    xyaa_templumtx(t1093-1,t1091,t1089,1) = xyra_tempmtx( 
     .       1               t1093-1,t1091,t1089,1)                             
     .                 end do                                                   
     .              end do                                                      
     .  !CDIR       NODEP                                                       
     .              do t1091 = J10 + 1, xyaa_templumtx.DSC.U2, 2                
     .  !CDIR          NODEP                                                    
     .                 do t1093 = 1, xyaa_templumtx.DSC.U1 + 1                  
     .                    xyaa_templumtx(t1093-1,t1091,t1089,-1) = xyra_tempmtx(
     .       1               t1093-1,t1091,t1089,-1)                            
     .                    xyaa_templumtx(t1093-1,t1091+1,t1089,-1) =            
     .       1               xyra_tempmtx(t1093-1,t1091+1,t1089,-1)             
     .                    xyaa_templumtx(t1093-1,t1091,t1089,0) = xyra_tempmtx( 
     .       1               t1093-1,t1091,t1089,0)                             
     .                    xyaa_templumtx(t1093-1,t1091+1,t1089,0) = xyra_tempmtx
     .       1               (t1093-1,t1091+1,t1089,0)                          
     .                    xyaa_templumtx(t1093-1,t1091,t1089,1) = xyra_tempmtx( 
     .       1               t1093-1,t1091,t1089,1)                             
     .                    xyaa_templumtx(t1093-1,t1091+1,t1089,1) = xyra_tempmtx
     .       1               (t1093-1,t1091+1,t1089,1)                          
     .                 end do                                                   
     .              end do                                                      
     .           endif                                                          
     .        end do                                                            
   406  
   407      call PhyImplLUDecomp3( &
   408        & xyaa_TempLUMtx,    & ! (inout)
   409        & imax * jmax, kmax  & ! (in)
   410        )
   411  
   412      do k = 1, kmax
   413        xya_DelTempLUVec(:,:,k) = &
     .        if (t77 .gt. 0) then                                              
     .           J11 = and(t77,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t1103 = 1, J11                                              
     .  !CDIR       NODEP                                                       
     .              do t1105 = 1, t76 + 1                                       
     .                 xya_deltempluvec(t1105-1,t1103,k) = -(xyr_heatflux(t1105-
     .       1            1,t1103,k)-xyr_heatflux(t1105-1,t1103,k-1))           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1103 = J11 + 1, t77, 4                                     
     .  !CDIR       NODEP                                                       
     .              do t1105 = 1, t76 + 1                                       
     .                 xya_deltempluvec(t1105-1,t1103,k) = xyr_heatflux(t1105-1,
     .       1            t1103,k-1) - xyr_heatflux(t1105-1,t1103,k)            
     .                 xya_deltempluvec(t1105-1,t1103+1,k) = xyr_heatflux(t1105-
     .       1            1,t1103+1,k-1) - xyr_heatflux(t1105-1,t1103+1,k)      
     .                 xya_deltempluvec(t1105-1,t1103+2,k) = xyr_heatflux(t1105-
     .       1            1,t1103+2,k-1) - xyr_heatflux(t1105-1,t1103+2,k)      
     .                 xya_deltempluvec(t1105-1,t1103+3,k) = xyr_heatflux(t1105-
     .       1            1,t1103+3,k-1) - xyr_heatflux(t1105-1,t1103+3,k)      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   414          - ( xyr_HeatFlux(:,:,k) - xyr_HeatFlux(:,:,k-1) )
   415      end do
   416  
   417      call PhyImplLUSolve3(           &
   418        & xya_DelTempLUVec,           & ! (inout)
   419        & xyaa_TempLUMtx,             & ! (in)
   420        & 1, imax * jmax , kmax       & ! (in)
   421        & )
   422  
   423      xyz_DTempDt = xya_DelTempLUVec / ( 2.0_DP * DelTime )
     .        if (xya_deltempluvec.DSC.U2 .gt. 0) then                          
     .           J12 = and(xya_deltempluvec.DSC.U2,3)                           
     .  !CDIR    NODEP                                                          
     .           do t1115 = 1, J12                                              
     .              D53 = 1.D0/(2.00000000000000e+000*deltime)                  
     .  !CDIR       NODEP                                                       
     .              do t1117 = 1, xya_deltempluvec.DSC.U1 + 1                   
     .                 xyz_dtempdt(t1117-1,t1115,t1113+1) = xya_deltempluvec(   
     .       1            t1117-1,t1115,t1113+1)*D53                            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1115 = J12 + 1, xya_deltempluvec.DSC.U2, 4                 
     .              D54 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D55 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D56 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D57 = 1.D0/(2.00000000000000e+000*deltime)                  
     .  !CDIR       NODEP                                                       
     .              do t1117 = 1, xya_deltempluvec.DSC.U1 + 1                   
     .                 xyz_dtempdt(t1117-1,t1115,t1113+1) = xya_deltempluvec(   
     .       1            t1117-1,t1115,t1113+1)*D54                            
     .                 xyz_dtempdt(t1117-1,t1115+1,t1113+1) = xya_deltempluvec( 
     .       1            t1117-1,t1115+1,t1113+1)*D55                          
     .                 xyz_dtempdt(t1117-1,t1115+2,t1113+1) = xya_deltempluvec( 
     .       1            t1117-1,t1115+2,t1113+1)*D56                          
     .                 xyz_dtempdt(t1117-1,t1115+3,t1113+1) = xya_deltempluvec( 
     .       1            t1117-1,t1115+3,t1113+1)*D57                          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   424  
   425  
   426      ! 漾η׻
   427      ! Calculate specific humidity
   428      !
   429      xyza_QMixLUMtx = xyza_QMixMtx
     .  !CDIR NODEP                                                             
     .        do t1127 = 1, xyza_qmixlumtx.DSC.U3                               
     .           if (xyza_qmixlumtx.DSC.U2 .gt. 0) then                         
     .              J13 = and(xyza_qmixlumtx.DSC.U2,1)                          
     .  !CDIR       NODEP                                                       
     .              do t1129 = 1, J13                                           
     .  !CDIR          NODEP                                                    
     .                 do t1131 = 1, xyza_qmixlumtx.DSC.U1 + 1                  
     .                    xyza_qmixlumtx(t1131-1,t1129,t1127,-1) = xyza_qmixmtx(
     .       1               t1131-1,t1129,t1127,-1)                            
     .                    xyza_qmixlumtx(t1131-1,t1129,t1127,0) = xyza_qmixmtx( 
     .       1               t1131-1,t1129,t1127,0)                             
     .                    xyza_qmixlumtx(t1131-1,t1129,t1127,1) = xyza_qmixmtx( 
     .       1               t1131-1,t1129,t1127,1)                             
     .                 end do                                                   
     .              end do                                                      
     .  !CDIR       NODEP                                                       
     .              do t1129 = J13 + 1, xyza_qmixlumtx.DSC.U2, 2                
     .  !CDIR          NODEP                                                    
     .                 do t1131 = 1, xyza_qmixlumtx.DSC.U1 + 1                  
     .                    xyza_qmixlumtx(t1131-1,t1129,t1127,-1) = xyza_qmixmtx(
     .       1               t1131-1,t1129,t1127,-1)                            
     .                    xyza_qmixlumtx(t1131-1,t1129+1,t1127,-1) =            
     .       1               xyza_qmixmtx(t1131-1,t1129+1,t1127,-1)             
     .                    xyza_qmixlumtx(t1131-1,t1129,t1127,0) = xyza_qmixmtx( 
     .       1               t1131-1,t1129,t1127,0)                             
     .                    xyza_qmixlumtx(t1131-1,t1129+1,t1127,0) = xyza_qmixmtx
     .       1               (t1131-1,t1129+1,t1127,0)                          
     .                    xyza_qmixlumtx(t1131-1,t1129,t1127,1) = xyza_qmixmtx( 
     .       1               t1131-1,t1129,t1127,1)                             
     .                    xyza_qmixlumtx(t1131-1,t1129+1,t1127,1) = xyza_qmixmtx
     .       1               (t1131-1,t1129+1,t1127,1)                          
     .                 end do                                                   
     .              end do                                                      
     .           endif                                                          
     .        end do                                                            
   430  
   431      call PhyImplLUDecomp3( &
   432        & xyza_QMixLUMtx,    &   ! (inout)
   433        & imax * jmax, kmax  &   ! (in)
   434        & )
   435  
   436      do n = 1, ncmax
   437        do k = 1, kmax
   438          xyz_DelQMixLUVec(:,:,k) = &
     .        if (t84 .gt. 0) then                                              
     .           J14 = and(t84,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t1141 = 1, J14                                              
     .  !CDIR       NODEP                                                       
     .              do t1143 = 1, t83 + 1                                       
     .                 xyz_delqmixluvec(t1143-1,t1141,k) = -(xyrf_qmixflux(t1143
     .       1            -1,t1141,k,n)-xyrf_qmixflux(t1143-1,t1141,k-1,n))     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1141 = J14 + 1, t84, 4                                     
     .  !CDIR       NODEP                                                       
     .              do t1143 = 1, t83 + 1                                       
     .                 xyz_delqmixluvec(t1143-1,t1141,k) = xyrf_qmixflux(t1143-1
     .       1            ,t1141,k-1,n) - xyrf_qmixflux(t1143-1,t1141,k,n)      
     .                 xyz_delqmixluvec(t1143-1,t1141+1,k) = xyrf_qmixflux(t1143
     .       1            -1,t1141+1,k-1,n) - xyrf_qmixflux(t1143-1,t1141+1,k,n)
     .                 xyz_delqmixluvec(t1143-1,t1141+2,k) = xyrf_qmixflux(t1143
     .       1            -1,t1141+2,k-1,n) - xyrf_qmixflux(t1143-1,t1141+2,k,n)
     .                 xyz_delqmixluvec(t1143-1,t1141+3,k) = xyrf_qmixflux(t1143
     .       1            -1,t1141+3,k-1,n) - xyrf_qmixflux(t1143-1,t1141+3,k,n)
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   439            & - ( xyrf_QMixFlux(:,:,k,n) - xyrf_QMixFlux(:,:,k-1,n) )
   440        end do
   441  
   442        call PhyImplLUSolve3(      &
   443          & xyz_DelQMixLUVec,      & ! (inout)
   444          & xyza_QMixLUMtx,        & ! (in)
   445          & 1, imax * jmax , kmax  & ! (in)
   446          & )
   447  
   448        xyzf_DQMixDt(:,:,:,n) = xyz_DelQMixLUVec(:,:,:) / ( 2. * DelTime )
     .        if (xyz_delqmixluvec.DSC.U2 .gt. 0) then                          
     .           J15 = and(xyz_delqmixluvec.DSC.U2,3)                           
     .  !CDIR    NODEP                                                          
     .           do t1153 = 1, J15                                              
     .              D58 = 1.D0/(2.00000000000000e+000*deltime)                  
     .  !CDIR       NODEP                                                       
     .              do t1155 = 1, xyz_delqmixluvec.DSC.U1 + 1                   
     .                 xyzf_dqmixdt(t1155-1,t1153,t1151+1,n) = xyz_delqmixluvec(
     .       1            t1155-1,t1153,t1151+1)*D58                            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1153 = J15 + 1, xyz_delqmixluvec.DSC.U2, 4                 
     .              D59 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D60 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D61 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D62 = 1.D0/(2.00000000000000e+000*deltime)                  
     .  !CDIR       NODEP                                                       
     .              do t1155 = 1, xyz_delqmixluvec.DSC.U1 + 1                   
     .                 xyzf_dqmixdt(t1155-1,t1153,t1151+1,n) = xyz_delqmixluvec(
     .       1            t1155-1,t1153,t1151+1)*D59                            
     .                 xyzf_dqmixdt(t1155-1,t1153+1,t1151+1,n) =                
     .       1            xyz_delqmixluvec(t1155-1,t1153+1,t1151+1)*D60         
     .                 xyzf_dqmixdt(t1155-1,t1153+2,t1151+1,n) =                
     .       1            xyz_delqmixluvec(t1155-1,t1153+2,t1151+1)*D61         
     .                 xyzf_dqmixdt(t1155-1,t1153+3,t1151+1,n) =                
     .       1            xyz_delqmixluvec(t1155-1,t1153+3,t1151+1)*D62         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   449      end do
   450  
   451  
   452      ! ׻ַ¬
   453      ! Pause measurement of computation time
   454      !
   455      call TimesetClockStop( module_name )
   456  
   457    end subroutine PhyImplAtmOnlyTendency
   458  
   459    !-------------------------------------------------------------------
   460  
   461    subroutine PhyImplAtmOnlyInit
   462      !
   463      ! phy_implicit_atmonly ⥸塼νԤޤ.
   464      ! NAMELIST#phy_implicit_atmonly_nml ɤ߹ߤϤμ³ǹԤޤ.
   465      !
   466      ! "phy_implicit_atmonly" module is initialized.
   467      ! "NAMELIST#phy_implicit_atmonly_nml" is loaded in this procedure.
   468      !
   469  
   470      ! ⥸塼 ; USE statements
   471      !
   472  
   473      ! NAMELIST եϤ˴ؤ桼ƥƥ
   474      ! Utilities for NAMELIST file input
   475      !
   476      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   477  
   478      ! ե
   479      ! File I/O support
   480      !
   481      use dc_iounit, only: FileOpen
   482  
   483      ! ̷ѥ᥿
   484      ! Kind type parameter
   485      !
   486      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   487  
   488      ! ʸ
   489      ! Character handling
   490      !
   491      use dc_string, only: StoA
   492  
   493      ! ʸ ; Declaration statements
   494      !
   495      implicit none
   496  
   497      ! ѿ
   498      ! Work variables
   499      !
   500  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   501  !!$                              ! Unit number for NAMELIST file open
   502  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   503  !!$                              ! IOSTAT of NAMELIST read
   504  
   505      ! NAMELIST ѿ
   506      ! NAMELIST group name
   507      !
   508  !!$    namelist /phy_implicit_atmonly_nml/ &
   509  !!$      SOHeatCapacity          ! Slab ocean heat capacity (J m-2 K-1)
   510            !
   511            ! ǥեͤˤĤƤϽ³ "phy_implicit_atmonly#PhyImplInit"
   512            ! Υɤ򻲾ȤΤ.
   513            !
   514            ! Refer to source codes in the initialization procedure
   515            ! "phy_implicit_atmonly#PhyImplInit" for the default values.
   516            !
   517  
   518      ! ¹ʸ ; Executable statement
   519      !
   520  
   521      if ( phy_implicit_atmonly_inited ) return
   522  
   523      ! ǥեͤ
   524      ! Default values settings
   525      !
   526  
   527  !!$    SOHeatCapacity = 4.187d3 * 1.0d3 * 60.0d0
   528  !!$                         ! 4.187d3 (J (kg K)-1) * 1.0d3 (kg m-3) * 60.0d0 (m)
   529  
   530  
   531  !!$    ! NAMELIST ɤ߹
   532  !!$    ! NAMELIST is input
   533  !!$    !
   534  !!$    if ( trim(namelist_filename) /= '' ) then
   535  !!$      call FileOpen( unit_nml, &          ! (out)
   536  !!$        & namelist_filename, mode = 'r' ) ! (in)
   537  !!$
   538  !!$      rewind( unit_nml )
   539  !!$      read( unit_nml,                     &  ! (in)
   540  !!$        & nml = phy_implicit_atmonly_nml, &  ! (out)
   541  !!$        & iostat = iostat_nml )              ! (out)
   542  !!$      close( unit_nml )
   543  !!$
   544  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   545  !!$    end if
   546  
   547  
   548  
   549      !  ; Print
   550      !
   551      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   552  !!$    call MessageNotify( 'M', module_name, '  SOHeatCapacity = %f', d = (/ SOHeatCapacity /) )
   553      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   554  
   555  
   556      phy_implicit_atmonly_inited = .true.
   557  
   558    end subroutine PhyImplAtmOnlyInit
   559  
   560    !-------------------------------------------------------------------
   561  
   562  end module phy_implicit_atmonly
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:28 2012
FILE NAME: phy_implicit_atmonly.f90
PROGRAM NAME: phy_implicit_atmonly
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ˡˤʬ (絤Τ / ɽ̲١ھٷ׻ʤ)
     2:            !
     3:            != Time integration by using implicit scheme in case without calculation of surface and soil temperature
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: phy_implicit_atmonly.f90,v 1.2 2011-07-08 03:55:19 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module phy_implicit_atmonly
    13:              !
    14:              != ˡˤʬ (絤Τ / ɽ̲١ھٷ׻ʤ)
    15:              !
    16:              != Time integration by using implicit scheme in case without calculation of surface and soil temperature
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              !== Procedures List
    21:              !
    22:              ! PhyImplTendency      :: ѲΨη׻
    23:              ! ------------         :: ------------
    24:              ! PhyImplTendency      :: Calculate tendency
    25:              !
    26:              !--
    27:              !== NAMELIST
    28:              !
    29:              ! NAMELIST#phy_implicit_nml
    30:              !++
    31:            
    32:              ! ⥸塼 ; USE statements
    33:              !
    34:            
    35:              ! ʻ
    36:              ! Grid points settings
    37:              !
    38:              use gridset, only:   imax, & ! ٳʻ. 
    39:                                           ! Number of grid points in longitude
    40:                &                  jmax, & ! ٳʻ. 
    41:                                           ! Number of grid points in latitude
    42:                &                  kmax, & ! ľؿ. 
    43:                                           ! Number of vertical level
    44:                &                  kslmax  ! ϲαľؿ. 
    45:                                           ! Number of subsurface vertical level
    46:            
    47:              ! ˴ؤ
    48:              ! Settings of array for atmospheric composition
    49:              !
    50:              use composition, only: ncmax, IndexH2OVap
    51:            
    52:              ! ̷ѥ᥿
    53:              ! Kind type parameter
    54:              !
    55:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    56:                &                 STRING     ! ʸ.       Strings. 
    57:            
    58:              ! å
    59:              ! Message output
    60:              !
    61:              use dc_message, only: MessageNotify
    62:            
    63:              ! ʸ ; Declaration statements
    64:              !
    65:              implicit none
    66:              private
    67:            
    68:              ! ³
    69:              ! Public procedure
    70:              !
    71:              public :: PhyImplAtmOnlyTendency
    72:              public :: PhyImplAtmOnlyInit
    73:            
    74:            
    75:              ! ѿ
    76:              ! Public variables
    77:              !
    78:            
    79:              ! ѿ
    80:              ! Private variables
    81:              !
    82:              logical, save :: phy_implicit_atmonly_inited = .false.
    83:                                          ! ե饰. 
    84:                                          ! Initialization flag
    85:            
    86:              character(*), parameter:: module_name = 'phy_implicit_atmonly'
    87:                                          ! ⥸塼̾. 
    88:                                          ! Module name
    89:              character(*), parameter:: version = &
    90:                & '$Name: dcpam5-20120921 $' // &
    91:                & '$Id: phy_implicit_atmonly.f90,v 1.2 2011-07-08 03:55:19 yot Exp $'
    92:                                          ! ⥸塼ΥС
    93:                                          ! Module version
    94:            
    95:            
    96:            contains
    97:            
    98:              subroutine PhyImplAtmOnlyTendency(                           &
    99:                & xyr_MomFluxX, xyr_MomFluxY, xyr_HeatFlux, xyrf_QMixFlux, & ! (in)
   100:                & xyr_Press, xyz_Exner, xyr_Exner,                         & ! (in)
   101:                & xyr_VelTransCoef, xyr_TempTransCoef,                     & ! (in)
   102:                & xyr_QMixTransCoef,                                       & ! (in)
   103:                & xy_SurfVelTransCoef, xy_SurfTempTransCoef,               & ! (in)
   104:                & xy_SurfQVapTransCoef,                                    & ! (in)
   105:                & xyz_DUDt, xyz_DVDt, xyz_DTempDt, xyzf_DQMixDt            & ! (out)
   106:                & )
   107:                !
   108:                ! ѲΨη׻Ԥޤ. 
   109:                !
   110:                ! Calculate tendencies. 
   111:                !
   112:            
   113:                ! ⥸塼 ; USE statements
   114:                !
   115:            
   116:                ! ʪ
   117:                ! Physical constants settings
   118:                !
   119:                use constants, only: &
   120:                  & Grav, &               ! $ g $ [m s-2]. 
   121:                                          ! ϲ®. 
   122:                                          ! Gravitational acceleration
   123:                  & CpDry, &
   124:                                          ! $ C_p $ [J kg-1 K-1]. 
   125:                                          ! 絤갵Ǯ. 
   126:                                          ! Specific heat of air at constant pressure
   127:                  & LatentHeat, &
   128:                                          ! $ L $ [J kg-1] . 
   129:                                          ! ŷǮ. 
   130:                                          ! Latent heat of condensation
   131:                  & GasRDry
   132:                                          ! $ R $ [J kg-1 K-1]. 
   133:                                          ! 絤ε. 
   134:                                          ! Gas constant of air
   135:            
   136:                ! 
   137:                ! Time control
   138:                !
   139:                use timeset, only: &
   140:                  & DelTime, &            ! $ \Delta t $ [s]
   141:                  & TimeN, &              ! ƥå $ t $ λ. Time of step $ t $. 
   142:                  & TimesetClockStart, TimesetClockStop
   143:            
   144:                ! ˡˤʬΤΥ롼
   145:                ! Routines for time integration with implicit scheme
   146:                !
   147:                use phy_implicit_utils, only : PhyImplLUDecomp3, PhyImplLUSolve3
   148:            
   149:                ! ʸ ; Declaration statements
   150:                !
   151:                implicit none
   152:            
   153:                real(DP), intent(in):: xyr_MomFluxX (0:imax-1, 1:jmax, 0:kmax)
   154:                                          ! ư̥եå. 
   155:                                          ! Eastward momentum flux
   156:                real(DP), intent(in):: xyr_MomFluxY (0:imax-1, 1:jmax, 0:kmax)
   157:                                          ! ư̥եå. 
   158:                                          ! Northward momentum flux
   159:                real(DP), intent(in):: xyr_HeatFlux (0:imax-1, 1:jmax, 0:kmax)
   160:                                          ! Ǯեå. 
   161:                                          ! Heat flux
   162:                real(DP), intent(in):: xyrf_QMixFlux(0:imax-1, 1:jmax, 0:kmax, 1:ncmax)
   163:                                          ! 漾եå. 
   164:                                          ! Specific humidity flux
   165:            
   166:                real(DP), intent(in):: xyr_Press (0:imax-1, 1:jmax, 0:kmax)
   167:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   168:                                          ! Air pressure (half level)
   169:                real(DP), intent(in):: xyz_Exner (0:imax-1, 1:jmax, 1:kmax)
   170:                                          ! Exner ؿ (٥). 
   171:                                          ! Exner function (full level)
   172:                real(DP), intent(in):: xyr_Exner (0:imax-1, 1:jmax, 0:kmax)
   173:                                          ! Exner ؿ (Ⱦ٥). 
   174:                                          ! Exner function (half level)
   175:            
   176:                real(DP), intent(in):: xyr_VelTransCoef (0:imax-1, 1:jmax, 0:kmax)
   177:                                          ! ͢ư. 
   178:                                          ! Transfer coefficient: velocity
   179:                real(DP), intent(in):: xyr_TempTransCoef (0:imax-1, 1:jmax, 0:kmax)
   180:                                          ! ͢. 
   181:                                          ! Transfer coefficient: temperature
   182:                real(DP), intent(in):: xyr_QMixTransCoef(0:imax-1, 1:jmax, 0:kmax)
   183:                                          ! ͢. 
   184:                                          ! Transfer coefficient: mass of constituents
   185:            
   186:                real(DP), intent(in):: xy_SurfVelTransCoef (0:imax-1, 1:jmax)
   187:                                          ! ͢ư. 
   188:                                          ! Diffusion coefficient: velocity
   189:                real(DP), intent(in):: xy_SurfTempTransCoef (0:imax-1, 1:jmax)
   190:                                          ! ͢. 
   191:                                          ! Transfer coefficient: temperature
   192:                real(DP), intent(in):: xy_SurfQVapTransCoef (0:imax-1, 1:jmax)
   193:                                          ! ͢漾. 
   194:                                          ! Transfer coefficient: specific humidity
   195:            
   196:                real(DP), intent(out):: xyz_DUDt (0:imax-1, 1:jmax, 1:kmax)
   197:                                          ! $ \DP{u}{t} $ . ®Ѳ. 
   198:                                          ! Eastward wind tendency
   199:                real(DP), intent(out):: xyz_DVDt (0:imax-1, 1:jmax, 1:kmax)
   200:                                          ! $ \DP{v}{t} $ . ®Ѳ. 
   201:                                          ! Northward wind tendency
   202:                real(DP), intent(out):: xyz_DTempDt (0:imax-1, 1:jmax, 1:kmax)
   203:                                          ! $ \DP{T}{t} $ . Ѳ. 
   204:                                          ! Temperature tendency
   205:                real(DP), intent(out):: xyzf_DQMixDt(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   206:                                          ! $ \DP{q}{t} $ . ̺Ѳ. 
   207:                                          ! Mass mixing ratio tendency
   208:            
   209:                ! ѿ
   210:                ! Work variables
   211:                !
   212:                real(DP):: xyza_UVMtx  (0:imax-1, 1:jmax, 1:kmax, -1:1)
   213:                                          ! ®ٱ. 
   214:                                          ! Implicit matrix about velocity 
   215:                real(DP):: xyra_TempMtx(0:imax-1, 1:jmax, 1:kmax, -1:1)
   216:                                          ! ٱ. 
   217:                                          ! Implicit matrix about temperature
   218:                real(DP):: xyza_QMixMtx(0:imax-1, 1:jmax, 1:kmax, -1:1)
   219:                                          ! ̺汢. 
   220:                                          ! Implicit matrix about mass mixing ratio
   221:            
   222:                real(DP):: xyza_UVLUMtx    (0:imax-1, 1:jmax, 1:kmax,-1:1)
   223:                                          ! LU . 
   224:                                          ! LU matrix
   225:                real(DP):: xyza_QMixLUMtx  (0:imax-1, 1:jmax, 1:kmax, -1:1)
   226:                                          ! LU .
   227:                                          ! LU matrix
   228:                real(DP):: xyz_DelQMixLUVec(0:imax-1, 1:jmax, 1:kmax)
   229:                                          ! $ q $ λѲ.
   230:                                          ! Tendency of $ q $
   231:            
   232:                real(DP):: xyaa_TempLUMtx  (0:imax-1, 1:jmax, 1:kmax, -1:1)
   233:                                          ! LU .
   234:                                          ! LU matrix
   235:                real(DP):: xya_DelTempLUVec(0:imax-1, 1:jmax, 1:kmax)
   236:                                          ! $ T, Tg $ λѲ.
   237:                                          ! Tendency of $ T $ and $ Tg |
   238:            
   239:            
   240:            !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   241:            !!$                              ! Work variables for DO loop in longitude
   242:            !!$    integer:: j               ! ˲ DO 롼Ѻѿ
   243:            !!$                              ! Work variables for DO loop in latitude
   244:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   245:                                          ! Work variables for DO loop in vertical direction
   246:            !!$    integer:: l               !  DO 롼Ѻѿ
   247:            !!$                              ! Work variables for DO loop of matrices
   248:                integer:: n               ! ˲ DO 롼Ѻѿ
   249:                                          ! Work variables for DO loop in dimension of constituents
   250:            
   251:                ! ¹ʸ ; Executable statement
   252:                !
   253:            
   254:                ! ǧ
   255:                ! Initialization check
   256:                !
   257:                if ( .not. phy_implicit_atmonly_inited ) then
   258:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   259:                end if
   260:            
   261:            
   262:                ! ׻ַ¬
   263:                ! Start measurement of computation time
   264:                !
   265:                call TimesetClockStart( module_name )
   266:            
   267:            
   268:            
   269:                ! ˡΤι
   270:                ! Create matrices for implicit scheme
   271:                !
   272:            
   273:                ! ľȻ͢鱢η׻ (®)
   274:                ! Calculate implicit matrices from transfer coefficient of vertical diffusion scheme (velocity)
   275:                !
   276:                k = 1
   277: *V----->       xyza_UVMtx  (:,:,k,-1) = 0.0d0
   278: ||             xyza_UVMtx  (:,:,k, 0) =                                                  &
   279: ||               & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   280: ||               & + xy_SurfVelTransCoef(:,:)                                            &
   281: ||               & + xyr_VelTransCoef(:,:,k  )
   282: *V-----        xyza_UVMtx  (:,:,k, 1) = &
   283:                  & - xyr_VelTransCoef(:,:,k)
   284:            
   285: +------>       do k = 2, kmax-1
   286: |*V---->         xyza_UVMtx  (:,:,k,-1) = &
   287: |||                & - xyr_VelTransCoef(:,:,k-1)
   288: |||              xyza_UVMtx  (:,:,k, 0) =                                                  &
   289: |||                & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   290: |||                & + xyr_VelTransCoef(:,:,k-1)                                           &
   291: |||                & + xyr_VelTransCoef(:,:,k  )
   292: |*V----          xyza_UVMtx  (:,:,k, 1) = &
   293: |                  & - xyr_VelTransCoef(:,:,k)
   294: +------        end do
   295:            
   296:                k = kmax
   297: *V----->       xyza_UVMtx  (:,:,k,-1) = &
   298: ||               & - xyr_VelTransCoef(:,:,k-1)
   299: ||             xyza_UVMtx  (:,:,k, 0) =                                                  &
   300: ||               & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   301: ||               & + xyr_VelTransCoef(:,:,k-1)
   302: *V-----        xyza_UVMtx  (:,:,k, 1) = 0.0d0
   303:            
   304:            
   305:                ! ľȻ͢鱢η׻ ()
   306:                ! Calculate implicit matrices from transfer coefficient of vertical diffusion scheme (temperature)
   307:                !
   308:                k = 1
   309: *V----->       xyra_TempMtx(:,:,k,-1) = 0.0_DP
   310: ||             xyra_TempMtx(:,:,k, 0) =                                                          &
   311: ||               & - CpDry * ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   312: ||               & + CpDry * xyr_Exner(:,:,k  ) / xyz_Exner(:,:,k  ) * xyr_TempTransCoef(:,:,k  )
   313: *V-----        xyra_TempMtx(:,:,k, 1) = &
   314:                  & - CpDry * xyr_Exner(:,:,k  ) / xyz_Exner(:,:,k+1) * xyr_TempTransCoef(:,:,k  )
   315:            
   316: +------>       do k = 2, kmax-1
   317: |*V---->         xyra_TempMtx(:,:,k,-1) = &
   318: |||                & - CpDry * xyr_Exner(:,:,k-1) / xyz_Exner(:,:,k-1) * xyr_TempTransCoef(:,:,k-1)
   319: |||              xyra_TempMtx(:,:,k, 0) =                                                          &
   320: |||                & - CpDry * ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   321: |||                & + CpDry * xyr_Exner(:,:,k-1) / xyz_Exner(:,:,k  ) * xyr_TempTransCoef(:,:,k-1)&
   322: |||                & + CpDry * xyr_Exner(:,:,k  ) / xyz_Exner(:,:,k  ) * xyr_TempTransCoef(:,:,k  )
   323: |*V----          xyra_TempMtx(:,:,k, 1) = &
   324: |                  & - CpDry * xyr_Exner(:,:,k  ) / xyz_Exner(:,:,k+1) * xyr_TempTransCoef(:,:,k  )
   325: +------        end do
   326:            
   327:                k = kmax
   328: *V----->       xyra_TempMtx(:,:,k,-1) = &
   329: ||               & - CpDry * xyr_Exner(:,:,k-1) / xyz_Exner(:,:,k-1) * xyr_TempTransCoef(:,:,k-1)
   330: ||             xyra_TempMtx(:,:,k, 0) =                                                          &
   331: ||               & - CpDry * ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   332: ||               & + CpDry * xyr_Exner(:,:,k-1) / xyz_Exner(:,:,k  ) * xyr_TempTransCoef(:,:,k-1)
   333: *V-----        xyra_TempMtx(:,:,k, 1) = 0.0d0
   334:            
   335:            
   336:            
   337:                ! ľȻ͢鱢η׻ (漾)
   338:                ! Calculate implicit matrices from transfer coefficient of vertical diffusion scheme (specific humidity)
   339:                !
   340:            
   341:                k = 1
   342: *V----->       xyza_QMixMtx(:,:,k,-1) =                                                  &
   343: ||               & 0.0d0
   344: ||             xyza_QMixMtx(:,:,k, 0) =                                                  &
   345: ||               & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   346: ||               & + xyr_QMixTransCoef(:,:,k  )
   347: *V-----        xyza_QMixMtx(:,:,k, 1) =                                                  &
   348:                  & - xyr_QMixTransCoef(:,:,k  )
   349:            
   350: +------>       do k = 2, kmax-1
   351: |*V---->         xyza_QMixMtx(:,:,k,-1) =                                                  &
   352: |||                & - xyr_QMixTransCoef(:,:,k-1)
   353: |||              xyza_QMixMtx(:,:,k, 0) =                                                  &
   354: |||                & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   355: |||                & + xyr_QMixTransCoef(:,:,k-1)                                          &
   356: |||                & + xyr_QMixTransCoef(:,:,k  )
   357: |*V----          xyza_QMixMtx(:,:,k, 1) =                                                  &
   358: |                  & - xyr_QMixTransCoef(:,:,k  )
   359: +------        end do
   360:            
   361:                k = kmax
   362: *V----->       xyza_QMixMtx(:,:,k,-1) =                                                  &
   363: ||               & - xyr_QMixTransCoef(:,:,k-1)
   364: ||             xyza_QMixMtx(:,:,k, 0) =                                                  &
   365: ||               & - ( xyr_Press(:,:,k) - xyr_Press(:,:,k-1) ) / Grav / ( 2. * DelTime ) &
   366: ||               & + xyr_QMixTransCoef(:,:,k-1)
   367: *V-----        xyza_QMixMtx(:,:,k, 1) = 0.0d0
   368:            
   369:            
   370:            
   371:            
   372:                ! ®, ®η׻
   373:                ! Calculate eastward and northward wind
   374:                !
   375: +++V===        xyza_UVLUMtx = xyza_UVMtx
   376:            
   377:                call PhyImplLUDecomp3( &
   378:                  & xyza_UVLUMtx, &     ! (inout)
   379:                  & imax * jmax, kmax ) ! (in)
   380:            
   381: W------>       do k = 1, kmax
   382: |**---->         xyz_DUDt(:,:,k) = - ( xyr_MomFluxX(:,:,k) - xyr_MomFluxX(:,:,k-1) )
   383: |**----          xyz_DVDt(:,:,k) = - ( xyr_MomFluxY(:,:,k) - xyr_MomFluxY(:,:,k-1) )
   384: W------        end do
   385:            
   386:                call PhyImplLUSolve3( &
   387:                  & xyz_DUDt, &            ! (inout)
   388:                  & xyza_UVLUMtx, &        ! (in)
   389:                  & 1, imax * jmax, kmax ) ! (in)
   390:            
   391:                call PhyImplLUSolve3( &
   392:                  & xyz_DVDt, &            ! (inout)
   393:                  & xyza_UVLUMtx, &        ! (in)
   394:                  & 1, imax * jmax, kmax ) ! (in)
   395:            
   396: W------>       do k = 1, kmax
   397: |++---->         xyz_DUDt(:,:,k) = xyz_DUDt(:,:,k) / ( 2. * DelTime )
   398: |++----          xyz_DVDt(:,:,k) = xyz_DVDt(:,:,k) / ( 2. * DelTime )
   399: W------        end do
   400:            
   401:            
   402:                ! ٤η׻
   403:                ! Calculate temperature
   404:                !
   405: +++V===        xyaa_TempLUMtx = xyra_TempMtx
   406:            
   407:                call PhyImplLUDecomp3( &
   408:                  & xyaa_TempLUMtx,    & ! (inout)
   409:                  & imax * jmax, kmax  & ! (in)
   410:                  )
   411:            
   412: +------>       do k = 1, kmax
   413: |+V====          xya_DelTempLUVec(:,:,k) = &
   414: |                  - ( xyr_HeatFlux(:,:,k) - xyr_HeatFlux(:,:,k-1) )
   415: +------        end do
   416:            
   417:                call PhyImplLUSolve3(           &
   418:                  & xya_DelTempLUVec,           & ! (inout)
   419:                  & xyaa_TempLUMtx,             & ! (in)
   420:                  & 1, imax * jmax , kmax       & ! (in)
   421:                  & )
   422:            
   423: ++V====        xyz_DTempDt = xya_DelTempLUVec / ( 2.0_DP * DelTime )
   424:            
   425:            
   426:                ! 漾η׻
   427:                ! Calculate specific humidity
   428:                !
   429: +++V===        xyza_QMixLUMtx = xyza_QMixMtx
   430:            
   431:                call PhyImplLUDecomp3( &
   432:                  & xyza_QMixLUMtx,    &   ! (inout)
   433:                  & imax * jmax, kmax  &   ! (in)
   434:                  & )
   435:            
   436: +------>       do n = 1, ncmax
   437: |+----->         do k = 1, kmax
   438: ||+V===            xyz_DelQMixLUVec(:,:,k) = &
   439: ||                   & - ( xyrf_QMixFlux(:,:,k,n) - xyrf_QMixFlux(:,:,k-1,n) )
   440: |+-----          end do
   441: |          
   442: |                call PhyImplLUSolve3(      &
   443: |                  & xyz_DelQMixLUVec,      & ! (inout)
   444: |                  & xyza_QMixLUMtx,        & ! (in)
   445: |                  & 1, imax * jmax , kmax  & ! (in)
   446: |                  & )
   447: |          
   448: |++V===          xyzf_DQMixDt(:,:,:,n) = xyz_DelQMixLUVec(:,:,:) / ( 2. * DelTime )
   449: +------        end do
   450:            
   451:            
   452:                ! ׻ַ¬
   453:                ! Pause measurement of computation time
   454:                !
   455:                call TimesetClockStop( module_name )
   456:            
   457:              end subroutine PhyImplAtmOnlyTendency
   458:            
   459:              !-------------------------------------------------------------------
   460:            
   461:              subroutine PhyImplAtmOnlyInit
   462:                !
   463:                ! phy_implicit_atmonly ⥸塼νԤޤ. 
   464:                ! NAMELIST#phy_implicit_atmonly_nml ɤ߹ߤϤμ³ǹԤޤ. 
   465:                !
   466:                ! "phy_implicit_atmonly" module is initialized. 
   467:                ! "NAMELIST#phy_implicit_atmonly_nml" is loaded in this procedure. 
   468:                !
   469:            
   470:                ! ⥸塼 ; USE statements
   471:                !
   472:            
   473:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   474:                ! Utilities for NAMELIST file input
   475:                !
   476:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   477:            
   478:                ! ե
   479:                ! File I/O support
   480:                !
   481:                use dc_iounit, only: FileOpen
   482:            
   483:                ! ̷ѥ᥿
   484:                ! Kind type parameter
   485:                !
   486:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   487:            
   488:                ! ʸ
   489:                ! Character handling
   490:                !
   491:                use dc_string, only: StoA
   492:            
   493:                ! ʸ ; Declaration statements
   494:                !
   495:                implicit none
   496:            
   497:                ! ѿ
   498:                ! Work variables
   499:                !
   500:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   501:            !!$                              ! Unit number for NAMELIST file open
   502:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   503:            !!$                              ! IOSTAT of NAMELIST read
   504:            
   505:                ! NAMELIST ѿ
   506:                ! NAMELIST group name
   507:                !
   508:            !!$    namelist /phy_implicit_atmonly_nml/ &
   509:            !!$      SOHeatCapacity          ! Slab ocean heat capacity (J m-2 K-1)
   510:                      !
   511:                      ! ǥեͤˤĤƤϽ³ "phy_implicit_atmonly#PhyImplInit" 
   512:                      ! Υɤ򻲾ȤΤ. 
   513:                      !
   514:                      ! Refer to source codes in the initialization procedure
   515:                      ! "phy_implicit_atmonly#PhyImplInit" for the default values. 
   516:                      !
   517:            
   518:                ! ¹ʸ ; Executable statement
   519:                !
   520:            
   521:                if ( phy_implicit_atmonly_inited ) return
   522:            
   523:                ! ǥեͤ
   524:                ! Default values settings
   525:                !
   526:            
   527:            !!$    SOHeatCapacity = 4.187d3 * 1.0d3 * 60.0d0
   528:            !!$                         ! 4.187d3 (J (kg K)-1) * 1.0d3 (kg m-3) * 60.0d0 (m)
   529:            
   530:            
   531:            !!$    ! NAMELIST ɤ߹
   532:            !!$    ! NAMELIST is input
   533:            !!$    !
   534:            !!$    if ( trim(namelist_filename) /= '' ) then
   535:            !!$      call FileOpen( unit_nml, &          ! (out)
   536:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   537:            !!$
   538:            !!$      rewind( unit_nml )
   539:            !!$      read( unit_nml,                     &  ! (in)
   540:            !!$        & nml = phy_implicit_atmonly_nml, &  ! (out)
   541:            !!$        & iostat = iostat_nml )              ! (out)
   542:            !!$      close( unit_nml )
   543:            !!$
   544:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   545:            !!$    end if
   546:            
   547:            
   548:            
   549:                !  ; Print
   550:                !
   551:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   552:            !!$    call MessageNotify( 'M', module_name, '  SOHeatCapacity = %f', d = (/ SOHeatCapacity /) )
   553:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   554:            
   555:            
   556:                phy_implicit_atmonly_inited = .true.
   557:            
   558:              end subroutine PhyImplAtmOnlyInit
   559:            
   560:              !-------------------------------------------------------------------
   561:            
   562:            end module phy_implicit_atmonly
