Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:36 2012
FILE NAME: surface_data.f90
PROGRAM NAME: surface_data
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   244  opt  (1592): Outer loop unrolled inside inner loop.
   244  vec  (   4): Vectorized array expression.
   244  vec  (   4): Vectorized array expression.
   280  opt  (1593): Loop nest collapsed into one loop.
   280  vec  (   4): Vectorized array expression.
   281  opt  (1593): Loop nest collapsed into one loop.
   281  vec  (   4): Vectorized array expression.
   282  opt  (1593): Loop nest collapsed into one loop.
   282  vec  (   4): Vectorized array expression.
   283  opt  (1593): Loop nest collapsed into one loop.
   283  vec  (   4): Vectorized array expression.
   284  opt  (1593): Loop nest collapsed into one loop.
   284  vec  (   4): Vectorized array expression.
   285  opt  (1593): Loop nest collapsed into one loop.
   285  vec  (   4): Vectorized array expression.
   286  opt  (1593): Loop nest collapsed into one loop.
   286  vec  (   4): Vectorized array expression.
   287  opt  (1593): Loop nest collapsed into one loop.
   287  vec  (   4): Vectorized array expression.
   288  opt  (1593): Loop nest collapsed into one loop.
   288  vec  (   4): Vectorized array expression.
   291  warn (  82): Name "j" is not used.
   387  vec  (   3): Unvectorized loop.
   387  vec  (  13): Overhead of loop division is too large.
   387  vec  (   3): Unvectorized loop.
   387  vec  (  13): Overhead of loop division is too large.
   389  opt  (1592): Outer loop unrolled inside inner loop.
   389  vec  (   4): Vectorized array expression.
   389  vec  (   4): Vectorized array expression.
   407  vec  (   1): Vectorized loop.
   425  opt  (1593): Loop nest collapsed into one loop.
   425  vec  (   4): Vectorized array expression.
   498  vec  (   3): Unvectorized loop.
   498  vec  (  13): Overhead of loop division is too large.
   500  vec  (   4): Vectorized array expression.
   502  vec  (   4): Vectorized array expression.
   505  opt  (1592): Outer loop unrolled inside inner loop.
   505  vec  (   4): Vectorized array expression.
   505  vec  (   4): Vectorized array expression.
   513  vec  (   3): Unvectorized loop.
   513  vec  (  13): Overhead of loop division is too large.
   515  vec  (   4): Vectorized array expression.
   517  vec  (   4): Vectorized array expression.
   520  opt  (1592): Outer loop unrolled inside inner loop.
   520  vec  (   4): Vectorized array expression.
   520  vec  (   4): Vectorized array expression.
   527  vec  (   3): Unvectorized loop.
   527  vec  (  13): Overhead of loop division is too large.
   529  vec  (   4): Vectorized array expression.
   531  vec  (   4): Vectorized array expression.
   534  opt  (1592): Outer loop unrolled inside inner loop.
   534  vec  (   4): Vectorized array expression.
   534  vec  (   4): Vectorized array expression.
   541  vec  (   3): Unvectorized loop.
   541  vec  (  13): Overhead of loop division is too large.
   543  vec  (   4): Vectorized array expression.
   545  vec  (   4): Vectorized array expression.
   548  vec  (   4): Vectorized array expression.
   551  vec  (   4): Vectorized array expression.
   554  opt  (1592): Outer loop unrolled inside inner loop.
   554  vec  (   4): Vectorized array expression.
   554  vec  (   4): Vectorized array expression.
   569  opt  (1592): Outer loop unrolled inside inner loop.
   569  vec  (   4): Vectorized array expression.
   569  vec  (   4): Vectorized array expression.
   598  warn (  82): Name "i" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:36 2012
FILE NAME: surface_data.f90
PROGRAM NAME: surface_data
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ɽ̥ǡ
     2  !
     3  != Prepare surface data
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
     6  ! Version::   $Id: surface_data.f90,v 1.10 2011-06-19 11:12:41 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module surface_data
    13    !
    14    != ɽ̥ǡ
    15    !
    16    != Prepare surface data
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! GCM Ѥɽ̥ǡޤ.
    21    ! ߤϻŪ Hosaka et al. (1998)  SST ʬۤͿޤ.
    22    !
    23    ! Surface data for GCM is generated.
    24    ! Now, SST profile in Hosaka et al. (1998) is provided tentatively.
    25    !
    26    !== Procedures List
    27    !
    28    ! SetSurfData   :: ɽ̥ǡμ
    29    ! ------------  :: ------------
    30    ! SetSurfData   :: Set surface data
    31    !
    32    !== NAMELIST
    33    !
    34    ! NAMELIST#surface_data_nml
    35    !
    36  
    37    ! ⥸塼 ; USE statements
    38    !
    39  
    40    ! ʻ
    41    ! Grid points settings
    42    !
    43    use gridset, only: imax, & ! ٳʻ.
    44                               ! Number of grid points in longitude
    45      &                jmax, & ! ٳʻ.
    46                               ! Number of grid points in latitude
    47      &                kmax    ! ľؿ.
    48                               ! Number of vertical level
    49  
    50    ! ̷ѥ᥿
    51    ! Kind type parameter
    52    !
    53    use dc_types, only: DP, &      ! ټ¿. Double precision.
    54      &                 STRING     ! ʸ.       Strings.
    55  
    56    ! ̷ѥ᥿
    57    ! Kind type parameter
    58    !
    59    use dc_types, only: DP     ! ټ¿. Double precision.
    60  
    61    ! å
    62    ! Message output
    63    !
    64    use dc_message, only: MessageNotify
    65  
    66    ! ʸ ; Declaration statements
    67    !
    68    implicit none
    69    private
    70  
    71    ! ³
    72    ! Public procedure
    73    !
    74    public:: SetSurfData
    75    public:: SurfDataInit
    76  
    77    ! ѿ
    78    ! Public variables
    79    !
    80    logical, save :: surface_data_inited = .false.
    81                                ! ե饰.
    82                                ! Initialization flag
    83  
    84    ! ѿ
    85    ! Private variables
    86    !
    87    character(STRING), save:: Pattern
    88                                ! ɽ̥ǡΥѥ.
    89                                ! ʲΥѥǽ.
    90                                !
    91                                ! Surface data pattern.
    92                                ! Available patterns are as follows.
    93                                !
    94                                ! * "Hosaka et al. (1998)"
    95                                ! * "Homogeneous"
    96                                !
    97    real(DP), save:: SurfTemp
    98                                ! ɽ̲٤δ.
    99                                ! Standard value of surface temperature
   100    real(DP), save:: Albedo
   101                                ! ɽ٥.
   102                                ! Surface albedo
   103    real(DP), save:: HumidCoef
   104                                ! ɽ.
   105                                ! Surface humidity coefficient
   106    real(DP), save:: RoughLength
   107                                ! ɽĹ.
   108                                ! Surface rough length
   109    real(DP), save:: HeatCapacity
   110                                ! ɽǮ.
   111                                ! Surface heat capacity
   112    real(DP), save:: TempFlux
   113                                ! Ǯեå.
   114                                ! Ground temperature flux
   115    integer, save:: SurfCond
   116                                ! ɽ (0: , 1: ).
   117                                ! Surface condition (0: fixed, 1: variable)
   118    real(DP), save:: SeaIceConc
   119                                ! ɹ̩
   120                                ! Sea ice concentration
   121    real(DP), save:: SoilHeatCap
   122                                ! ھǮ (J K-1 kg-1)
   123                                ! Specific heat of soil (J K-1 kg-1)
   124    real(DP), save:: SoilHeatDiffCoef
   125                                ! ھǮƳ (J m-3 K-1)
   126                                ! Heat conduction coefficient of soil (J m-3 K-1)
   127  
   128    character(*), parameter:: module_name = 'surface_data'
   129                                ! ⥸塼̾.
   130                                ! Module name
   131    character(*), parameter:: version = &
   132      & '$Name: dcpam5-20120921 $' // &
   133      & '$Id: surface_data.f90,v 1.10 2011-06-19 11:12:41 yot Exp $'
   134                                ! ⥸塼ΥС
   135                                ! Module version
   136  
   137  
   138  contains
   139  
   140    !--------------------------------------------------------------------------------------
   141  
   142    subroutine SetSurfData( &
   143      & xy_SurfTemp, xy_SurfAlbedo, xy_SurfHumidCoef, & ! (out)
   144      & xy_SurfRoughLength, xy_SurfHeatCapacity,      & ! (out)
   145      & xy_DeepSubSurfHeatFlux, xy_SurfCond,          & ! (out)
   146      & xy_SeaIceConc,                                & ! (out)
   147      & xy_SoilHeatCap, xy_SoilHeatDiffCoef           & ! (out)
   148      & )
   149      !
   150      ! GCM Ѥɽ̥ǡ֤ޤ.
   151      !
   152      ! Return surface data for GCM.
   153      !
   154  
   155      ! ⥸塼 ; USE statements
   156      !
   157  
   158      ! ʸ
   159      ! Character handling
   160      !
   161      use dc_string, only: LChar
   162  
   163      ! ʪ
   164      ! Physical and mathematical constants settings
   165      !
   166      use constants0, only: &
   167        & PI                    ! $ \pi $.
   168                                ! ߼Ψ. Circular constant
   169  
   170      ! ɸǡ
   171      ! Axes data settings
   172      !
   173      use axesset, only: &
   174        & y_Lat                 ! $ \varphi $ [rad.] . . Latitude
   175  
   176      ! ե뤫 1 ץեɤꤹ.
   177      ! read 1-D profile from a file and set it
   178      !
   179      use set_1d_profile, only : Set1DProfileSurfTemp
   180  
   181  
   182      ! ʸ ; Declaration statements
   183      !
   184      implicit none
   185      real(DP), intent(out), optional:: xy_SurfTemp (0:imax-1, 1:jmax)
   186                                ! ɽ̲.
   187                                ! Surface temperature
   188      real(DP), intent(out), optional:: xy_SurfAlbedo (0:imax-1, 1:jmax)
   189                                ! ɽ٥.
   190                                ! Surface albedo
   191      real(DP), intent(out), optional:: xy_SurfHumidCoef (0:imax-1, 1:jmax)
   192                                ! ɽ.
   193                                ! Surface humidity coefficient
   194      real(DP), intent(out), optional:: xy_SurfRoughLength (0:imax-1, 1:jmax)
   195                                ! ɽĹ.
   196                                ! Surface rough length
   197      real(DP), intent(out), optional:: xy_SurfHeatCapacity (0:imax-1, 1:jmax)
   198                                ! ɽǮ.
   199                                ! Surface heat capacity
   200      real(DP), intent(out), optional:: xy_DeepSubSurfHeatFlux (0:imax-1, 1:jmax)
   201                                ! Ǯեå.
   202                                ! "Deep subsurface heat flux"
   203                                ! Heat flux at the bottom of surface/soil layer.
   204      integer , intent(out), optional:: xy_SurfCond (0:imax-1, 1:jmax)
   205                                ! ɽ (0: , 1: ) .
   206                                ! Surface condition (0: fixed, 1: variable)
   207      real(DP), intent(out), optional:: xy_SeaIceConc(0:imax-1, 1:jmax)
   208                                ! ɹ̩
   209                                ! Sea ice concentration
   210      real(DP), intent(out), optional:: xy_SoilHeatCap(0:imax-1,1:jmax)
   211                                ! ھǮ (J K-1 kg-1)
   212                                ! Specific heat of soil (J K-1 kg-1)
   213      real(DP), intent(out), optional:: xy_SoilHeatDiffCoef(0:imax-1,1:jmax)
   214                                ! ھǮƳ (J m-3 K-1)
   215                                ! Heat conduction coefficient of soil (J m-3 K-1)
   216  
   217      ! ѿ
   218      ! Work variables
   219      !
   220  !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   221  !!$                              ! Work variables for DO loop in longitude
   222      integer:: j               ! ˲ DO 롼Ѻѿ
   223                                ! Work variables for DO loop in latitude
   224  !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   225  !!$                              ! Work variables for DO loop in vertical direction
   226  
   227      ! ¹ʸ ; Executable statement
   228  
   229  
   230      ! ǧ
   231      ! Initialization check
   232      !
   233      if ( .not. surface_data_inited ) then
   234        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   235      end if
   236  
   237  
   238      select case ( LChar( trim(Pattern) ) )
   239  
   240      case ( 'homogeneous' )
   241        ! SST 
   242        ! SST is homogeneous
   243        !
   244        if ( present(xy_SurfTemp) ) xy_SurfTemp = SurfTemp
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t245 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t247 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surftemp(t247-1,t245) = surftemp                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t245 = J1 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t247 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surftemp(t247-1,t245) = surftemp                      
     .                 xy_surftemp(t247-1,t245+1) = surftemp                    
     .                 xy_surftemp(t247-1,t245+2) = surftemp                    
     .                 xy_surftemp(t247-1,t245+3) = surftemp                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10008                                                       
   245  
   246      case ( 'hosaka et al. (1998)' )
   247        ! Hosaka et al. (1998) ˤѤ줿 SST
   248        ! SST used in Hosaka et al. (1998)
   249        !
   250        if ( present( xy_SurfTemp ) ) then
   251          call Hosakaetal98SST( &
   252            & xy_SurfTemp  & ! (out)
   253            & )
   254        end if
   255  
   256      case ( 'nh01_control' )
   257        ! Neale and Hoskins (2001)  Control experiment ˤѤ줿 SST
   258        ! SST used for Control experiment by Neale and Hoskins (2001)
   259        !
   260        if ( present( xy_SurfTemp ) ) then
   261          call NH01SST( &
   262            & 'control',     & ! (in   )
   263            & xy_SurfTemp  & ! (inout)
   264            & )
   265        end if
   266  
   267      case ( '1-d profile' )
   268  
   269        if ( present( xy_SurfTemp ) ) then
   270          call Set1DProfileSurfTemp( &
   271            & xy_SurfTemp &
   272            & )
   273        end if
   274  
   275      case default
   276        call MessageNotify( 'E', module_name, 'Pattern=<%c> is invalid.', &
   277          & c1 = trim(Pattern) )
   278      end select
   279  
   280      if ( present(xy_SurfAlbedo          ) ) xy_SurfAlbedo          = Albedo
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t239 = 1, jmax*imax                                            
     .           xy_surfalbedo(t239-1,1) = albedo                               
     .        end do                                                            
   281      if ( present(xy_SurfHumidCoef       ) ) xy_SurfHumidCoef       = HumidCoef
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t233 = 1, jmax*imax                                            
     .           xy_surfhumidcoef(t233-1,1) = humidcoef                         
     .        end do                                                            
   282      if ( present(xy_SurfRoughLength     ) ) xy_SurfRoughLength     = RoughLength
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t227 = 1, jmax*imax                                            
     .           xy_surfroughlength(t227-1,1) = roughlength                     
     .        end do                                                            
   283      if ( present(xy_SurfHeatCapacity    ) ) xy_SurfHeatCapacity    = HeatCapacity
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t221 = 1, jmax*imax                                            
     .           xy_surfheatcapacity(t221-1,1) = heatcapacity                   
     .        end do                                                            
   284      if ( present(xy_DeepSubSurfHeatFlux ) ) xy_DeepSubSurfHeatFlux = TempFlux
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t215 = 1, jmax*imax                                            
     .           xy_deepsubsurfheatflux(t215-1,1) = tempflux                    
     .        end do                                                            
   285      if ( present(xy_SurfCond            ) ) xy_SurfCond            = SurfCond
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t209 = 1, jmax*imax                                            
     .           xy_surfcond(t209-1,1) = surfcond                               
     .        end do                                                            
   286      if ( present(xy_SeaIceConc          ) ) xy_SeaIceConc          = SeaIceConc
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t203 = 1, jmax*imax                                            
     .           xy_seaiceconc(t203-1,1) = seaiceconc                           
     .        end do                                                            
   287      if ( present(xy_SoilHeatCap         ) ) xy_SoilHeatCap         = SoilHeatCap
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t197 = 1, jmax*imax                                            
     .           xy_soilheatcap(t197-1,1) = soilheatcap                         
     .        end do                                                            
   288      if ( present(xy_SoilHeatDiffCoef    ) ) xy_SoilHeatDiffCoef    = SoilHeatDiffCoef
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t191 = 1, jmax*imax                                            
     .           xy_soilheatdiffcoef(t191-1,1) = soilheatdiffcoef               
     .        end do                                                            
   289  
   290  
   291    end subroutine SetSurfData
   292  
   293    !--------------------------------------------------------------------------------------
   294  
   295    subroutine Hosakaetal98SST( &
   296      & xy_SurfTemp  & ! (out)
   297      & )
   298      !
   299      ! GCM Ѥɽ̥ǡ֤ޤ.
   300      !
   301      ! Return surface data for GCM.
   302      !
   303  
   304      ! ⥸塼 ; USE statements
   305      !
   306  
   307      ! ɸǡ
   308      ! Axes data settings
   309      !
   310      use axesset, only: &
   311        & y_Lat                 ! $ \varphi $ [rad.] . . Latitude
   312  
   313      ! ʪ
   314      ! Physical and mathematical constants settings
   315      !
   316      use constants0, only: &
   317        & PI                    ! $ \pi $.
   318                                ! ߼Ψ. Circular constant
   319  
   320      ! ʸ
   321      ! Character handling
   322      !
   323      use dc_string, only: LChar
   324  
   325      ! ʸ ; Declaration statements
   326      !
   327      implicit none
   328      real(DP), intent(out) :: xy_SurfTemp (0:imax-1, 1:jmax)
   329                                ! ɽ̲.
   330                                ! Surface temperature
   331  
   332      ! ѿ (Hosaka et al. (1998))
   333      ! Work variables (Hosaka et al. (1998))
   334      !
   335      real(DP):: TempEq         ! ƻ (Τˤ LatCenter ) Ǥβ.
   336                                ! Temperature on the equator
   337                                ! (on LatCenter, to be exact)
   338      real(DP):: LatCenter      ! ٺǹΰ.
   339                                ! Latitude on which temperature is maximum.
   340      real(DP):: LatFlatWidth   ! ٤ʿó.
   341                                ! Latitude width in which temperature is flattened
   342      integer:: jp
   343      integer:: jm
   344  
   345      real(DP):: LatA, Alpha, Beta, Gamma
   346  
   347      real(DP):: Phi1, AlphaBeta4, Phi, LatAPlus, LatAMinus
   348      real(DP):: SurfTempMx
   349  
   350      ! ѿ
   351      ! Work variables
   352      !
   353  !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   354  !!$                              ! Work variables for DO loop in longitude
   355      integer:: j               ! ˲ DO 롼Ѻѿ
   356                                ! Work variables for DO loop in latitude
   357  !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   358  !!$                              ! Work variables for DO loop in vertical direction
   359  
   360      ! ¹ʸ ; Executable statement
   361  
   362      ! ǧ
   363      ! Initialization check
   364      !
   365      if ( .not. surface_data_inited ) then
   366        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   367      end if
   368  
   369  
   370      ! Hosaka et al. (1998) ˤѤ줿 SST
   371      ! SST used in Hosaka et al. (1998)
   372      !
   373  
   374  !!$    TempEq       = SurfTemp
   375      TempEq       = 302.0_DP
   376      LatCenter    =   0.0_DP
   377      LatFlatWidth =   7.0_DP
   378  
   379      LatA         =  30.0_DP
   380      Alpha        =  60.0_DP
   381      Beta         =  32.0_DP
   382      Gamma        =   0.0_DP
   383  
   384      Phi1 = abs( LatA * PI / 180.0_DP )
   385      AlphaBeta4  = 2.0_DP *( Phi1**3 ) * ( Beta / Alpha )
   386  
   387      do j = 1, jmax
   388        Phi = abs( y_Lat(j) - LatCenter * PI / 180.0_DP )
   389        xy_SurfTemp (:,j) = &
   390          & TempEq &
   391          & - Alpha / 2.0_DP &
   392          &   * ( Phi - max( sqrt( Phi1**2 + AlphaBeta4 ) - sqrt( ( Phi - Phi1 )**2 + AlphaBeta4 ), 0.0_DP ) ) &
   393          & + Gamma * ( Phi**3 )
   394      end do
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .           do j = 1, J1                                                   
     .              phi = abs(y_lat(j)-latcenter*3.14159265358979e+000/         
     .       1         1.80000000000000e+002)                                   
     .              D5 = 1.D0/2.00000000000000e+000                             
     .  !CDIR       NODEP                                                       
     .              do t160 = 1, imax                                           
     .                 xy_surftemp(t160-1,j) = tempeq - alpha*D5*(phi - max(    
     .       1            dsqrt(phi1**2 + alphabeta4) - dsqrt((phi - phi1)**2 + 
     .       2            alphabeta4),0.0000000000000000e+000)) + gamma*phi**3  
     .              end do                                                      
     .           end do                                                         
     .           do j = J1 + 1, jmax, 4                                         
     .              phi2 = abs(y_lat(j)-latcenter*3.14159265358979e+000/        
     .       1         1.80000000000000e+002)                                   
     .              phi3 = abs(y_lat(j+1)-latcenter*3.14159265358979e+000/      
     .       1         1.80000000000000e+002)                                   
     .              phi4 = abs(y_lat(j+2)-latcenter*3.14159265358979e+000/      
     .       1         1.80000000000000e+002)                                   
     .              phi5 = abs(y_lat(j+3)-latcenter*3.14159265358979e+000/      
     .       1         1.80000000000000e+002)                                   
     .              D6 = 1.D0/2.00000000000000e+000                             
     .              D7 = 1.D0/2.00000000000000e+000                             
     .              D8 = 1.D0/2.00000000000000e+000                             
     .              D9 = 1.D0/2.00000000000000e+000                             
     .  !CDIR       NODEP                                                       
     .              do t160 = 1, imax                                           
     .                 xy_surftemp(t160-1,j) = tempeq - (alpha*D6)*(phi2 - max((
     .       1            dsqrt(((phi1**2) + alphabeta4))) - dsqrt((phi2 - phi1)
     .       2            **2 + alphabeta4),0.0000000000000000e+000)) + gamma*  
     .       3            phi2**3                                               
     .                 xy_surftemp(t160-1,j+1) = tempeq - (alpha*D7)*(phi3 -    
     .       1            max((dsqrt(((phi1**2) + alphabeta4))) - dsqrt((phi3 - 
     .       2            phi1)**2 + alphabeta4),0.0000000000000000e+000)) +    
     .       3            gamma*phi3**3                                         
     .                 xy_surftemp(t160-1,j+2) = tempeq - (alpha*D8)*(phi4 -    
     .       1            max((dsqrt(((phi1**2) + alphabeta4))) - dsqrt((phi4 - 
     .       2            phi1)**2 + alphabeta4),0.0000000000000000e+000)) +    
     .       3            gamma*phi4**3                                         
     .                 xy_surftemp(t160-1,j+3) = tempeq - (alpha*D9)*(phi5 -    
     .       1            max((dsqrt(((phi1**2) + alphabeta4))) - dsqrt((phi5 - 
     .       2            phi1)**2 + alphabeta4),0.0000000000000000e+000)) +    
     .       3            gamma*phi5**3                                         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   395  
   396      ! 濴 LatCenter +/- LatFlatWidth δ֤ʿó
   397      ! Flatten between LatCenter +/- LatFlatWidth
   398      !
   399      if ( LatFlatWidth < 0.0_DP ) then
   400        LatFlatWidth = - LatFlatWidth
   401      end if
   402      LatAPlus = ( LatCenter + LatFlatWidth ) * PI / 180.0_DP
   403      LatAMinus = ( LatCenter - LatFlatWidth ) * PI / 180.0_DP
   404  
   405      jp = 1
   406      jm = jmax
   407      do j = 1, jmax
   408        if ( y_Lat(j) <= LatAPlus ) then
   409          jp = j
   410          if ( j == jmax ) jp = jp - 1
   411        end if
   412        if ( y_Lat(j) < LatAMinus ) then
   413          jm = j
   414          if ( j == jmax ) jm = jm - 1
   415        end if
   416      end do
     .  !CDIR NODEP                                                             
     .        do j = 1, jmax                                                    
     .           if (y_lat(j) .le. lataplus) then                               
     .              jp = (j)                                                    
     .              if ((j) .eq. jmax) then                                     
     .                 jp = jp - 1                                              
     .              endif                                                       
     .           endif                                                          
     .           if (y_lat(j) .lt. lataminus) then                              
     .              jm = (j)                                                    
     .              if ((j) .eq. jmax) then                                     
     .                 jm = jm - 1                                              
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
   417  
   418      if ( jmax /= 1 ) then
   419        SurfTempMx = &
   420          & (   xy_SurfTemp(0,jm) * ( y_Lat(jm+1) - LatAMinus ) &
   421          &   + xy_SurfTemp(0,jm+1) * ( LatAMinus - y_Lat(jm) ) &
   422          & ) &
   423          & / ( y_Lat(jm+1) - y_Lat(jm) )
   424  
   425        xy_SurfTemp(:,jm+1:jp) = SurfTempMx
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t163 = 1, (jp - jm)*imax                                       
     .           xy_surftemp(t163-1,1+jm) = surftempmx                          
     .        end do                                                            
   426      end if
   427  
   428  
   429    end subroutine Hosakaetal98SST
   430  
   431    !--------------------------------------------------------------------------------------
   432  
   433    recursive subroutine NH01SST( &
   434      & SSTType,     & ! (in   )
   435      & xy_SurfTemp  & ! (inout)
   436      & )
   437      !
   438      ! Set SST described by Neale and Hoskins (2001)
   439      !
   440  
   441      ! ⥸塼 ; USE statements
   442      !
   443  
   444      ! ɸǡ
   445      ! Axes data settings
   446      !
   447      use axesset, only: &
   448        & x_Lon,         &      ! $ \lambda $ [rad.] . . Longitude
   449        & y_Lat                 ! $ \varphi $ [rad.] . . Latitude
   450  
   451      ! ʪ
   452      ! Physical and mathematical constants settings
   453      !
   454      use constants0, only: &
   455        & PI                    ! $ \pi $.
   456                                ! ߼Ψ. Circular constant
   457  
   458      ! ʸ
   459      ! Character handling
   460      !
   461      use dc_string, only: LChar
   462  
   463      ! ʸ ; Declaration statements
   464      !
   465      implicit none
   466      character(len=*), intent(in   ) :: SSTType
   467      real(DP)        , intent(inout) :: xy_SurfTemp (0:imax-1, 1:jmax)
   468                                ! ɽ̲.
   469                                ! Surface temperature
   470  
   471      ! ѿ
   472      ! Work variables
   473      !
   474      real(DP) :: Temp0         ! Zero degree Celsius
   475                                ! Latitude width in which temperature is flattened
   476      real(DP) :: xy_SurfTempTmp1 (0:imax-1, 1:jmax)
   477      real(DP) :: xy_SurfTempTmp2 (0:imax-1, 1:jmax)
   478  
   479      ! ѿ
   480      ! Work variables
   481      !
   482      integer:: i               ! ˲ DO 롼Ѻѿ
   483                                ! Work variables for DO loop in longitude
   484      integer:: j               ! ˲ DO 롼Ѻѿ
   485                                ! Work variables for DO loop in latitude
   486  !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   487  !!$                              ! Work variables for DO loop in vertical direction
   488  
   489      ! ¹ʸ ; Executable statement
   490  
   491      Temp0 = 273.15d0
   492  
   493      if ( SSTType == 'control' ) then
   494        ! Neale and Hoskins (2001)  control experiment ˤѤ줿 SST
   495        ! SST used for control experiment by Neale and Hoskins (2001)
   496        !
   497  
   498        do j = 1, jmax
   499          if ( abs( y_Lat(j) ) < PI / 3.0d0 ) then
   500            xy_SurfTemp(:,j) = 27.0d0 * ( 1.0d0 - sin( 3.0d0 * y_Lat(j) / 2.0d0 )**2 )
     .        D1 = 3.00000000000000e+000/2.00000000000000e+000                  
     .  !CDIR NODEP                                                             
     .        do t294 = 1, imax                                                 
     .           xy_surftemp(t294-1,j) = 2.70000000000000e+001*(                
     .       1      1.00000000000000e+000 - dsin(y_lat(j)*D1)**2)               
     .        end do                                                            
     .        go to 10074                                                       
   501          else
   502            xy_SurfTemp(:,j) = 0.0d0
     .  !CDIR NODEP                                                             
     .        do t283 = 1, imax                                                 
     .           xy_surftemp(t283-1,j) = 0.0000000000000000e+000                
     .        end do                                                            
   503          end if
   504        end do
   505        xy_SurfTemp = xy_SurfTemp + Temp0
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t286 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t288 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surftemp(t288-1,t286) = xy_surftemp(t288-1,t286) +    
     .       1            temp0                                                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t286 = J1 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t288 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surftemp(t288-1,t286) = xy_surftemp(t288-1,t286) +    
     .       1            temp0                                                 
     .                 xy_surftemp(t288-1,t286+1) = xy_surftemp(t288-1,t286+1)  
     .       1             + temp0                                              
     .                 xy_surftemp(t288-1,t286+2) = xy_surftemp(t288-1,t286+2)  
     .       1             + temp0                                              
     .                 xy_surftemp(t288-1,t286+3) = xy_surftemp(t288-1,t286+3)  
     .       1             + temp0                                              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10007                                                       
   506  
   507  
   508      else if ( SSTType == 'peaked' ) then
   509        ! Neale and Hoskins (2001)  Peaked experiment ˤѤ줿 SST
   510        ! SST used for Peaked experiment by Neale and Hoskins (2001)
   511        !
   512  
   513        do j = 1, jmax
   514          if ( abs( y_Lat(j) ) < PI / 3.0d0 ) then
   515            xy_SurfTemp(:,j) = 27.0d0 * ( 1.0d0 - 3.0d0 * abs( y_Lat(j) ) / PI )
     .        D2 = 3.00000000000000e+000/3.14159265358979e+000                  
     .  !CDIR NODEP                                                             
     .        do t280 = 1, imax                                                 
     .           xy_surftemp(t280-1,j) = 2.70000000000000e+001*(                
     .       1      1.00000000000000e+000 - abs(y_lat(j))*D2)                   
     .        end do                                                            
     .        go to 10059                                                       
   516          else
   517            xy_SurfTemp(:,j) = 0.0d0
     .  !CDIR NODEP                                                             
     .        do t269 = 1, imax                                                 
     .           xy_surftemp(t269-1,j) = 0.0000000000000000e+000                
     .        end do                                                            
   518          end if
   519        end do
   520        xy_SurfTemp = xy_SurfTemp + Temp0
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t272 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t274 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surftemp(t274-1,t272) = xy_surftemp(t274-1,t272) +    
     .       1            temp0                                                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t272 = J2 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t274 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surftemp(t274-1,t272) = xy_surftemp(t274-1,t272) +    
     .       1            temp0                                                 
     .                 xy_surftemp(t274-1,t272+1) = xy_surftemp(t274-1,t272+1)  
     .       1             + temp0                                              
     .                 xy_surftemp(t274-1,t272+2) = xy_surftemp(t274-1,t272+2)  
     .       1             + temp0                                              
     .                 xy_surftemp(t274-1,t272+3) = xy_surftemp(t274-1,t272+3)  
     .       1             + temp0                                              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10007                                                       
   521  
   522      else if ( SSTType == 'flat' ) then
   523        ! Neale and Hoskins (2001)  Flat experiment ˤѤ줿 SST
   524        ! SST used for Flat experiment by Neale and Hoskins (2001)
   525        !
   526  
   527        do j = 1, jmax
   528          if ( abs( y_Lat(j) ) < PI / 3.0d0 ) then
   529            xy_SurfTemp(:,j) = 27.0d0 * ( 1.0d0 - sin( 3.0d0 * y_Lat(j) / 2.0d0 )**4 )
     .        D3 = 3.00000000000000e+000/2.00000000000000e+000                  
     .  !CDIR NODEP                                                             
     .        do t266 = 1, imax                                                 
     .           xy_surftemp(t266-1,j) = 2.70000000000000e+001*(                
     .       1      1.00000000000000e+000 - dsin(y_lat(j)*D3)**4)               
     .        end do                                                            
     .        go to 10044                                                       
   530          else
   531            xy_SurfTemp(:,j) = 0.0d0
     .  !CDIR NODEP                                                             
     .        do t255 = 1, imax                                                 
     .           xy_surftemp(t255-1,j) = 0.0000000000000000e+000                
     .        end do                                                            
   532          end if
   533        end do
   534        xy_SurfTemp = xy_SurfTemp + Temp0
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t258 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t260 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surftemp(t260-1,t258) = xy_surftemp(t260-1,t258) +    
     .       1            temp0                                                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t258 = J3 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t260 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surftemp(t260-1,t258) = xy_surftemp(t260-1,t258) +    
     .       1            temp0                                                 
     .                 xy_surftemp(t260-1,t258+1) = xy_surftemp(t260-1,t258+1)  
     .       1             + temp0                                              
     .                 xy_surftemp(t260-1,t258+2) = xy_surftemp(t260-1,t258+2)  
     .       1             + temp0                                              
     .                 xy_surftemp(t260-1,t258+3) = xy_surftemp(t260-1,t258+3)  
     .       1             + temp0                                              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10007                                                       
   535  
   536      else if ( SSTType == 'control-5n' ) then
   537        ! Neale and Hoskins (2001)  Control-5N experiment ˤѤ줿 SST
   538        ! SST used for Control-5N experiment by Neale and Hoskins (2001)
   539        !
   540  
   541        do j = 1, jmax
   542          if ( y_Lat(j) < - PI / 3.0d0 ) then
   543            xy_SurfTemp(:,j) = 0.0d0
     .  !CDIR NODEP                                                             
     .        do t252 = 1, imax                                                 
     .           xy_surftemp(t252-1,j) = 0.0000000000000000e+000                
     .        end do                                                            
     .        go to 10023                                                       
   544          else if ( y_Lat(j) < PI / 36.0d0 ) then
   545            xy_SurfTemp(:,j) = 27.0d0                                             &
     .  !CDIR NODEP                                                             
     .        do t249 = 1, imax                                                 
     .           xy_surftemp(t249-1,j) = 2.70000000000000e+001*(                
     .       1      1.00000000000000e+000 - dsin(1.38461538461538e+000*(y_lat(j)
     .       2      -8.72664625997164e-002))**2)                                
     .        end do                                                            
     .        go to 10023                                                       
   546              & * ( 1.0d0 - sin( 90.0d0/65.0d0 * ( y_Lat(j) - PI/36.0d0 ) )**2 )
   547          else if ( y_Lat(j) < PI / 3.0d0 ) then
   548            xy_SurfTemp(:,j) = 27.0d0                                             &
     .  !CDIR NODEP                                                             
     .        do t246 = 1, imax                                                 
     .           xy_surftemp(t246-1,j) = 2.70000000000000e+001*(                
     .       1      1.00000000000000e+000 - dsin(1.63636363636363e+000*(y_lat(j)
     .       2      -8.72664625997164e-002))**2)                                
     .        end do                                                            
     .        go to 10023                                                       
   549              & * ( 1.0d0 - sin( 90.0d0/55.0d0 * ( y_Lat(j) - PI/36.0d0 ) )**2 )
   550          else
   551            xy_SurfTemp(:,j) = 0.0d0
     .  !CDIR NODEP                                                             
     .        do t235 = 1, imax                                                 
     .           xy_surftemp(t235-1,j) = 0.0000000000000000e+000                
     .        end do                                                            
   552          end if
   553        end do
   554        xy_SurfTemp = xy_SurfTemp + Temp0
     .        if (jmax .gt. 0) then                                             
     .           J4 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t238 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t240 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surftemp(t240-1,t238) = xy_surftemp(t240-1,t238) +    
     .       1            temp0                                                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t238 = J4 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t240 = 1, imax + 1 - min0(1,imax)                        
     .                 xy_surftemp(t240-1,t238) = xy_surftemp(t240-1,t238) +    
     .       1            temp0                                                 
     .                 xy_surftemp(t240-1,t238+1) = xy_surftemp(t240-1,t238+1)  
     .       1             + temp0                                              
     .                 xy_surftemp(t240-1,t238+2) = xy_surftemp(t240-1,t238+2)  
     .       1             + temp0                                              
     .                 xy_surftemp(t240-1,t238+3) = xy_surftemp(t240-1,t238+3)  
     .       1             + temp0                                              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10007                                                       
   555  
   556      else if ( SSTType == 'qobs' ) then
   557        ! Neale and Hoskins (2001)  Qobs experiment ˤѤ줿 SST
   558        ! SST used for Qobs experiment by Neale and Hoskins (2001)
   559        !
   560  
   561        call NH01SST( &
   562          & 'control',     & ! (in   )
   563          & xy_SurfTempTmp1  & ! (inout)
   564          & )
   565        call NH01SST( &
   566          & 'flat',     & ! (in   )
   567          & xy_SurfTempTmp2  & ! (inout)
   568          & )
   569        xy_SurfTemp = ( xy_SurfTempTmp1 + xy_SurfTempTmp2 ) * 0.5d0
     .        if (xy_surftemptmp1.DSC.U2 .gt. 0) then                           
     .           J5 = and(xy_surftemptmp1.DSC.U2,3)                             
     .  !CDIR    NODEP                                                          
     .           do t225 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t227 = 1, xy_surftemptmp1.DSC.U1 + 2 - min0(1,           
     .       1         xy_surftemptmp1.DSC.U1 + 1)                              
     .                 xy_surftemp(t227-1,t225) = (xy_surftemptmp1(t227-1,t225)+
     .       1            xy_surftemptmp2(t227-1,t225))*5.00000000000000e-001   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t225 = J5 + 1, xy_surftemptmp1.DSC.U2, 4                    
     .  !CDIR       NODEP                                                       
     .              do t227 = 1, xy_surftemptmp1.DSC.U1 + 2 - min0(1,           
     .       1         xy_surftemptmp1.DSC.U1 + 1)                              
     .                 xy_surftemp(t227-1,t225) = (xy_surftemptmp1(t227-1,t225)+
     .       1            xy_surftemptmp2(t227-1,t225))*5.00000000000000e-001   
     .                 xy_surftemp(t227-1,t225+1) = (xy_surftemptmp1(t227-1,t225
     .       1            +1)+xy_surftemptmp2(t227-1,t225+1))*                  
     .       2            5.00000000000000e-001                                 
     .                 xy_surftemp(t227-1,t225+2) = (xy_surftemptmp1(t227-1,t225
     .       1            +2)+xy_surftemptmp2(t227-1,t225+2))*                  
     .       2            5.00000000000000e-001                                 
     .                 xy_surftemp(t227-1,t225+3) = (xy_surftemptmp1(t227-1,t225
     .       1            +3)+xy_surftemptmp2(t227-1,t225+3))*                  
     .       2            5.00000000000000e-001                                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10007                                                       
   570  
   571  !!$    else if ( SSTType == '1keq' ) then
   572  !!$      ! Neale and Hoskins (2001)  1KEQ experiment ˤѤ줿 SST
   573  !!$      ! SST used for 1KEQ experiment by Neale and Hoskins (2001)
   574  !!$      !
   575  !!$
   576  !!$      call NH01SST( &
   577  !!$        & 'control',     & ! (in   )
   578  !!$        & xy_SurfTemp  & ! (inout)
   579  !!$        & )
   580  !!$
   581  !!$      do j = 1, jmax
   582  !!$        do i = 1,
   583  !!$          if ( ( abs( x_Lon(i) - PI ) < PI /  3.0d0 ) .and. &
   584  !!$            &  ( abs( y_Lat(j)      ) < PI / 12.0d0 ) ) then
   585  !!$            xy_SurfTemp(i,j) = xy_SurfTemp(i,j)                                 &
   586  !!$              & + 1.0d0 * cos( PI/2.0d0 * ( x_Lon(i) - PI ) / ( PI ) )**2       &
   587  !!$              &         * cos( PI/2.0d0 * y_Lat(j)          / ( PI ) )**2 )
   588  !!$          end if
   589  !!$        end do
   590  !!$      end do
   591  
   592      else
   593        call MessageNotify( 'E', module_name, 'SSTType=<%c> is invalid.', &
   594          & c1 = trim(SSTType) )
   595      end if
   596  
   597  
   598    end subroutine NH01SST
   599  
   600    !--------------------------------------------------------------------------------------
   601  
   602    subroutine SurfDataInit
   603  
   604      ! ⥸塼 ; USE statements
   605      !
   606  
   607      ! NAMELIST եϤ˴ؤ桼ƥƥ
   608      ! Utilities for NAMELIST file input
   609      !
   610      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   611  
   612      ! ե
   613      ! File I/O support
   614      !
   615      use dc_iounit, only: FileOpen
   616  
   617      ! ʸ
   618      ! Character handling
   619      !
   620      use dc_string, only: LChar
   621  
   622      ! ʸ ; Declaration statements
   623      !
   624      implicit none
   625  
   626      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   627                                ! Unit number for NAMELIST file open
   628      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   629                                ! IOSTAT of NAMELIST read
   630  
   631      ! NAMELIST ѿ
   632      ! NAMELIST group name
   633      !
   634      namelist /surface_data_nml/ Pattern,          &
   635        & SurfTemp, Albedo, HumidCoef, RoughLength, &
   636        & HeatCapacity, TempFlux, SurfCond,         &
   637        & SeaIceConc,                               &
   638        & SoilHeatCap, SoilHeatDiffCoef
   639            !
   640            ! ǥեͤˤĤƤϽ³ "surface_data#SurfDataInit"
   641            ! Υɤ򻲾ȤΤ.
   642            !
   643            ! Refer to source codes in the initialization procedure
   644            ! "surface_data#SurfDataInit" for the default values.
   645            !
   646  
   647  
   648      ! ¹ʸ ; Executable statement
   649  
   650      if ( surface_data_inited ) return
   651  
   652  
   653      ! ǥեͤ (ޤ Pattern Τ)
   654      ! Default values settings (At first, "Pattern" only)
   655      !
   656      Pattern      = 'Hosaka et al. (1998)'
   657      SurfTemp     = 273.15_DP
   658      Albedo       = 0.15_DP
   659      HumidCoef    = 1.0_DP
   660      RoughLength  = 1.0e-4_DP
   661      HeatCapacity = 0.0_DP
   662      TempFlux     = 0.0_DP
   663      SurfCond     = 0
   664      SeaIceConc   = 0.0_DP
   665  
   666      SoilHeatCap      = 2.1d6
   667      !   volumetric heat capacity (J m-3 K-1)
   668      !   Value of Clay for porosity f=0.4, volumetric wetness theta=0.2 in Table 12.3 by
   669      !   Hillel (2004).
   670      !   Note that the unit of Table 12.3 of Hillel (2004) would be wrong. Although the
   671      !   unit in the Table is wrong, the volumetric heat capacity of 2.1d6 J m-3 K-1 is
   672      !   within the range of typical value of it.
   673  
   674      SoilHeatDiffCoef = 1.2d0
   675      !   thermal conductivity (W m-1 K-1)
   676      !   Value of Clay for porosity f=0.4, volumetric wetness theta=0.2 in Table 12.3 by
   677      !   Hillel (2004).
   678  
   679      !   Reference
   680      !
   681      !   Hillet, D.,
   682      !     Introduction to Environmental Soil Physics,
   683      !     Elsevier Academic Press, pp494, 2004.
   684  
   685  
   686      !   Sample values for Mars
   687      !     These values were obtained from Kiefer (1976) and Kieffer et al. (1977).
   688      !   Reference
   689      !     Kieffer, Science, 194, 1344-1346, 1976.
   690      !     Kieffer et al., JGR, 82, 4249-4291, 1977.
   691      !
   692      !   Standard model: see Kieffer et al. (1977) p. 4286,
   693      !   albedo,                 A   = 0.25
   694      !     (Kieffer et al., 1977)
   695      !   thermal inertia,        I   = 6.5e-3 cal cm-2 s-1/2 K-1 = 272 J m-2 s-1/2 K-1
   696      !     (Kieffer et al., 1977)
   697      !   density,                rho = 1.65 g cm-3 = 1650 kg m-3
   698      !     (Kieffer, 1976)
   699      !   specific heat,          cp  = 0.14 cal g-1 K-1 = 586 J kg-1 K-1
   700      !     (Kieffer, 1976)
   701      !
   702      !   heat capacity,          cp*rho = 0.97e6 J m-3 K-1
   703      !   conduction coefficient, k = I**2 / (cp*rho) = 7.6e-2   J m-1 s-1 K-1
   704      !
   705  !!$    SoilHeatCap      = 0.97d6
   706  !!$    SoilHeatDiffCoef = 0.076d0
   707  
   708      ! NOTE:
   709      !   Values by Kieffer (1976) and Kieffer et al. (1977) would be appropriate for GCM
   710      !   experiment.
   711  
   712  
   713      !   Sample values for Mars
   714      !     These values were obtained from Savijarvi (1995).
   715      !   Reference
   716      !     Savijarvi, H., Mars boundary layer modeling: Diurnal moisture cycle and soil
   717      !       properties at the Viking lander 1 site, Icarus, 117, 120-127, 1995.
   718      !
   719  !!$    SoilHeatCap      = 0.8d6
   720  !!$    SoilHeatDiffCoef = 0.18d0
   721  
   722  
   723      ! NAMELIST ɤ߹ (ޤ Pattern Τ)
   724      ! NAMELIST is input (At first, "Pattern" only)
   725      !
   726      if ( trim(namelist_filename) /= '' ) then
   727        call FileOpen( unit_nml, &          ! (out)
   728          & namelist_filename, mode = 'r' ) ! (in)
   729  
   730        rewind( unit_nml )
   731        read( unit_nml, &             ! (in)
   732          & nml = surface_data_nml, & ! (out)
   733          & iostat = iostat_nml )     ! (out)
   734        close( unit_nml )
   735  
   736        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   737      end if
   738  
   739  
   740      ! NAMELIST ɤ߹
   741      ! NAMELIST is input
   742      !
   743      if ( trim(namelist_filename) /= '' ) then
   744        call FileOpen( unit_nml, &          ! (out)
   745          & namelist_filename, mode = 'r' ) ! (in)
   746  
   747        rewind( unit_nml )
   748        read( unit_nml, &             ! (in)
   749          & nml = surface_data_nml, & ! (out)
   750          & iostat = iostat_nml )     ! (out)
   751        close( unit_nml )
   752  
   753        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   754      end if
   755  
   756  
   757      !  ; Print
   758      !
   759      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   760      call MessageNotify( 'M', module_name, '  Pattern          = %c', c1 = trim(Pattern) )
   761      call MessageNotify( 'M', module_name, '  SurfTemp         = %f', d = (/ SurfTemp         /) )
   762      call MessageNotify( 'M', module_name, '  Albedo           = %f', d = (/ Albedo           /) )
   763      call MessageNotify( 'M', module_name, '  HumidCoef        = %f', d = (/ HumidCoef        /) )
   764      call MessageNotify( 'M', module_name, '  RoughLength      = %f', d = (/ RoughLength      /) )
   765      call MessageNotify( 'M', module_name, '  HeatCapacity     = %f', d = (/ HeatCapacity     /) )
   766      call MessageNotify( 'M', module_name, '  TempFlux         = %f', d = (/ TempFlux         /) )
   767      call MessageNotify( 'M', module_name, '  SurfCond         = %d', i = (/ SurfCond         /) )
   768      call MessageNotify( 'M', module_name, '  SeaIceConc       = %f', d = (/ SeaIceConc       /) )
   769      call MessageNotify( 'M', module_name, '  SoilHeatCap      = %f', d = (/ SoilHeatCap      /) )
   770      call MessageNotify( 'M', module_name, '  SoilHeatDiffCoef = %f', d = (/ SoilHeatDiffCoef /) )
   771      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   772  
   773      surface_data_inited = .true.
   774  
   775    end subroutine SurfDataInit
   776  
   777    !--------------------------------------------------------------------------------------
   778  
   779  end module surface_data
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:36 2012
FILE NAME: surface_data.f90
PROGRAM NAME: surface_data
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ɽ̥ǡ
     2:            !
     3:            != Prepare surface data
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
     6:            ! Version::   $Id: surface_data.f90,v 1.10 2011-06-19 11:12:41 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module surface_data
    13:              !
    14:              != ɽ̥ǡ
    15:              !
    16:              != Prepare surface data
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! GCM Ѥɽ̥ǡޤ.
    21:              ! ߤϻŪ Hosaka et al. (1998)  SST ʬۤͿޤ.
    22:              !
    23:              ! Surface data for GCM is generated.
    24:              ! Now, SST profile in Hosaka et al. (1998) is provided tentatively.
    25:              !
    26:              !== Procedures List
    27:              !
    28:              ! SetSurfData   :: ɽ̥ǡμ
    29:              ! ------------  :: ------------
    30:              ! SetSurfData   :: Set surface data
    31:              !
    32:              !== NAMELIST
    33:              !
    34:              ! NAMELIST#surface_data_nml
    35:              !
    36:            
    37:              ! ⥸塼 ; USE statements
    38:              !
    39:            
    40:              ! ʻ
    41:              ! Grid points settings
    42:              !
    43:              use gridset, only: imax, & ! ٳʻ. 
    44:                                         ! Number of grid points in longitude
    45:                &                jmax, & ! ٳʻ. 
    46:                                         ! Number of grid points in latitude
    47:                &                kmax    ! ľؿ. 
    48:                                         ! Number of vertical level
    49:            
    50:              ! ̷ѥ᥿
    51:              ! Kind type parameter
    52:              !
    53:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    54:                &                 STRING     ! ʸ.       Strings. 
    55:            
    56:              ! ̷ѥ᥿
    57:              ! Kind type parameter
    58:              !
    59:              use dc_types, only: DP     ! ټ¿. Double precision. 
    60:            
    61:              ! å
    62:              ! Message output
    63:              !
    64:              use dc_message, only: MessageNotify
    65:            
    66:              ! ʸ ; Declaration statements
    67:              !
    68:              implicit none
    69:              private
    70:            
    71:              ! ³
    72:              ! Public procedure
    73:              !
    74:              public:: SetSurfData
    75:              public:: SurfDataInit
    76:            
    77:              ! ѿ
    78:              ! Public variables
    79:              !
    80:              logical, save :: surface_data_inited = .false.
    81:                                          ! ե饰. 
    82:                                          ! Initialization flag
    83:            
    84:              ! ѿ
    85:              ! Private variables
    86:              !
    87:              character(STRING), save:: Pattern
    88:                                          ! ɽ̥ǡΥѥ. 
    89:                                          ! ʲΥѥǽ. 
    90:                                          ! 
    91:                                          ! Surface data pattern. 
    92:                                          ! Available patterns are as follows.
    93:                                          ! 
    94:                                          ! * "Hosaka et al. (1998)"
    95:                                          ! * "Homogeneous"
    96:                                          ! 
    97:              real(DP), save:: SurfTemp
    98:                                          ! ɽ̲٤δ. 
    99:                                          ! Standard value of surface temperature
   100:              real(DP), save:: Albedo
   101:                                          ! ɽ٥. 
   102:                                          ! Surface albedo
   103:              real(DP), save:: HumidCoef
   104:                                          ! ɽ. 
   105:                                          ! Surface humidity coefficient
   106:              real(DP), save:: RoughLength
   107:                                          ! ɽĹ. 
   108:                                          ! Surface rough length
   109:              real(DP), save:: HeatCapacity
   110:                                          ! ɽǮ. 
   111:                                          ! Surface heat capacity
   112:              real(DP), save:: TempFlux
   113:                                          ! Ǯեå. 
   114:                                          ! Ground temperature flux
   115:              integer, save:: SurfCond
   116:                                          ! ɽ (0: , 1: ). 
   117:                                          ! Surface condition (0: fixed, 1: variable)
   118:              real(DP), save:: SeaIceConc
   119:                                          ! ɹ̩
   120:                                          ! Sea ice concentration
   121:              real(DP), save:: SoilHeatCap
   122:                                          ! ھǮ (J K-1 kg-1)
   123:                                          ! Specific heat of soil (J K-1 kg-1)
   124:              real(DP), save:: SoilHeatDiffCoef
   125:                                          ! ھǮƳ (J m-3 K-1)
   126:                                          ! Heat conduction coefficient of soil (J m-3 K-1)
   127:            
   128:              character(*), parameter:: module_name = 'surface_data'
   129:                                          ! ⥸塼̾. 
   130:                                          ! Module name
   131:              character(*), parameter:: version = &
   132:                & '$Name: dcpam5-20120921 $' // &
   133:                & '$Id: surface_data.f90,v 1.10 2011-06-19 11:12:41 yot Exp $'
   134:                                          ! ⥸塼ΥС
   135:                                          ! Module version
   136:            
   137:            
   138:            contains
   139:            
   140:              !--------------------------------------------------------------------------------------
   141:            
   142:              subroutine SetSurfData( &
   143:                & xy_SurfTemp, xy_SurfAlbedo, xy_SurfHumidCoef, & ! (out)
   144:                & xy_SurfRoughLength, xy_SurfHeatCapacity,      & ! (out)
   145:                & xy_DeepSubSurfHeatFlux, xy_SurfCond,          & ! (out)
   146:                & xy_SeaIceConc,                                & ! (out)
   147:                & xy_SoilHeatCap, xy_SoilHeatDiffCoef           & ! (out)
   148:                & )
   149:                !
   150:                ! GCM Ѥɽ̥ǡ֤ޤ.
   151:                !
   152:                ! Return surface data for GCM.
   153:                !
   154:            
   155:                ! ⥸塼 ; USE statements
   156:                !
   157:            
   158:                ! ʸ
   159:                ! Character handling
   160:                !
   161:                use dc_string, only: LChar
   162:            
   163:                ! ʪ
   164:                ! Physical and mathematical constants settings
   165:                !
   166:                use constants0, only: &
   167:                  & PI                    ! $ \pi $.
   168:                                          ! ߼Ψ. Circular constant
   169:            
   170:                ! ɸǡ
   171:                ! Axes data settings
   172:                !
   173:                use axesset, only: &
   174:                  & y_Lat                 ! $ \varphi $ [rad.] . . Latitude
   175:            
   176:                ! ե뤫 1 ץեɤꤹ. 
   177:                ! read 1-D profile from a file and set it 
   178:                !
   179:                use set_1d_profile, only : Set1DProfileSurfTemp
   180:            
   181:            
   182:                ! ʸ ; Declaration statements
   183:                !
   184:                implicit none
   185:                real(DP), intent(out), optional:: xy_SurfTemp (0:imax-1, 1:jmax)
   186:                                          ! ɽ̲. 
   187:                                          ! Surface temperature
   188:                real(DP), intent(out), optional:: xy_SurfAlbedo (0:imax-1, 1:jmax)
   189:                                          ! ɽ٥. 
   190:                                          ! Surface albedo
   191:                real(DP), intent(out), optional:: xy_SurfHumidCoef (0:imax-1, 1:jmax)
   192:                                          ! ɽ. 
   193:                                          ! Surface humidity coefficient
   194:                real(DP), intent(out), optional:: xy_SurfRoughLength (0:imax-1, 1:jmax)
   195:                                          ! ɽĹ. 
   196:                                          ! Surface rough length
   197:                real(DP), intent(out), optional:: xy_SurfHeatCapacity (0:imax-1, 1:jmax)
   198:                                          ! ɽǮ. 
   199:                                          ! Surface heat capacity
   200:                real(DP), intent(out), optional:: xy_DeepSubSurfHeatFlux (0:imax-1, 1:jmax)
   201:                                          ! Ǯեå. 
   202:                                          ! "Deep subsurface heat flux"
   203:                                          ! Heat flux at the bottom of surface/soil layer.
   204:                integer , intent(out), optional:: xy_SurfCond (0:imax-1, 1:jmax)
   205:                                          ! ɽ (0: , 1: ) . 
   206:                                          ! Surface condition (0: fixed, 1: variable)
   207:                real(DP), intent(out), optional:: xy_SeaIceConc(0:imax-1, 1:jmax)
   208:                                          ! ɹ̩
   209:                                          ! Sea ice concentration
   210:                real(DP), intent(out), optional:: xy_SoilHeatCap(0:imax-1,1:jmax)
   211:                                          ! ھǮ (J K-1 kg-1)
   212:                                          ! Specific heat of soil (J K-1 kg-1)
   213:                real(DP), intent(out), optional:: xy_SoilHeatDiffCoef(0:imax-1,1:jmax)
   214:                                          ! ھǮƳ (J m-3 K-1)
   215:                                          ! Heat conduction coefficient of soil (J m-3 K-1)
   216:            
   217:                ! ѿ
   218:                ! Work variables
   219:                !
   220:            !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   221:            !!$                              ! Work variables for DO loop in longitude
   222:                integer:: j               ! ˲ DO 롼Ѻѿ
   223:                                          ! Work variables for DO loop in latitude
   224:            !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   225:            !!$                              ! Work variables for DO loop in vertical direction
   226:            
   227:                ! ¹ʸ ; Executable statement
   228:            
   229:            
   230:                ! ǧ
   231:                ! Initialization check
   232:                !
   233:                if ( .not. surface_data_inited ) then
   234:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   235:                end if
   236:            
   237:            
   238:                select case ( LChar( trim(Pattern) ) )
   239:            
   240:                case ( 'homogeneous' )
   241:                  ! SST 
   242:                  ! SST is homogeneous
   243:                  !
   244: +V=====          if ( present(xy_SurfTemp) ) xy_SurfTemp = SurfTemp
   245:            
   246:                case ( 'hosaka et al. (1998)' )
   247:                  ! Hosaka et al. (1998) ˤѤ줿 SST
   248:                  ! SST used in Hosaka et al. (1998)
   249:                  !
   250:                  if ( present( xy_SurfTemp ) ) then
   251:                    call Hosakaetal98SST( &
   252:                      & xy_SurfTemp  & ! (out)
   253:                      & )
   254:                  end if
   255:            
   256:                case ( 'nh01_control' )
   257:                  ! Neale and Hoskins (2001)  Control experiment ˤѤ줿 SST
   258:                  ! SST used for Control experiment by Neale and Hoskins (2001)
   259:                  !
   260:                  if ( present( xy_SurfTemp ) ) then
   261:                    call NH01SST( &
   262:                      & 'control',     & ! (in   )
   263:                      & xy_SurfTemp  & ! (inout)
   264:                      & )
   265:                  end if
   266:            
   267:                case ( '1-d profile' )
   268:            
   269:                  if ( present( xy_SurfTemp ) ) then
   270:                    call Set1DProfileSurfTemp( &
   271:                      & xy_SurfTemp &
   272:                      & )
   273:                  end if
   274:            
   275:                case default
   276:                  call MessageNotify( 'E', module_name, 'Pattern=<%c> is invalid.', &
   277:                    & c1 = trim(Pattern) )
   278:                end select
   279:            
   280: WW=====        if ( present(xy_SurfAlbedo          ) ) xy_SurfAlbedo          = Albedo
   281: WW=====        if ( present(xy_SurfHumidCoef       ) ) xy_SurfHumidCoef       = HumidCoef
   282: WW=====        if ( present(xy_SurfRoughLength     ) ) xy_SurfRoughLength     = RoughLength
   283: WW=====        if ( present(xy_SurfHeatCapacity    ) ) xy_SurfHeatCapacity    = HeatCapacity
   284: W*=====        if ( present(xy_DeepSubSurfHeatFlux ) ) xy_DeepSubSurfHeatFlux = TempFlux
   285: **=====        if ( present(xy_SurfCond            ) ) xy_SurfCond            = SurfCond
   286: **=====        if ( present(xy_SeaIceConc          ) ) xy_SeaIceConc          = SeaIceConc
   287: **=====        if ( present(xy_SoilHeatCap         ) ) xy_SoilHeatCap         = SoilHeatCap
   288: **=====        if ( present(xy_SoilHeatDiffCoef    ) ) xy_SoilHeatDiffCoef    = SoilHeatDiffCoef
   289:            
   290:            
   291:              end subroutine SetSurfData
   292:            
   293:              !--------------------------------------------------------------------------------------
   294:            
   295:              subroutine Hosakaetal98SST( &
   296:                & xy_SurfTemp  & ! (out)
   297:                & )
   298:                !
   299:                ! GCM Ѥɽ̥ǡ֤ޤ.
   300:                !
   301:                ! Return surface data for GCM.
   302:                !
   303:            
   304:                ! ⥸塼 ; USE statements
   305:                !
   306:            
   307:                ! ɸǡ
   308:                ! Axes data settings
   309:                !
   310:                use axesset, only: &
   311:                  & y_Lat                 ! $ \varphi $ [rad.] . . Latitude
   312:            
   313:                ! ʪ
   314:                ! Physical and mathematical constants settings
   315:                !
   316:                use constants0, only: &
   317:                  & PI                    ! $ \pi $.
   318:                                          ! ߼Ψ. Circular constant
   319:            
   320:                ! ʸ
   321:                ! Character handling
   322:                !
   323:                use dc_string, only: LChar
   324:            
   325:                ! ʸ ; Declaration statements
   326:                !
   327:                implicit none
   328:                real(DP), intent(out) :: xy_SurfTemp (0:imax-1, 1:jmax)
   329:                                          ! ɽ̲. 
   330:                                          ! Surface temperature
   331:            
   332:                ! ѿ (Hosaka et al. (1998))
   333:                ! Work variables (Hosaka et al. (1998))
   334:                !
   335:                real(DP):: TempEq         ! ƻ (Τˤ LatCenter ) Ǥβ.
   336:                                          ! Temperature on the equator 
   337:                                          ! (on LatCenter, to be exact)
   338:                real(DP):: LatCenter      ! ٺǹΰ. 
   339:                                          ! Latitude on which temperature is maximum.
   340:                real(DP):: LatFlatWidth   ! ٤ʿó. 
   341:                                          ! Latitude width in which temperature is flattened
   342:                integer:: jp
   343:                integer:: jm
   344:            
   345:                real(DP):: LatA, Alpha, Beta, Gamma
   346:            
   347:                real(DP):: Phi1, AlphaBeta4, Phi, LatAPlus, LatAMinus
   348:                real(DP):: SurfTempMx
   349:            
   350:                ! ѿ
   351:                ! Work variables
   352:                !
   353:            !!$    integer:: i               ! ˲ DO 롼Ѻѿ
   354:            !!$                              ! Work variables for DO loop in longitude
   355:                integer:: j               ! ˲ DO 롼Ѻѿ
   356:                                          ! Work variables for DO loop in latitude
   357:            !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   358:            !!$                              ! Work variables for DO loop in vertical direction
   359:            
   360:                ! ¹ʸ ; Executable statement
   361:            
   362:                ! ǧ
   363:                ! Initialization check
   364:                !
   365:                if ( .not. surface_data_inited ) then
   366:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   367:                end if
   368:            
   369:            
   370:                ! Hosaka et al. (1998) ˤѤ줿 SST
   371:                ! SST used in Hosaka et al. (1998)
   372:                !
   373:            
   374:            !!$    TempEq       = SurfTemp
   375:                TempEq       = 302.0_DP
   376:                LatCenter    =   0.0_DP
   377:                LatFlatWidth =   7.0_DP
   378:            
   379:                LatA         =  30.0_DP
   380:                Alpha        =  60.0_DP
   381:                Beta         =  32.0_DP
   382:                Gamma        =   0.0_DP
   383:            
   384:                Phi1 = abs( LatA * PI / 180.0_DP )
   385:                AlphaBeta4  = 2.0_DP *( Phi1**3 ) * ( Beta / Alpha )
   386:            
   387: +------>       do j = 1, jmax
   388: |                Phi = abs( y_Lat(j) - LatCenter * PI / 180.0_DP )
   389: |V=====          xy_SurfTemp (:,j) = &
   390: |                  & TempEq &
   391: |                  & - Alpha / 2.0_DP &
   392: |                  &   * ( Phi - max( sqrt( Phi1**2 + AlphaBeta4 ) - sqrt( ( Phi - Phi1 )**2 + AlphaBeta4 ), 0.0_DP ) ) &
   393: |                  & + Gamma * ( Phi**3 )
   394: +------        end do
   395:            
   396:                ! 濴 LatCenter +/- LatFlatWidth δ֤ʿó
   397:                ! Flatten between LatCenter +/- LatFlatWidth
   398:                !
   399:                if ( LatFlatWidth < 0.0_DP ) then
   400:                  LatFlatWidth = - LatFlatWidth
   401:                end if
   402:                LatAPlus = ( LatCenter + LatFlatWidth ) * PI / 180.0_DP
   403:                LatAMinus = ( LatCenter - LatFlatWidth ) * PI / 180.0_DP
   404:            
   405:                jp = 1
   406:                jm = jmax
   407: V------>       do j = 1, jmax
   408: |                if ( y_Lat(j) <= LatAPlus ) then
   409: |                  jp = j
   410: |                  if ( j == jmax ) jp = jp - 1
   411: |                end if
   412: |                if ( y_Lat(j) < LatAMinus ) then
   413: |                  jm = j
   414: |                  if ( j == jmax ) jm = jm - 1
   415: |                end if
   416: V------        end do
   417:            
   418:                if ( jmax /= 1 ) then
   419:                  SurfTempMx = &
   420:                    & (   xy_SurfTemp(0,jm) * ( y_Lat(jm+1) - LatAMinus ) &
   421:                    &   + xy_SurfTemp(0,jm+1) * ( LatAMinus - y_Lat(jm) ) &
   422:                    & ) &
   423:                    & / ( y_Lat(jm+1) - y_Lat(jm) )
   424:            
   425: W*=====          xy_SurfTemp(:,jm+1:jp) = SurfTempMx
   426:                end if
   427:            
   428:            
   429:              end subroutine Hosakaetal98SST
   430:            
   431:              !--------------------------------------------------------------------------------------
   432:            
   433:              recursive subroutine NH01SST( &
   434:                & SSTType,     & ! (in   )
   435:                & xy_SurfTemp  & ! (inout)
   436:                & )
   437:                !
   438:                ! Set SST described by Neale and Hoskins (2001)
   439:                !
   440:            
   441:                ! ⥸塼 ; USE statements
   442:                !
   443:            
   444:                ! ɸǡ
   445:                ! Axes data settings
   446:                !
   447:                use axesset, only: &
   448:                  & x_Lon,         &      ! $ \lambda $ [rad.] . . Longitude
   449:                  & y_Lat                 ! $ \varphi $ [rad.] . . Latitude
   450:            
   451:                ! ʪ
   452:                ! Physical and mathematical constants settings
   453:                !
   454:                use constants0, only: &
   455:                  & PI                    ! $ \pi $.
   456:                                          ! ߼Ψ. Circular constant
   457:            
   458:                ! ʸ
   459:                ! Character handling
   460:                !
   461:                use dc_string, only: LChar
   462:            
   463:                ! ʸ ; Declaration statements
   464:                !
   465:                implicit none
   466:                character(len=*), intent(in   ) :: SSTType
   467:                real(DP)        , intent(inout) :: xy_SurfTemp (0:imax-1, 1:jmax)
   468:                                          ! ɽ̲.
   469:                                          ! Surface temperature
   470:            
   471:                ! ѿ
   472:                ! Work variables
   473:                !
   474:                real(DP) :: Temp0         ! Zero degree Celsius
   475:                                          ! Latitude width in which temperature is flattened
   476:                real(DP) :: xy_SurfTempTmp1 (0:imax-1, 1:jmax)
   477:                real(DP) :: xy_SurfTempTmp2 (0:imax-1, 1:jmax)
   478:            
   479:                ! ѿ
   480:                ! Work variables
   481:                !
   482:                integer:: i               ! ˲ DO 롼Ѻѿ
   483:                                          ! Work variables for DO loop in longitude
   484:                integer:: j               ! ˲ DO 롼Ѻѿ
   485:                                          ! Work variables for DO loop in latitude
   486:            !!$    integer:: k               ! ľ˲ DO 롼Ѻѿ
   487:            !!$                              ! Work variables for DO loop in vertical direction
   488:            
   489:                ! ¹ʸ ; Executable statement
   490:            
   491:                Temp0 = 273.15d0
   492:            
   493:                if ( SSTType == 'control' ) then
   494:                  ! Neale and Hoskins (2001)  control experiment ˤѤ줿 SST
   495:                  ! SST used for control experiment by Neale and Hoskins (2001)
   496:                  !
   497:            
   498: +------>         do j = 1, jmax
   499: |                  if ( abs( y_Lat(j) ) < PI / 3.0d0 ) then
   500: |V=====              xy_SurfTemp(:,j) = 27.0d0 * ( 1.0d0 - sin( 3.0d0 * y_Lat(j) / 2.0d0 )**2 )
   501: |                  else
   502: |V=====              xy_SurfTemp(:,j) = 0.0d0
   503: |                  end if
   504: +------          end do
   505: +V=====          xy_SurfTemp = xy_SurfTemp + Temp0
   506:            
   507:            
   508:                else if ( SSTType == 'peaked' ) then
   509:                  ! Neale and Hoskins (2001)  Peaked experiment ˤѤ줿 SST
   510:                  ! SST used for Peaked experiment by Neale and Hoskins (2001)
   511:                  !
   512:            
   513: +------>         do j = 1, jmax
   514: |                  if ( abs( y_Lat(j) ) < PI / 3.0d0 ) then
   515: |V=====              xy_SurfTemp(:,j) = 27.0d0 * ( 1.0d0 - 3.0d0 * abs( y_Lat(j) ) / PI )
   516: |                  else
   517: |V=====              xy_SurfTemp(:,j) = 0.0d0
   518: |                  end if
   519: +------          end do
   520: +V=====          xy_SurfTemp = xy_SurfTemp + Temp0
   521:            
   522:                else if ( SSTType == 'flat' ) then
   523:                  ! Neale and Hoskins (2001)  Flat experiment ˤѤ줿 SST
   524:                  ! SST used for Flat experiment by Neale and Hoskins (2001)
   525:                  !
   526:            
   527: +------>         do j = 1, jmax
   528: |                  if ( abs( y_Lat(j) ) < PI / 3.0d0 ) then
   529: |V=====              xy_SurfTemp(:,j) = 27.0d0 * ( 1.0d0 - sin( 3.0d0 * y_Lat(j) / 2.0d0 )**4 )
   530: |                  else
   531: |V=====              xy_SurfTemp(:,j) = 0.0d0
   532: |                  end if
   533: +------          end do
   534: +V=====          xy_SurfTemp = xy_SurfTemp + Temp0
   535:            
   536:                else if ( SSTType == 'control-5n' ) then
   537:                  ! Neale and Hoskins (2001)  Control-5N experiment ˤѤ줿 SST
   538:                  ! SST used for Control-5N experiment by Neale and Hoskins (2001)
   539:                  !
   540:            
   541: +------>         do j = 1, jmax
   542: |                  if ( y_Lat(j) < - PI / 3.0d0 ) then
   543: |V=====              xy_SurfTemp(:,j) = 0.0d0
   544: |                  else if ( y_Lat(j) < PI / 36.0d0 ) then
   545: |V=====              xy_SurfTemp(:,j) = 27.0d0                                             &
   546: |                      & * ( 1.0d0 - sin( 90.0d0/65.0d0 * ( y_Lat(j) - PI/36.0d0 ) )**2 )
   547: |                  else if ( y_Lat(j) < PI / 3.0d0 ) then
   548: |V=====              xy_SurfTemp(:,j) = 27.0d0                                             &
   549: |                      & * ( 1.0d0 - sin( 90.0d0/55.0d0 * ( y_Lat(j) - PI/36.0d0 ) )**2 )
   550: |                  else
   551: |V=====              xy_SurfTemp(:,j) = 0.0d0
   552: |                  end if
   553: +------          end do
   554: +V=====          xy_SurfTemp = xy_SurfTemp + Temp0
   555:            
   556:                else if ( SSTType == 'qobs' ) then
   557:                  ! Neale and Hoskins (2001)  Qobs experiment ˤѤ줿 SST
   558:                  ! SST used for Qobs experiment by Neale and Hoskins (2001)
   559:                  !
   560:            
   561:                  call NH01SST( &
   562:                    & 'control',     & ! (in   )
   563:                    & xy_SurfTempTmp1  & ! (inout)
   564:                    & )
   565:                  call NH01SST( &
   566:                    & 'flat',     & ! (in   )
   567:                    & xy_SurfTempTmp2  & ! (inout)
   568:                    & )
   569: +V=====          xy_SurfTemp = ( xy_SurfTempTmp1 + xy_SurfTempTmp2 ) * 0.5d0
   570:            
   571:            !!$    else if ( SSTType == '1keq' ) then
   572:            !!$      ! Neale and Hoskins (2001)  1KEQ experiment ˤѤ줿 SST
   573:            !!$      ! SST used for 1KEQ experiment by Neale and Hoskins (2001)
   574:            !!$      !
   575:            !!$
   576:            !!$      call NH01SST( &
   577:            !!$        & 'control',     & ! (in   )
   578:            !!$        & xy_SurfTemp  & ! (inout)
   579:            !!$        & )
   580:            !!$
   581:            !!$      do j = 1, jmax
   582:            !!$        do i = 1,
   583:            !!$          if ( ( abs( x_Lon(i) - PI ) < PI /  3.0d0 ) .and. &
   584:            !!$            &  ( abs( y_Lat(j)      ) < PI / 12.0d0 ) ) then
   585:            !!$            xy_SurfTemp(i,j) = xy_SurfTemp(i,j)                                 &
   586:            !!$              & + 1.0d0 * cos( PI/2.0d0 * ( x_Lon(i) - PI ) / ( PI ) )**2       &
   587:            !!$              &         * cos( PI/2.0d0 * y_Lat(j)          / ( PI ) )**2 )
   588:            !!$          end if
   589:            !!$        end do
   590:            !!$      end do
   591:            
   592:                else
   593:                  call MessageNotify( 'E', module_name, 'SSTType=<%c> is invalid.', &
   594:                    & c1 = trim(SSTType) )
   595:                end if
   596:            
   597:            
   598:              end subroutine NH01SST
   599:            
   600:              !--------------------------------------------------------------------------------------
   601:            
   602:              subroutine SurfDataInit
   603:            
   604:                ! ⥸塼 ; USE statements
   605:                !
   606:            
   607:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   608:                ! Utilities for NAMELIST file input
   609:                !
   610:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   611:            
   612:                ! ե
   613:                ! File I/O support
   614:                !
   615:                use dc_iounit, only: FileOpen
   616:            
   617:                ! ʸ
   618:                ! Character handling
   619:                !
   620:                use dc_string, only: LChar
   621:            
   622:                ! ʸ ; Declaration statements
   623:                !
   624:                implicit none
   625:            
   626:                integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   627:                                          ! Unit number for NAMELIST file open
   628:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   629:                                          ! IOSTAT of NAMELIST read
   630:            
   631:                ! NAMELIST ѿ
   632:                ! NAMELIST group name
   633:                !
   634:                namelist /surface_data_nml/ Pattern,          &
   635:                  & SurfTemp, Albedo, HumidCoef, RoughLength, &
   636:                  & HeatCapacity, TempFlux, SurfCond,         &
   637:                  & SeaIceConc,                               &
   638:                  & SoilHeatCap, SoilHeatDiffCoef
   639:                      !
   640:                      ! ǥեͤˤĤƤϽ³ "surface_data#SurfDataInit" 
   641:                      ! Υɤ򻲾ȤΤ. 
   642:                      !
   643:                      ! Refer to source codes in the initialization procedure
   644:                      ! "surface_data#SurfDataInit" for the default values. 
   645:                      !
   646:            
   647:            
   648:                ! ¹ʸ ; Executable statement
   649:            
   650:                if ( surface_data_inited ) return
   651:            
   652:            
   653:                ! ǥեͤ (ޤ Pattern Τ)
   654:                ! Default values settings (At first, "Pattern" only)
   655:                !
   656:                Pattern      = 'Hosaka et al. (1998)'
   657:                SurfTemp     = 273.15_DP
   658:                Albedo       = 0.15_DP
   659:                HumidCoef    = 1.0_DP
   660:                RoughLength  = 1.0e-4_DP
   661:                HeatCapacity = 0.0_DP
   662:                TempFlux     = 0.0_DP
   663:                SurfCond     = 0
   664:                SeaIceConc   = 0.0_DP
   665:            
   666:                SoilHeatCap      = 2.1d6
   667:                !   volumetric heat capacity (J m-3 K-1)
   668:                !   Value of Clay for porosity f=0.4, volumetric wetness theta=0.2 in Table 12.3 by
   669:                !   Hillel (2004).
   670:                !   Note that the unit of Table 12.3 of Hillel (2004) would be wrong. Although the
   671:                !   unit in the Table is wrong, the volumetric heat capacity of 2.1d6 J m-3 K-1 is
   672:                !   within the range of typical value of it.
   673:            
   674:                SoilHeatDiffCoef = 1.2d0
   675:                !   thermal conductivity (W m-1 K-1)
   676:                !   Value of Clay for porosity f=0.4, volumetric wetness theta=0.2 in Table 12.3 by
   677:                !   Hillel (2004).
   678:            
   679:                !   Reference
   680:                !
   681:                !   Hillet, D.,
   682:                !     Introduction to Environmental Soil Physics,
   683:                !     Elsevier Academic Press, pp494, 2004.
   684:            
   685:            
   686:                !   Sample values for Mars
   687:                !     These values were obtained from Kiefer (1976) and Kieffer et al. (1977).
   688:                !   Reference
   689:                !     Kieffer, Science, 194, 1344-1346, 1976.
   690:                !     Kieffer et al., JGR, 82, 4249-4291, 1977.
   691:                !
   692:                !   Standard model: see Kieffer et al. (1977) p. 4286,
   693:                !   albedo,                 A   = 0.25
   694:                !     (Kieffer et al., 1977)
   695:                !   thermal inertia,        I   = 6.5e-3 cal cm-2 s-1/2 K-1 = 272 J m-2 s-1/2 K-1
   696:                !     (Kieffer et al., 1977)
   697:                !   density,                rho = 1.65 g cm-3 = 1650 kg m-3
   698:                !     (Kieffer, 1976)
   699:                !   specific heat,          cp  = 0.14 cal g-1 K-1 = 586 J kg-1 K-1
   700:                !     (Kieffer, 1976)
   701:                !
   702:                !   heat capacity,          cp*rho = 0.97e6 J m-3 K-1
   703:                !   conduction coefficient, k = I**2 / (cp*rho) = 7.6e-2   J m-1 s-1 K-1
   704:                !
   705:            !!$    SoilHeatCap      = 0.97d6
   706:            !!$    SoilHeatDiffCoef = 0.076d0
   707:            
   708:                ! NOTE:
   709:                !   Values by Kieffer (1976) and Kieffer et al. (1977) would be appropriate for GCM
   710:                !   experiment.
   711:            
   712:            
   713:                !   Sample values for Mars
   714:                !     These values were obtained from Savijarvi (1995).
   715:                !   Reference
   716:                !     Savijarvi, H., Mars boundary layer modeling: Diurnal moisture cycle and soil
   717:                !       properties at the Viking lander 1 site, Icarus, 117, 120-127, 1995.
   718:                !
   719:            !!$    SoilHeatCap      = 0.8d6
   720:            !!$    SoilHeatDiffCoef = 0.18d0
   721:            
   722:            
   723:                ! NAMELIST ɤ߹ (ޤ Pattern Τ)
   724:                ! NAMELIST is input (At first, "Pattern" only)
   725:                !
   726:                if ( trim(namelist_filename) /= '' ) then
   727:                  call FileOpen( unit_nml, &          ! (out)
   728:                    & namelist_filename, mode = 'r' ) ! (in)
   729:            
   730:                  rewind( unit_nml )
   731:                  read( unit_nml, &             ! (in)
   732:                    & nml = surface_data_nml, & ! (out)
   733:                    & iostat = iostat_nml )     ! (out)
   734:                  close( unit_nml )
   735:            
   736:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   737:                end if
   738:            
   739:            
   740:                ! NAMELIST ɤ߹
   741:                ! NAMELIST is input
   742:                !
   743:                if ( trim(namelist_filename) /= '' ) then
   744:                  call FileOpen( unit_nml, &          ! (out)
   745:                    & namelist_filename, mode = 'r' ) ! (in)
   746:            
   747:                  rewind( unit_nml )
   748:                  read( unit_nml, &             ! (in)
   749:                    & nml = surface_data_nml, & ! (out)
   750:                    & iostat = iostat_nml )     ! (out)
   751:                  close( unit_nml )
   752:            
   753:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   754:                end if
   755:            
   756:            
   757:                !  ; Print
   758:                !
   759:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   760:                call MessageNotify( 'M', module_name, '  Pattern          = %c', c1 = trim(Pattern) )
   761:                call MessageNotify( 'M', module_name, '  SurfTemp         = %f', d = (/ SurfTemp         /) )
   762:                call MessageNotify( 'M', module_name, '  Albedo           = %f', d = (/ Albedo           /) )
   763:                call MessageNotify( 'M', module_name, '  HumidCoef        = %f', d = (/ HumidCoef        /) )
   764:                call MessageNotify( 'M', module_name, '  RoughLength      = %f', d = (/ RoughLength      /) )
   765:                call MessageNotify( 'M', module_name, '  HeatCapacity     = %f', d = (/ HeatCapacity     /) )
   766:                call MessageNotify( 'M', module_name, '  TempFlux         = %f', d = (/ TempFlux         /) )
   767:                call MessageNotify( 'M', module_name, '  SurfCond         = %d', i = (/ SurfCond         /) )
   768:                call MessageNotify( 'M', module_name, '  SeaIceConc       = %f', d = (/ SeaIceConc       /) )
   769:                call MessageNotify( 'M', module_name, '  SoilHeatCap      = %f', d = (/ SoilHeatCap      /) )
   770:                call MessageNotify( 'M', module_name, '  SoilHeatDiffCoef = %f', d = (/ SoilHeatDiffCoef /) )
   771:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   772:            
   773:                surface_data_inited = .true.
   774:            
   775:              end subroutine SurfDataInit
   776:            
   777:              !--------------------------------------------------------------------------------------
   778:            
   779:            end module surface_data
