Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:51 2012
FILE NAME: cloud_T1993base.f90
PROGRAM NAME: cloud_t1993base
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   311  opt  (  11): Fused array assignments. :line 311 - 316
   311  vec  (   4): Vectorized array expression.
   311  vec  (   4): Vectorized array expression.
   316  opt  (1592): Outer loop unrolled inside inner loop.
   322  opt  (  11): Fused array assignments. :line 322 - 326
   322  vec  (   4): Vectorized array expression.
   335  vec  (   1): Vectorized loop.
   335  vec  (   1): Vectorized loop.
   341  opt  (1592): Outer loop unrolled inside inner loop.
   347  opt  (  11): Fused array assignments. :line 347 - 349
   347  vec  (   4): Vectorized array expression.
   347  vec  (   4): Vectorized array expression.
   349  opt  (1592): Outer loop unrolled inside inner loop.
   356  opt  (1592): Outer loop unrolled inside inner loop.
   356  vec  (   4): Vectorized array expression.
   356  vec  (   4): Vectorized array expression.
   359  vec  (   1): Vectorized loop.
   368  opt  (  11): Fused array assignments. :line 368 - 372
   368  vec  (   4): Vectorized array expression.
   368  vec  (   4): Vectorized array expression.
   372  opt  (1592): Outer loop unrolled inside inner loop.
   377  vec  (   1): Vectorized loop.
   415  opt  (1592): Outer loop unrolled inside inner loop.
   415  vec  (   4): Vectorized array expression.
   415  vec  (   4): Vectorized array expression.
   417  vec  (   1): Vectorized loop.
   417  vec  (   1): Vectorized loop.
   427  opt  (1592): Outer loop unrolled inside inner loop.
   429  opt  (1592): Outer loop unrolled inside inner loop.
   429  vec  (   4): Vectorized array expression.
   429  vec  (   4): Vectorized array expression.
   430  opt  (1772): Loop nest fused with following nest(s).
   431  vec  (   1): Vectorized loop.
   468  opt  (  11): Fused array assignments. :line 468 - 485
   468  vec  (   4): Vectorized array expression.
   494  vec  (   1): Vectorized loop.
   494  vec  (   1): Vectorized loop.
   498  opt  (1592): Outer loop unrolled inside inner loop.
   500  opt  (1592): Outer loop unrolled inside inner loop.
   500  vec  (   4): Vectorized array expression.
   500  vec  (   4): Vectorized array expression.
   505  opt  (  11): Fused array assignments. :line 505 - 521
   505  vec  (   4): Vectorized array expression.
   524  vec  (   1): Vectorized loop.
   524  vec  (   1): Vectorized loop.
   528  opt  (1592): Outer loop unrolled inside inner loop.
   534  opt  (1592): Outer loop unrolled inside inner loop.
   534  vec  (   4): Vectorized array expression.
   534  vec  (   4): Vectorized array expression.
   542  vec  (   1): Vectorized loop.
   542  vec  (   1): Vectorized loop.
   550  opt  (1592): Outer loop unrolled inside inner loop.
   552  opt  (  11): Fused array assignments. :line 552 - 581
   552  vec  (   4): Vectorized array expression.
   587  opt  (1593): Loop nest collapsed into one loop.
   587  vec  (   1): Vectorized loop.
   596  opt  (1593): Loop nest collapsed into one loop.
   596  vec  (   1): Vectorized loop.
   609  vec  (   3): Unvectorized loop.
   609  vec  (  13): Overhead of loop division is too large.
   611  opt  (1017): Subroutine call prevents optimization.
   611  vec  (  17): Unvectorizable statement.
   614  vec  (  22): Dependency unknown. Unvectorizable dependency is assumed.:i
   620  opt  (  11): Fused array assignments. :line 620 - 621
   620  vec  (   4): Vectorized array expression.
   620  vec  (   4): Vectorized array expression.
   621  opt  (1592): Outer loop unrolled inside inner loop.
   633  opt  (1592): Outer loop unrolled inside inner loop.
   633  vec  (   4): Vectorized array expression.
   633  vec  (   4): Vectorized array expression.
   634  vec  (   3): Unvectorized loop.
   634  vec  (  13): Overhead of loop division is too large.
   635  opt  (1592): Outer loop unrolled inside inner loop.
   635  vec  (   4): Vectorized array expression.
   635  vec  (   4): Vectorized array expression.
   641  opt  (1592): Outer loop unrolled inside inner loop.
   641  vec  (   4): Vectorized array expression.
   641  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:51 2012
FILE NAME: cloud_T1993base.f90
PROGRAM NAME: cloud_t1993base
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Tiedtke (1993) ˴Ťǥ
     2  !
     3  != Cloud model based on Tiedtke (1993)
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: cloud_T1993base.f90,v 1.2 2012-09-17 11:00:57 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module cloud_T1993base
    13    !
    14    != Tiedtke (1993) ˴Ťǥ
    15    !
    16    != Cloud model based on Tiedtke (1993)
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ñǥˤη׻.
    21    !
    22    ! In this module, the amount of cloud is calculated by use of a simple
    23    ! cloud model.
    24    !
    25    !== Procedures List
    26    !
    27  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    28  !!$  ! ------------            :: ------------
    29  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    30    !
    31    !== NAMELIST
    32    !
    33    ! NAMELIST#cloud_T1993base_nml
    34    !
    35  
    36    ! ⥸塼 ; USE statements
    37  
    38    !
    39    ! Kind type parameter
    40    !
    41    use dc_types, only: DP, &      ! Double precision.
    42      &                 STRING, &  ! Strings.
    43      &                 TOKEN      ! Keywords.
    44  
    45    ! å
    46    ! Message output
    47    !
    48    use dc_message, only: MessageNotify
    49  
    50    ! ʻ
    51    ! Grid points settings
    52    !
    53    use gridset, only: imax, & ! ٳʻ.
    54                               ! Number of grid points in longitude
    55      &                jmax, & ! ٳʻ.
    56                               ! Number of grid points in latitude
    57      &                kmax    ! ľؿ.
    58                               ! Number of vertical level
    59  
    60    implicit none
    61  
    62    private
    63  
    64  
    65    ! ³
    66    ! Public procedure
    67    !
    68    public :: CloudT1993base
    69    public :: CloudT1993baseInit
    70  
    71  
    72    ! ѿ
    73    ! Public variables
    74    !
    75  
    76  
    77    ! ѿ
    78    ! Private variables
    79    !
    80    logical , save        :: FlagSnow
    81                             ! A flag for snow
    82  
    83    real(DP), save        :: CloudLifeTime
    84  
    85  
    86    logical, save :: cloud_T1993base_inited = .false.
    87                                ! ե饰.
    88                                ! Initialization flag
    89  
    90    character(*), parameter:: module_name = 'cloud_T1993base'
    91                                ! ⥸塼̾.
    92                                ! Module name
    93    character(*), parameter:: version = &
    94      & '$Name: dcpam5-20120921 $' // &
    95      & '$Id: cloud_T1993base.f90,v 1.2 2012-09-17 11:00:57 yot Exp $'
    96                                ! ⥸塼ΥС
    97                                ! Module version
    98  
    99    !--------------------------------------------------------------------------------------
   100  
   101  contains
   102  
   103    !----------------------------------------------------------------------------
   104    ! This subroutine, SetCloudCloudWaterAdjustWithCloudCoverV4, is
   105    ! created at 2012/08/13.
   106  
   107  !!$  call CloudT1993base(                                        &
   108  !!$    & xyz_Press, xyr_Press, xyz_VirTemp,                      & ! (in)
   109  !!$    & xyz_DQH2OLiqDtCum,                                      & ! (in)
   110  !!$    & xyz_MoistConvDetTend,                                   & ! (in)
   111  !!$    & xyz_OMG, xyz_MoistConvSubsidMassFlux, xyz_DTempDt,      & ! (in)
   112  !!$    & xyz_TempA, xyzf_QMixA(:,:,:,IndexH2OVap),               & ! (inout)
   113  !!$    & xyzf_QMixA(:,:,:,CompositionInqIndex('H2OLiq')),        & ! (inout)
   114  !!$    & xyzf_QMixA(:,:,:,CompositionInqIndex('CloudCoverTMP')), & ! (inout)
   115  !!$    & xy_Rain, xy_Snow                                        & ! (out)
   116  !!$    & )
   117  
   118  
   119    subroutine CloudT1993base(                                    &
   120      & xyz_Press, xyr_Press, xyz_VirTemp,                        & ! (in)
   121      & xyz_DQCloudWaterDtCum,                                    & ! (in)
   122      & xyz_MoistConvDetTend,                                     & ! (in)
   123      & xyz_OMG, xyz_MoistConvSubsidMassFlux, xyz_DTempDtPhy,     & ! (in)
   124      & xyz_Temp, xyz_QH2OVap,                                    & ! (inout)
   125      & xyz_QCloudWater,                                          & ! (inout)
   126      & xyz_CloudCover,                                           & ! (inout)
   127      & xy_SurfRainFlux, xy_SurfSnowFlux                          & ! (out)
   128      & )
   129  
   130      ! USE statements
   131      !
   132  
   133      ! 
   134      ! Time control
   135      !
   136      use timeset, only: &
   137        & DelTime            ! $ \Delta t $ [s]
   138  
   139      ! ʪ
   140      ! Physical and mathematical constants settings
   141      !
   142      use constants0, only: &
   143        & PI                    ! $ \pi $ .
   144                                ! ߼Ψ.  Circular constant
   145  
   146      ! ʪ
   147      ! Physical constants settings
   148      !
   149      use constants, only: &
   150        & Grav, &
   151                                ! $ g $ [m s-2].
   152                                ! ϲ®.
   153                                ! Gravitational acceleration
   154        & CpDry, &
   155                                ! $ C_p $ [J kg-1 K-1].
   156                                ! 絤갵Ǯ.
   157                                ! Specific heat of air at constant pressure
   158        & GasRDry, &
   159                                ! $ R $ [J kg-1 K-1].
   160                                ! 絤ε.
   161                                ! Gas constant of air
   162        & GasRWet, &
   163                                ! $ R_v $ [J kg-1 K-1].
   164                                ! ŷʬε.
   165                                ! Gas constant of condensible elements
   166        & LatentHeat
   167                                ! $ L $ [J kg-1] .
   168                                ! ŷǮ.
   169                                ! Latent heat of condensation
   170  
   171      ! ˰漾λ
   172      ! Evaluate saturation specific humidity
   173      !
   174      use saturate, only: xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
   175  
   176      ! 絬϶ŷ (ήŷ)
   177      ! Large scale condensation
   178      !
   179      use lscond, only: LScaleCond
   180  
   181      ! طϥ롼
   182      ! Cloud-related routines
   183      !
   184      use cloud_utils, only : CloudUtilsCalcPRCPKeyLLTemp
   185  
   186  
   187      real(DP), intent(in   ) :: xyz_Press                  (0:imax-1, 1:jmax, 1:kmax)
   188      real(DP), intent(in   ) :: xyr_Press                  (0:imax-1, 1:jmax, 0:kmax)
   189      real(DP), intent(in   ) :: xyz_VirTemp                (0:imax-1, 1:jmax, 1:kmax)
   190      real(DP), intent(in   ) :: xyz_DQCloudWaterDtCum      (0:imax-1, 1:jmax, 1:kmax)
   191      real(DP), intent(in   ) :: xyz_MoistConvDetTend       (0:imax-1, 1:jmax, 1:kmax)
   192      real(DP), intent(in   ) :: xyz_OMG                    (0:imax-1, 1:jmax, 1:kmax)
   193      real(DP), intent(in   ) :: xyz_MoistConvSubsidMassFlux(0:imax-1, 1:jmax, 1:kmax)
   194      real(DP), intent(in   ) :: xyz_DTempDtPhy             (0:imax-1, 1:jmax, 1:kmax)
   195      real(DP), intent(inout) :: xyz_Temp                   (0:imax-1, 1:jmax, 1:kmax)
   196      real(DP), intent(inout) :: xyz_QH2OVap                (0:imax-1, 1:jmax, 1:kmax)
   197      real(DP), intent(inout) :: xyz_QCloudWater            (0:imax-1, 1:jmax, 1:kmax)
   198      real(DP), intent(inout) :: xyz_CloudCover             (0:imax-1, 1:jmax, 1:kmax)
   199      real(DP), intent(out)   :: xy_SurfRainFlux            (0:imax-1, 1:jmax)
   200      real(DP), intent(out)   :: xy_SurfSnowFlux            (0:imax-1, 1:jmax)
   201  
   202  
   203      real(DP) :: xyz_QCloudWaterB     (0:imax-1, 1:jmax, 1:kmax)
   204  
   205      real(DP) :: xyz_QH2OVapSat       (0:imax-1, 1:jmax, 1:kmax)
   206      real(DP) :: xyz_DQH2OVapSatDPress(0:imax-1, 1:jmax, 1:kmax)
   207      real(DP) :: xyz_DQH2OVapSatDTemp (0:imax-1, 1:jmax, 1:kmax)
   208      real(DP) :: xyz_DQH2OVapSatDt    (0:imax-1, 1:jmax, 1:kmax)
   209  
   210      real(DP) :: xyz_ZeroOneDQsDt    (0:imax-1, 1:jmax, 1:kmax)
   211      real(DP) :: xyz_DelCloudCoverStr(0:imax-1, 1:jmax, 1:kmax)
   212      real(DP) :: xyz_FactA           (0:imax-1, 1:jmax, 1:kmax)
   213      real(DP) :: xyz_FactA1          (0:imax-1, 1:jmax, 1:kmax)
   214      real(DP) :: xyz_FactA2          (0:imax-1, 1:jmax, 1:kmax)
   215      real(DP) :: xyz_FactB           (0:imax-1, 1:jmax, 1:kmax)
   216      real(DP) :: xyz_FactC           (0:imax-1, 1:jmax, 1:kmax)
   217      real(DP) :: xyz_FactC1          (0:imax-1, 1:jmax, 1:kmax)
   218      real(DP) :: xyz_FactC2          (0:imax-1, 1:jmax, 1:kmax)
   219      real(DP) :: xyz_FactD           (0:imax-1, 1:jmax, 1:kmax)
   220      real(DP) :: xyz_FactE           (0:imax-1, 1:jmax, 1:kmax)
   221      real(DP) :: xyz_FactE1          (0:imax-1, 1:jmax, 1:kmax)
   222      real(DP) :: xyz_FactE2          (0:imax-1, 1:jmax, 1:kmax)
   223  
   224      real(DP) :: xy_Rain                    (0:imax-1, 1:jmax)
   225      real(DP) :: xyz_Rain                   (0:imax-1, 1:jmax, 1:kmax)
   226      real(DP) :: xy_RainConvFactor          (0:imax-1, 1:jmax)
   227      real(DP) :: xy_FactCo                  (0:imax-1, 1:jmax)
   228      real(DP) :: xy_FactBF                  (0:imax-1, 1:jmax)
   229      real(DP) :: xy_QCloudWaterConvThreshold(0:imax-1, 1:jmax)
   230  
   231      real(DP) :: xyz_DTempDtLSC             (0:imax-1, 1:jmax, 1:kmax)
   232      real(DP) :: xyz_DQVapDtLSC             (0:imax-1, 1:jmax, 1:kmax)
   233      real(DP) :: xyz_RainLSC                (0:imax-1, 1:jmax, 1:kmax)
   234      real(DP) :: xy_RainLSC                 (0:imax-1, 1:jmax)
   235  
   236  
   237      real(DP), parameter :: MixCoef                  = 1.0d-6
   238      real(DP), parameter :: QCloudWaterEvapThreshold = 1.0d-10
   239  !!$    real(DP), parameter :: RHThreshold              = 0.999_DP
   240      real(DP), parameter :: RHThreshold              = 1.0_DP - 1.0d-10
   241      ! Values below are obtained from Sundqvist et al. (1989), but some of
   242      ! those are arbitrarily selected.
   243      real(DP), parameter :: C0                       = 1.0d-3
   244      real(DP), parameter :: C1                       = 300.0_DP
   245      real(DP), parameter :: C2                       = 0.5_DP
   246      real(DP), parameter :: QCloudWaterConvThreshold = 4.0d-4
   247  
   248  
   249      ! Parameters for evaporation of rain
   250      real(DP), parameter :: DensWater            = 1.0d3
   251      !                            rho_w
   252      !   Values below are from Kessler (1969)
   253      real(DP), parameter :: RainFallVelFactor         = 130.0d0
   254      !                            K
   255      real(DP), parameter :: MedianDiameterFactor      = 3.67d0
   256      !                            C'
   257      real(DP), parameter :: RainDistFactor            = 1.0d7
   258      !                            N0
   259      real(DP), parameter :: RainEvapRatUnitDiamFactor = 2.24d3
   260      !                            C
   261      real(DP), parameter :: H2OVapDiffCoef            = 1.0d-5
   262      !                            Kd
   263  
   264      real(DP) :: Dens0
   265      !                            rho_0
   266      real(DP) :: V00
   267      !                            V_{00}
   268      real(DP) :: RainEvapFactor
   269  
   270      real(DP) :: xyz_Dens        (0:imax-1, 1:jmax, 1:kmax)
   271      !                           rho
   272      real(DP) :: xy_DensRain     (0:imax-1, 1:jmax)
   273      !                           (rho q_r)
   274      real(DP) :: xy_RainArea     (0:imax-1, 1:jmax)
   275      !                           a_p
   276      real(DP) :: xy_RainEvapArea (0:imax-1, 1:jmax)
   277      !                           A = max( a_p - a, 0 )
   278      real(DP) :: xyz_RainEvapRate(0:imax-1, 1:jmax, 1:kmax)
   279  
   280      real(DP) :: xy_DelRain      (0:imax-1, 1:jmax)
   281      real(DP) :: DelQH2OVap
   282  
   283      real(DP) :: RainFallVel
   284  
   285      integer :: i
   286      integer :: j
   287      integer :: k
   288  
   289  
   290      ! ¹ʸ ; Executable statement
   291      !
   292  
   293      ! ǧ
   294      ! Initialization check
   295      !
   296      if ( .not. cloud_T1993base_inited ) then
   297        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   298      end if
   299  
   300  
   301      ! Parameters for evaporation of rain
   302      Dens0 = 1013.0d2 / ( GasRDry * 300.0_DP )
   303      V00 = RainFallVelFactor * sqrt( MedianDiameterFactor ) &
   304        & / ( PI * DensWater * RainDistFactor )**(1.0d0/8.0d0)
   305      RainEvapFactor =                                      &
   306  !      & RainEvapRatUnitDiamFactor * gamma( 13.0d0/5.0d0 ) &
   307        & RainEvapRatUnitDiamFactor * 1.429624558860304d0   &
   308        & * H2OVapDiffCoef * RainDistFactor**(7.0d0/20.0d0) &
   309        & / ( PI * DensWater )**(13.0d0/20.0d0)
   310      ! Values for evaporation of rain
   311      xyz_Dens = xyz_Press / ( GasRDry * xyz_VirTemp )
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t1792 = 1, J1                                               
     .  !CDIR       NODEP                                                       
     .              do t1794 = 1, imax                                          
     .                 xyz_dens(t1794-1,t1792,t1790+1) = xyz_press(t1794-1,t1792
     .       1            ,t1790+1)/(gasrdry*xyz_virtemp(t1794-1,t1792,t1790+1))
     .                 xyz_qcloudwaterb(t1794-1,t1792,t1790+1) = xyz_qcloudwater
     .       1            (t1794-1,t1792,t1790+1)                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1792 = J1 + 1, jmax, 2                                     
     .  !CDIR       NODEP                                                       
     .              do t1794 = 1, imax                                          
     .                 xyz_dens(t1794-1,t1792,t1790+1) = xyz_press(t1794-1,t1792
     .       1            ,t1790+1)/(gasrdry*xyz_virtemp(t1794-1,t1792,t1790+1))
     .                 xyz_dens(t1794-1,t1792+1,t1790+1) = xyz_press(t1794-1,   
     .       1            t1792+1,t1790+1)/(gasrdry*xyz_virtemp(t1794-1,t1792+1,
     .       2            t1790+1))                                             
     .                 xyz_qcloudwaterb(t1794-1,t1792,t1790+1) = xyz_qcloudwater
     .       1            (t1794-1,t1792,t1790+1)                               
     .                 xyz_qcloudwaterb(t1794-1,t1792+1,t1790+1) =              
     .       1            xyz_qcloudwater(t1794-1,t1792+1,t1790+1)              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   312  
   313  
   314      ! Save cloud water amount
   315      !
   316      xyz_QCloudWaterB = xyz_QCloudWater
   317  
   318  
   319      xyz_QH2OVapSat       = xyz_CalcQVapSat( xyz_Temp, xyz_Press )
   320      xyz_DQH2OVapSatDTemp = xyz_CalcDQVapSatDTemp( xyz_Temp, xyz_QH2OVapSat )
   321  
   322      xyz_DQH2OVapSatDPress = xyz_QH2OVapSat / xyz_Press                           &
     .        D1 = latentheat/cpdry                                             
     .  !CDIR NODEP                                                             
     .        do t1815 = 1, t211 + 1                                            
     .           xyz_dqh2ovapsatdpress1 = xyz_qh2ovapsat(t1815-1,t1813+1,t1811+1
     .       1      )/xyz_press(t1815-1,t1813+1,t1811+1)*(latentheat*gasrdry*   
     .       2      xyz_virtemp(t1815-1,t1813+1,t1811+1)-((cpdry*gasrwet)*(     
     .       3      xyz_temp(t1815-1,t1813+1,t1811+1)**2)))/(xyz_cloudcover(    
     .       4      t1815-1,t1813+1,t1811+1)*latentheat**2*xyz_qh2ovapsat(t1815-
     .       5      1,t1813+1,t1811+1)+((cpdry*gasrwet)*(xyz_temp(t1815-1,t1813+
     .       6      1,t1811+1)**2)))                                            
     .           xyz_dqh2ovapsatdt(t1815-1,t1813+1,t1811+1) =                   
     .       1      xyz_dqh2ovapsatdpress1*(xyz_omg(t1815-1,t1813+1,t1811+1)+   
     .       2      grav*xyz_moistconvsubsidmassflux(t1815-1,t1813+1,t1811+1))  
     .       3       + xyz_dqh2ovapsatdtemp(t1815-1,t1813+1,t1811+1)/(          
     .       4      1.00000000000000e+000 + xyz_cloudcover(t1815-1,t1813+1,t1811
     .       5      +1)*D1*xyz_dqh2ovapsatdtemp(t1815-1,t1813+1,t1811+1))*      
     .       6      xyz_dtempdtphy(t1815-1,t1813+1,t1811+1)                     
     .        end do                                                            
   323        & * ( LatentHeat * GasRDry * xyz_VirTemp - CpDry * GasRWet * xyz_Temp**2 ) &
   324        & / ( xyz_CloudCover * LatentHeat**2 * xyz_QH2OVapSat + CpDry * GasRWet * xyz_Temp**2 )
   325  
   326      xyz_DQH2OVapSatDt =                                                            &
   327        &   xyz_DQH2OVapSatDPress * ( xyz_OMG + Grav * xyz_MoistConvSubsidMassFlux ) &
   328        & + xyz_DQH2OVapSatDTemp                                                      &
   329        &   / ( 1.0_DP + xyz_CloudCover * LatentHeat / CpDry * xyz_DQH2OVapSatDTemp ) &
   330        &   * xyz_DTempDtPhy
   331  
   332  
   333      do k = 1, kmax
   334        do j = 1, jmax
   335          do i = 0, imax-1
   336            if ( xyz_DQH2OVapSatDt(i,j,k) < 0.0_DP ) then
   337              xyz_ZeroOneDQsDt(i,j,k) = 1.0_DP
   338            else
   339              xyz_ZeroOneDQsDt(i,j,k) = 0.0_DP
   340            end if
   341          end do
   342        end do
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,1)                                               
     .           do j = 1, J2                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_dqh2ovapsatdt(i-1,j,k) .lt.                      
     .       1            0.0000000000000000e+000) then                         
     .                    xyz_zeroonedqsdt(i-1,j,k) = 1.00000000000000e+000     
     .                 else                                                     
     .                    xyz_zeroonedqsdt(i-1,j,k) = 0.0000000000000000e+000   
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J2 + 1, jmax, 2                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_dqh2ovapsatdt(i-1,j,k) .lt.                      
     .       1            0.0000000000000000e+000) then                         
     .                    xyz_zeroonedqsdt(i-1,j,k) = 1.00000000000000e+000     
     .                 else                                                     
     .                    xyz_zeroonedqsdt(i-1,j,k) = 0.0000000000000000e+000   
     .                 endif                                                    
     .                 if (xyz_dqh2ovapsatdt(i-1,j+1,k) .lt.                    
     .       1            0.0000000000000000e+000) then                         
     .                    xyz_zeroonedqsdt(i-1,j+1,k) = 1.00000000000000e+000   
     .                 else                                                     
     .                    xyz_zeroonedqsdt(i-1,j+1,k) = 0.0000000000000000e+000 
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   343      end do
   344  
   345  
   346      ! Rain at the surface
   347      xy_Rain     = 0.0_DP
     .        if (xy_rain.DSC.U2 .gt. 0) then                                   
     .           J3 = and(xy_rain.DSC.U2,1)                                     
     .  !CDIR    NODEP                                                          
     .           do t1865 = 1, J3                                               
     .  !CDIR       NODEP                                                       
     .              do t1867 = 1, xy_rain.DSC.U1 + 1                            
     .                 xy_rain(t1867-1,t1865) = 0.0000000000000000e+000         
     .                 xy_rainarea(t1867-1,t1865) = 0.0000000000000000e+000     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1865 = J3 + 1, xy_rain.DSC.U2, 2                           
     .  !CDIR       NODEP                                                       
     .              do t1867 = 1, xy_rain.DSC.U1 + 1                            
     .                 xy_rain(t1867-1,t1865) = 0.0000000000000000e+000         
     .                 xy_rain(t1867-1,t1865+1) = 0.0000000000000000e+000       
     .                 xy_rainarea(t1867-1,t1865) = 0.0000000000000000e+000     
     .                 xy_rainarea(t1867-1,t1865+1) = 0.0000000000000000e+000   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   348      ! Rain area
   349      xy_RainArea = 0.0_DP
   350  
   351      k_loop : do k = kmax, 1, -1
   352  
   353        ! Evaporation of rain
   354        !
   355        if ( k == kmax ) then
   356          xy_RainArea = 0.0_DP
     .        if (xy_rainarea.DSC.U2 .gt. 0) then                               
     .           J4 = and(xy_rainarea.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t2149 = 1, J4                                               
     .  !CDIR       NODEP                                                       
     .              do t2151 = 1, xy_rainarea.DSC.U1 + 2 - min0(1,              
     .       1         xy_rainarea.DSC.U1 + 1)                                  
     .                 xy_rainarea(t2151-1,t2149) = 0.0000000000000000e+000     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t2149 = J4 + 1, xy_rainarea.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t2151 = 1, xy_rainarea.DSC.U1 + 2 - min0(1,              
     .       1         xy_rainarea.DSC.U1 + 1)                                  
     .                 xy_rainarea(t2151-1,t2149) = 0.0000000000000000e+000     
     .                 xy_rainarea(t2151-1,t2149+1) = 0.0000000000000000e+000   
     .                 xy_rainarea(t2151-1,t2149+2) = 0.0000000000000000e+000   
     .                 xy_rainarea(t2151-1,t2149+3) = 0.0000000000000000e+000   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
     .        go to 10042                                                       
   357        else
   358          do j = 1, jmax
   359            do i = 0, imax-1
   360              if ( xyz_Rain(i,j,k+1) > 0.0_DP ) then
   361                if ( xyz_CloudCover(i,j,k+1) > xy_RainArea(i,j) ) then
   362                  xy_RainArea(i,j) = xyz_CloudCover(i,j,k+1)
   363                end if
   364              end if
   365            end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax                                                    
     .           if (xyz_rain(i-1,j,k+1) .gt. 0.0000000000000000e+000) then     
     .              if (xyz_cloudcover(i-1,j,k+1) .gt. xy_rainarea(i-1,j)) then 
     .                 xy_rainarea(i-1,j) = xyz_cloudcover(i-1,j,k+1)           
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
   366          end do
   367        end if
   368        xy_DensRain =                                                      &
     .        if (xy_rain.DSC.U2 .gt. 0) then                                   
     .           J5 = and(xy_rain.DSC.U2,1)                                     
     .  !CDIR    NODEP                                                          
     .           do t1873 = 1, J5                                               
     .  !CDIR       NODEP                                                       
     .              do t1875 = 1, xy_rain.DSC.U1 + 1                            
     .                 xy_densrain(t1875-1,t1873) = (xy_rain(t1875-1,t1873)/((  
     .       1            xy_rainarea(t1875-1,t1873)+1.00000000000000e-010)*v00*
     .       2            dsqrt(dens0/xyz_dens(t1875-1,t1873,k))))**            
     .       3            8.88888888888888e-001                                 
     .                 xy_rainevaparea1 = max(xy_rainarea(t1875-1,t1873)-       
     .       1            xyz_cloudcover(t1875-1,t1873,k),                      
     .       2            0.0000000000000000e+000)                              
     .                 xyz_rainevaprate(t1875-1,t1873,k) = xyz_dens(t1875-1,    
     .       1            t1873,k)*xy_rainevaparea1*rainevapfactor*max(         
     .       2            xyz_qh2ovapsat(t1875-1,t1873,k)-xyz_qh2ovap(t1875-1,  
     .       3            t1873,k),0.0000000000000000e+000)*xy_densrain(t1875-1,
     .       4            t1873)**6.50000000000000e-001                         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1873 = J5 + 1, xy_rain.DSC.U2, 2                           
     .  !CDIR       NODEP                                                       
     .              do t1875 = 1, xy_rain.DSC.U1 + 1                            
     .                 xy_densrain(t1875-1,t1873) = (xy_rain(t1875-1,t1873)/((  
     .       1            xy_rainarea(t1875-1,t1873)+1.00000000000000e-010)*v00*
     .       2            dsqrt(dens0/xyz_dens(t1875-1,t1873,k))))**            
     .       3            8.88888888888888e-001                                 
     .                 xy_densrain(t1875-1,t1873+1) = (xy_rain(t1875-1,t1873+1)/
     .       1            ((xy_rainarea(t1875-1,t1873+1)+1.00000000000000e-010)*
     .       2            v00*dsqrt(dens0/xyz_dens(t1875-1,t1873+1,k))))**      
     .       3            8.88888888888888e-001                                 
     .                 xy_rainevaparea(t1875-1,t1873) = max(xy_rainarea(t1875-1,
     .       1            t1873)-xyz_cloudcover(t1875-1,t1873,k),               
     .       2            0.0000000000000000e+000)                              
     .                 xy_rainevaparea(t1875-1,t1873+1) = max(xy_rainarea(t1875-
     .       1            1,t1873+1)-xyz_cloudcover(t1875-1,t1873+1,k),         
     .       2            0.0000000000000000e+000)                              
     .                 xyz_rainevaprate(t1875-1,t1873,k) = xyz_dens(t1875-1,    
     .       1            t1873,k)*xy_rainevaparea(t1875-1,t1873)*rainevapfactor
     .       2            *max(xyz_qh2ovapsat(t1875-1,t1873,k)-xyz_qh2ovap(t1875
     .       3            -1,t1873,k),0.0000000000000000e+000)*xy_densrain(t1875
     .       4            -1,t1873)**6.50000000000000e-001                      
     .                 xyz_rainevaprate(t1875-1,t1873+1,k) = xyz_dens(t1875-1,  
     .       1            t1873+1,k)*xy_rainevaparea(t1875-1,t1873+1)*          
     .       2            rainevapfactor*max(xyz_qh2ovapsat(t1875-1,t1873+1,k)- 
     .       3            xyz_qh2ovap(t1875-1,t1873+1,k),0.0000000000000000e+000
     .       4            )*xy_densrain(t1875-1,t1873+1)**6.50000000000000e-001 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   369          & ( xy_Rain / ( xy_RainArea + 1.0d-10 )                          &
   370          &   / ( V00 * sqrt( Dens0 / xyz_Dens(:,:,k) ) ) )**(8.0d0/9.0d0)
   371        xy_RainEvapArea = max( xy_RainArea - xyz_CloudCover(:,:,k), 0.0_DP )
   372        xyz_RainEvapRate(:,:,k) =                                         &
   373          & xyz_Dens(:,:,k) * xy_RainEvapArea * RainEvapFactor            &
   374          &   * max( xyz_QH2OVapSat(:,:,k) - xyz_QH2OVap(:,:,k), 0.0_DP ) &
   375          &   * xy_DensRain**(13.0d0/20.0d0)
   376        do j = 1, jmax
   377          do i = 0, imax-1
   378            RainFallVel =                             &
   379              & V00 * sqrt( Dens0 / xyz_Dens(i,j,k) ) &
   380              &   * xy_DensRain(i,j)**(1.0d0/8.0d0)
   381            if ( xy_RainArea(i,j) * RainFallVel * xyz_RainEvapRate(i,j,k) &
   382              &    * 2.0_DP * DelTime                                     &
   383              &      > xy_Rain(i,j) ) then
   384              xyz_RainEvapRate(i,j,k) =                              &
   385                & xy_Rain(i,j)                                       &
   386                &   / ( ( xy_RainArea(i,j) + 1.0d-10 ) * RainFallVel &
   387                &       * 2.0_DP * DelTime )
   388              xy_DelRain(i,j) = - xy_Rain(i,j)
   389            else
   390              xy_DelRain(i,j) =                                    &
   391                & - xy_RainArea(i,j) * RainFallVel                 &
   392                & * xyz_RainEvapRate(i,j,k) * ( 2.0_DP * DelTime )
   393            end if
   394            xy_Rain(i,j) = xy_Rain(i,j) + xy_DelRain(i,j)
   395  !!$            xyz_QH2OVap(i,j,k) = xyz_QH2OVap(i,j,k)              &
   396  !!$              & + xyz_RainEvapRate(i,j,k) * ( 2.0_DP * DelTime ) &
   397  !!$              &     / xyz_Dens(i,j,k)
   398  !!$            xyz_Temp(i,j,k) = xyz_Temp(i,j,k)                    &
   399  !!$              & - xyz_RainEvapRate(i,j,k) * ( 2.0_DP * DelTime ) &
   400  !!$              &     / xyz_Dens(i,j,k)                            &
   401  !!$              &     * LatentHeat / CpDry
   402            ! DelRain = DelQH2OVap * DelPress / Grav / ( 2.0_DP * DelTime )
   403            DelQH2OVap =                                             &
   404              & - xy_DelRain(i,j) * ( 2.0_DP * DelTime )             &
   405              &   * Grav / ( xyr_Press(i,j,k-1) - xyr_Press(i,j,k) )
   406            xyz_QH2OVap(i,j,k) = xyz_QH2OVap(i,j,k)                  &
   407              & + DelQH2OVap
   408            xyz_Temp(i,j,k) = xyz_Temp(i,j,k)                        &
   409              & - DelQH2OVap                                         &
   410              &   * LatentHeat / CpDry
   411          end do
     .        D4 = latentheat/cpdry                                             
     .  !CDIR NODEP                                                             
     .        do i = 1, imax                                                    
     .           rainfallvel = v00*dsqrt(dens0/xyz_dens(i-1,j,k))*xy_densrain(i-
     .       1      1,j)**1.25000000000000e-001                                 
     .           if ((2.00000000000000e+000*deltime)*(xy_rainarea(i-1,j)*       
     .       1      rainfallvel)*xyz_rainevaprate(i-1,j,k) .gt. xy_rain(i-1,j)) 
     .       2      then                                                        
     .              xyz_rainevaprate(i-1,j,k) = xy_rain(i-1,j)/((xy_rainarea(i-1
     .       1         ,j)+1.00000000000000e-010)*rainfallvel*                  
     .       2         2.00000000000000e+000*deltime)                           
     .              xy_delrain(i-1,j) = -xy_rain(i-1,j)                         
     .           else                                                           
     .              xy_delrain(i-1,j) = -(xy_rainarea(i-1,j)*rainfallvel)*      
     .       1         xyz_rainevaprate(i-1,j,k)*(2.00000000000000e+000*deltime)
     .           endif                                                          
     .           xy_rain(i-1,j) = xy_rain(i-1,j) + xy_delrain(i-1,j)            
     .           delqh2ovap = -xy_delrain(i-1,j)*(2.00000000000000e+000*deltime)
     .       1      *grav/(xyr_press(i-1,j,k-1)-xyr_press(i-1,j,k))             
     .           xyz_qh2ovap(i-1,j,k) = xyz_qh2ovap(i-1,j,k) + delqh2ovap       
     .           xyz_temp(i-1,j,k) = xyz_temp(i-1,j,k) - delqh2ovap*D4          
     .        end do                                                            
   412        end do
   413  
   414  
   415        xyz_FactC1(:,:,k) = xyz_MoistConvDetTend(:,:,k)
     .        if (xyz_factc1.DSC.U2 .gt. 0) then                                
     .           J6 = and(xyz_factc1.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t1903 = 1, J6                                               
     .  !CDIR       NODEP                                                       
     .              do t1905 = 1, xyz_factc1.DSC.U1 + 1                         
     .                 xyz_factc1(t1905-1,t1903,k) = xyz_moistconvdettend(t1905-
     .       1            1,t1903,k)                                            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1903 = J6 + 1, xyz_factc1.DSC.U2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t1905 = 1, xyz_factc1.DSC.U1 + 1                         
     .                 xyz_factc1(t1905-1,t1903,k) = xyz_moistconvdettend(t1905-
     .       1            1,t1903,k)                                            
     .                 xyz_factc1(t1905-1,t1903+1,k) = xyz_moistconvdettend(    
     .       1            t1905-1,t1903+1,k)                                    
     .                 xyz_factc1(t1905-1,t1903+2,k) = xyz_moistconvdettend(    
     .       1            t1905-1,t1903+2,k)                                    
     .                 xyz_factc1(t1905-1,t1903+3,k) = xyz_moistconvdettend(    
     .       1            t1905-1,t1903+3,k)                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   416        do j = 1, jmax
   417          do i = 0, imax-1
   418            if ( xyz_QH2OVap(i,j,k) < RHThreshold * xyz_QH2OVapSat(i,j,k) ) then
   419              xyz_FactC2(i,j,k) =                                         &
   420                & - ( 1.0_DP - xyz_CloudCover(i,j,k) )                    &
   421                &   / ( xyz_QH2OVapSat(i,j,k) - xyz_QH2OVap(i,j,k) )      &
   422                &   * xyz_DQH2OVapSatDt(i,j,k) * xyz_ZeroOneDQsDt(i,j,k)
   423            else
   424  !!$              xyz_FactC2(i,j,k) = 0.0_DP
   425              xyz_FactC2(i,j,k) = 1.0_DP / ( 2.0_DP * DelTime )
   426            end if
   427          end do
   428        end do
     .        if (jmax .gt. 0) then                                             
     .           J7 = and(jmax,1)                                               
     .           do j = 1, J7                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_qh2ovap(i-1,j,k) .lt. 9.99999999899999e-001*     
     .       1            xyz_qh2ovapsat(i-1,j,k)) then                         
     .                    xyz_factc2(i-1,j,k) = -(1.00000000000000e+000 -       
     .       1               xyz_cloudcover(i-1,j,k))/(xyz_qh2ovapsat(i-1,j,k)- 
     .       2               xyz_qh2ovap(i-1,j,k))*xyz_dqh2ovapsatdt(i-1,j,k)*  
     .       3               xyz_zeroonedqsdt(i-1,j,k)                          
     .                 else                                                     
     .                    xyz_factc2(i-1,j,k) = 1.00000000000000e+000/(         
     .       1               2.00000000000000e+000*deltime)                     
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J7 + 1, jmax, 2                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_qh2ovap(i-1,j,k) .lt. 9.99999999899999e-001*     
     .       1            xyz_qh2ovapsat(i-1,j,k)) then                         
     .                    xyz_factc2(i-1,j,k) = -(1.00000000000000e+000 -       
     .       1               xyz_cloudcover(i-1,j,k))/(xyz_qh2ovapsat(i-1,j,k)- 
     .       2               xyz_qh2ovap(i-1,j,k))*xyz_dqh2ovapsatdt(i-1,j,k)*  
     .       3               xyz_zeroonedqsdt(i-1,j,k)                          
     .                 else                                                     
     .                    xyz_factc2(i-1,j,k) = 1.00000000000000e+000/(         
     .       1               2.00000000000000e+000*deltime)                     
     .                 endif                                                    
     .                 if (xyz_qh2ovap(i-1,j+1,k) .lt. 9.99999999899999e-001*   
     .       1            xyz_qh2ovapsat(i-1,j+1,k)) then                       
     .                    xyz_factc2(i-1,j+1,k) = -(1.00000000000000e+000 -     
     .       1               xyz_cloudcover(i-1,j+1,k))/(xyz_qh2ovapsat(i-1,j+1,
     .       2               k)-xyz_qh2ovap(i-1,j+1,k))*xyz_dqh2ovapsatdt(i-1,j+
     .       3               1,k)*xyz_zeroonedqsdt(i-1,j+1,k)                   
     .                 else                                                     
     .                    xyz_factc2(i-1,j+1,k) = 1.00000000000000e+000/(       
     .       1               2.00000000000000e+000*deltime)                     
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   429        xyz_FactC(:,:,k) = xyz_FactC1(:,:,k) + xyz_FactC2(:,:,k)
     .        if (xyz_factc1.DSC.U2 .gt. 0) then                                
     .           J8 = and(xyz_factc1.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t1911 = 1, J8                                               
     .  !CDIR       NODEP                                                       
     .              do t1913 = 1, xyz_factc1.DSC.U1 + 1                         
     .                 xyz_factc(t1913-1,t1911,k) = xyz_factc1(t1913-1,t1911,k) 
     .       1             + xyz_factc2(t1913-1,t1911,k)                        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1911 = J8 + 1, xyz_factc1.DSC.U2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t1913 = 1, xyz_factc1.DSC.U1 + 1                         
     .                 xyz_factc(t1913-1,t1911,k) = xyz_factc1(t1913-1,t1911,k) 
     .       1             + xyz_factc2(t1913-1,t1911,k)                        
     .                 xyz_factc(t1913-1,t1911+1,k) = xyz_factc1(t1913-1,t1911+1
     .       1            ,k) + xyz_factc2(t1913-1,t1911+1,k)                   
     .                 xyz_factc(t1913-1,t1911+2,k) = xyz_factc1(t1913-1,t1911+2
     .       1            ,k) + xyz_factc2(t1913-1,t1911+2,k)                   
     .                 xyz_factc(t1913-1,t1911+3,k) = xyz_factc1(t1913-1,t1911+3
     .       1            ,k) + xyz_factc2(t1913-1,t1911+3,k)                   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   430        do j = 1, jmax
   431          do i = 0, imax-1
   432            if ( xyz_QH2OVapSat(i,j,k) > xyz_QH2OVap(i,j,k) ) then
   433              xyz_FactD(i,j,k) =                                      &
   434                & 2.0_DP * xyz_CloudCover(i,j,k) * MixCoef            &
   435                & * ( xyz_QH2OVapSat(i,j,k) - xyz_QH2OVap(i,j,k) )    &
   436                & / ( xyz_QCloudWater(i,j,k) + 1.0d-100 )
   437            else
   438              xyz_FactD(i,j,k) = 0.0_DP
   439            end if
   440          end do
   441        end do
   442        !
   443        do j = 1, jmax
   444          do i = 0, imax-1
   445            if ( xyz_QH2OVap(i,j,k) < RHThreshold * xyz_QH2OVapSat(i,j,k) ) then
   446              xyz_FactE1(i,j,k) =                                             &
   447                &   ( 1.0_DP - xyz_CloudCover(i,j,k) )**2                     &
   448                & / ( 2.0_DP                                                  &
   449                &       * ( xyz_QH2OVapSat(i,j,k) - xyz_QH2OVap(i,j,k) ) )    &
   450                & * xyz_DQH2OVapSatDt(i,j,k) * xyz_ZeroOneDQsDt(i,j,k)
   451            else
   452              xyz_FactE1(i,j,k) = 0.0_DP
   453            end if
   454          end do
   455        end do
   456        do j = 1, jmax
   457          do i = 0, imax-1
   458            if ( xyz_QH2OVapSat(i,j,k) > xyz_QH2OVap(i,j,k) ) then
   459              xyz_FactE2(i,j,k) =                                     &
   460                & + xyz_CloudCover(i,j,k)**2 * MixCoef                &
   461                & * ( xyz_QH2OVapSat(i,j,k) - xyz_QH2OVap(i,j,k) )    &
   462                & / ( xyz_QCloudWater(i,j,k) + 1.0d-100 )
   463            else
   464              xyz_FactE2(i,j,k) = 0.0_DP
   465            end if
   466          end do
   467        end do
     .        do j = 1, jmax                                                    
     .  !CDIR    NODEP                                                          
     .           do i = 1, imax                                                 
     .              if ((xyz_qh2ovapsat(i-1,j,k).gt.xyz_qh2ovap(i-1,j,k))) then 
     .                 xyz_factd(i-1,j,k) = 2.00000000000000e+000*xyz_cloudcover
     .       1            (i-1,j,k)*9.99999999999999e-007*(xyz_qh2ovapsat(i-1,j,
     .       2            k)-xyz_qh2ovap(i-1,j,k))/(xyz_qcloudwater(i-1,j,k)+   
     .       3            1.00000000000000e-100)                                
     .              else                                                        
     .                 xyz_factd(i-1,j,k) = 0.0000000000000000e+000             
     .              endif                                                       
     .              if (xyz_qh2ovap(i-1,j,k) .lt. 9.99999999899999e-001*        
     .       1         xyz_qh2ovapsat(i-1,j,k)) then                            
     .                 xyz_facte1(i-1,j,k) = (1.00000000000000e+000 -           
     .       1            xyz_cloudcover(i-1,j,k))**2/(2.00000000000000e+000*(  
     .       2            xyz_qh2ovapsat(i-1,j,k)-xyz_qh2ovap(i-1,j,k)))*       
     .       3            xyz_dqh2ovapsatdt(i-1,j,k)*xyz_zeroonedqsdt(i-1,j,k)  
     .              else                                                        
     .                 xyz_facte1(i-1,j,k) = 0.0000000000000000e+000            
     .              endif                                                       
     .              if ((xyz_qh2ovapsat(i-1,j,k).gt.xyz_qh2ovap(i-1,j,k))) then 
     .                 xyz_facte2(i-1,j,k) = xyz_cloudcover(i-1,j,k)**2*        
     .       1            9.99999999999999e-007*(xyz_qh2ovapsat(i-1,j,k)-       
     .       2            xyz_qh2ovap(i-1,j,k))/(xyz_qcloudwater(i-1,j,k)+      
     .       3            1.00000000000000e-100)                                
     .              else                                                        
     .                 xyz_facte2(i-1,j,k) = 0.0000000000000000e+000            
     .              endif                                                       
     .           end do                                                         
     .        end do                                                            
   468        xyz_FactE(:,:,k) = xyz_FactE1(:,:,k) + xyz_FactE2(:,:,k)
     .        D5 = 1.D0/2.00000000000000e+000                                   
     .  !CDIR NODEP                                                             
     .        do t1923 = 1, xyz_facte1.DSC.U1 + 1                               
     .           xyz_facte(t1923-1,t1921+1,k) = xyz_facte1(t1923-1,t1921+1,k) + 
     .       1      xyz_facte2(t1923-1,t1921+1,k)                               
     .           xyz_delcloudcoverstr1 = (2.00000000000000e+000*deltime)*       
     .       1      xyz_factc2(t1923-1,t1921+1,k) - xyz_factc2(t1923-1,t1921+1,k
     .       2      )/((xyz_factc(t1923-1,t1921+1,k)+xyz_factd(t1923-1,t1921+1,k
     .       3      ))+1.00000000000000e-100)*((2.00000000000000e+000*deltime)* 
     .       4      xyz_factc(t1923-1,t1921+1,k)+(xyz_cloudcover(t1923-1,t1921+1
     .       5      ,k)-xyz_factc(t1923-1,t1921+1,k)/((xyz_factc(t1923-1,t1921+1
     .       6      ,k)+xyz_factd(t1923-1,t1921+1,k))+1.00000000000000e-100))*( 
     .       7      1.00000000000000e+000-dexp((-(xyz_factc(t1923-1,t1921+1,k)+ 
     .       8      xyz_factd(t1923-1,t1921+1,k))*2.00000000000000e+000*deltime)
     .       9      )))                                                         
     .           xyz_facta1(t1923-1,t1921+1,k) = xyz_dqcloudwaterdtcum(t1923-1, 
     .       1      t1921+1,k)                                                  
     .           xyz_facta2(t1923-1,t1921+1,k) = (-xyz_cloudcover(t1923-1,t1921+
     .       1      1,k)*xyz_dqh2ovapsatdt(t1923-1,t1921+1,k)) -                
     .       2      xyz_delcloudcoverstr1*xyz_dqh2ovapsatdt(t1923-1,t1921+1,k)* 
     .       3      xyz_zeroonedqsdt(t1923-1,t1921+1,k)*D5 - xyz_cloudcover(    
     .       4      t1923-1,t1921+1,k)*9.99999999999999e-007*(xyz_qh2ovapsat(   
     .       5      t1923-1,t1921+1,k)-xyz_qh2ovap(t1923-1,t1921+1,k))          
     .        end do                                                            
   469        !
   470        xyz_DelCloudCoverStr(:,:,k) =                                         &
   471          &   xyz_FactC2(:,:,k) * 2.0_DP * DelTime                            &
   472          & - xyz_FactC2(:,:,k)                                               &
   473          &  / ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) + 1.0d-100 )             &
   474          &   * (                                                             &
   475          &         xyz_FactC(:,:,k) * 2.0_DP * DelTime                       &
   476          &       + ( xyz_CloudCover(:,:,k)                                   &
   477          &             - xyz_FactC(:,:,k)                                    &
   478          &             / ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) + 1.0d-100 ) )&
   479          &         * ( 1.0_DP                                                &
   480          &               - exp( - ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) )    &
   481          &                   * 2.0_DP * DelTime ) )                          &
   482          &     )
   483        !
   484        xyz_FactA1(:,:,k) = xyz_DQCloudWaterDtCum(:,:,k)
   485        xyz_FactA2(:,:,k) =                                                   &
   486          & - xyz_CloudCover(:,:,k) * xyz_DQH2OVapSatDt(:,:,k)                &
   487          & - xyz_DelCloudCoverStr(:,:,k) * xyz_DQH2OVapSatDt(:,:,k)          &
   488          &     * xyz_ZeroOneDQsDt(:,:,k)                                     &
   489          &     / 2.0_DP                                                      &
   490          & - xyz_CloudCover(:,:,k) * MixCoef                                 &
   491          &     * ( xyz_QH2OVapSat(:,:,k) - xyz_QH2OVap(:,:,k) )
   492        !    The value of xyz_FactA2 is checked, and is updated.
   493        do j = 1, jmax
   494          do i = 0, imax-1
   495            if ( xyz_FactA2(i,j,k) * 2.0_DP * DelTime > xyz_QH2OVap(i,j,k) ) then
   496              xyz_FactA2(i,j,k) = xyz_QH2OVap(i,j,k) / ( 2.0_DP * DelTime )
   497            end if
   498          end do
   499        end do
     .        if (jmax .gt. 0) then                                             
     .           J9 = and(jmax,1)                                               
     .           do j = 1, J9                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if ((2.00000000000000e+000*deltime)*xyz_facta2(i-1,j,k)  
     .       1             .gt. xyz_qh2ovap(i-1,j,k)) then                      
     .                    xyz_facta2(i-1,j,k) = xyz_qh2ovap(i-1,j,k)/(          
     .       1               2.00000000000000e+000*deltime)                     
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J9 + 1, jmax, 2                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if ((2.00000000000000e+000*deltime)*xyz_facta2(i-1,j,k)  
     .       1             .gt. xyz_qh2ovap(i-1,j,k)) then                      
     .                    xyz_facta2(i-1,j,k) = xyz_qh2ovap(i-1,j,k)/(          
     .       1               2.00000000000000e+000*deltime)                     
     .                 endif                                                    
     .                 if ((2.00000000000000e+000*deltime)*xyz_facta2(i-1,j+1,k)
     .       1             .gt. xyz_qh2ovap(i-1,j+1,k)) then                    
     .                    xyz_facta2(i-1,j+1,k) = xyz_qh2ovap(i-1,j+1,k)/(      
     .       1               2.00000000000000e+000*deltime)                     
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   500        xyz_FactA(:,:,k) = xyz_FactA1(:,:,k) + xyz_FactA2(:,:,k)
     .        if (xyz_facta1.DSC.U2 .gt. 0) then                                
     .           J10 = and(xyz_facta1.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t1977 = 1, J10                                              
     .  !CDIR       NODEP                                                       
     .              do t1979 = 1, xyz_facta1.DSC.U1 + 1                         
     .                 xyz_facta(t1979-1,t1977,k) = xyz_facta1(t1979-1,t1977,k) 
     .       1             + xyz_facta2(t1979-1,t1977,k)                        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1977 = J10 + 1, xyz_facta1.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t1979 = 1, xyz_facta1.DSC.U1 + 1                         
     .                 xyz_facta(t1979-1,t1977,k) = xyz_facta1(t1979-1,t1977,k) 
     .       1             + xyz_facta2(t1979-1,t1977,k)                        
     .                 xyz_facta(t1979-1,t1977+1,k) = xyz_facta1(t1979-1,t1977+1
     .       1            ,k) + xyz_facta2(t1979-1,t1977+1,k)                   
     .                 xyz_facta(t1979-1,t1977+2,k) = xyz_facta1(t1979-1,t1977+2
     .       1            ,k) + xyz_facta2(t1979-1,t1977+2,k)                   
     .                 xyz_facta(t1979-1,t1977+3,k) = xyz_facta1(t1979-1,t1977+3
     .       1            ,k) + xyz_facta2(t1979-1,t1977+3,k)                   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   501  
   502  
   503  !!$        xy_RainConvFactor = 1.0_DP / ( CloudLifeTime + 1.0d-100 )
   504        !
   505        xy_FactCo = 1.0_DP &
     .  !CDIR NODEP                                                             
     .        do t1989 = 1, xy_rain.DSC.U1 + 1                                  
     .           xy_factco1 = 1.00000000000000e+000 + 3.00000000000000e+002*    
     .       1      dsqrt(xy_rain(t1989-1,t1987+1))                             
     .           xy_factbf1 = 1.00000000000000e+000 + 5.00000000000000e-001*    
     .       1      dsqrt(max(2.68000000000000e+002 - xyz_temp(t1989-1,t1987+1,k
     .       2      ),0.0000000000000000e+000))                                 
     .           xy_qcloudwaterconvthreshold1 = 4.00000000000000e-004/(         
     .       1      xy_factco1*xy_factbf1)                                      
     .           xy_rainconvfactor1 = (xy_factco1*xy_factbf1)*                  
     .       1      1.00000000000000e-003*(1.00000000000000e+000 - dexp((-(     
     .       2      xyz_qcloudwater(t1989-1,t1987+1,k)/((xyz_cloudcover(t1989-1,
     .       3      t1987+1,k)+1.00000000000000e-100)*                          
     .       4      xy_qcloudwaterconvthreshold1))**2)))                        
     .           xyz_factb(t1989-1,t1987+1,k) = xy_rainconvfactor1              
     .        end do                                                            
   506          & + C1 * sqrt( xy_Rain )
   507        xy_FactBF = 1.0_DP &
   508          & + C2 * sqrt( max( 268.0_DP - xyz_Temp(:,:,k), 0.0_DP ) )
   509        xy_QCloudWaterConvThreshold =                            &
   510          & QCloudWaterConvThreshold / ( xy_FactCo * xy_FactBF )
   511        xy_RainConvFactor = C0 * xy_FactCo * xy_FactBF              &
   512          & * (                                                     &
   513          &       1.0_DP                                            &
   514          &     - exp(                                              &
   515          &            - ( xyz_QCloudWater(:,:,k)                   &
   516          &                / ( ( xyz_CloudCover(:,:,k) + 1.0d-100 ) &
   517          &                    * xy_QCloudWaterConvThreshold ) )**2 &
   518          &          )                                              &
   519          &   )
   520        !
   521        xyz_FactB(:,:,k) = xy_RainConvFactor
   522        !
   523        do j = 1, jmax
   524          do i = 0, imax-1
   525            if ( xyz_FactB(i,j,k) < 1.0_DP / 1.0d10 ) then
   526              xyz_FactB(i,j,k) = 1.0_DP / 1.0d10
   527            end if
   528          end do
   529        end do
     .        if (jmax .gt. 0) then                                             
     .           J11 = and(jmax,1)                                              
     .           do j = 1, J11                                                  
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_factb(i-1,j,k) .lt. 1.00000000000000e-010) then  
     .                    xyz_factb(i-1,j,k) = 1.00000000000000e-010            
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J11 + 1, jmax, 2                                        
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_factb(i-1,j,k) .lt. 1.00000000000000e-010) then  
     .                    xyz_factb(i-1,j,k) = 1.00000000000000e-010            
     .                 endif                                                    
     .                 if (xyz_factb(i-1,j+1,k) .lt. 1.00000000000000e-010) then
     .                    xyz_factb(i-1,j+1,k) = 1.00000000000000e-010          
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   530  
   531  
   532        ! Values at next time step are calculated.
   533        !
   534        xyz_QCloudWater(:,:,k) =                                             &
     .        if (xyz_factb.DSC.U2 .gt. 0) then                                 
     .           J12 = and(xyz_factb.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t2021 = 1, J12                                              
     .  !CDIR       NODEP                                                       
     .              do t2023 = 1, xyz_factb.DSC.U1 + 1                          
     .                 xyz_qcloudwater(t2023-1,t2021,k) = xyz_qcloudwater(t2023-
     .       1            1,t2021,k)*(dexp((-((xyz_factb(t2023-1,t2021,k)*      
     .       2            2.00000000000000e+000)*deltime)))) + xyz_facta(t2023-1
     .       3            ,t2021,k)/xyz_factb(t2023-1,t2021,k)*(                
     .       4            1.00000000000000e+000 - (dexp((-((xyz_factb(t2023-1,  
     .       5            t2021,k)*2.00000000000000e+000)*deltime)))))          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t2021 = J12 + 1, xyz_factb.DSC.U2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t2023 = 1, xyz_factb.DSC.U1 + 1                          
     .                 xyz_qcloudwater(t2023-1,t2021,k) = xyz_qcloudwater(t2023-
     .       1            1,t2021,k)*(dexp((-((xyz_factb(t2023-1,t2021,k)*      
     .       2            2.00000000000000e+000)*deltime)))) + xyz_facta(t2023-1
     .       3            ,t2021,k)/xyz_factb(t2023-1,t2021,k)*(                
     .       4            1.00000000000000e+000 - (dexp((-((xyz_factb(t2023-1,  
     .       5            t2021,k)*2.00000000000000e+000)*deltime)))))          
     .                 xyz_qcloudwater(t2023-1,t2021+1,k) = xyz_qcloudwater(    
     .       1            t2023-1,t2021+1,k)*(dexp((-((xyz_factb(t2023-1,t2021+1
     .       2            ,k)*2.00000000000000e+000)*deltime)))) + xyz_facta(   
     .       3            t2023-1,t2021+1,k)/xyz_factb(t2023-1,t2021+1,k)*(     
     .       4            1.00000000000000e+000 - (dexp((-((xyz_factb(t2023-1,  
     .       5            t2021+1,k)*2.00000000000000e+000)*deltime)))))        
     .                 xyz_qcloudwater(t2023-1,t2021+2,k) = xyz_qcloudwater(    
     .       1            t2023-1,t2021+2,k)*(dexp((-((xyz_factb(t2023-1,t2021+2
     .       2            ,k)*2.00000000000000e+000)*deltime)))) + xyz_facta(   
     .       3            t2023-1,t2021+2,k)/xyz_factb(t2023-1,t2021+2,k)*(     
     .       4            1.00000000000000e+000 - (dexp((-((xyz_factb(t2023-1,  
     .       5            t2021+2,k)*2.00000000000000e+000)*deltime)))))        
     .                 xyz_qcloudwater(t2023-1,t2021+3,k) = xyz_qcloudwater(    
     .       1            t2023-1,t2021+3,k)*(dexp((-((xyz_factb(t2023-1,t2021+3
     .       2            ,k)*2.00000000000000e+000)*deltime)))) + xyz_facta(   
     .       3            t2023-1,t2021+3,k)/xyz_factb(t2023-1,t2021+3,k)*(     
     .       4            1.00000000000000e+000 - (dexp((-((xyz_factb(t2023-1,  
     .       5            t2021+3,k)*2.00000000000000e+000)*deltime)))))        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   535          &   xyz_QCloudWater(:,:,k)                                         &
   536          &     * exp( - xyz_FactB(:,:,k) * 2.0_DP * DelTime )               &
   537          & + xyz_FactA(:,:,k) / xyz_FactB(:,:,k)                            &
   538          &     * ( 1.0_DP - exp( - xyz_FactB(:,:,k) * 2.0_DP * DelTime ) )
   539        !   The value of cloud water amount is checked, and xyz_FactA
   540        !   is updated.
   541        do j = 1, jmax
   542          do i = 0, imax-1
   543            if ( xyz_QCloudWater(i,j,k) < 0.0_DP ) then
   544              xyz_FactA2(i,j,k) = - xyz_FactA1(i,j,k)                         &
   545                & - xyz_FactB(i,j,k) * xyz_QCloudWaterB(i,j,k)                &
   546                & * exp( - xyz_FactB(i,j,k) * 2.0_DP * DelTime )              &
   547                & / ( 1.0_DP - exp( - xyz_FactB(i,j,k) * 2.0_DP * DelTime ) )
   548              xyz_QCloudWater(i,j,k) = 0.0_DP
   549            end if
   550          end do
   551        end do
     .        if (jmax .gt. 0) then                                             
     .           J13 = and(jmax,1)                                              
     .           do j = 1, J13                                                  
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_qcloudwater(i-1,j,k) .lt. 0.0000000000000000e+000
     .       1            ) then                                                
     .                    xyz_facta2(i-1,j,k) = (-xyz_facta1(i-1,j,k)) -        
     .       1               xyz_factb(i-1,j,k)*xyz_qcloudwaterb(i-1,j,k)*(dexp(
     .       2               (-((xyz_factb(i-1,j,k)*2.00000000000000e+000)*     
     .       3               deltime))))/(1.00000000000000e+000 - (dexp((-((    
     .       4               xyz_factb(i-1,j,k)*2.00000000000000e+000)*deltime))
     .       5               )))                                                
     .                    xyz_qcloudwater(i-1,j,k) = 0.0000000000000000e+000    
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J13 + 1, jmax, 2                                        
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_qcloudwater(i-1,j,k) .lt. 0.0000000000000000e+000
     .       1            ) then                                                
     .                    xyz_facta2(i-1,j,k) = (-xyz_facta1(i-1,j,k)) -        
     .       1               xyz_factb(i-1,j,k)*xyz_qcloudwaterb(i-1,j,k)*(dexp(
     .       2               (-((xyz_factb(i-1,j,k)*2.00000000000000e+000)*     
     .       3               deltime))))/(1.00000000000000e+000 - (dexp((-((    
     .       4               xyz_factb(i-1,j,k)*2.00000000000000e+000)*deltime))
     .       5               )))                                                
     .                    xyz_qcloudwater(i-1,j,k) = 0.0000000000000000e+000    
     .                 endif                                                    
     .                 if (xyz_qcloudwater(i-1,j+1,k) .lt.                      
     .       1            0.0000000000000000e+000) then                         
     .                    xyz_facta2(i-1,j+1,k) = (-xyz_facta1(i-1,j+1,k)) -    
     .       1               xyz_factb(i-1,j+1,k)*xyz_qcloudwaterb(i-1,j+1,k)*( 
     .       2               dexp((-((xyz_factb(i-1,j+1,k)*2.00000000000000e+000
     .       3               )*deltime))))/(1.00000000000000e+000 - (dexp((-((  
     .       4               xyz_factb(i-1,j+1,k)*2.00000000000000e+000)*deltime
     .       5               )))))                                              
     .                    xyz_qcloudwater(i-1,j+1,k) = 0.0000000000000000e+000  
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   552        xyz_FactA(:,:,k) = xyz_FactA1(:,:,k) + xyz_FactA2(:,:,k)
     .        D11 = latentheat/cpdry                                            
     .        D12 = 1.D0/(2.00000000000000e+000*deltime)                        
     .        D13 = 1.D0/grav                                                   
     .  !CDIR NODEP                                                             
     .        do t2039 = 1, xyz_facta1.DSC.U1 + 1                               
     .           xyz_facta(t2039-1,t2037+1,k) = xyz_facta1(t2039-1,t2037+1,k) + 
     .       1      xyz_facta2(t2039-1,t2037+1,k)                               
     .           xyz_cloudcover(t2039-1,t2037+1,k) = xyz_cloudcover(t2039-1,    
     .       1      t2037+1,k)*(dexp((-(((xyz_factc(t2039-1,t2037+1,k)+xyz_factd
     .       2      (t2039-1,t2037+1,k))*2.00000000000000e+000)*deltime)))) + ( 
     .       3      xyz_factc(t2039-1,t2037+1,k)+xyz_facte(t2039-1,t2037+1,k))/(
     .       4      (xyz_factc(t2039-1,t2037+1,k)+xyz_factd(t2039-1,t2037+1,k))+
     .       5      1.00000000000000e-100)*(1.00000000000000e+000 - (dexp((-((( 
     .       6      xyz_factc(t2039-1,t2037+1,k)+xyz_factd(t2039-1,t2037+1,k))* 
     .       7      2.00000000000000e+000)*deltime)))))                         
     .           xyz_qh2ovap(t2039-1,t2037+1,k) = xyz_qh2ovap(t2039-1,t2037+1,k)
     .       1       - ((xyz_facta2(t2039-1,t2037+1,k)*2.00000000000000e+000)*  
     .       2      deltime)                                                    
     .           xyz_temp(t2039-1,t2037+1,k) = xyz_temp(t2039-1,t2037+1,k) + (( 
     .       1      xyz_facta2(t2039-1,t2037+1,k)*2.00000000000000e+000)*deltime
     .       2      )*D11                                                       
     .           xyz_rain1 = (2.00000000000000e+000*deltime)*xyz_facta(t2039-1, 
     .       1      t2037+1,k) + xyz_qcloudwaterb(t2039-1,t2037+1,k)*(          
     .       2      1.00000000000000e+000 - (dexp((-((xyz_factb(t2039-1,t2037+1,
     .       3      k)*2.00000000000000e+000)*deltime))))) - xyz_facta(t2039-1, 
     .       4      t2037+1,k)/xyz_factb(t2039-1,t2037+1,k)*(                   
     .       5      1.00000000000000e+000 - (dexp((-((xyz_factb(t2039-1,t2037+1,
     .       6      k)*2.00000000000000e+000)*deltime)))))                      
     .           xyz_rain1 = xyz_rain1*D12                                      
     .           xy_rain(t2039-1,t2037+1) = xy_rain(t2039-1,t2037+1) + xyz_rain1
     .       1      *(xyr_press(t2039-1,t2037+1,k-1)-xyr_press(t2039-1,t2037+1,k
     .       2      ))*D13                                                      
     .           xyz_rain(t2039-1,t2037+1,k) = xyz_rain1                        
     .        end do                                                            
   553        !
   554        xyz_CloudCover(:,:,k) =                                            &
   555          &   xyz_CloudCover(:,:,k)                                        &
   556          &    * exp( - ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) )            &
   557          &               * 2.0_DP * DelTime )                             &
   558          & + ( xyz_FactC(:,:,k) + xyz_FactE(:,:,k) )                      &
   559          &    / ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) + 1.0d-100 )        &
   560          &    * ( 1.0_DP - exp( - ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) ) &
   561          &                          * 2.0_DP * DelTime ) )
   562        !
   563        xyz_QH2OVap(:,:,k) = xyz_QH2OVap(:,:,k) &
   564          & - xyz_FactA2(:,:,k) * 2.0_DP * DelTime
   565        !
   566        xyz_Temp(:,:,k) = xyz_Temp(:,:,k) &
   567          & + xyz_FactA2(:,:,k) * 2.0_DP * DelTime * LatentHeat / CpDry
   568  
   569  
   570        ! Rain
   571        !
   572        xyz_Rain(:,:,k) =                                                    &
   573          &   xyz_FactA(:,:,k) * 2.0_DP * DelTime                            &
   574          & + xyz_QCloudWaterB(:,:,k)                                        &
   575          &    * ( 1.0_DP - exp( - xyz_FactB(:,:,k) * 2.0_DP * DelTime ) )   &
   576          & - xyz_FactA(:,:,k) / xyz_FactB(:,:,k)                            &
   577          &    * ( 1.0_DP - exp( - xyz_FactB(:,:,k) * 2.0_DP * DelTime ) )
   578        xyz_Rain(:,:,k) = xyz_Rain(:,:,k) / ( 2.0_DP * DelTime )
   579  
   580        ! Rain at the surface
   581        xy_Rain = xy_Rain     &
   582          & + xyz_Rain(:,:,k) &
   583          &    * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   584  
   585        ! Evaporation
   586        !
   587        do j = 1, jmax
   588          do i = 0, imax-1
   589            if ( xyz_QCloudWater(i,j,k) < QCloudWaterEvapThreshold ) then
   590              xyz_CloudCover(i,j,k) = 0.0_DP
   591            end if
   592          end do
   593        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xyz_qcloudwater(j-1,1,k) .lt. 1.00000000000000e-010) then  
     .              xyz_cloudcover(j-1,1,k) = 0.0000000000000000e+000           
     .           endif                                                          
     .        end do                                                            
   594  
   595        ! Cloud cover is restricted.
   596        do j = 1, jmax
   597          do i = 0, imax-1
   598            if ( xyz_CloudCover(i,j,k) > 1.0_DP ) then
   599              xyz_CloudCover(i,j,k) = 1.0_DP
   600            else if ( xyz_CloudCover(i,j,k) < 0.0_DP ) then
   601              xyz_CloudCover(i,j,k) = 0.0_DP
   602            end if
   603          end do
   604        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xyz_cloudcover(j-1,1,k) .gt. 1.00000000000000e+000) then   
     .              xyz_cloudcover(j-1,1,k) = 1.00000000000000e+000             
     .           else                                                           
     .              if (xyz_cloudcover(j-1,1,k) .lt. 0.0000000000000000e+000)   
     .       1         then                                                     
     .                 xyz_cloudcover(j-1,1,k) = 0.0000000000000000e+000        
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
   605  
   606  
   607        ! Check values
   608        do j = 1, jmax
   609          do i = 0, imax-1
   610            if ( xyz_QCloudWater(i,j,k) < 0.0_DP ) then
   611              write( 6, * ) 'QCloudWater is negative', &
   612                & i, j, k, xyz_QCloudWater(i,j,k)
   613            end if
   614          end do
   615        end do
   616  
   617      end do k_loop
   618  
   619  
   620      xyz_DTempDtLSC = 0.0_DP
     .        if (xyz_dtempdtlsc.DSC.U2 .gt. 0) then                            
     .           J14 = and(xyz_dtempdtlsc.DSC.U2,1)                             
     .  !CDIR    NODEP                                                          
     .           do t2109 = 1, J14                                              
     .  !CDIR       NODEP                                                       
     .              do t2111 = 1, xyz_dtempdtlsc.DSC.U1 + 1                     
     .                 xyz_dtempdtlsc(t2111-1,t2109,t2107+1) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyz_dqvapdtlsc(t2111-1,t2109,t2107+1) =                  
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t2109 = J14 + 1, xyz_dtempdtlsc.DSC.U2, 2                   
     .  !CDIR       NODEP                                                       
     .              do t2111 = 1, xyz_dtempdtlsc.DSC.U1 + 1                     
     .                 xyz_dtempdtlsc(t2111-1,t2109,t2107+1) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyz_dtempdtlsc(t2111-1,t2109+1,t2107+1) =                
     .       1            0.0000000000000000e+000                               
     .                 xyz_dqvapdtlsc(t2111-1,t2109,t2107+1) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyz_dqvapdtlsc(t2111-1,t2109+1,t2107+1) =                
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   621      xyz_DQVapDtLSC = 0.0_DP
   622  
   623      ! 絬϶ŷ (ήŷ) (Manabe, 1965)
   624      ! Large scale condensation (non-convective condensation) (Manabe, 1965)
   625      !
   626      call LScaleCond(                        &
   627        & xyz_Temp, xyz_QH2OVap,              & ! (inout)
   628        & xyz_DTempDtLSC, xyz_DQVapDtLSC,     & ! (inout)
   629        & xyz_Press, xyr_Press,               & ! (in)
   630        & xyz_RainLSC                         & ! (out)
   631        & )
   632  
   633      xy_RainLSC = 0.0_DP
     .        if (xy_rainlsc.DSC.U2 .gt. 0) then                                
     .           J15 = and(xy_rainlsc.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t2119 = 1, J15                                              
     .  !CDIR       NODEP                                                       
     .              do t2121 = 1, xy_rainlsc.DSC.U1 + 1                         
     .                 xy_rainlsc(t2121-1,t2119) = 0.0000000000000000e+000      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t2119 = J15 + 1, xy_rainlsc.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t2121 = 1, xy_rainlsc.DSC.U1 + 1                         
     .                 xy_rainlsc(t2121-1,t2119) = 0.0000000000000000e+000      
     .                 xy_rainlsc(t2121-1,t2119+1) = 0.0000000000000000e+000    
     .                 xy_rainlsc(t2121-1,t2119+2) = 0.0000000000000000e+000    
     .                 xy_rainlsc(t2121-1,t2119+3) = 0.0000000000000000e+000    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   634      do k = kmax, 1, -1
   635        xy_RainLSC = xy_RainLSC     &
     .        if (xy_rainlsc.DSC.U2 .gt. 0) then                                
     .           J16 = and(xy_rainlsc.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t2125 = 1, J16                                              
     .              D15 = 1.D0/grav                                             
     .  !CDIR       NODEP                                                       
     .              do t2127 = 1, xy_rainlsc.DSC.U1 + 1                         
     .                 xy_rainlsc(t2127-1,t2125) = xy_rainlsc(t2127-1,t2125) +  
     .       1            xyz_rainlsc(t2127-1,t2125,k)*(xyr_press(t2127-1,t2125,
     .       2            k-1)-xyr_press(t2127-1,t2125,k))*D15                  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t2125 = J16 + 1, xy_rainlsc.DSC.U2, 4                       
     .              D16 = 1.D0/grav                                             
     .              D17 = 1.D0/grav                                             
     .              D18 = 1.D0/grav                                             
     .              D19 = 1.D0/grav                                             
     .  !CDIR       NODEP                                                       
     .              do t2127 = 1, xy_rainlsc.DSC.U1 + 1                         
     .                 xy_rainlsc(t2127-1,t2125) = xy_rainlsc(t2127-1,t2125) +  
     .       1            xyz_rainlsc(t2127-1,t2125,k)*(xyr_press(t2127-1,t2125,
     .       2            k-1)-xyr_press(t2127-1,t2125,k))*D16                  
     .                 xy_rainlsc(t2127-1,t2125+1) = xy_rainlsc(t2127-1,t2125+1)
     .       1             + xyz_rainlsc(t2127-1,t2125+1,k)*(xyr_press(t2127-1, 
     .       2            t2125+1,k-1)-xyr_press(t2127-1,t2125+1,k))*D17        
     .                 xy_rainlsc(t2127-1,t2125+2) = xy_rainlsc(t2127-1,t2125+2)
     .       1             + xyz_rainlsc(t2127-1,t2125+2,k)*(xyr_press(t2127-1, 
     .       2            t2125+2,k-1)-xyr_press(t2127-1,t2125+2,k))*D18        
     .                 xy_rainlsc(t2127-1,t2125+3) = xy_rainlsc(t2127-1,t2125+3)
     .       1             + xyz_rainlsc(t2127-1,t2125+3,k)*(xyr_press(t2127-1, 
     .       2            t2125+3,k-1)-xyr_press(t2127-1,t2125+3,k))*D19        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   636          & + xyz_RainLSC(:,:,k)    &
   637          &    * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   638      end do
   639  
   640  
   641      xy_Rain = xy_Rain + xy_RainLSC
     .        if (xy_rain.DSC.U2 .gt. 0) then                                   
     .           J17 = and(xy_rain.DSC.U2,3)                                    
     .  !CDIR    NODEP                                                          
     .           do t2139 = 1, J17                                              
     .  !CDIR       NODEP                                                       
     .              do t2141 = 1, xy_rain.DSC.U1 + 1                            
     .                 xy_rain(t2141-1,t2139) = xy_rain(t2141-1,t2139) +        
     .       1            xy_rainlsc(t2141-1,t2139)                             
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t2139 = J17 + 1, xy_rain.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t2141 = 1, xy_rain.DSC.U1 + 1                            
     .                 xy_rain(t2141-1,t2139) = xy_rain(t2141-1,t2139) +        
     .       1            xy_rainlsc(t2141-1,t2139)                             
     .                 xy_rain(t2141-1,t2139+1) = xy_rain(t2141-1,t2139+1) +    
     .       1            xy_rainlsc(t2141-1,t2139+1)                           
     .                 xy_rain(t2141-1,t2139+2) = xy_rain(t2141-1,t2139+2) +    
     .       1            xy_rainlsc(t2141-1,t2139+2)                           
     .                 xy_rain(t2141-1,t2139+3) = xy_rain(t2141-1,t2139+3) +    
     .       1            xy_rainlsc(t2141-1,t2139+3)                           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   642  
   643  
   644      call CloudUtilsCalcPRCPKeyLLTemp(      &
   645        & xyz_Temp, xy_Rain,                 &  ! (in )
   646        & xy_SurfRainFlux, xy_SurfSnowFlux   &  ! (out)
   647        & )
   648  
   649  
   650    end subroutine CloudT1993base
   651  
   652    !--------------------------------------------------------------------------------------
   653  
   654    subroutine CloudT1993baseInit( &
   655      & ArgFlagSnow                &
   656      & )
   657  
   658      ! ե
   659      ! File I/O support
   660      !
   661      use dc_iounit, only: FileOpen
   662  
   663      ! NAMELIST եϤ˴ؤ桼ƥƥ
   664      ! Utilities for NAMELIST file input
   665      !
   666      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   667  
   668      ! ҥȥǡ
   669      ! History data output
   670      !
   671      use gtool_historyauto, only: HistoryAutoAddVariable
   672  
   673      ! 絬϶ŷ (ήŷ)
   674      ! Large scale condensation (non-convective condensation)
   675      !
   676      use lscond, only : LScaleCondInit
   677  
   678  
   679      ! ʸ ; Declaration statements
   680      !
   681  
   682      logical, intent(in) :: ArgFlagSnow
   683  
   684  
   685      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   686                                ! Unit number for NAMELIST file open
   687      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   688                                ! IOSTAT of NAMELIST read
   689  
   690      ! NAMELIST ѿ
   691      ! NAMELIST group name
   692      !
   693      namelist /cloud_T1993base_nml/ &
   694        & CloudLifeTime
   695            !
   696            ! ǥեͤˤĤƤϽ³ "cloud_T1993base#CloudT1993baseInit"
   697            ! Υɤ򻲾ȤΤ.
   698            !
   699            ! Refer to source codes in the initialization procedure
   700            ! "cloud_T1993base#CloudT1993baseInit" for the default values.
   701            !
   702  
   703      ! ¹ʸ ; Executable statement
   704      !
   705  
   706      if ( cloud_T1993base_inited ) return
   707  
   708  
   709      FlagSnow = ArgFlagSnow
   710  
   711  
   712      ! ǥեͤ
   713      ! Default values settings
   714      !
   715      CloudLifeTime       = 3600.0_DP
   716  
   717  
   718      ! NAMELIST ɤ߹
   719      ! NAMELIST is input
   720      !
   721      if ( trim(namelist_filename) /= '' ) then
   722        call FileOpen( unit_nml, &          ! (out)
   723          & namelist_filename, mode = 'r' ) ! (in)
   724  
   725        rewind( unit_nml )
   726        read( unit_nml,                     & ! (in)
   727          & nml = cloud_T1993base_nml,      & ! (out)
   728          & iostat = iostat_nml )             ! (out)
   729        close( unit_nml )
   730  
   731        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   732      end if
   733  
   734  
   735      ! Initialization of modules used in this module
   736      !
   737  
   738      ! 絬϶ŷ (ήŷ) (Manabe, 1965)
   739      ! Large scale condensation (non-convective condensation) (Le Treut and Li, 1991)
   740      !
   741      call LScaleCondInit
   742  
   743  
   744      ! ҥȥǡϤΤΤؤѿϿ
   745      ! Register of variables for history data output
   746      !
   747  !!$    call HistoryAutoAddVariable( 'EffCloudCover', &
   748  !!$      & (/ 'lon ', 'lat ', 'time' /), &
   749  !!$      & 'effective cloud cover', '1' )
   750  
   751  
   752  
   753      !  ; Print
   754      !
   755      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   756      call MessageNotify( 'M', module_name, 'CloudLifeTime       = %f', d = (/ CloudLifeTime /) )
   757      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   758  
   759  
   760      cloud_T1993base_inited = .true.
   761  
   762    end subroutine CloudT1993baseInit
   763  
   764    !--------------------------------------------------------------------------------------
   765  
   766  end module cloud_T1993base
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:51 2012
FILE NAME: cloud_T1993base.f90
PROGRAM NAME: cloud_t1993base
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Tiedtke (1993) ˴Ťǥ
     2:            !
     3:            != Cloud model based on Tiedtke (1993)
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: cloud_T1993base.f90,v 1.2 2012-09-17 11:00:57 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module cloud_T1993base
    13:              !
    14:              != Tiedtke (1993) ˴Ťǥ
    15:              !
    16:              != Cloud model based on Tiedtke (1993)
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ñǥˤη׻.
    21:              !
    22:              ! In this module, the amount of cloud is calculated by use of a simple
    23:              ! cloud model.
    24:              !
    25:              !== Procedures List
    26:              !
    27:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    28:            !!$  ! ------------            :: ------------
    29:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    30:              !
    31:              !== NAMELIST
    32:              !
    33:              ! NAMELIST#cloud_T1993base_nml
    34:              !
    35:            
    36:              ! ⥸塼 ; USE statements
    37:            
    38:              !
    39:              ! Kind type parameter
    40:              !
    41:              use dc_types, only: DP, &      ! Double precision.
    42:                &                 STRING, &  ! Strings.
    43:                &                 TOKEN      ! Keywords.
    44:            
    45:              ! å
    46:              ! Message output
    47:              !
    48:              use dc_message, only: MessageNotify
    49:            
    50:              ! ʻ
    51:              ! Grid points settings
    52:              !
    53:              use gridset, only: imax, & ! ٳʻ.
    54:                                         ! Number of grid points in longitude
    55:                &                jmax, & ! ٳʻ.
    56:                                         ! Number of grid points in latitude
    57:                &                kmax    ! ľؿ.
    58:                                         ! Number of vertical level
    59:            
    60:              implicit none
    61:            
    62:              private
    63:            
    64:            
    65:              ! ³
    66:              ! Public procedure
    67:              !
    68:              public :: CloudT1993base
    69:              public :: CloudT1993baseInit
    70:            
    71:            
    72:              ! ѿ
    73:              ! Public variables
    74:              !
    75:            
    76:            
    77:              ! ѿ
    78:              ! Private variables
    79:              !
    80:              logical , save        :: FlagSnow
    81:                                       ! A flag for snow
    82:            
    83:              real(DP), save        :: CloudLifeTime
    84:            
    85:            
    86:              logical, save :: cloud_T1993base_inited = .false.
    87:                                          ! ե饰.
    88:                                          ! Initialization flag
    89:            
    90:              character(*), parameter:: module_name = 'cloud_T1993base'
    91:                                          ! ⥸塼̾.
    92:                                          ! Module name
    93:              character(*), parameter:: version = &
    94:                & '$Name: dcpam5-20120921 $' // &
    95:                & '$Id: cloud_T1993base.f90,v 1.2 2012-09-17 11:00:57 yot Exp $'
    96:                                          ! ⥸塼ΥС
    97:                                          ! Module version
    98:            
    99:              !--------------------------------------------------------------------------------------
   100:            
   101:            contains
   102:            
   103:              !----------------------------------------------------------------------------
   104:              ! This subroutine, SetCloudCloudWaterAdjustWithCloudCoverV4, is 
   105:              ! created at 2012/08/13.
   106:            
   107:            !!$  call CloudT1993base(                                        &
   108:            !!$    & xyz_Press, xyr_Press, xyz_VirTemp,                      & ! (in)
   109:            !!$    & xyz_DQH2OLiqDtCum,                                      & ! (in)
   110:            !!$    & xyz_MoistConvDetTend,                                   & ! (in)
   111:            !!$    & xyz_OMG, xyz_MoistConvSubsidMassFlux, xyz_DTempDt,      & ! (in)
   112:            !!$    & xyz_TempA, xyzf_QMixA(:,:,:,IndexH2OVap),               & ! (inout)
   113:            !!$    & xyzf_QMixA(:,:,:,CompositionInqIndex('H2OLiq')),        & ! (inout)
   114:            !!$    & xyzf_QMixA(:,:,:,CompositionInqIndex('CloudCoverTMP')), & ! (inout)
   115:            !!$    & xy_Rain, xy_Snow                                        & ! (out)
   116:            !!$    & )
   117:            
   118:            
   119:              subroutine CloudT1993base(                                    &
   120:                & xyz_Press, xyr_Press, xyz_VirTemp,                        & ! (in)
   121:                & xyz_DQCloudWaterDtCum,                                    & ! (in)
   122:                & xyz_MoistConvDetTend,                                     & ! (in)
   123:                & xyz_OMG, xyz_MoistConvSubsidMassFlux, xyz_DTempDtPhy,     & ! (in)
   124:                & xyz_Temp, xyz_QH2OVap,                                    & ! (inout)
   125:                & xyz_QCloudWater,                                          & ! (inout)
   126:                & xyz_CloudCover,                                           & ! (inout)
   127:                & xy_SurfRainFlux, xy_SurfSnowFlux                          & ! (out)
   128:                & )
   129:            
   130:                ! USE statements
   131:                !
   132:            
   133:                ! 
   134:                ! Time control
   135:                !
   136:                use timeset, only: &
   137:                  & DelTime            ! $ \Delta t $ [s]
   138:            
   139:                ! ʪ
   140:                ! Physical and mathematical constants settings
   141:                !
   142:                use constants0, only: &
   143:                  & PI                    ! $ \pi $ .
   144:                                          ! ߼Ψ.  Circular constant
   145:            
   146:                ! ʪ
   147:                ! Physical constants settings
   148:                !
   149:                use constants, only: &
   150:                  & Grav, &
   151:                                          ! $ g $ [m s-2].
   152:                                          ! ϲ®.
   153:                                          ! Gravitational acceleration
   154:                  & CpDry, &
   155:                                          ! $ C_p $ [J kg-1 K-1].
   156:                                          ! 絤갵Ǯ.
   157:                                          ! Specific heat of air at constant pressure
   158:                  & GasRDry, &
   159:                                          ! $ R $ [J kg-1 K-1].
   160:                                          ! 絤ε.
   161:                                          ! Gas constant of air
   162:                  & GasRWet, &
   163:                                          ! $ R_v $ [J kg-1 K-1].
   164:                                          ! ŷʬε.
   165:                                          ! Gas constant of condensible elements
   166:                  & LatentHeat
   167:                                          ! $ L $ [J kg-1] .
   168:                                          ! ŷǮ.
   169:                                          ! Latent heat of condensation
   170:            
   171:                ! ˰漾λ
   172:                ! Evaluate saturation specific humidity
   173:                !
   174:                use saturate, only: xyz_CalcQVapSat, xyz_CalcDQVapSatDTemp
   175:            
   176:                ! 絬϶ŷ (ήŷ)
   177:                ! Large scale condensation
   178:                !
   179:                use lscond, only: LScaleCond
   180:            
   181:                ! طϥ롼
   182:                ! Cloud-related routines
   183:                !
   184:                use cloud_utils, only : CloudUtilsCalcPRCPKeyLLTemp
   185:            
   186:            
   187:                real(DP), intent(in   ) :: xyz_Press                  (0:imax-1, 1:jmax, 1:kmax)
   188:                real(DP), intent(in   ) :: xyr_Press                  (0:imax-1, 1:jmax, 0:kmax)
   189:                real(DP), intent(in   ) :: xyz_VirTemp                (0:imax-1, 1:jmax, 1:kmax)
   190:                real(DP), intent(in   ) :: xyz_DQCloudWaterDtCum      (0:imax-1, 1:jmax, 1:kmax)
   191:                real(DP), intent(in   ) :: xyz_MoistConvDetTend       (0:imax-1, 1:jmax, 1:kmax)
   192:                real(DP), intent(in   ) :: xyz_OMG                    (0:imax-1, 1:jmax, 1:kmax)
   193:                real(DP), intent(in   ) :: xyz_MoistConvSubsidMassFlux(0:imax-1, 1:jmax, 1:kmax)
   194:                real(DP), intent(in   ) :: xyz_DTempDtPhy             (0:imax-1, 1:jmax, 1:kmax)
   195:                real(DP), intent(inout) :: xyz_Temp                   (0:imax-1, 1:jmax, 1:kmax)
   196:                real(DP), intent(inout) :: xyz_QH2OVap                (0:imax-1, 1:jmax, 1:kmax)
   197:                real(DP), intent(inout) :: xyz_QCloudWater            (0:imax-1, 1:jmax, 1:kmax)
   198:                real(DP), intent(inout) :: xyz_CloudCover             (0:imax-1, 1:jmax, 1:kmax)
   199:                real(DP), intent(out)   :: xy_SurfRainFlux            (0:imax-1, 1:jmax)
   200:                real(DP), intent(out)   :: xy_SurfSnowFlux            (0:imax-1, 1:jmax)
   201:            
   202:            
   203:                real(DP) :: xyz_QCloudWaterB     (0:imax-1, 1:jmax, 1:kmax)
   204:            
   205:                real(DP) :: xyz_QH2OVapSat       (0:imax-1, 1:jmax, 1:kmax)
   206:                real(DP) :: xyz_DQH2OVapSatDPress(0:imax-1, 1:jmax, 1:kmax)
   207:                real(DP) :: xyz_DQH2OVapSatDTemp (0:imax-1, 1:jmax, 1:kmax)
   208:                real(DP) :: xyz_DQH2OVapSatDt    (0:imax-1, 1:jmax, 1:kmax)
   209:            
   210:                real(DP) :: xyz_ZeroOneDQsDt    (0:imax-1, 1:jmax, 1:kmax)
   211:                real(DP) :: xyz_DelCloudCoverStr(0:imax-1, 1:jmax, 1:kmax)
   212:                real(DP) :: xyz_FactA           (0:imax-1, 1:jmax, 1:kmax)
   213:                real(DP) :: xyz_FactA1          (0:imax-1, 1:jmax, 1:kmax)
   214:                real(DP) :: xyz_FactA2          (0:imax-1, 1:jmax, 1:kmax)
   215:                real(DP) :: xyz_FactB           (0:imax-1, 1:jmax, 1:kmax)
   216:                real(DP) :: xyz_FactC           (0:imax-1, 1:jmax, 1:kmax)
   217:                real(DP) :: xyz_FactC1          (0:imax-1, 1:jmax, 1:kmax)
   218:                real(DP) :: xyz_FactC2          (0:imax-1, 1:jmax, 1:kmax)
   219:                real(DP) :: xyz_FactD           (0:imax-1, 1:jmax, 1:kmax)
   220:                real(DP) :: xyz_FactE           (0:imax-1, 1:jmax, 1:kmax)
   221:                real(DP) :: xyz_FactE1          (0:imax-1, 1:jmax, 1:kmax)
   222:                real(DP) :: xyz_FactE2          (0:imax-1, 1:jmax, 1:kmax)
   223:            
   224:                real(DP) :: xy_Rain                    (0:imax-1, 1:jmax)
   225:                real(DP) :: xyz_Rain                   (0:imax-1, 1:jmax, 1:kmax)
   226:                real(DP) :: xy_RainConvFactor          (0:imax-1, 1:jmax)
   227:                real(DP) :: xy_FactCo                  (0:imax-1, 1:jmax)
   228:                real(DP) :: xy_FactBF                  (0:imax-1, 1:jmax)
   229:                real(DP) :: xy_QCloudWaterConvThreshold(0:imax-1, 1:jmax)
   230:            
   231:                real(DP) :: xyz_DTempDtLSC             (0:imax-1, 1:jmax, 1:kmax)
   232:                real(DP) :: xyz_DQVapDtLSC             (0:imax-1, 1:jmax, 1:kmax)
   233:                real(DP) :: xyz_RainLSC                (0:imax-1, 1:jmax, 1:kmax)
   234:                real(DP) :: xy_RainLSC                 (0:imax-1, 1:jmax)
   235:            
   236:            
   237:                real(DP), parameter :: MixCoef                  = 1.0d-6
   238:                real(DP), parameter :: QCloudWaterEvapThreshold = 1.0d-10
   239:            !!$    real(DP), parameter :: RHThreshold              = 0.999_DP
   240:                real(DP), parameter :: RHThreshold              = 1.0_DP - 1.0d-10
   241:                ! Values below are obtained from Sundqvist et al. (1989), but some of 
   242:                ! those are arbitrarily selected.
   243:                real(DP), parameter :: C0                       = 1.0d-3
   244:                real(DP), parameter :: C1                       = 300.0_DP
   245:                real(DP), parameter :: C2                       = 0.5_DP
   246:                real(DP), parameter :: QCloudWaterConvThreshold = 4.0d-4
   247:            
   248:            
   249:                ! Parameters for evaporation of rain
   250:                real(DP), parameter :: DensWater            = 1.0d3
   251:                !                            rho_w
   252:                !   Values below are from Kessler (1969)
   253:                real(DP), parameter :: RainFallVelFactor         = 130.0d0
   254:                !                            K
   255:                real(DP), parameter :: MedianDiameterFactor      = 3.67d0
   256:                !                            C'
   257:                real(DP), parameter :: RainDistFactor            = 1.0d7
   258:                !                            N0
   259:                real(DP), parameter :: RainEvapRatUnitDiamFactor = 2.24d3
   260:                !                            C
   261:                real(DP), parameter :: H2OVapDiffCoef            = 1.0d-5
   262:                !                            Kd
   263:            
   264:                real(DP) :: Dens0
   265:                !                            rho_0
   266:                real(DP) :: V00
   267:                !                            V_{00}
   268:                real(DP) :: RainEvapFactor
   269:            
   270:                real(DP) :: xyz_Dens        (0:imax-1, 1:jmax, 1:kmax)
   271:                !                           rho
   272:                real(DP) :: xy_DensRain     (0:imax-1, 1:jmax)
   273:                !                           (rho q_r)
   274:                real(DP) :: xy_RainArea     (0:imax-1, 1:jmax)
   275:                !                           a_p
   276:                real(DP) :: xy_RainEvapArea (0:imax-1, 1:jmax)
   277:                !                           A = max( a_p - a, 0 )
   278:                real(DP) :: xyz_RainEvapRate(0:imax-1, 1:jmax, 1:kmax)
   279:            
   280:                real(DP) :: xy_DelRain      (0:imax-1, 1:jmax)
   281:                real(DP) :: DelQH2OVap
   282:            
   283:                real(DP) :: RainFallVel
   284:            
   285:                integer :: i
   286:                integer :: j
   287:                integer :: k
   288:            
   289:            
   290:                ! ¹ʸ ; Executable statement
   291:                !
   292:            
   293:                ! ǧ
   294:                ! Initialization check
   295:                !
   296:                if ( .not. cloud_T1993base_inited ) then
   297:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   298:                end if
   299:            
   300:            
   301:                ! Parameters for evaporation of rain
   302:                Dens0 = 1013.0d2 / ( GasRDry * 300.0_DP )
   303:                V00 = RainFallVelFactor * sqrt( MedianDiameterFactor ) &
   304:                  & / ( PI * DensWater * RainDistFactor )**(1.0d0/8.0d0)
   305:                RainEvapFactor =                                      &
   306:            !      & RainEvapRatUnitDiamFactor * gamma( 13.0d0/5.0d0 ) &
   307:                  & RainEvapRatUnitDiamFactor * 1.429624558860304d0   &
   308:                  & * H2OVapDiffCoef * RainDistFactor**(7.0d0/20.0d0) &
   309:                  & / ( PI * DensWater )**(13.0d0/20.0d0)
   310:                ! Values for evaporation of rain
   311: **V---->       xyz_Dens = xyz_Press / ( GasRDry * xyz_VirTemp )
   312: |||        
   313: |||        
   314: |||            ! Save cloud water amount
   315: |||            !
   316: **V----        xyz_QCloudWaterB = xyz_QCloudWater
   317:            
   318:            
   319:                xyz_QH2OVapSat       = xyz_CalcQVapSat( xyz_Temp, xyz_Press )
   320:                xyz_DQH2OVapSatDTemp = xyz_CalcDQVapSatDTemp( xyz_Temp, xyz_QH2OVapSat )
   321:            
   322: **V---->       xyz_DQH2OVapSatDPress = xyz_QH2OVapSat / xyz_Press                           &
   323: |||              & * ( LatentHeat * GasRDry * xyz_VirTemp - CpDry * GasRWet * xyz_Temp**2 ) &
   324: |||              & / ( xyz_CloudCover * LatentHeat**2 * xyz_QH2OVapSat + CpDry * GasRWet * xyz_Temp**2 )
   325: |||        
   326: **V----        xyz_DQH2OVapSatDt =                                                            &
   327:                  &   xyz_DQH2OVapSatDPress * ( xyz_OMG + Grav * xyz_MoistConvSubsidMassFlux ) &
   328:                  & + xyz_DQH2OVapSatDTemp                                                      &
   329:                  &   / ( 1.0_DP + xyz_CloudCover * LatentHeat / CpDry * xyz_DQH2OVapSatDTemp ) &
   330:                  &   * xyz_DTempDtPhy
   331:            
   332:            
   333: +------>       do k = 1, kmax
   334: |+----->         do j = 1, jmax
   335: ||V---->           do i = 0, imax-1
   336: |||                  if ( xyz_DQH2OVapSatDt(i,j,k) < 0.0_DP ) then
   337: |||                    xyz_ZeroOneDQsDt(i,j,k) = 1.0_DP
   338: |||                  else
   339: |||                    xyz_ZeroOneDQsDt(i,j,k) = 0.0_DP
   340: |||                  end if
   341: ||V----            end do
   342: |+-----          end do
   343: +------        end do
   344:            
   345:            
   346:                ! Rain at the surface
   347: *V----->       xy_Rain     = 0.0_DP
   348: ||             ! Rain area
   349: *V-----        xy_RainArea = 0.0_DP
   350:            
   351: +------>       k_loop : do k = kmax, 1, -1
   352: |          
   353: |                ! Evaporation of rain
   354: |                !
   355: |                if ( k == kmax ) then
   356: |+V====            xy_RainArea = 0.0_DP
   357: |                else
   358: |+----->           do j = 1, jmax
   359: ||V---->             do i = 0, imax-1
   360: |||                    if ( xyz_Rain(i,j,k+1) > 0.0_DP ) then
   361: |||                      if ( xyz_CloudCover(i,j,k+1) > xy_RainArea(i,j) ) then
   362: |||                        xy_RainArea(i,j) = xyz_CloudCover(i,j,k+1)
   363: |||                      end if
   364: |||                    end if
   365: ||V----              end do
   366: |+-----            end do
   367: |                end if
   368: |*V---->         xy_DensRain =                                                      &
   369: |||                & ( xy_Rain / ( xy_RainArea + 1.0d-10 )                          &
   370: |||                &   / ( V00 * sqrt( Dens0 / xyz_Dens(:,:,k) ) ) )**(8.0d0/9.0d0)
   371: |||              xy_RainEvapArea = max( xy_RainArea - xyz_CloudCover(:,:,k), 0.0_DP )
   372: |*V----          xyz_RainEvapRate(:,:,k) =                                         &
   373: |                  & xyz_Dens(:,:,k) * xy_RainEvapArea * RainEvapFactor            &
   374: |                  &   * max( xyz_QH2OVapSat(:,:,k) - xyz_QH2OVap(:,:,k), 0.0_DP ) &
   375: |                  &   * xy_DensRain**(13.0d0/20.0d0)
   376: |+----->         do j = 1, jmax
   377: ||V---->           do i = 0, imax-1
   378: |||                  RainFallVel =                             &
   379: |||                    & V00 * sqrt( Dens0 / xyz_Dens(i,j,k) ) &
   380: |||                    &   * xy_DensRain(i,j)**(1.0d0/8.0d0)
   381: |||                  if ( xy_RainArea(i,j) * RainFallVel * xyz_RainEvapRate(i,j,k) &
   382: |||                    &    * 2.0_DP * DelTime                                     &
   383: |||                    &      > xy_Rain(i,j) ) then
   384: |||                    xyz_RainEvapRate(i,j,k) =                              &
   385: |||                      & xy_Rain(i,j)                                       &
   386: |||                      &   / ( ( xy_RainArea(i,j) + 1.0d-10 ) * RainFallVel &
   387: |||                      &       * 2.0_DP * DelTime )
   388: |||                    xy_DelRain(i,j) = - xy_Rain(i,j)
   389: |||                  else
   390: |||                    xy_DelRain(i,j) =                                    &
   391: |||                      & - xy_RainArea(i,j) * RainFallVel                 &
   392: |||                      & * xyz_RainEvapRate(i,j,k) * ( 2.0_DP * DelTime )
   393: |||                  end if
   394: |||                  xy_Rain(i,j) = xy_Rain(i,j) + xy_DelRain(i,j)
   395: |||        !!$            xyz_QH2OVap(i,j,k) = xyz_QH2OVap(i,j,k)              &
   396: |||        !!$              & + xyz_RainEvapRate(i,j,k) * ( 2.0_DP * DelTime ) &
   397: |||        !!$              &     / xyz_Dens(i,j,k)
   398: |||        !!$            xyz_Temp(i,j,k) = xyz_Temp(i,j,k)                    &
   399: |||        !!$              & - xyz_RainEvapRate(i,j,k) * ( 2.0_DP * DelTime ) &
   400: |||        !!$              &     / xyz_Dens(i,j,k)                            &
   401: |||        !!$              &     * LatentHeat / CpDry
   402: |||                  ! DelRain = DelQH2OVap * DelPress / Grav / ( 2.0_DP * DelTime )
   403: |||                  DelQH2OVap =                                             &
   404: |||                    & - xy_DelRain(i,j) * ( 2.0_DP * DelTime )             &
   405: |||                    &   * Grav / ( xyr_Press(i,j,k-1) - xyr_Press(i,j,k) )
   406: |||                  xyz_QH2OVap(i,j,k) = xyz_QH2OVap(i,j,k)                  &
   407: |||                    & + DelQH2OVap
   408: |||                  xyz_Temp(i,j,k) = xyz_Temp(i,j,k)                        &
   409: |||                    & - DelQH2OVap                                         &
   410: |||                    &   * LatentHeat / CpDry
   411: ||V----            end do
   412: |+-----          end do
   413: |          
   414: |          
   415: |+V====          xyz_FactC1(:,:,k) = xyz_MoistConvDetTend(:,:,k)
   416: |+----->         do j = 1, jmax
   417: ||V---->           do i = 0, imax-1
   418: |||                  if ( xyz_QH2OVap(i,j,k) < RHThreshold * xyz_QH2OVapSat(i,j,k) ) then
   419: |||                    xyz_FactC2(i,j,k) =                                         &
   420: |||                      & - ( 1.0_DP - xyz_CloudCover(i,j,k) )                    &
   421: |||                      &   / ( xyz_QH2OVapSat(i,j,k) - xyz_QH2OVap(i,j,k) )      &
   422: |||                      &   * xyz_DQH2OVapSatDt(i,j,k) * xyz_ZeroOneDQsDt(i,j,k)
   423: |||                  else
   424: |||        !!$              xyz_FactC2(i,j,k) = 0.0_DP
   425: |||                    xyz_FactC2(i,j,k) = 1.0_DP / ( 2.0_DP * DelTime )
   426: |||                  end if
   427: ||V----            end do
   428: |+-----          end do
   429: |+V====          xyz_FactC(:,:,k) = xyz_FactC1(:,:,k) + xyz_FactC2(:,:,k)
   430: |+----->         do j = 1, jmax
   431: ||V---->           do i = 0, imax-1
   432: |||                  if ( xyz_QH2OVapSat(i,j,k) > xyz_QH2OVap(i,j,k) ) then
   433: |||                    xyz_FactD(i,j,k) =                                      &
   434: |||                      & 2.0_DP * xyz_CloudCover(i,j,k) * MixCoef            &
   435: |||                      & * ( xyz_QH2OVapSat(i,j,k) - xyz_QH2OVap(i,j,k) )    &
   436: |||                      & / ( xyz_QCloudWater(i,j,k) + 1.0d-100 )
   437: |||                  else
   438: |||                    xyz_FactD(i,j,k) = 0.0_DP
   439: |||                  end if
   440: |||                end do
   441: |||              end do
   442: |||              !
   443: |||              do j = 1, jmax
   444: |||                do i = 0, imax-1
   445: |||                  if ( xyz_QH2OVap(i,j,k) < RHThreshold * xyz_QH2OVapSat(i,j,k) ) then
   446: |||                    xyz_FactE1(i,j,k) =                                             &
   447: |||                      &   ( 1.0_DP - xyz_CloudCover(i,j,k) )**2                     &
   448: |||                      & / ( 2.0_DP                                                  &
   449: |||                      &       * ( xyz_QH2OVapSat(i,j,k) - xyz_QH2OVap(i,j,k) ) )    &
   450: |||                      & * xyz_DQH2OVapSatDt(i,j,k) * xyz_ZeroOneDQsDt(i,j,k)
   451: |||                  else
   452: |||                    xyz_FactE1(i,j,k) = 0.0_DP
   453: |||                  end if
   454: |||                end do
   455: |||              end do
   456: |||              do j = 1, jmax
   457: |||                do i = 0, imax-1
   458: |||                  if ( xyz_QH2OVapSat(i,j,k) > xyz_QH2OVap(i,j,k) ) then
   459: |||                    xyz_FactE2(i,j,k) =                                     &
   460: |||                      & + xyz_CloudCover(i,j,k)**2 * MixCoef                &
   461: |||                      & * ( xyz_QH2OVapSat(i,j,k) - xyz_QH2OVap(i,j,k) )    &
   462: |||                      & / ( xyz_QCloudWater(i,j,k) + 1.0d-100 )
   463: |||                  else
   464: |||                    xyz_FactE2(i,j,k) = 0.0_DP
   465: |||                  end if
   466: ||V----            end do
   467: |+-----          end do
   468: |*V---->         xyz_FactE(:,:,k) = xyz_FactE1(:,:,k) + xyz_FactE2(:,:,k)
   469: |||              !
   470: |||              xyz_DelCloudCoverStr(:,:,k) =                                         &
   471: |||                &   xyz_FactC2(:,:,k) * 2.0_DP * DelTime                            &
   472: |||                & - xyz_FactC2(:,:,k)                                               &
   473: |||                &  / ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) + 1.0d-100 )             &
   474: |||                &   * (                                                             &
   475: |||                &         xyz_FactC(:,:,k) * 2.0_DP * DelTime                       &
   476: |||                &       + ( xyz_CloudCover(:,:,k)                                   &
   477: |||                &             - xyz_FactC(:,:,k)                                    &
   478: |||                &             / ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) + 1.0d-100 ) )&
   479: |||                &         * ( 1.0_DP                                                &
   480: |||                &               - exp( - ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) )    &
   481: |||                &                   * 2.0_DP * DelTime ) )                          &
   482: |||                &     )
   483: |||              !
   484: |||              xyz_FactA1(:,:,k) = xyz_DQCloudWaterDtCum(:,:,k)
   485: |*V----          xyz_FactA2(:,:,k) =                                                   &
   486: |                  & - xyz_CloudCover(:,:,k) * xyz_DQH2OVapSatDt(:,:,k)                &
   487: |                  & - xyz_DelCloudCoverStr(:,:,k) * xyz_DQH2OVapSatDt(:,:,k)          &
   488: |                  &     * xyz_ZeroOneDQsDt(:,:,k)                                     &
   489: |                  &     / 2.0_DP                                                      &
   490: |                  & - xyz_CloudCover(:,:,k) * MixCoef                                 &
   491: |                  &     * ( xyz_QH2OVapSat(:,:,k) - xyz_QH2OVap(:,:,k) )
   492: |                !    The value of xyz_FactA2 is checked, and is updated.
   493: |+----->         do j = 1, jmax
   494: ||V---->           do i = 0, imax-1
   495: |||                  if ( xyz_FactA2(i,j,k) * 2.0_DP * DelTime > xyz_QH2OVap(i,j,k) ) then
   496: |||                    xyz_FactA2(i,j,k) = xyz_QH2OVap(i,j,k) / ( 2.0_DP * DelTime )
   497: |||                  end if
   498: ||V----            end do
   499: |+-----          end do
   500: |+V====          xyz_FactA(:,:,k) = xyz_FactA1(:,:,k) + xyz_FactA2(:,:,k)
   501: |          
   502: |          
   503: |          !!$        xy_RainConvFactor = 1.0_DP / ( CloudLifeTime + 1.0d-100 )
   504: |                !
   505: |*V---->         xy_FactCo = 1.0_DP &
   506: |||                & + C1 * sqrt( xy_Rain )
   507: |||              xy_FactBF = 1.0_DP &
   508: |||                & + C2 * sqrt( max( 268.0_DP - xyz_Temp(:,:,k), 0.0_DP ) )
   509: |||              xy_QCloudWaterConvThreshold =                            &
   510: |||                & QCloudWaterConvThreshold / ( xy_FactCo * xy_FactBF )
   511: |||              xy_RainConvFactor = C0 * xy_FactCo * xy_FactBF              &
   512: |||                & * (                                                     &
   513: |||                &       1.0_DP                                            &
   514: |||                &     - exp(                                              &
   515: |||                &            - ( xyz_QCloudWater(:,:,k)                   &
   516: |||                &                / ( ( xyz_CloudCover(:,:,k) + 1.0d-100 ) &
   517: |||                &                    * xy_QCloudWaterConvThreshold ) )**2 &
   518: |||                &          )                                              &
   519: |||                &   )
   520: |||              !
   521: |*V----          xyz_FactB(:,:,k) = xy_RainConvFactor
   522: |                !
   523: |+----->         do j = 1, jmax
   524: ||V---->           do i = 0, imax-1
   525: |||                  if ( xyz_FactB(i,j,k) < 1.0_DP / 1.0d10 ) then
   526: |||                    xyz_FactB(i,j,k) = 1.0_DP / 1.0d10
   527: |||                  end if
   528: ||V----            end do
   529: |+-----          end do
   530: |          
   531: |          
   532: |                ! Values at next time step are calculated.
   533: |                !
   534: |+V====          xyz_QCloudWater(:,:,k) =                                             &
   535: |                  &   xyz_QCloudWater(:,:,k)                                         &
   536: |                  &     * exp( - xyz_FactB(:,:,k) * 2.0_DP * DelTime )               &
   537: |                  & + xyz_FactA(:,:,k) / xyz_FactB(:,:,k)                            &
   538: |                  &     * ( 1.0_DP - exp( - xyz_FactB(:,:,k) * 2.0_DP * DelTime ) )
   539: |                !   The value of cloud water amount is checked, and xyz_FactA 
   540: |                !   is updated.
   541: |+----->         do j = 1, jmax
   542: ||V---->           do i = 0, imax-1
   543: |||                  if ( xyz_QCloudWater(i,j,k) < 0.0_DP ) then
   544: |||                    xyz_FactA2(i,j,k) = - xyz_FactA1(i,j,k)                         &
   545: |||                      & - xyz_FactB(i,j,k) * xyz_QCloudWaterB(i,j,k)                &
   546: |||                      & * exp( - xyz_FactB(i,j,k) * 2.0_DP * DelTime )              &
   547: |||                      & / ( 1.0_DP - exp( - xyz_FactB(i,j,k) * 2.0_DP * DelTime ) )
   548: |||                    xyz_QCloudWater(i,j,k) = 0.0_DP
   549: |||                  end if
   550: ||V----            end do
   551: |+-----          end do
   552: |*V---->         xyz_FactA(:,:,k) = xyz_FactA1(:,:,k) + xyz_FactA2(:,:,k)
   553: |||              !
   554: |||              xyz_CloudCover(:,:,k) =                                            &
   555: |||                &   xyz_CloudCover(:,:,k)                                        &
   556: |||                &    * exp( - ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) )            &
   557: |||                &               * 2.0_DP * DelTime )                             &
   558: |||                & + ( xyz_FactC(:,:,k) + xyz_FactE(:,:,k) )                      &
   559: |||                &    / ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) + 1.0d-100 )        &
   560: |||                &    * ( 1.0_DP - exp( - ( xyz_FactC(:,:,k) + xyz_FactD(:,:,k) ) &
   561: |||                &                          * 2.0_DP * DelTime ) )
   562: |||              !
   563: |||              xyz_QH2OVap(:,:,k) = xyz_QH2OVap(:,:,k) &
   564: |||                & - xyz_FactA2(:,:,k) * 2.0_DP * DelTime
   565: |||              !
   566: |||              xyz_Temp(:,:,k) = xyz_Temp(:,:,k) &
   567: |||                & + xyz_FactA2(:,:,k) * 2.0_DP * DelTime * LatentHeat / CpDry
   568: |||        
   569: |||        
   570: |||              ! Rain
   571: |||              !
   572: |||              xyz_Rain(:,:,k) =                                                    &
   573: |||                &   xyz_FactA(:,:,k) * 2.0_DP * DelTime                            &
   574: |||                & + xyz_QCloudWaterB(:,:,k)                                        &
   575: |||                &    * ( 1.0_DP - exp( - xyz_FactB(:,:,k) * 2.0_DP * DelTime ) )   &
   576: |||                & - xyz_FactA(:,:,k) / xyz_FactB(:,:,k)                            &
   577: |||                &    * ( 1.0_DP - exp( - xyz_FactB(:,:,k) * 2.0_DP * DelTime ) )
   578: |||              xyz_Rain(:,:,k) = xyz_Rain(:,:,k) / ( 2.0_DP * DelTime )
   579: |||        
   580: |||              ! Rain at the surface
   581: |*V----          xy_Rain = xy_Rain     &
   582: |                  & + xyz_Rain(:,:,k) &
   583: |                  &    * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   584: |          
   585: |                ! Evaporation
   586: |                !
   587: |W----->         do j = 1, jmax
   588: ||*---->           do i = 0, imax-1
   589: |||                  if ( xyz_QCloudWater(i,j,k) < QCloudWaterEvapThreshold ) then
   590: |||                    xyz_CloudCover(i,j,k) = 0.0_DP
   591: |||                  end if
   592: ||*----            end do
   593: |W-----          end do
   594: |          
   595: |                ! Cloud cover is restricted.
   596: |W----->         do j = 1, jmax
   597: ||*---->           do i = 0, imax-1
   598: |||                  if ( xyz_CloudCover(i,j,k) > 1.0_DP ) then
   599: |||                    xyz_CloudCover(i,j,k) = 1.0_DP
   600: |||                  else if ( xyz_CloudCover(i,j,k) < 0.0_DP ) then
   601: |||                    xyz_CloudCover(i,j,k) = 0.0_DP
   602: |||                  end if
   603: ||*----            end do
   604: |W-----          end do
   605: |          
   606: |          
   607: |                ! Check values
   608: |+----->         do j = 1, jmax
   609: ||+---->           do i = 0, imax-1
   610: |||                  if ( xyz_QCloudWater(i,j,k) < 0.0_DP ) then
   611: |||                    write( 6, * ) 'QCloudWater is negative', &
   612: |||                      & i, j, k, xyz_QCloudWater(i,j,k)
   613: |||                  end if
   614: ||+----            end do
   615: |+-----          end do
   616: |          
   617: +------        end do k_loop
   618:            
   619:            
   620: **V---->       xyz_DTempDtLSC = 0.0_DP
   621: **V----        xyz_DQVapDtLSC = 0.0_DP
   622:            
   623:                ! 絬϶ŷ (ήŷ) (Manabe, 1965)
   624:                ! Large scale condensation (non-convective condensation) (Manabe, 1965)
   625:                !
   626:                call LScaleCond(                        &
   627:                  & xyz_Temp, xyz_QH2OVap,              & ! (inout)
   628:                  & xyz_DTempDtLSC, xyz_DQVapDtLSC,     & ! (inout)
   629:                  & xyz_Press, xyr_Press,               & ! (in)
   630:                  & xyz_RainLSC                         & ! (out)
   631:                  & )
   632:            
   633: +V=====        xy_RainLSC = 0.0_DP
   634: +------>       do k = kmax, 1, -1
   635: |+V====          xy_RainLSC = xy_RainLSC     &
   636: |                  & + xyz_RainLSC(:,:,k)    &
   637: |                  &    * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   638: +------        end do
   639:            
   640:            
   641: +V=====        xy_Rain = xy_Rain + xy_RainLSC
   642:            
   643:            
   644:                call CloudUtilsCalcPRCPKeyLLTemp(      &
   645:                  & xyz_Temp, xy_Rain,                 &  ! (in )
   646:                  & xy_SurfRainFlux, xy_SurfSnowFlux   &  ! (out)
   647:                  & )
   648:            
   649:            
   650:              end subroutine CloudT1993base
   651:            
   652:              !--------------------------------------------------------------------------------------
   653:            
   654:              subroutine CloudT1993baseInit( &
   655:                & ArgFlagSnow                &
   656:                & )
   657:            
   658:                ! ե
   659:                ! File I/O support
   660:                !
   661:                use dc_iounit, only: FileOpen
   662:            
   663:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   664:                ! Utilities for NAMELIST file input
   665:                !
   666:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   667:            
   668:                ! ҥȥǡ
   669:                ! History data output
   670:                !
   671:                use gtool_historyauto, only: HistoryAutoAddVariable
   672:            
   673:                ! 絬϶ŷ (ήŷ)
   674:                ! Large scale condensation (non-convective condensation)
   675:                !
   676:                use lscond, only : LScaleCondInit
   677:            
   678:            
   679:                ! ʸ ; Declaration statements
   680:                !
   681:            
   682:                logical, intent(in) :: ArgFlagSnow
   683:            
   684:            
   685:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   686:                                          ! Unit number for NAMELIST file open
   687:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   688:                                          ! IOSTAT of NAMELIST read
   689:            
   690:                ! NAMELIST ѿ
   691:                ! NAMELIST group name
   692:                !
   693:                namelist /cloud_T1993base_nml/ &
   694:                  & CloudLifeTime
   695:                      !
   696:                      ! ǥեͤˤĤƤϽ³ "cloud_T1993base#CloudT1993baseInit"
   697:                      ! Υɤ򻲾ȤΤ.
   698:                      !
   699:                      ! Refer to source codes in the initialization procedure
   700:                      ! "cloud_T1993base#CloudT1993baseInit" for the default values.
   701:                      !
   702:            
   703:                ! ¹ʸ ; Executable statement
   704:                !
   705:            
   706:                if ( cloud_T1993base_inited ) return
   707:            
   708:            
   709:                FlagSnow = ArgFlagSnow
   710:            
   711:            
   712:                ! ǥեͤ
   713:                ! Default values settings
   714:                !
   715:                CloudLifeTime       = 3600.0_DP
   716:            
   717:            
   718:                ! NAMELIST ɤ߹
   719:                ! NAMELIST is input
   720:                !
   721:                if ( trim(namelist_filename) /= '' ) then
   722:                  call FileOpen( unit_nml, &          ! (out)
   723:                    & namelist_filename, mode = 'r' ) ! (in)
   724:            
   725:                  rewind( unit_nml )
   726:                  read( unit_nml,                     & ! (in)
   727:                    & nml = cloud_T1993base_nml,      & ! (out)
   728:                    & iostat = iostat_nml )             ! (out)
   729:                  close( unit_nml )
   730:            
   731:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   732:                end if
   733:            
   734:            
   735:                ! Initialization of modules used in this module
   736:                !
   737:            
   738:                ! 絬϶ŷ (ήŷ) (Manabe, 1965)
   739:                ! Large scale condensation (non-convective condensation) (Le Treut and Li, 1991)
   740:                !
   741:                call LScaleCondInit
   742:            
   743:            
   744:                ! ҥȥǡϤΤΤؤѿϿ
   745:                ! Register of variables for history data output
   746:                !
   747:            !!$    call HistoryAutoAddVariable( 'EffCloudCover', &
   748:            !!$      & (/ 'lon ', 'lat ', 'time' /), &
   749:            !!$      & 'effective cloud cover', '1' )
   750:            
   751:            
   752:            
   753:                !  ; Print
   754:                !
   755:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   756:                call MessageNotify( 'M', module_name, 'CloudLifeTime       = %f', d = (/ CloudLifeTime /) )
   757:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   758:            
   759:            
   760:                cloud_T1993base_inited = .true.
   761:            
   762:              end subroutine CloudT1993baseInit
   763:            
   764:              !--------------------------------------------------------------------------------------
   765:            
   766:            end module cloud_T1993base
