Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:37 2012
FILE NAME: cloud_utils.f90
PROGRAM NAME: cloud_utils
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   139  opt  (  11): Fused array assignments. :line 139 - 142
   139  vec  (   4): Vectorized array expression.
   146  opt  (1593): Loop nest collapsed into one loop.
   146  vec  (   4): Vectorized array expression.
   192  opt  (1593): Loop nest collapsed into one loop.
   192  vec  (   1): Vectorized loop.
   206  opt  (  11): Fused array assignments. :line 206 - 207
   206  opt  (1593): Loop nest collapsed into one loop.
   206  vec  (   4): Vectorized array expression.
   254  opt  (1592): Outer loop unrolled inside inner loop.
   254  vec  (   4): Vectorized array expression.
   254  vec  (   4): Vectorized array expression.
   255  vec  (   3): Unvectorized loop.
   255  vec  (  13): Overhead of loop division is too large.
   256  opt  (1592): Outer loop unrolled inside inner loop.
   256  vec  (   4): Vectorized array expression.
   256  vec  (   4): Vectorized array expression.
   335  opt  (1592): Outer loop unrolled inside inner loop.
   335  vec  (   4): Vectorized array expression.
   335  vec  (   4): Vectorized array expression.
   339  opt  (1593): Loop nest collapsed into one loop.
   339  vec  (   4): Vectorized array expression.
   340  vec  (   3): Unvectorized loop.
   340  vec  (  13): Overhead of loop division is too large.
   341  opt  (1037): Feedback of array elements.
   341  opt  (1592): Outer loop unrolled inside inner loop.
   341  vec  (   4): Vectorized array expression.
   341  vec  (   4): Vectorized array expression.
   348  vec  (   3): Unvectorized loop.
   348  vec  (  13): Overhead of loop division is too large.
   349  opt  (1036): Potential feedback - use directive if OK.
   349  opt  (1593): Loop nest collapsed into one loop.
   349  vec  (   4): Vectorized array expression.
   357  opt  (1592): Outer loop unrolled inside inner loop.
   357  vec  (   4): Vectorized array expression.
   357  vec  (   4): Vectorized array expression.
   407  opt  (  11): Fused array assignments. :line 407 - 409
   407  vec  (   4): Vectorized array expression.
   407  vec  (   4): Vectorized array expression.
   409  opt  (1592): Outer loop unrolled inside inner loop.
   412  opt  (1593): Loop nest collapsed into one loop.
   412  vec  (   4): Vectorized array expression.
   422  vec  (   1): Vectorized loop.
   424  vec  (  26): Macro operation Search.
   425  opt  (1084): Branch out of the loop inhibits optimization.
   437  vec  (   1): Vectorized loop.
   477  opt  (1593): Loop nest collapsed into one loop.
   477  vec  (   4): Vectorized array expression.
   478  vec  (   3): Unvectorized loop.
   478  vec  (  13): Overhead of loop division is too large.
   479  opt  (1019): Feedback of scalar value from one loop pass to another.
   479  opt  (1592): Outer loop unrolled inside inner loop.
   479  vec  (   4): Vectorized array expression.
   479  vec  (   4): Vectorized array expression.
   484  opt  (1593): Loop nest collapsed into one loop.
   484  vec  (   4): Vectorized array expression.
   493  vec  (   3): Unvectorized loop.
   493  vec  (  13): Overhead of loop division is too large.
   494  opt  (1036): Potential feedback - use directive if OK.
   494  opt  (1593): Loop nest collapsed into one loop.
   494  vec  (   4): Vectorized array expression.
   536  opt  (1593): Loop nest collapsed into one loop.
   536  vec  (   4): Vectorized array expression.
   568  opt  (1593): Loop nest collapsed into one loop.
   568  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:37 2012
FILE NAME: cloud_utils.f90
PROGRAM NAME: cloud_utils
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != طϥ롼
     2  !
     3  != Cloud-related routines
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: cloud_utils.f90,v 1.1 2012-09-08 15:16:39 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  module cloud_utils
    12    !
    13    != طϥ롼
    14    !
    15    != Cloud-related routines
    16    !
    17    ! <b>Note that Japanese and English are described in parallel.</b>
    18    !
    19    ! ʬۤ.
    20    !
    21    ! In this module, the amount of cloud or cloud optical depth are set.
    22    ! This module is under development and is still a preliminary version.
    23    !
    24    !== Procedures List
    25    !
    26  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    27  !!$  ! ------------            :: ------------
    28  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    29    !
    30    !== NAMELIST
    31    !
    32    ! NAMELIST#cloud_utils_nml
    33    !
    34  
    35    ! ⥸塼 ; USE statements
    36  
    37    !
    38    ! Kind type parameter
    39    !
    40    use dc_types, only: DP, &      ! Double precision.
    41      &                 STRING, &  ! Strings.
    42      &                 TOKEN      ! Keywords.
    43  
    44    ! å
    45    ! Message output
    46    !
    47    use dc_message, only: MessageNotify
    48  
    49    ! ʻ
    50    ! Grid points settings
    51    !
    52    use gridset, only: imax, & ! ٳʻ.
    53                               ! Number of grid points in longitude
    54      &                jmax, & ! ٳʻ.
    55                               ! Number of grid points in latitude
    56      &                kmax    ! ľؿ.
    57                               ! Number of vertical level
    58  
    59    implicit none
    60  
    61    private
    62  
    63  
    64    ! ³
    65    ! Public procedure
    66    !
    67    public :: CloudUtilsWatFraction
    68    public :: CloudUtilsCalcPRCPKeyLLTemp
    69    public :: CloudUtilsCalcPRCPKeyLLTemp3D
    70    public :: CloudUtilsCalcOverlapCloudTrans
    71  !!$  public :: CloudUtilsSmearCloudOptDep
    72    public :: CloudUtilsLocalizeCloud
    73    public :: CloudUtilsInit
    74  
    75  
    76    ! ѿ
    77    ! Public variables
    78    !
    79  
    80  
    81    ! ѿ
    82    ! Private variables
    83    !
    84    logical , save        :: FlagSnow
    85                             ! A flag for snow
    86  
    87    integer , save        :: IDCloudOverlapType
    88    integer , parameter   :: IDCloudOverlapTypeRandom     = 1
    89    integer , parameter   :: IDCloudOverlapTypeMaxOverlap = 2
    90  
    91    real(DP), save        :: TempWatLim
    92    real(DP), save        :: TempIceLim
    93  
    94  
    95    logical, save :: cloud_utils_inited = .false.
    96                                ! ե饰.
    97                                ! Initialization flag
    98  
    99    character(*), parameter:: module_name = 'cloud_utils'
   100                                ! ⥸塼̾.
   101                                ! Module name
   102    character(*), parameter:: version = &
   103      & '$Name: dcpam5-20120921 $' // &
   104      & '$Id: cloud_utils.f90,v 1.1 2012-09-08 15:16:39 yot Exp $'
   105                                ! ⥸塼ΥС
   106                                ! Module version
   107  
   108    !--------------------------------------------------------------------------------------
   109  
   110  contains
   111  
   112    !--------------------------------------------------------------------------------------
   113  
   114    subroutine CloudUtilsWatFraction(   &
   115      & xyz_Temp,                       & ! (in )
   116      & xyz_WatFrac                     & ! (out)
   117      & )
   118  
   119      ! USE statements
   120      !
   121  
   122      real(DP), intent(in ) :: xyz_Temp   (0:imax-1, 1:jmax, 1:kmax)
   123      real(DP), intent(out) :: xyz_WatFrac(0:imax-1, 1:jmax, 1:kmax)
   124  
   125  
   126      ! ¹ʸ ; Executable statement
   127      !
   128  
   129      ! ǧ
   130      ! Initialization check
   131      !
   132      if ( .not. cloud_utils_inited ) then
   133        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   134      end if
   135  
   136  
   137      if ( FlagSnow ) then
   138  
   139        xyz_WatFrac = ( 1.0_DP - 0.0_DP ) / ( TempWatLim - TempIceLim ) &
   140          & * ( xyz_Temp - TempIceLim )
   141        xyz_WatFrac = min( xyz_WatFrac, 1.0_DP )
   142        xyz_WatFrac = max( xyz_WatFrac, 0.0_DP )
   143  
   144      else
   145  
   146        xyz_WatFrac = 1.0_DP
     .  !CDIR    NODEP                                                          
     .  !CDIR NOASSUME                                                          
     .        do t55 = 1, kmax*jmax*imax                                        
     .           xyz_watfrac(t55-1,1,1) = 1.00000000000000e+000                 
     .        end do                                                            
   147  
   148      end if
   149  
   150  
   151    end subroutine CloudUtilsWatFraction
   152  
   153    !--------------------------------------------------------------------------------------
   154  
   155    subroutine CloudUtilsCalcPRCPKeyLLTemp(  &
   156      & xyz_Temp, xy_PRCP,                   &  ! (in )
   157      & xy_SurfRainFlux, xy_SurfSnowFlux     &  ! (out)
   158      & )
   159  
   160  
   161      ! ȳɹ
   162      ! Setting constants of snow and sea ice
   163      !
   164      use constants_snowseaice, only: TempCondWater
   165  
   166  
   167      real(DP), intent(in ) :: xyz_Temp       ( 0:imax-1, 1:jmax, 1:kmax )
   168      real(DP), intent(in ) :: xy_PRCP        ( 0:imax-1, 1:jmax )
   169      real(DP), intent(out) :: xy_SurfRainFlux( 0:imax-1, 1:jmax )
   170      real(DP), intent(out) :: xy_SurfSnowFlux( 0:imax-1, 1:jmax )
   171  
   172  
   173      ! ѿ
   174      ! Work variables
   175      !
   176      integer:: i               ! ˲ DO 롼Ѻѿ
   177                                ! Work variables for DO loop in longitude
   178      integer:: j               ! ˲ DO 롼Ѻѿ
   179                                ! Work variables for DO loop in latitude
   180  
   181  
   182      ! ǧ
   183      ! Initialization check
   184      !
   185      if ( .not. cloud_utils_inited ) then
   186        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   187      end if
   188  
   189  
   190      if ( FlagSnow ) then
   191  
   192        do j = 1, jmax
   193          do i = 0, imax-1
   194            if ( xyz_Temp(i,j,1) > TempCondWater ) then
   195              xy_SurfRainFlux(i,j) = xy_PRCP(i,j)
   196              xy_SurfSnowFlux(i,j) = 0.0_DP
   197            else
   198              xy_SurfRainFlux(i,j) = 0.0_DP
   199              xy_SurfSnowFlux(i,j) = xy_PRCP(i,j)
   200            end if
   201          end do
   202        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           if (xyz_temp(j-1,1,1) .gt. tempcondwater) then                 
     .              xy_surfrainflux(j-1,1) = xy_prcp(j-1,1)                     
     .              xy_surfsnowflux(j-1,1) = 0.0000000000000000e+000            
     .           else                                                           
     .              xy_surfrainflux(j-1,1) = 0.0000000000000000e+000            
     .              xy_surfsnowflux(j-1,1) = xy_prcp(j-1,1)                     
     .           endif                                                          
     .        end do                                                            
     .        go to 10008                                                       
   203  
   204      else
   205  
   206        xy_SurfRainFlux = xy_PRCP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t90 = 1, jmax*imax                                             
     .           xy_surfrainflux(t90-1,1) = xy_prcp(t90-1,1)                    
     .           xy_surfsnowflux(t90-1,1) = 0.0000000000000000e+000             
     .        end do                                                            
   207        xy_SurfSnowFlux = 0.0_DP
   208  
   209      end if
   210  
   211  
   212    end subroutine CloudUtilsCalcPRCPKeyLLTemp
   213  
   214    !--------------------------------------------------------------------------------------
   215  
   216    subroutine CloudUtilsCalcPRCPKeyLLTemp3D(  &
   217      & xyr_Press, xyz_Temp, xyz_DQH2OLiqDt,   &  ! (in )
   218      & xy_SurfRainFlux, xy_SurfSnowFlux       &  ! (out)
   219      & )
   220  
   221      ! ʪ
   222      ! Physical constants settings
   223      !
   224      use constants, only:  &
   225        & Grav
   226                                ! $ g $ [m s-2].
   227                                ! ϲ®.
   228                                ! Gravitational acceleration
   229  
   230      real(DP), intent(in ) :: xyr_Press       ( 0:imax-1, 1:jmax, 0:kmax )
   231      real(DP), intent(in ) :: xyz_Temp        ( 0:imax-1, 1:jmax, 1:kmax )
   232      real(DP), intent(in ) :: xyz_DQH2OLiqDt  ( 0:imax-1, 1:jmax, 1:kmax )
   233      real(DP), intent(out) :: xy_SurfRainFlux ( 0:imax-1, 1:jmax )
   234      real(DP), intent(out) :: xy_SurfSnowFlux ( 0:imax-1, 1:jmax )
   235  
   236  
   237      ! ѿ
   238      ! Work variables
   239      !
   240      real(DP) :: xy_PRCP( 0:imax-1, 1:jmax )
   241  
   242      integer  :: k
   243  
   244  
   245      ! ǧ
   246      ! Initialization check
   247      !
   248      if ( .not. cloud_utils_inited ) then
   249        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   250      end if
   251  
   252  
   253  
   254      xy_PRCP = 0.0d0
     .        if (xy_prcp.DSC.U2 .gt. 0) then                                   
     .           J1 = and(xy_prcp.DSC.U2,3)                                     
     .  !CDIR    NODEP                                                          
     .           do t105 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t107 = 1, xy_prcp.DSC.U1 + 1                             
     .                 xy_prcp(t107-1,t105) = 0.0000000000000000e+000           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t105 = J1 + 1, xy_prcp.DSC.U2, 4                            
     .  !CDIR       NODEP                                                       
     .              do t107 = 1, xy_prcp.DSC.U1 + 1                             
     .                 xy_prcp(t107-1,t105) = 0.0000000000000000e+000           
     .                 xy_prcp(t107-1,t105+1) = 0.0000000000000000e+000         
     .                 xy_prcp(t107-1,t105+2) = 0.0000000000000000e+000         
     .                 xy_prcp(t107-1,t105+3) = 0.0000000000000000e+000         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   255      do k = kmax, 1, -1
   256        xy_PRCP = xy_PRCP                                       &
     .        if (xy_prcp.DSC.U2 .gt. 0) then                                   
     .           J2 = and(xy_prcp.DSC.U2,3)                                     
     .  !CDIR    NODEP                                                          
     .           do t111 = 1, J2                                                
     .              D1 = 1.D0/grav                                              
     .  !CDIR       NODEP                                                       
     .              do t113 = 1, xy_prcp.DSC.U1 + 1                             
     .                 xy_prcp(t113-1,t111) = xy_prcp(t113-1,t111) +            
     .       1            xyz_dqh2oliqdt(t113-1,t111,k)*(xyr_press(t113-1,t111,k
     .       2            -1)-xyr_press(t113-1,t111,k))*D1                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t111 = J2 + 1, xy_prcp.DSC.U2, 4                            
     .              D2 = 1.D0/grav                                              
     .              D3 = 1.D0/grav                                              
     .              D4 = 1.D0/grav                                              
     .              D5 = 1.D0/grav                                              
     .  !CDIR       NODEP                                                       
     .              do t113 = 1, xy_prcp.DSC.U1 + 1                             
     .                 xy_prcp(t113-1,t111) = xy_prcp(t113-1,t111) +            
     .       1            xyz_dqh2oliqdt(t113-1,t111,k)*(xyr_press(t113-1,t111,k
     .       2            -1)-xyr_press(t113-1,t111,k))*D2                      
     .                 xy_prcp(t113-1,t111+1) = xy_prcp(t113-1,t111+1) +        
     .       1            xyz_dqh2oliqdt(t113-1,t111+1,k)*(xyr_press(t113-1,t111
     .       2            +1,k-1)-xyr_press(t113-1,t111+1,k))*D3                
     .                 xy_prcp(t113-1,t111+2) = xy_prcp(t113-1,t111+2) +        
     .       1            xyz_dqh2oliqdt(t113-1,t111+2,k)*(xyr_press(t113-1,t111
     .       2            +2,k-1)-xyr_press(t113-1,t111+2,k))*D4                
     .                 xy_prcp(t113-1,t111+3) = xy_prcp(t113-1,t111+3) +        
     .       1            xyz_dqh2oliqdt(t113-1,t111+3,k)*(xyr_press(t113-1,t111
     .       2            +3,k-1)-xyr_press(t113-1,t111+3,k))*D5                
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   257          & + xyz_DQH2OLiqDt(:,:,k)                             &
   258          & * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   259      end do
   260  
   261  
   262      call CloudUtilsCalcPRCPKeyLLTemp(      &
   263        & xyz_Temp, xy_PRCP,                 &  ! (in )
   264        & xy_SurfRainFlux, xy_SurfSnowFlux   &  ! (out)
   265        & )
   266  
   267  
   268    end subroutine CloudUtilsCalcPRCPKeyLLTemp3D
   269  
   270    !--------------------------------------------------------------------------------------
   271  
   272    subroutine CloudUtilsCalcOverlapCloudTrans(  &
   273      & xyz_TransCloudOneLayer, xyz_CloudCover,  & ! (in)
   274      & xyrr_OverlappedCloudTrans                & ! (out)
   275      & )
   276  
   277      ! USE statements
   278      !
   279  
   280      ! ҥȥǡ
   281      ! History data output
   282      !
   283      use gtool_historyauto, only: HistoryAutoPut
   284  
   285      ! 
   286      ! Time control
   287      !
   288      use timeset, only: &
   289        & TimeN, &              ! ƥå $ t $ λ.
   290                                ! Time of step $ t $.
   291        & EndTime, &            ! ׻λ.
   292                                ! End time of calculation
   293        & TimesetClockStart, TimesetClockStop
   294  
   295  !!$    use sort, only : SortQuick
   296  
   297      real(DP), intent(in ) :: xyz_TransCloudOneLayer   (0:imax-1, 1:jmax, 1:kmax)
   298      real(DP), intent(in ) :: xyz_CloudCover           (0:imax-1, 1:jmax, 1:kmax)
   299      real(DP), intent(out) :: xyrr_OverlappedCloudTrans(0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   300  
   301  
   302      real(DP) :: xyz_EffCloudCover           (0:imax-1, 1:jmax, 1:kmax)
   303      real(DP) :: xyz_CloudCoverSorted        (0:imax-1, 1:jmax, 1:kmax)
   304      real(DP) :: xyz_EffCloudCoverSorted     (0:imax-1, 1:jmax, 1:kmax)
   305      real(DP) :: xyz_TransCloudOneLayerSorted(0:imax-1, 1:jmax, 1:kmax)
   306      real(DP) :: CloudCoverSortedCur
   307      real(DP) :: EffCloudCoverSortedCur
   308      real(DP) :: TransCloudOneLayerSortedCur
   309      integer  :: KInsPos
   310      integer  :: i
   311      integer  :: j
   312      integer  :: k
   313      integer  :: kk
   314      integer  :: kkk
   315  
   316  
   317  
   318      ! ¹ʸ ; Executable statement
   319      !
   320  
   321      ! ǧ
   322      ! Initialization check
   323      !
   324      if ( .not. cloud_utils_inited ) then
   325        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   326      end if
   327  
   328  
   329      ! Cloud optical depth
   330      !
   331  
   332      select case ( IDCloudOverlapType )
   333      case ( IDCloudOverlapTypeRandom )
   334  
   335        xyz_EffCloudCover = xyz_CloudCover * ( 1.0_DP - xyz_TransCloudOneLayer )
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t481 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t483 = 1, imax                                           
     .                 xyz_effcloudcover(t483-1,t481,t479+1) = xyz_cloudcover(  
     .       1            t483-1,t481,t479+1)*(1.00000000000000e+000 -          
     .       2            xyz_transcloudonelayer(t483-1,t481,t479+1))           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t481 = J1 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t483 = 1, imax                                           
     .                 xyz_effcloudcover(t483-1,t481,t479+1) = xyz_cloudcover(  
     .       1            t483-1,t481,t479+1)*(1.00000000000000e+000 -          
     .       2            xyz_transcloudonelayer(t483-1,t481,t479+1))           
     .                 xyz_effcloudcover(t483-1,t481+1,t479+1) = xyz_cloudcover(
     .       1            t483-1,t481+1,t479+1)*(1.00000000000000e+000 -        
     .       2            xyz_transcloudonelayer(t483-1,t481+1,t479+1))         
     .                 xyz_effcloudcover(t483-1,t481+2,t479+1) = xyz_cloudcover(
     .       1            t483-1,t481+2,t479+1)*(1.00000000000000e+000 -        
     .       2            xyz_transcloudonelayer(t483-1,t481+2,t479+1))         
     .                 xyz_effcloudcover(t483-1,t481+3,t479+1) = xyz_cloudcover(
     .       1            t483-1,t481+3,t479+1)*(1.00000000000000e+000 -        
     .       2            xyz_transcloudonelayer(t483-1,t481+3,t479+1))         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   336  
   337        do k = 0, kmax
   338          kk = k
   339          xyrr_OverlappedCloudTrans(:,:,k,kk) = 1.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t494 = 1, jmax*imax                                            
     .           xyrr_overlappedcloudtrans(t494-1,1,k,kk) =                     
     .       1      1.00000000000000e+000                                       
     .        end do                                                            
   340          do kk = k+1, kmax
   341            xyrr_OverlappedCloudTrans(:,:,k,kk) =        &
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t500 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t502 = 1, imax                                           
     .                 xyrr_overlappedcloudtrans(t502-1,t500,k,kk) =            
     .       1            xyrr_overlappedcloudtrans(t502-1,t500,k,kk-1)*(       
     .       2            1.00000000000000e+000 - xyz_effcloudcover(t502-1,t500,
     .       3            kk))                                                  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t500 = J2 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t502 = 1, imax                                           
     .                 xyrr_overlappedcloudtrans(t502-1,t500,k,kk) =            
     .       1            xyrr_overlappedcloudtrans(t502-1,t500,k,kk-1)*(       
     .       2            1.00000000000000e+000 - xyz_effcloudcover(t502-1,t500,
     .       3            kk))                                                  
     .                 xyrr_overlappedcloudtrans(t502-1,t500+1,k,kk) =          
     .       1            xyrr_overlappedcloudtrans(t502-1,t500+1,k,kk-1)*(     
     .       2            1.00000000000000e+000 - xyz_effcloudcover(t502-1,t500+
     .       3            1,kk))                                                
     .                 xyrr_overlappedcloudtrans(t502-1,t500+2,k,kk) =          
     .       1            xyrr_overlappedcloudtrans(t502-1,t500+2,k,kk-1)*(     
     .       2            1.00000000000000e+000 - xyz_effcloudcover(t502-1,t500+
     .       3            2,kk))                                                
     .                 xyrr_overlappedcloudtrans(t502-1,t500+3,k,kk) =          
     .       1            xyrr_overlappedcloudtrans(t502-1,t500+3,k,kk-1)*(     
     .       2            1.00000000000000e+000 - xyz_effcloudcover(t502-1,t500+
     .       3            3,kk))                                                
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   342              & xyrr_OverlappedCloudTrans(:,:,k,kk-1)    &
   343              & * ( 1.0_DP - xyz_EffCloudCover(:,:,kk) )
   344          end do
   345        end do
   346  
   347        do k = 0, kmax
   348          do kk = 0, k-1
   349            xyrr_OverlappedCloudTrans(:,:,k,kk) = xyrr_OverlappedCloudTrans(:,:,kk,k)
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t510 = 1, jmax*imax                                            
     .           xyrr_overlappedcloudtrans(t510-1,1,k,kk) =                     
     .       1      xyrr_overlappedcloudtrans(t510-1,1,kk,k)                    
     .        end do                                                            
   350          end do
   351        end do
   352  
   353      case ( IDCloudOverlapTypeMaxOverlap )
   354  
   355        ! see Chou et al. (2001)
   356  
   357        xyz_EffCloudCover = xyz_CloudCover * ( 1.0_DP - xyz_TransCloudOneLayer )
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t402 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t404 = 1, imax                                           
     .                 xyz_effcloudcover(t404-1,t402,t400+1) = xyz_cloudcover(  
     .       1            t404-1,t402,t400+1)*(1.00000000000000e+000 -          
     .       2            xyz_transcloudonelayer(t404-1,t402,t400+1))           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t402 = J3 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t404 = 1, imax                                           
     .                 xyz_effcloudcover(t404-1,t402,t400+1) = xyz_cloudcover(  
     .       1            t404-1,t402,t400+1)*(1.00000000000000e+000 -          
     .       2            xyz_transcloudonelayer(t404-1,t402,t400+1))           
     .                 xyz_effcloudcover(t404-1,t402+1,t400+1) = xyz_cloudcover(
     .       1            t404-1,t402+1,t400+1)*(1.00000000000000e+000 -        
     .       2            xyz_transcloudonelayer(t404-1,t402+1,t400+1))         
     .                 xyz_effcloudcover(t404-1,t402+2,t400+1) = xyz_cloudcover(
     .       1            t404-1,t402+2,t400+1)*(1.00000000000000e+000 -        
     .       2            xyz_transcloudonelayer(t404-1,t402+2,t400+1))         
     .                 xyz_effcloudcover(t404-1,t402+3,t400+1) = xyz_cloudcover(
     .       1            t404-1,t402+3,t400+1)*(1.00000000000000e+000 -        
     .       2            xyz_transcloudonelayer(t404-1,t402+3,t400+1))         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   358  
   359  
   360        ! Original method (computationally expensive, probably)
   361        !
   362  !!$        do k = 0, kmax
   363  !!$          kk = k
   364  !!$          xyrr_OverlappedCloudTrans(:,:,k,kk) = 1.0_DP
   365  !!$          do kk = k+1, kmax
   366  !!$
   367  !!$            xyz_CloudCoverSorted         = xyz_CloudCover
   368  !!$            xyz_EffCloudCoverSorted      = xyz_EffCloudCover
   369  !!$            xyz_TransCloudOneLayerSorted = xyz_TransCloudOneLayer
   370  !!$
   371  !!$            call SortQuick( imax, jmax, kk-k,             &
   372  !!$              & xyz_CloudCoverSorted        (:,:,k+1:kk), &
   373  !!$              & xyz_EffCloudCoverSorted     (:,:,k+1:kk), &
   374  !!$              & xyz_TransCloudOneLayerSorted(:,:,k+1:kk)  &
   375  !!$              & )
   376  !!$
   377  !!$            xyrr_OverlappedCloudTrans(:,:,k,kk) = 0.0_DP
   378  !!$            do kkk = k+1, kk
   379  !!$              xyrr_OverlappedCloudTrans(:,:,k,kk) =         &
   380  !!$                & xyz_EffCloudCoverSorted(:,:,kkk)          &
   381  !!$                & + xyrr_OverlappedCloudTrans(:,:,k,kk)     &
   382  !!$                &   * xyz_TransCloudOneLayerSorted(:,:,kkk)
   383  !!$            end do
   384  !!$            xyrr_OverlappedCloudTrans(:,:,k,kk) = &
   385  !!$              & 1.0_DP - xyrr_OverlappedCloudTrans(:,:,k,kk)
   386  !!$
   387  !!$          end do
   388  !!$        end do
   389  
   390  
   391        ! Economical method (probably)
   392        !
   393        do k = 0, kmax
   394  
   395  !!$          do kkk = 1, kmax
   396  !!$              xyz_CloudCoverSorted(:,:,kkk) = real( kmax-kkk ) / real(kmax)
   397  !!$!              xyz_CloudCoverSorted(:,:,kkk) = abs( 0.55d0 - real( kmax-kkk ) / real(kmax) )
   398  !!$          end do
   399  !!$          ! debug output
   400  !!$          if ( k == 0 ) then
   401  !!$            kk = kmax
   402  !!$            do kkk = k+1, kk
   403  !!$              write( 6, * ) kkk, xyz_CloudCoverSorted(0,jmax/2+1,kkk)
   404  !!$            end do
   405  !!$          end if
   406  
   407          xyz_CloudCoverSorted         = xyz_CloudCover
     .        if (xyz_cloudcoversorted.DSC.U2 .gt. 0) then                      
     .           J4 = and(xyz_cloudcoversorted.DSC.U2,1)                        
     .  !CDIR    NODEP                                                          
     .           do t417 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t419 = 1, xyz_cloudcoversorted.DSC.U1 + 1                
     .                 xyz_cloudcoversorted(t419-1,t417,t415+1) = xyz_cloudcover
     .       1            (t419-1,t417,t415+1)                                  
     .                 xyz_effcloudcoversorted(t419-1,t417,t415+1) =            
     .       1            xyz_effcloudcover(t419-1,t417,t415+1)                 
     .                 xyz_transcloudonelayersorted(t419-1,t417,t415+1) =       
     .       1            xyz_transcloudonelayer(t419-1,t417,t415+1)            
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t417 = J4 + 1, xyz_cloudcoversorted.DSC.U2, 2               
     .  !CDIR       NODEP                                                       
     .              do t419 = 1, xyz_cloudcoversorted.DSC.U1 + 1                
     .                 xyz_cloudcoversorted(t419-1,t417,t415+1) = xyz_cloudcover
     .       1            (t419-1,t417,t415+1)                                  
     .                 xyz_cloudcoversorted(t419-1,t417+1,t415+1) =             
     .       1            xyz_cloudcover(t419-1,t417+1,t415+1)                  
     .                 xyz_effcloudcoversorted(t419-1,t417,t415+1) =            
     .       1            xyz_effcloudcover(t419-1,t417,t415+1)                 
     .                 xyz_effcloudcoversorted(t419-1,t417+1,t415+1) =          
     .       1            xyz_effcloudcover(t419-1,t417+1,t415+1)               
     .                 xyz_transcloudonelayersorted(t419-1,t417,t415+1) =       
     .       1            xyz_transcloudonelayer(t419-1,t417,t415+1)            
     .                 xyz_transcloudonelayersorted(t419-1,t417+1,t415+1) =     
     .       1            xyz_transcloudonelayer(t419-1,t417+1,t415+1)          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   408          xyz_EffCloudCoverSorted      = xyz_EffCloudCover
   409          xyz_TransCloudOneLayerSorted = xyz_TransCloudOneLayer
   410  
   411          kk = k
   412          xyrr_OverlappedCloudTrans(:,:,k,kk) = 1.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t439 = 1, jmax*imax                                            
     .           xyrr_overlappedcloudtrans(t439-1,1,k,kk) =                     
     .       1      1.00000000000000e+000                                       
     .        end do                                                            
   413          do kk = k+1, kmax
   414  
   415  
   416            do j = 1, jmax
   417              do i = 0, imax-1
   418  
   419                ! xyz_CloudCoverSorted(i,j,kk) is inserved in an appropriate position.
   420                !
   421                KInsPos = kk
   422                loop : do kkk = k+1, kk-1
   423  
   424                  if ( xyz_CloudCoverSorted(i,j,kk) < xyz_CloudCoverSorted(i,j,kkk) ) then
   425                    KInsPos = kkk
   426                    exit loop
   427                  end if
   428  
   429                end do loop
   430  
   431                ! values are saved
   432                CloudCoverSortedCur         = xyz_CloudCoverSorted        (i,j,kk)
   433                EffCloudCoverSortedCur      = xyz_EffCloudCoverSorted     (i,j,kk)
   434                TransCloudOneLayerSortedCur = xyz_TransCloudOneLayerSorted(i,j,kk)
   435  
   436                ! values are shifted upward to empty an array at insert position
   437                do kkk = kk, KInsPos+1, -1
   438                  xyz_CloudCoverSorted        (i,j,kkk) = &
   439                    & xyz_CloudCoverSorted        (i,j,kkk-1)
   440                  xyz_EffCloudCoverSorted     (i,j,kkk) = &
   441                    & xyz_EffCloudCoverSorted     (i,j,kkk-1)
   442                  xyz_TransCloudOneLayerSorted(i,j,kkk) = &
   443                    & xyz_TransCloudOneLayerSorted(i,j,kkk-1)
   444                end do
     .  !CDIR NODEP                                                             
     .        do kkk = 1, kk - kinspos                                          
     .           xyz_cloudcoversorted(i,j,kk+1-kkk) = xyz_cloudcoversorted(i,j, 
     .       1      kk-kkk)                                                     
     .           xyz_effcloudcoversorted(i,j,kk+1-kkk) = xyz_effcloudcoversorted
     .       1      (i,j,kk-kkk)                                                
     .           xyz_transcloudonelayersorted(i,j,kk+1-kkk) =                   
     .       1      xyz_transcloudonelayersorted(i,j,kk-kkk)                    
     .        end do                                                            
   445                kkk = KInsPos
   446                xyz_CloudCoverSorted        (i,j,kkk) = CloudCoverSortedCur
   447                xyz_EffCloudCoverSorted     (i,j,kkk) = EffCloudCoverSortedCur
   448                xyz_TransCloudOneLayerSorted(i,j,kkk) = TransCloudOneLayerSortedCur
   449  
   450              end do
   451            end do
   452  
   453  
   454  !!$            xyz_CloudCoverSorted         = xyz_CloudCover
   455  !!$            do kkk = 1, kmax
   456  !!$              xyz_CloudCoverSorted(:,:,kkk) = real( kmax-kkk ) / real(kmax)
   457  !!$            end do
   458  !!$            xyz_EffCloudCoverSorted      = xyz_EffCloudCover
   459  !!$            xyz_TransCloudOneLayerSorted = xyz_TransCloudOneLayer
   460  !!$
   461  !!$            call SortQuick( imax, jmax, kk-k,             &
   462  !!$              & xyz_CloudCoverSorted        (:,:,k+1:kk), &
   463  !!$              & xyz_EffCloudCoverSorted     (:,:,k+1:kk), &
   464  !!$              & xyz_TransCloudOneLayerSorted(:,:,k+1:kk)  &
   465  !!$              & )
   466  
   467  
   468  !!$            ! debug output
   469  !!$            if ( ( k == 0 ) .and. ( kk == kmax-2 ) ) then
   470  !!$              do kkk = k+1, kk
   471  !!$                write( 6, * ) kkk, xyz_CloudCoverSorted(0,jmax/2+1,kkk)
   472  !!$              end do
   473  !!$              write( 6, * ) '-----'
   474  !!$            end if
   475  
   476  
   477            xyrr_OverlappedCloudTrans(:,:,k,kk) = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t445 = 1, jmax*imax                                            
     .           xyrr_overlappedcloudtrans(t445-1,1,k,kk) =                     
     .       1      0.0000000000000000e+000                                     
     .        end do                                                            
   478            do kkk = k+1, kk
   479              xyrr_OverlappedCloudTrans(:,:,k,kk) =         &
     .        if (xyz_effcloudcoversorted.DSC.U2 .gt. 0) then                   
     .           J5 = and(xyz_effcloudcoversorted.DSC.U2,3)                     
     .  !CDIR    NODEP                                                          
     .           do t451 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t453 = 1, xyz_effcloudcoversorted.DSC.U1 + 1             
     .                 xyrr_overlappedcloudtrans(t453-1,t451,k,kk) =            
     .       1            xyz_effcloudcoversorted(t453-1,t451,kkk) +            
     .       2            xyrr_overlappedcloudtrans(t453-1,t451,k,kk)*          
     .       3            xyz_transcloudonelayersorted(t453-1,t451,kkk)         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t451 = J5 + 1, xyz_effcloudcoversorted.DSC.U2, 4            
     .  !CDIR       NODEP                                                       
     .              do t453 = 1, xyz_effcloudcoversorted.DSC.U1 + 1             
     .                 xyrr_overlappedcloudtrans(t453-1,t451,k,kk) =            
     .       1            xyz_effcloudcoversorted(t453-1,t451,kkk) +            
     .       2            xyrr_overlappedcloudtrans(t453-1,t451,k,kk)*          
     .       3            xyz_transcloudonelayersorted(t453-1,t451,kkk)         
     .                 xyrr_overlappedcloudtrans(t453-1,t451+1,k,kk) =          
     .       1            xyz_effcloudcoversorted(t453-1,t451+1,kkk) +          
     .       2            xyrr_overlappedcloudtrans(t453-1,t451+1,k,kk)*        
     .       3            xyz_transcloudonelayersorted(t453-1,t451+1,kkk)       
     .                 xyrr_overlappedcloudtrans(t453-1,t451+2,k,kk) =          
     .       1            xyz_effcloudcoversorted(t453-1,t451+2,kkk) +          
     .       2            xyrr_overlappedcloudtrans(t453-1,t451+2,k,kk)*        
     .       3            xyz_transcloudonelayersorted(t453-1,t451+2,kkk)       
     .                 xyrr_overlappedcloudtrans(t453-1,t451+3,k,kk) =          
     .       1            xyz_effcloudcoversorted(t453-1,t451+3,kkk) +          
     .       2            xyrr_overlappedcloudtrans(t453-1,t451+3,k,kk)*        
     .       3            xyz_transcloudonelayersorted(t453-1,t451+3,kkk)       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   480                & xyz_EffCloudCoverSorted(:,:,kkk)          &
   481                & + xyrr_OverlappedCloudTrans(:,:,k,kk)     &
   482                &   * xyz_TransCloudOneLayerSorted(:,:,kkk)
   483            end do
   484            xyrr_OverlappedCloudTrans(:,:,k,kk) = &
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t463 = 1, jmax*imax                                            
     .           xyrr_overlappedcloudtrans(t463-1,1,k,kk) =                     
     .       1      1.00000000000000e+000 - xyrr_overlappedcloudtrans(t463-1,1,k
     .       2      ,kk)                                                        
     .        end do                                                            
   485              & 1.0_DP - xyrr_OverlappedCloudTrans(:,:,k,kk)
   486  
   487          end do
   488        end do
   489  
   490  
   491  
   492        do k = 0, kmax
   493          do kk = 0, k-1
   494            xyrr_OverlappedCloudTrans(:,:,k,kk) = xyrr_OverlappedCloudTrans(:,:,kk,k)
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t471 = 1, jmax*imax                                            
     .           xyrr_overlappedcloudtrans(t471-1,1,k,kk) =                     
     .       1      xyrr_overlappedcloudtrans(t471-1,1,kk,k)                    
     .        end do                                                            
   495          end do
   496        end do
   497  
   498  
   499      end select
   500  
   501      ! Output effective cloud cover
   502      !
   503  !!$    call HistoryAutoPut( TimeN, 'EffCloudCover', &
   504  !!$      & 1.0_DP - xyrr_OverlappedCloudTrans(:,:,0,kmax) )
   505  
   506  
   507    end subroutine CloudUtilsCalcOverlapCloudTrans
   508  
   509    !--------------------------------------------------------------------------------------
   510  
   511    subroutine CloudUtilsSmearCloudOptDep(  &
   512      & xyz_CloudCover,                     & ! (in   )
   513      & xyz_DelCloudOptDep                  & ! (inout)
   514      & )
   515  
   516      ! USE statements
   517      !
   518  
   519      real(DP), intent(in   ) :: xyz_CloudCover    (0:imax-1, 1:jmax, 1:kmax)
   520      real(DP), intent(inout) :: xyz_DelCloudOptDep(0:imax-1, 1:jmax, 1:kmax)
   521  
   522  
   523      ! ¹ʸ ; Executable statement
   524      !
   525  
   526      ! ǧ
   527      ! Initialization check
   528      !
   529      if ( .not. cloud_utils_inited ) then
   530        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   531      end if
   532  
   533  
   534      ! Cloud optical depth is scaled by the way of Kiehl et al. (1994).
   535  
   536      xyz_DelCloudOptDep = xyz_DelCloudOptDep * xyz_CloudCover**1.5_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t41 = 1, kmax*jmax*imax                                        
     .           xyz_delcloudoptdep(t41-1,1,1) = xyz_delcloudoptdep(t41-1,1,1)* 
     .       1      xyz_cloudcover(t41-1,1,1)**1.50000000000000e+000            
     .        end do                                                            
   537  
   538  
   539    end subroutine CloudUtilsSmearCloudOptDep
   540  
   541    !--------------------------------------------------------------------------------------
   542  
   543    subroutine CloudUtilsLocalizeCloud(  &
   544      & xyz_CloudCover,                  & ! (in   )
   545      & xyz_DelCloudOptDep               & ! (inout)
   546      & )
   547  
   548      ! USE statements
   549      !
   550  
   551      real(DP), intent(in   ) :: xyz_CloudCover    (0:imax-1, 1:jmax, 1:kmax)
   552      real(DP), intent(inout) :: xyz_DelCloudOptDep(0:imax-1, 1:jmax, 1:kmax)
   553  
   554  
   555      ! ¹ʸ ; Executable statement
   556      !
   557  
   558      ! ǧ
   559      ! Initialization check
   560      !
   561      if ( .not. cloud_utils_inited ) then
   562        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   563      end if
   564  
   565  
   566      ! Cloud optical depth is scaled by considering cloud cover less than 1.
   567  
   568      xyz_DelCloudOptDep = xyz_DelCloudOptDep / max( xyz_CloudCover, 1.0d-3 )
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t41 = 1, kmax*jmax*imax                                        
     .           xyz_delcloudoptdep(t41-1,1,1) = xyz_delcloudoptdep(t41-1,1,1)/ 
     .       1      max(xyz_cloudcover(t41-1,1,1),1.00000000000000e-003)        
     .        end do                                                            
   569  
   570  
   571    end subroutine CloudUtilsLocalizeCloud
   572  
   573    !--------------------------------------------------------------------------------------
   574  
   575    subroutine CloudUtilsInit( &
   576      & ArgFlagSnow            &
   577      & )
   578  
   579      ! ե
   580      ! File I/O support
   581      !
   582      use dc_iounit, only: FileOpen
   583  
   584      ! NAMELIST եϤ˴ؤ桼ƥƥ
   585      ! Utilities for NAMELIST file input
   586      !
   587      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   588  
   589      ! ҥȥǡ
   590      ! History data output
   591      !
   592      use gtool_historyauto, only: HistoryAutoAddVariable
   593  
   594      ! 絬϶ŷ (ήŷ)
   595      ! Large scale condensation (non-convective condensation)
   596      !
   597      use lscond, only : LScaleCondInit
   598  
   599  
   600      ! ʸ ; Declaration statements
   601      !
   602  
   603      logical, intent(in) :: ArgFlagSnow
   604  
   605  
   606      character(STRING) :: CloudOverlapType
   607  
   608      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   609                                ! Unit number for NAMELIST file open
   610      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   611                                ! IOSTAT of NAMELIST read
   612  
   613      ! NAMELIST ѿ
   614      ! NAMELIST group name
   615      !
   616      namelist /cloud_utils_nml/ &
   617        & CloudOverlapType,      &
   618        & TempWatLim,          &
   619        & TempIceLim
   620            !
   621            ! ǥեͤˤĤƤϽ³ "cloud_utils#CloudUtilsInit"
   622            ! Υɤ򻲾ȤΤ.
   623            !
   624            ! Refer to source codes in the initialization procedure
   625            ! "cloud_utils#CloudUtilsInit" for the default values.
   626            !
   627  
   628      ! ¹ʸ ; Executable statement
   629      !
   630  
   631      if ( cloud_utils_inited ) return
   632  
   633  
   634      FlagSnow = ArgFlagSnow
   635  
   636  
   637      ! ǥեͤ
   638      ! Default values settings
   639      !
   640  
   641      CloudOverlapType    = "Random"
   642  !!$    CloudOverlapType    = "MaxOverlap"
   643  
   644      TempWatLim          = 273.15_DP
   645      TempIceLim          = 273.15_DP - 40.0_DP
   646  
   647  
   648      ! NAMELIST ɤ߹
   649      ! NAMELIST is input
   650      !
   651      if ( trim(namelist_filename) /= '' ) then
   652        call FileOpen( unit_nml, &          ! (out)
   653          & namelist_filename, mode = 'r' ) ! (in)
   654  
   655        rewind( unit_nml )
   656        read( unit_nml,                     & ! (in)
   657          & nml = cloud_utils_nml,          & ! (out)
   658          & iostat = iostat_nml )             ! (out)
   659        close( unit_nml )
   660  
   661        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   662      end if
   663  
   664  
   665      select case ( CloudOverlapType )
   666      case ( 'Random' )
   667        IDCloudOverlapType = IDCloudOverlapTypeRandom
   668      case ( 'MaxOverlap' )
   669        IDCloudOverlapType = IDCloudOverlapTypeMaxOverlap
   670      case default
   671        call MessageNotify( 'E', module_name,         &
   672          & 'CloudOverlapType=<%c> is not supported.', &
   673          & c1 = trim(CloudOverlapType) )
   674      end select
   675  
   676  
   677      ! Initialization of modules used in this module
   678      !
   679  
   680      ! 絬϶ŷ (ήŷ) (Manabe, 1965)
   681      ! Large scale condensation (non-convective condensation) (Le Treut and Li, 1991)
   682      !
   683      call LScaleCondInit
   684  
   685  
   686      ! ҥȥǡϤΤΤؤѿϿ
   687      ! Register of variables for history data output
   688      !
   689  !!$    call HistoryAutoAddVariable( 'EffCloudCover', &
   690  !!$      & (/ 'lon ', 'lat ', 'time' /), &
   691  !!$      & 'effective cloud cover', '1' )
   692  
   693  
   694  
   695      !  ; Print
   696      !
   697      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   698      call MessageNotify( 'M', module_name, 'CloudOverlapType = %c', c1 = trim(CloudOverlapType) )
   699      call MessageNotify( 'M', module_name, 'TempWatLim       = %f', d = (/ TempWatLim /) )
   700      call MessageNotify( 'M', module_name, 'TempIceLim       = %f', d = (/ TempIceLim /) )
   701      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   702  
   703  
   704      cloud_utils_inited = .true.
   705  
   706    end subroutine CloudUtilsInit
   707  
   708    !--------------------------------------------------------------------------------------
   709  
   710  end module cloud_utils
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:37 2012
FILE NAME: cloud_utils.f90
PROGRAM NAME: cloud_utils
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != طϥ롼
     2:            !
     3:            != Cloud-related routines
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: cloud_utils.f90,v 1.1 2012-09-08 15:16:39 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            module cloud_utils
    12:              !
    13:              != طϥ롼
    14:              !
    15:              != Cloud-related routines
    16:              !
    17:              ! <b>Note that Japanese and English are described in parallel.</b>
    18:              !
    19:              ! ʬۤ.
    20:              !
    21:              ! In this module, the amount of cloud or cloud optical depth are set.
    22:              ! This module is under development and is still a preliminary version. 
    23:              !
    24:              !== Procedures List
    25:              !
    26:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    27:            !!$  ! ------------            :: ------------
    28:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    29:              !
    30:              !== NAMELIST
    31:              !
    32:              ! NAMELIST#cloud_utils_nml
    33:              !
    34:            
    35:              ! ⥸塼 ; USE statements
    36:            
    37:              !
    38:              ! Kind type parameter
    39:              !
    40:              use dc_types, only: DP, &      ! Double precision.
    41:                &                 STRING, &  ! Strings.
    42:                &                 TOKEN      ! Keywords.
    43:            
    44:              ! å
    45:              ! Message output
    46:              !
    47:              use dc_message, only: MessageNotify
    48:            
    49:              ! ʻ
    50:              ! Grid points settings
    51:              !
    52:              use gridset, only: imax, & ! ٳʻ.
    53:                                         ! Number of grid points in longitude
    54:                &                jmax, & ! ٳʻ.
    55:                                         ! Number of grid points in latitude
    56:                &                kmax    ! ľؿ.
    57:                                         ! Number of vertical level
    58:            
    59:              implicit none
    60:            
    61:              private
    62:            
    63:            
    64:              ! ³
    65:              ! Public procedure
    66:              !
    67:              public :: CloudUtilsWatFraction
    68:              public :: CloudUtilsCalcPRCPKeyLLTemp
    69:              public :: CloudUtilsCalcPRCPKeyLLTemp3D
    70:              public :: CloudUtilsCalcOverlapCloudTrans
    71:            !!$  public :: CloudUtilsSmearCloudOptDep
    72:              public :: CloudUtilsLocalizeCloud
    73:              public :: CloudUtilsInit
    74:            
    75:            
    76:              ! ѿ
    77:              ! Public variables
    78:              !
    79:            
    80:            
    81:              ! ѿ
    82:              ! Private variables
    83:              !
    84:              logical , save        :: FlagSnow
    85:                                       ! A flag for snow
    86:            
    87:              integer , save        :: IDCloudOverlapType
    88:              integer , parameter   :: IDCloudOverlapTypeRandom     = 1
    89:              integer , parameter   :: IDCloudOverlapTypeMaxOverlap = 2
    90:            
    91:              real(DP), save        :: TempWatLim
    92:              real(DP), save        :: TempIceLim
    93:            
    94:            
    95:              logical, save :: cloud_utils_inited = .false.
    96:                                          ! ե饰.
    97:                                          ! Initialization flag
    98:            
    99:              character(*), parameter:: module_name = 'cloud_utils'
   100:                                          ! ⥸塼̾.
   101:                                          ! Module name
   102:              character(*), parameter:: version = &
   103:                & '$Name: dcpam5-20120921 $' // &
   104:                & '$Id: cloud_utils.f90,v 1.1 2012-09-08 15:16:39 yot Exp $'
   105:                                          ! ⥸塼ΥС
   106:                                          ! Module version
   107:            
   108:              !--------------------------------------------------------------------------------------
   109:            
   110:            contains
   111:            
   112:              !--------------------------------------------------------------------------------------
   113:            
   114:              subroutine CloudUtilsWatFraction(   &
   115:                & xyz_Temp,                       & ! (in )
   116:                & xyz_WatFrac                     & ! (out)
   117:                & )
   118:            
   119:                ! USE statements
   120:                !
   121:            
   122:                real(DP), intent(in ) :: xyz_Temp   (0:imax-1, 1:jmax, 1:kmax)
   123:                real(DP), intent(out) :: xyz_WatFrac(0:imax-1, 1:jmax, 1:kmax)
   124:            
   125:            
   126:                ! ¹ʸ ; Executable statement
   127:                !
   128:            
   129:                ! ǧ
   130:                ! Initialization check
   131:                !
   132:                if ( .not. cloud_utils_inited ) then
   133:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   134:                end if
   135:            
   136:            
   137:                if ( FlagSnow ) then
   138:            
   139: **V---->         xyz_WatFrac = ( 1.0_DP - 0.0_DP ) / ( TempWatLim - TempIceLim ) &
   140: |||                & * ( xyz_Temp - TempIceLim )
   141: |||              xyz_WatFrac = min( xyz_WatFrac, 1.0_DP )
   142: **V----          xyz_WatFrac = max( xyz_WatFrac, 0.0_DP )
   143:            
   144:                else
   145:            
   146: W**====          xyz_WatFrac = 1.0_DP
   147:            
   148:                end if
   149:            
   150:            
   151:              end subroutine CloudUtilsWatFraction
   152:            
   153:              !--------------------------------------------------------------------------------------
   154:            
   155:              subroutine CloudUtilsCalcPRCPKeyLLTemp(  &
   156:                & xyz_Temp, xy_PRCP,                   &  ! (in )
   157:                & xy_SurfRainFlux, xy_SurfSnowFlux     &  ! (out)
   158:                & )
   159:            
   160:            
   161:                ! ȳɹ
   162:                ! Setting constants of snow and sea ice
   163:                !
   164:                use constants_snowseaice, only: TempCondWater
   165:            
   166:            
   167:                real(DP), intent(in ) :: xyz_Temp       ( 0:imax-1, 1:jmax, 1:kmax )
   168:                real(DP), intent(in ) :: xy_PRCP        ( 0:imax-1, 1:jmax )
   169:                real(DP), intent(out) :: xy_SurfRainFlux( 0:imax-1, 1:jmax )
   170:                real(DP), intent(out) :: xy_SurfSnowFlux( 0:imax-1, 1:jmax )
   171:            
   172:            
   173:                ! ѿ
   174:                ! Work variables
   175:                !
   176:                integer:: i               ! ˲ DO 롼Ѻѿ
   177:                                          ! Work variables for DO loop in longitude
   178:                integer:: j               ! ˲ DO 롼Ѻѿ
   179:                                          ! Work variables for DO loop in latitude
   180:            
   181:            
   182:                ! ǧ
   183:                ! Initialization check
   184:                !
   185:                if ( .not. cloud_utils_inited ) then
   186:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   187:                end if
   188:            
   189:            
   190:                if ( FlagSnow ) then
   191:            
   192: W------>         do j = 1, jmax
   193: |*----->           do i = 0, imax-1
   194: ||                   if ( xyz_Temp(i,j,1) > TempCondWater ) then
   195: ||                     xy_SurfRainFlux(i,j) = xy_PRCP(i,j)
   196: ||                     xy_SurfSnowFlux(i,j) = 0.0_DP
   197: ||                   else
   198: ||                     xy_SurfRainFlux(i,j) = 0.0_DP
   199: ||                     xy_SurfSnowFlux(i,j) = xy_PRCP(i,j)
   200: ||                   end if
   201: |*-----            end do
   202: W------          end do
   203:            
   204:                else
   205:            
   206: *W----->         xy_SurfRainFlux = xy_PRCP
   207: *W-----          xy_SurfSnowFlux = 0.0_DP
   208:            
   209:                end if
   210:            
   211:            
   212:              end subroutine CloudUtilsCalcPRCPKeyLLTemp
   213:            
   214:              !--------------------------------------------------------------------------------------
   215:            
   216:              subroutine CloudUtilsCalcPRCPKeyLLTemp3D(  &
   217:                & xyr_Press, xyz_Temp, xyz_DQH2OLiqDt,   &  ! (in )
   218:                & xy_SurfRainFlux, xy_SurfSnowFlux       &  ! (out)
   219:                & )
   220:            
   221:                ! ʪ
   222:                ! Physical constants settings
   223:                !
   224:                use constants, only:  &
   225:                  & Grav
   226:                                          ! $ g $ [m s-2].
   227:                                          ! ϲ®.
   228:                                          ! Gravitational acceleration
   229:            
   230:                real(DP), intent(in ) :: xyr_Press       ( 0:imax-1, 1:jmax, 0:kmax )
   231:                real(DP), intent(in ) :: xyz_Temp        ( 0:imax-1, 1:jmax, 1:kmax )
   232:                real(DP), intent(in ) :: xyz_DQH2OLiqDt  ( 0:imax-1, 1:jmax, 1:kmax )
   233:                real(DP), intent(out) :: xy_SurfRainFlux ( 0:imax-1, 1:jmax )
   234:                real(DP), intent(out) :: xy_SurfSnowFlux ( 0:imax-1, 1:jmax )
   235:            
   236:            
   237:                ! ѿ
   238:                ! Work variables
   239:                !
   240:                real(DP) :: xy_PRCP( 0:imax-1, 1:jmax )
   241:            
   242:                integer  :: k
   243:            
   244:            
   245:                ! ǧ
   246:                ! Initialization check
   247:                !
   248:                if ( .not. cloud_utils_inited ) then
   249:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   250:                end if
   251:            
   252:            
   253:            
   254: +V=====        xy_PRCP = 0.0d0
   255: +------>       do k = kmax, 1, -1
   256: |+V====          xy_PRCP = xy_PRCP                                       &
   257: |                  & + xyz_DQH2OLiqDt(:,:,k)                             &
   258: |                  & * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   259: +------        end do
   260:            
   261:            
   262:                call CloudUtilsCalcPRCPKeyLLTemp(      &
   263:                  & xyz_Temp, xy_PRCP,                 &  ! (in )
   264:                  & xy_SurfRainFlux, xy_SurfSnowFlux   &  ! (out)
   265:                  & )
   266:            
   267:            
   268:              end subroutine CloudUtilsCalcPRCPKeyLLTemp3D
   269:            
   270:              !--------------------------------------------------------------------------------------
   271:            
   272:              subroutine CloudUtilsCalcOverlapCloudTrans(  &
   273:                & xyz_TransCloudOneLayer, xyz_CloudCover,  & ! (in)
   274:                & xyrr_OverlappedCloudTrans                & ! (out)
   275:                & )
   276:            
   277:                ! USE statements
   278:                !
   279:            
   280:                ! ҥȥǡ
   281:                ! History data output
   282:                !
   283:                use gtool_historyauto, only: HistoryAutoPut
   284:            
   285:                ! 
   286:                ! Time control
   287:                !
   288:                use timeset, only: &
   289:                  & TimeN, &              ! ƥå $ t $ λ.
   290:                                          ! Time of step $ t $.
   291:                  & EndTime, &            ! ׻λ.
   292:                                          ! End time of calculation
   293:                  & TimesetClockStart, TimesetClockStop
   294:            
   295:            !!$    use sort, only : SortQuick
   296:            
   297:                real(DP), intent(in ) :: xyz_TransCloudOneLayer   (0:imax-1, 1:jmax, 1:kmax)
   298:                real(DP), intent(in ) :: xyz_CloudCover           (0:imax-1, 1:jmax, 1:kmax)
   299:                real(DP), intent(out) :: xyrr_OverlappedCloudTrans(0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   300:            
   301:            
   302:                real(DP) :: xyz_EffCloudCover           (0:imax-1, 1:jmax, 1:kmax)
   303:                real(DP) :: xyz_CloudCoverSorted        (0:imax-1, 1:jmax, 1:kmax)
   304:                real(DP) :: xyz_EffCloudCoverSorted     (0:imax-1, 1:jmax, 1:kmax)
   305:                real(DP) :: xyz_TransCloudOneLayerSorted(0:imax-1, 1:jmax, 1:kmax)
   306:                real(DP) :: CloudCoverSortedCur
   307:                real(DP) :: EffCloudCoverSortedCur
   308:                real(DP) :: TransCloudOneLayerSortedCur
   309:                integer  :: KInsPos
   310:                integer  :: i
   311:                integer  :: j
   312:                integer  :: k
   313:                integer  :: kk
   314:                integer  :: kkk
   315:            
   316:            
   317:            
   318:                ! ¹ʸ ; Executable statement
   319:                !
   320:            
   321:                ! ǧ
   322:                ! Initialization check
   323:                !
   324:                if ( .not. cloud_utils_inited ) then
   325:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   326:                end if
   327:            
   328:            
   329:                ! Cloud optical depth
   330:                !
   331:            
   332:                select case ( IDCloudOverlapType )
   333:                case ( IDCloudOverlapTypeRandom )
   334:            
   335: ++V====          xyz_EffCloudCover = xyz_CloudCover * ( 1.0_DP - xyz_TransCloudOneLayer )
   336:            
   337: +------>         do k = 0, kmax
   338: |                  kk = k
   339: |W*====            xyrr_OverlappedCloudTrans(:,:,k,kk) = 1.0_DP
   340: |+----->           do kk = k+1, kmax
   341: ||+V===              xyrr_OverlappedCloudTrans(:,:,k,kk) =        &
   342: ||                     & xyrr_OverlappedCloudTrans(:,:,k,kk-1)    &
   343: ||                     & * ( 1.0_DP - xyz_EffCloudCover(:,:,kk) )
   344: |+-----            end do
   345: +------          end do
   346:            
   347: +------>         do k = 0, kmax
   348: |+----->           do kk = 0, k-1
   349: ||W+===              xyrr_OverlappedCloudTrans(:,:,k,kk) = xyrr_OverlappedCloudTrans(:,:,kk,k)
   350: |+-----            end do
   351: +------          end do
   352:            
   353:                case ( IDCloudOverlapTypeMaxOverlap )
   354:            
   355:                  ! see Chou et al. (2001)
   356:            
   357: ++V====          xyz_EffCloudCover = xyz_CloudCover * ( 1.0_DP - xyz_TransCloudOneLayer )
   358:            
   359:            
   360:                  ! Original method (computationally expensive, probably)
   361:                  !
   362:            !!$        do k = 0, kmax
   363:            !!$          kk = k
   364:            !!$          xyrr_OverlappedCloudTrans(:,:,k,kk) = 1.0_DP
   365:            !!$          do kk = k+1, kmax
   366:            !!$
   367:            !!$            xyz_CloudCoverSorted         = xyz_CloudCover
   368:            !!$            xyz_EffCloudCoverSorted      = xyz_EffCloudCover
   369:            !!$            xyz_TransCloudOneLayerSorted = xyz_TransCloudOneLayer
   370:            !!$
   371:            !!$            call SortQuick( imax, jmax, kk-k,             &
   372:            !!$              & xyz_CloudCoverSorted        (:,:,k+1:kk), &
   373:            !!$              & xyz_EffCloudCoverSorted     (:,:,k+1:kk), &
   374:            !!$              & xyz_TransCloudOneLayerSorted(:,:,k+1:kk)  &
   375:            !!$              & )
   376:            !!$
   377:            !!$            xyrr_OverlappedCloudTrans(:,:,k,kk) = 0.0_DP
   378:            !!$            do kkk = k+1, kk
   379:            !!$              xyrr_OverlappedCloudTrans(:,:,k,kk) =         &
   380:            !!$                & xyz_EffCloudCoverSorted(:,:,kkk)          &
   381:            !!$                & + xyrr_OverlappedCloudTrans(:,:,k,kk)     &
   382:            !!$                &   * xyz_TransCloudOneLayerSorted(:,:,kkk)
   383:            !!$            end do
   384:            !!$            xyrr_OverlappedCloudTrans(:,:,k,kk) = &
   385:            !!$              & 1.0_DP - xyrr_OverlappedCloudTrans(:,:,k,kk)
   386:            !!$
   387:            !!$          end do
   388:            !!$        end do
   389:            
   390:            
   391:                  ! Economical method (probably)
   392:                  !
   393: +------>         do k = 0, kmax
   394: |          
   395: |          !!$          do kkk = 1, kmax
   396: |          !!$              xyz_CloudCoverSorted(:,:,kkk) = real( kmax-kkk ) / real(kmax)
   397: |          !!$!              xyz_CloudCoverSorted(:,:,kkk) = abs( 0.55d0 - real( kmax-kkk ) / real(kmax) )
   398: |          !!$          end do
   399: |          !!$          ! debug output
   400: |          !!$          if ( k == 0 ) then
   401: |          !!$            kk = kmax
   402: |          !!$            do kkk = k+1, kk
   403: |          !!$              write( 6, * ) kkk, xyz_CloudCoverSorted(0,jmax/2+1,kkk)
   404: |          !!$            end do
   405: |          !!$          end if
   406: |          
   407: |**V--->           xyz_CloudCoverSorted         = xyz_CloudCover
   408: ||||               xyz_EffCloudCoverSorted      = xyz_EffCloudCover
   409: |**V---            xyz_TransCloudOneLayerSorted = xyz_TransCloudOneLayer
   410: |          
   411: |                  kk = k
   412: |W*====            xyrr_OverlappedCloudTrans(:,:,k,kk) = 1.0_DP
   413: |+----->           do kk = k+1, kmax
   414: ||         
   415: ||         
   416: ||+---->             do j = 1, jmax
   417: |||+--->               do i = 0, imax-1
   418: ||||       
   419: ||||                     ! xyz_CloudCoverSorted(i,j,kk) is inserved in an appropriate position.
   420: ||||                     !
   421: ||||                     KInsPos = kk
   422: ||||V-->                 loop : do kkk = k+1, kk-1
   423: |||||      
   424: |||||                      if ( xyz_CloudCoverSorted(i,j,kk) < xyz_CloudCoverSorted(i,j,kkk) ) then
   425: |||||                        KInsPos = kkk
   426: |||||                        exit loop
   427: |||||                      end if
   428: |||||      
   429: ||||V--                  end do loop
   430: ||||       
   431: ||||                     ! values are saved
   432: ||||                     CloudCoverSortedCur         = xyz_CloudCoverSorted        (i,j,kk)
   433: ||||                     EffCloudCoverSortedCur      = xyz_EffCloudCoverSorted     (i,j,kk)
   434: ||||                     TransCloudOneLayerSortedCur = xyz_TransCloudOneLayerSorted(i,j,kk)
   435: ||||       
   436: ||||                     ! values are shifted upward to empty an array at insert position
   437: ||||V-->                 do kkk = kk, KInsPos+1, -1
   438: |||||                      xyz_CloudCoverSorted        (i,j,kkk) = &
   439: |||||                        & xyz_CloudCoverSorted        (i,j,kkk-1)
   440: |||||                      xyz_EffCloudCoverSorted     (i,j,kkk) = &
   441: |||||                        & xyz_EffCloudCoverSorted     (i,j,kkk-1)
   442: |||||                      xyz_TransCloudOneLayerSorted(i,j,kkk) = &
   443: |||||                        & xyz_TransCloudOneLayerSorted(i,j,kkk-1)
   444: ||||V--                  end do
   445: ||||                     kkk = KInsPos
   446: ||||                     xyz_CloudCoverSorted        (i,j,kkk) = CloudCoverSortedCur
   447: ||||                     xyz_EffCloudCoverSorted     (i,j,kkk) = EffCloudCoverSortedCur
   448: ||||                     xyz_TransCloudOneLayerSorted(i,j,kkk) = TransCloudOneLayerSortedCur
   449: ||||       
   450: |||+---                end do
   451: ||+----              end do
   452: ||         
   453: ||         
   454: ||         !!$            xyz_CloudCoverSorted         = xyz_CloudCover
   455: ||         !!$            do kkk = 1, kmax
   456: ||         !!$              xyz_CloudCoverSorted(:,:,kkk) = real( kmax-kkk ) / real(kmax)
   457: ||         !!$            end do
   458: ||         !!$            xyz_EffCloudCoverSorted      = xyz_EffCloudCover
   459: ||         !!$            xyz_TransCloudOneLayerSorted = xyz_TransCloudOneLayer
   460: ||         !!$
   461: ||         !!$            call SortQuick( imax, jmax, kk-k,             &
   462: ||         !!$              & xyz_CloudCoverSorted        (:,:,k+1:kk), &
   463: ||         !!$              & xyz_EffCloudCoverSorted     (:,:,k+1:kk), &
   464: ||         !!$              & xyz_TransCloudOneLayerSorted(:,:,k+1:kk)  &
   465: ||         !!$              & )
   466: ||         
   467: ||         
   468: ||         !!$            ! debug output
   469: ||         !!$            if ( ( k == 0 ) .and. ( kk == kmax-2 ) ) then
   470: ||         !!$              do kkk = k+1, kk
   471: ||         !!$                write( 6, * ) kkk, xyz_CloudCoverSorted(0,jmax/2+1,kkk)
   472: ||         !!$              end do
   473: ||         !!$              write( 6, * ) '-----'
   474: ||         !!$            end if
   475: ||         
   476: ||         
   477: ||W*===              xyrr_OverlappedCloudTrans(:,:,k,kk) = 0.0_DP
   478: ||+---->             do kkk = k+1, kk
   479: |||+V==                xyrr_OverlappedCloudTrans(:,:,k,kk) =         &
   480: |||                      & xyz_EffCloudCoverSorted(:,:,kkk)          &
   481: |||                      & + xyrr_OverlappedCloudTrans(:,:,k,kk)     &
   482: |||                      &   * xyz_TransCloudOneLayerSorted(:,:,kkk)
   483: ||+----              end do
   484: ||W*===              xyrr_OverlappedCloudTrans(:,:,k,kk) = &
   485: ||                     & 1.0_DP - xyrr_OverlappedCloudTrans(:,:,k,kk)
   486: ||         
   487: |+-----            end do
   488: +------          end do
   489:            
   490:            
   491:            
   492: +------>         do k = 0, kmax
   493: |+----->           do kk = 0, k-1
   494: ||WW===              xyrr_OverlappedCloudTrans(:,:,k,kk) = xyrr_OverlappedCloudTrans(:,:,kk,k)
   495: |+-----            end do
   496: +------          end do
   497:            
   498:            
   499:                end select
   500:            
   501:                ! Output effective cloud cover
   502:                !
   503:            !!$    call HistoryAutoPut( TimeN, 'EffCloudCover', &
   504:            !!$      & 1.0_DP - xyrr_OverlappedCloudTrans(:,:,0,kmax) )
   505:            
   506:            
   507:              end subroutine CloudUtilsCalcOverlapCloudTrans
   508:            
   509:              !--------------------------------------------------------------------------------------
   510:            
   511:              subroutine CloudUtilsSmearCloudOptDep(  &
   512:                & xyz_CloudCover,                     & ! (in   )
   513:                & xyz_DelCloudOptDep                  & ! (inout)
   514:                & )
   515:            
   516:                ! USE statements
   517:                !
   518:            
   519:                real(DP), intent(in   ) :: xyz_CloudCover    (0:imax-1, 1:jmax, 1:kmax)
   520:                real(DP), intent(inout) :: xyz_DelCloudOptDep(0:imax-1, 1:jmax, 1:kmax)
   521:            
   522:            
   523:                ! ¹ʸ ; Executable statement
   524:                !
   525:            
   526:                ! ǧ
   527:                ! Initialization check
   528:                !
   529:                if ( .not. cloud_utils_inited ) then
   530:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   531:                end if
   532:            
   533:            
   534:                ! Cloud optical depth is scaled by the way of Kiehl et al. (1994).
   535:            
   536: W**====        xyz_DelCloudOptDep = xyz_DelCloudOptDep * xyz_CloudCover**1.5_DP
   537:            
   538:            
   539:              end subroutine CloudUtilsSmearCloudOptDep
   540:            
   541:              !--------------------------------------------------------------------------------------
   542:            
   543:              subroutine CloudUtilsLocalizeCloud(  &
   544:                & xyz_CloudCover,                  & ! (in   )
   545:                & xyz_DelCloudOptDep               & ! (inout)
   546:                & )
   547:            
   548:                ! USE statements
   549:                !
   550:            
   551:                real(DP), intent(in   ) :: xyz_CloudCover    (0:imax-1, 1:jmax, 1:kmax)
   552:                real(DP), intent(inout) :: xyz_DelCloudOptDep(0:imax-1, 1:jmax, 1:kmax)
   553:            
   554:            
   555:                ! ¹ʸ ; Executable statement
   556:                !
   557:            
   558:                ! ǧ
   559:                ! Initialization check
   560:                !
   561:                if ( .not. cloud_utils_inited ) then
   562:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   563:                end if
   564:            
   565:            
   566:                ! Cloud optical depth is scaled by considering cloud cover less than 1. 
   567:            
   568: ***====        xyz_DelCloudOptDep = xyz_DelCloudOptDep / max( xyz_CloudCover, 1.0d-3 )
   569:            
   570:            
   571:              end subroutine CloudUtilsLocalizeCloud
   572:            
   573:              !--------------------------------------------------------------------------------------
   574:            
   575:              subroutine CloudUtilsInit( &
   576:                & ArgFlagSnow            &
   577:                & )
   578:            
   579:                ! ե
   580:                ! File I/O support
   581:                !
   582:                use dc_iounit, only: FileOpen
   583:            
   584:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   585:                ! Utilities for NAMELIST file input
   586:                !
   587:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   588:            
   589:                ! ҥȥǡ
   590:                ! History data output
   591:                !
   592:                use gtool_historyauto, only: HistoryAutoAddVariable
   593:            
   594:                ! 絬϶ŷ (ήŷ)
   595:                ! Large scale condensation (non-convective condensation)
   596:                !
   597:                use lscond, only : LScaleCondInit
   598:            
   599:            
   600:                ! ʸ ; Declaration statements
   601:                !
   602:            
   603:                logical, intent(in) :: ArgFlagSnow
   604:            
   605:            
   606:                character(STRING) :: CloudOverlapType
   607:            
   608:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   609:                                          ! Unit number for NAMELIST file open
   610:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   611:                                          ! IOSTAT of NAMELIST read
   612:            
   613:                ! NAMELIST ѿ
   614:                ! NAMELIST group name
   615:                !
   616:                namelist /cloud_utils_nml/ &
   617:                  & CloudOverlapType,      &
   618:                  & TempWatLim,          &
   619:                  & TempIceLim
   620:                      !
   621:                      ! ǥեͤˤĤƤϽ³ "cloud_utils#CloudUtilsInit"
   622:                      ! Υɤ򻲾ȤΤ.
   623:                      !
   624:                      ! Refer to source codes in the initialization procedure
   625:                      ! "cloud_utils#CloudUtilsInit" for the default values.
   626:                      !
   627:            
   628:                ! ¹ʸ ; Executable statement
   629:                !
   630:            
   631:                if ( cloud_utils_inited ) return
   632:            
   633:            
   634:                FlagSnow = ArgFlagSnow
   635:            
   636:            
   637:                ! ǥեͤ
   638:                ! Default values settings
   639:                !
   640:            
   641:                CloudOverlapType    = "Random"
   642:            !!$    CloudOverlapType    = "MaxOverlap"
   643:            
   644:                TempWatLim          = 273.15_DP
   645:                TempIceLim          = 273.15_DP - 40.0_DP
   646:            
   647:            
   648:                ! NAMELIST ɤ߹
   649:                ! NAMELIST is input
   650:                !
   651:                if ( trim(namelist_filename) /= '' ) then
   652:                  call FileOpen( unit_nml, &          ! (out)
   653:                    & namelist_filename, mode = 'r' ) ! (in)
   654:            
   655:                  rewind( unit_nml )
   656:                  read( unit_nml,                     & ! (in)
   657:                    & nml = cloud_utils_nml,          & ! (out)
   658:                    & iostat = iostat_nml )             ! (out)
   659:                  close( unit_nml )
   660:            
   661:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   662:                end if
   663:            
   664:            
   665:                select case ( CloudOverlapType )
   666:                case ( 'Random' )
   667:                  IDCloudOverlapType = IDCloudOverlapTypeRandom
   668:                case ( 'MaxOverlap' )
   669:                  IDCloudOverlapType = IDCloudOverlapTypeMaxOverlap
   670:                case default
   671:                  call MessageNotify( 'E', module_name,         &
   672:                    & 'CloudOverlapType=<%c> is not supported.', &
   673:                    & c1 = trim(CloudOverlapType) )
   674:                end select
   675:            
   676:            
   677:                ! Initialization of modules used in this module
   678:                !
   679:            
   680:                ! 絬϶ŷ (ήŷ) (Manabe, 1965)
   681:                ! Large scale condensation (non-convective condensation) (Le Treut and Li, 1991)
   682:                !
   683:                call LScaleCondInit
   684:            
   685:            
   686:                ! ҥȥǡϤΤΤؤѿϿ
   687:                ! Register of variables for history data output
   688:                !
   689:            !!$    call HistoryAutoAddVariable( 'EffCloudCover', &
   690:            !!$      & (/ 'lon ', 'lat ', 'time' /), &
   691:            !!$      & 'effective cloud cover', '1' )
   692:            
   693:            
   694:            
   695:                !  ; Print
   696:                !
   697:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   698:                call MessageNotify( 'M', module_name, 'CloudOverlapType = %c', c1 = trim(CloudOverlapType) )
   699:                call MessageNotify( 'M', module_name, 'TempWatLim       = %f', d = (/ TempWatLim /) )
   700:                call MessageNotify( 'M', module_name, 'TempIceLim       = %f', d = (/ TempIceLim /) )
   701:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   702:            
   703:            
   704:                cloud_utils_inited = .true.
   705:            
   706:              end subroutine CloudUtilsInit
   707:            
   708:              !--------------------------------------------------------------------------------------
   709:            
   710:            end module cloud_utils
